#!/usr/bin/perl
use Time::Local;
use Date::Calc qw(:all);
$user = "";
$passwd = "";
$db = "FireWatchPPP";

($sec,$min,$hours,$mday,$mon,,$year,$wday,$yday) = (localtime)[0..7];

$year = ($year + 1900 );
$month = ($mon +1);
$weeknum = Week_Number($year, $month, $mday);

if (@ARGV[0] ne "" ) { 
@hostlist = @ARGV[0];
} else {
@hostlist = `cat host_list`;
}
chomp @hostlist;


open (SQL, "|mysql -u $user -p$passwd");
print SQL qq(use $db;\n);
foreach $host (@hostlist) {

print SQL qq(DROP TABLE IF EXISTS `${host}_InBnd_Week$weeknum`;);
print SQL qq(CREATE TABLE `${host}_InBnd_Week$weeknum`(
  DateTimeStamp datetime NOT NULL,
  DateStamp varchar(15) NOT NULL,
  TimeStamp time NOT NULL,
  Hostname varchar(32) NOT NULL,
  Event varchar(25) NOT NULL,
  Lan varchar(10) NOT NULL,
  NIC varchar(8) NOT NULL,
  SRC_IP varchar(15) NOT NULL,
  DST_IP varchar(15) NOT NULL,
  Protocol varchar(5) NOT NULL,
  SRC_Port bigint(6) NOT NULL,
  DST_Port bigint(6) NOT NULL,
  KEY SRC_IP (SRC_IP),
  KEY SRC_Port (SRC_Port),
  KEY DST_Port (DST_Port),
  KEY DateTimeStamp (DateTimeStamp)) TYPE=MyISAM;);

print SQL qq(DROP TABLE IF EXISTS `${host}_OutBnd_Week$weeknum`;);
print SQL qq(CREATE TABLE `${host}_OutBnd_Week$weeknum`(
  DateTimeStamp datetime NOT NULL,
  DateStamp varchar(12) NOT NULL,
  TimeStamp varchar(12) NOT NULL,
  Hostname varchar(32) NOT NULL,
  Event varchar(35) NOT NULL,
  Lan varchar(10) NOT NULL,
  NIC varchar(8) NOT NULL,
  SRC_IP varchar(20) NOT NULL,
  DST_IP varchar(20) NOT NULL,
  Protocol varchar(25) NOT NULL,
  SRC_Port varchar(8) NOT NULL,
  DST_Port varchar(8) NOT NULL) TYPE=MyISAM;);

print SQL qq(INSERT INTO Hosts VALUES ('$host'););
}
close SQL;
