#!/usr/bin/perl -w
#Script to send a daily report
use Time::Local;
use Date::Calc qw(:all);
use DBI;
use Socket;
use strict;


my (@Data,@Out_Data,$row,@Hosts,$hosts,$sth,$LastWeekNum);
my ($d, $m, $y) = (localtime(time() - 1 * 86400))[3,4,5];
my $stamp = join('-', ($y + 1900),($m +1),$d);
chomp $stamp;
#Convert localtime to secs since epoch(NOT UTC)
my ($sec,$min,$hours,$mday,$mon,,$year,$wday,$yday) = (localtime)[0..7];
my $epoch = timelocal($sec,$min,$hours,$mday,$mon,$year);
#Now we know what the current week is. Monday as first day of week 01-53
my $yearx = ($year + 1900 );
my $month = ($mon +1);
my $weeknum = Week_Number($yearx, $month, $mday);
chomp $weeknum;



if ($weeknum == "1") {
$LastWeekNum  = 53;
} elsif ($weeknum >= "2" ) {
$LastWeekNum  = ($weeknum - 1);
}
if ( $wday == "1" ) {
$weeknum = $LastWeekNum;
}
#Convert the epoch to todays Date and yesterdays Date
($sec,$min,$hours,$mday,$mon,$year,$wday,$yday)=localtime($epoch);
my $today = sprintf("%04d-%02d-%02d", $year+1900,$mon+1,$mday);
($sec,$min,$hours,$mday,$mon,$year,$wday,$yday)=localtime(($epoch - (86400)));
my $yesterday = sprintf("%04d-%02d-%02d", $year+1900,$mon+1,$mday);
chomp $yesterday;



my $db_name = "FireWatchPPP";
# default connection  parameters - all missing
        my ($host_name, $user_name, $password) = (undef, undef, undef);

        #Build the database stuff
        # construct data source
        my ($dsn) = "DBI:mysql:$db_name";
        $dsn .= ":hostname=$host_name" if $host_name;
        $dsn .= ";mysql_read_default_file=~watcher/FW/sel-sql.cnf";

        # connect to server
        my (%attr) = ( RaiseError => 1 );
        my ($dbh) = DBI->connect ($dsn, $user_name, $password, \%attr);
################################################################################################
# Get the Host List
	$sth = $dbh->prepare (qq{select HostName from Hosts});
$sth->execute();
while ( $row = $sth->fetchrow_array() ) {
push (@Hosts,  $row  );
}

foreach $hosts (@Hosts) {
###############################################################################################
# InBound query on External Interface Only
	$sth = $dbh->prepare (qq{select DateStamp,count(SRC_IP) as Event_Count,Event,SRC_IP,
					SRC_Port,DST_Port from ${hosts}_InBnd_Week$weeknum
					where Lan = 'External' and DateTimeStamp >= "$yesterday" 
					and DateTimeStamp <= "$today"
					group by SRC_IP});
	#To see it all (maybe 1000 rows +) uncomment this query and comment out the one above
	#my $sth = $dbh->prepare (qq{select DateStamp,TimeStamp,Event,SRC_IP,
					#SRC_Port,DST_Port from `${hosts}_InBnd_Week$weeknum`
					#where Lan = 'External' and DateTimeStamp >= "$yesterday" 
					#and DateTimeStamp <= "$today" group by TimeStamp});
$sth->execute();

while ( $row = $sth->fetchrow_arrayref() ) {
push (@Data, [ @$row[0],@$row[1],@$row[2],inet_ntoa(pack"N",hex(@$row[3])),@$row[4],@$row[5] ] );
}

#If you have a low traffic site and want to see everything
#uncomment this loop and comment out the while loop above
#while ( $row = $sth->fetchrow_arrayref() ) {
#push (@Data, [ @$row[0],@$row[1],@$row[2],inet_ntoa(pack"N",hex(@$row[3])),@$row[4],@$row[5] ] );
#}

#####################################################################################################
# Outbound Summary On External Interface
	 	$sth = $dbh -> prepare (qq{SELECT DateStamp,count(DST_IP) as Event_Count,DST_IP,SRC_Port,
			DST_Port,Protocol from ${hosts}_OutBnd_Week$weeknum
			where Lan = 'External' and DateTimeStamp >= "$yesterday" 
                        and DateTimeStamp <= "$today"
                	group by DST_IP,SRC_Port}); 
$sth->execute();
while ( $row = $sth->fetchrow_arrayref() ) {
push (@Out_Data, [ @$row[0],@$row[1],inet_ntoa(pack"N",hex(@$row[2])),@$row[3],@$row[4],@$row[5] ] );
}
######################################################################################################
}

foreach $hosts (@Hosts) {
open (MAIL, "|/usr/sbin/sendmail -t") || return 0;
print MAIL "TO: root\@localhost\n";
#print MAIL "CC: CCuser\@localhost\n";
print MAIL "From: FireWatch\n";
print MAIL "Subject: InBound Log for $stamp on $hosts\n";
print MAIL "$stamp $hosts\n";
foreach $row (@Data) {
print MAIL "@$row\n";
}
print MAIL ".";
}
close (MAIL);

foreach $hosts (@Hosts) {
open (MAIL, "|/usr/sbin/sendmail -t") || return 0;
print MAIL "TO: root\@localhost\n";
#print MAIL "CC: CCuser\@localhost\n";
print MAIL "From: FireWatch\n";
print MAIL "Subject: OutBound Log for $stamp on $hosts\n";
print MAIL "$stamp $hosts\n";
foreach $row (@Out_Data) {
print MAIL "@$row\n";
}
print MAIL ".";
}
close (MAIL);
select (STDOUT);
