#!/usr/bin/perl -w
#Script to send a daily report
use Time::Local;
use Date::Calc qw(:all);
use DBI;
use Socket;
use strict;


my (@Data,@row,$ip,$row,@Hosts,$hosts,$sth,$WeekLength,$hstname);
#Convert localtime to secs since epoch(NOT UTC)
my ($sec,$min,$hours,$mday,$mon,,$year,$wday,$yday) = (localtime)[0..7];
my $epoch = timelocal($sec,$min,$hours,$mday,$mon,$year);
#Now we know what the current week is. Monday as first day of week 01-53

my $yearx = ($year + 1900 );
my $month = ($mon +1);
my $weeknum = Week_Number($yearx, $month, $mday);
chomp $weeknum;


my $db_name = "FireWatchPPP";
# default connection  parameters - all missing
        my ($host_name, $user_name, $password) = (undef, undef, undef);

        #Build the database stuff
        # construct data source
        my ($dsn) = "DBI:mysql:$db_name";
        $dsn .= ":hostname=$host_name" if $host_name;
        $dsn .= ";mysql_read_default_file=~watcher/FW/roll-sql.cnf";

        # connect to server
        my (%attr) = ( RaiseError => 1 );
        my ($dbh) = DBI->connect ($dsn, $user_name, $password, \%attr);
################################################################################################
# Get the Host List
	$sth = $dbh->prepare (qq{select HostName from Hosts});
$sth->execute();
while ( $row = $sth->fetchrow_array() ) {
push (@Hosts,  $row  );
}

foreach $hosts (@Hosts) {
###############################################################################################
# InBound query on External Interface Only
my $num = int( rand  5000 );
my $temp_table = $num.$$.temp;
	$sth = $dbh -> prepare ("create temporary table $temp_table select count(SRC_IP) as Event_Count,
               SRC_IP,SRC_Port,DST_Port,Protocol from `${hosts}_InBnd_Week$weeknum` group by SRC_IP,DST_Port");
	$sth -> execute;
	$sth -> finish ();

         $sth = $dbh -> prepare ("select Event_Count,SRC_IP,SRC_Port,DST_Port,Protocol from $temp_table
                               group by Event_Count,SRC_IP order by Event_Count DESC limit 5");
         $sth -> execute;


foreach $hosts (@Hosts) {
open (MAIL, "|/usr/sbin/sendmail -t") || return 0;
print MAIL "TO: mypagernumber\@skytel.com\n";
print MAIL "From: FireWatch\n";
print MAIL "Subject: Top 5 on $hosts\n";
print MAIL "Sent at $hours$min for $hosts\n";
print MAIL ("\n");
while ( $row = $sth->fetchrow_arrayref() ) {
print MAIL ("@$row[0]  " );

$ip = (inet_ntoa(pack"N", hex(@$row[1])));
chomp $ip;
$hstname = `(dig +short -x  $ip)`;
chomp $hstname;

if ($hstname ne "") {
print MAIL ("$ip $hstname");
} else {
print MAIL ("$ip Failed to Resolve  ");
} # Close if else

print MAIL ("\n");
} # Close while of select
print MAIL ".";
} # Close foreach
close (MAIL);
select (STDOUT);
}
