#!/usr/bin/perl -w
#This script creates the new weekly db tables every sunday at 0000.
# I use 86400 seconds per day and 604800 seconds per week
use Time::Local;
use Date::Calc qw(:all);
use DBI;
use strict;
my ($Tables,@Tables,@row,$rows,$count,$row,$host,@Hosts,$rv);
#Convert localtime to secs since epoch(NOT UTC)
my ($sec,$min,$hours,$mday,$mon,,$year,$wday,$yday) = (localtime)[0..7];
my $epoch = timelocal($sec,$min,$hours,$mday,$mon,$year);
#Now we know what the current week is. Monday as first day of week 01-53

$year = ($year + 1900 );
my $month = ($mon +1);
my $weeknum = Week_Number($year, $month, $mday);


#Create the new table
my $db_name = ("FireWatchPPP");
# default connection  parameters - all missing
        my ($host_name, $user_name, $password) = (undef, undef, undef);

        #Build the database stuff
        # construct data source
        my ($dsn) = "DBI:mysql:$db_name";
        $dsn .= ":hostname=$host_name" if $host_name;
        $dsn .= ";mysql_read_default_file=~watcher/FW/roll-sql.cnf";

        # connect to server
        my (%attr) = ( RaiseError => 0, PrintError => 1 );
        my ($dbh) = DBI->connect ($dsn, $user_name, $password, \%attr);
################################################################################################
# Get the Host List
        my $sth = $dbh->prepare (qq{select HostName from Hosts});
$sth->execute();
while ( $row = $sth->fetchrow_array() ) {
push (@Hosts,  $row  );
}
#########################################################################################
# Check to see if the current weeks table exists
foreach $host (@Hosts) {
 $sth = $dbh->prepare(qq{ show tables });
$sth->execute();
while ( $row = $sth->fetchrow_array() ) {
push (@Tables,  $row  );
}
}


foreach $host (@Hosts) {
foreach $Tables (@Tables) {
if ( $Tables =~ m/${host}_OutBnd_Week$weeknum/ ) {
#print "Found ${host}_OutBnd_Week$weeknum tables Exiting\n";
exit (9);
}
}
}

foreach $host (@Hosts) {
# Create the tables
        $sth = $dbh->do (qq{ create table `${host}_InBnd_Week$weeknum`(
        DateTimeStamp datetime NOT NULL, 
        DateStamp varchar(15) NOT NULL,
        TimeStamp time NOT NULL,
        Hostname varchar(32) NOT NULL,
        Event varchar(25) NOT NULL,
        Lan varchar(10) NOT NULL,
        NIC varchar(8) NOT NULL,
        MAC varchar(45) NOT NULL,
        SRC_IP varchar(15) NOT NULL,
        DST_IP varchar(15) NOT NULL,
        Protocol varchar(5) NOT NULL,
        SRC_Port bigint(6) NOT NULL,
        DST_Port bigint(6) NOT NULL,
        KEY SRC_IP (SRC_IP),
        KEY SRC_Port (SRC_Port),
        KEY DST_Port (DST_Port),
        KEY DateTimeStamp (DateTimeStamp)
) });

$sth = $dbh->do (qq{ create table `${host}_OutBnd_Week$weeknum`(
        DateTimeStamp datetime NOT NULL,
        DateStamp varchar(12) NOT NULL,
        TimeStamp varchar(12) NOT NULL,
        Hostname varchar(32) NOT NULL,
        Event varchar(35) NOT NULL,
        Lan varchar(10) NOT NULL,
        NIC varchar(8) NOT NULL,
        SRC_IP varchar(20) NOT NULL,
        DST_IP varchar(20) NOT NULL,
        Protocol varchar(25) NOT NULL,
        SRC_Port varchar(8) NOT NULL,
        DST_Port varchar(8) NOT NULL,
        KEY SRC_Port (SRC_Port),
        KEY DST_Port (DST_Port),
        KEY DateTimeStamp (DateTimeStamp)
) });
} # Close foreach

#Bounce the logging script so that is loads the new week number (ie... table name)
my $bounce = "/sbin/service StartFire restart";

system ($bounce);

