#!/usr/bin/perl 
use Time::Local;
use Date::Calc qw(:all);
$user = "username";
$passwd = "password";
$db = "FireWatch"; #Do Not change this unless you plan on changing it everywhere

($sec,$min,$hours,$mday,$mon,,$year,$wday,$yday) = (localtime)[0..7];
$epoch = timelocal($sec,$min,$hours,$mday,$mon,$year);

$year = ($year + 1900 );
$month = ($mon +1);
$weeknum = Week_Number($year, $month, $mday);

if (@ARGV[0] ne "" ) {
@hostlist = @ARGV[0];
} else {
@hostlist = `cat host_list`;
}
chomp @hostlist;


$hostname = `hostname`;
chomp $hostname;

# Create the database
`mysqladmin create $db -u $user -p$passwd`; 

#Add the DB users
open (SQL, "|mysql -u $user -p$passwd");
print SQL qq(GRANT SELECT on *.* TO selector\@localhost IDENTIFIED BY 'selector';);
print SQL qq(GRANT SELECT on *.* TO selector\@`$hostname` IDENTIFIED BY 'selector';);
print SQL qq(GRANT SELECT on *.* TO selector\@`%` IDENTIFIED BY 'selector';);

print SQL qq(GRANT INSERT on *.* TO insertor\@localhost IDENTIFIED BY 'insertor';);
print SQL qq(GRANT INSERT on *.* TO insertor\@`$hostname` IDENTIFIED BY 'insertor';);
print SQL qq(GRANT INSERT on *.* TO insertor\@`%` IDENTIFIED BY 'insertor';);

print SQL qq(GRANT SELECT,CREATE on *.* TO creator\@localhost IDENTIFIED BY 'creator';);
print SQL qq(GRANT SELECT,CREATE on *.* TO creator\@`$hostname` IDENTIFIED BY 'creator';);
print SQL qq(GRANT SELECT,CREATE on *.* TO creator\@`%` IDENTIFIED BY 'creator';);
close SQL;

open (SQL, "|mysql -u $user -p$passwd");
print SQL qq(use $db;\n);
foreach $host (@hostlist) {

print SQL qq(DROP TABLE IF EXISTS `${host}_InBnd_Week$weeknum`;);
print SQL qq(CREATE TABLE `${host}_InBnd_Week$weeknum`(
  DateTimeStamp datetime NOT NULL,
  DateStamp varchar(15) NOT NULL,
  TimeStamp time NOT NULL,
  Hostname varchar(32) NOT NULL,
  Event varchar(25) NOT NULL,
  Lan varchar(10) NOT NULL,
  NIC varchar(8) NOT NULL,
  MAC varchar(45) NOT NULL,
  SRC_IP varchar(15) NOT NULL,
  DST_IP varchar(15) NOT NULL,
  Protocol varchar(5) NOT NULL,
  SRC_Port bigint(6) NOT NULL,
  DST_Port bigint(6) NOT NULL,
  KEY SRC_IP (SRC_IP),
  KEY SRC_Port (SRC_Port),
  KEY DST_Port (DST_Port),
  KEY DateTimeStamp (DateTimeStamp)) TYPE=MyISAM;);

print SQL qq(DROP TABLE IF EXISTS `${host}_OutBnd_Week$weeknum`;);
print SQL qq(CREATE TABLE `${host}_OutBnd_Week$weeknum`(
  DateTimeStamp datetime NOT NULL,
  DateStamp varchar(12) NOT NULL,
  TimeStamp varchar(12) NOT NULL,
  Hostname varchar(32) NOT NULL,
  Event varchar(35) NOT NULL,
  Lan varchar(10) NOT NULL,
  NIC varchar(8) NOT NULL,
  SRC_IP varchar(20) NOT NULL,
  DST_IP varchar(20) NOT NULL,
  Protocol varchar(25) NOT NULL,
  SRC_Port varchar(8) NOT NULL,
  DST_Port varchar(8) NOT NULL) TYPE=MyISAM;);
}
close SQL;

open (SQL, "|mysql -u $user -p$passwd");
print SQL qq(use $db;\n);
print SQL qq(DROP TABLE IF EXISTS Hosts;);
print SQL qq(CREATE TABLE Hosts(
  HostName varchar(100) NOT NULL) TYPE=MyISAM;);

foreach $host (@hostlist) {
print SQL qq(INSERT INTO Hosts VALUES ('$host'););
}
close SQL;

open (SQL, "|mysql -u $user -p$passwd");
print SQL qq(use $db;\n);
print SQL qq(DROP TABLE IF EXISTS Ports;);
print SQL qq(CREATE TABLE Ports (
  Service_Name varchar(200) NOT NULL,
  Port_Num int(11) NOT NULL,
  Protocol varchar(5) NOT NULL,
  Service_Desc varchar(200) NOT NULL,
  KEY port (Port_Num,Protocol)) TYPE=MyISAM;);

print SQL qq(INSERT INTO Ports VALUES ('', 0, 'tcp', 'Reserved'),
('tcpmux', 1, 'tcp', 'TCP Port Service Multiplexer'),
('compressnet', 2, 'tcp', 'Management Utility'),
('compressnet', 3, 'tcp', 'Compression Process'),
('rje', 5, 'tcp', 'Remote Job Entry'),
('echo', 7, 'tcp', 'Echo'),
('discard', 9, 'tcp', 'Discard'),
('systat', 11, 'tcp', 'Active Users'),
('daytime', 13, 'tcp', 'Daytime (RFC 867)'),
('qotd', 17, 'tcp', 'Quote of the Day'),
('msp', 18, 'tcp', 'Message Send Protocol'),
('chargen', 19, 'tcp', 'Character Generator'),
('ftp-data', 20, 'tcp', 'File Transfer [Default Data]'),
('ftp', 21, 'tcp', 'File Transfer [Control]'),
('ssh', 22, 'tcp', 'SSH Remote Login Protocol'),
('telnet', 23, 'tcp', 'Telnet'),
('', 24, 'tcp', 'any private mail system'),
('smtp', 25, 'tcp', 'Simple Mail Transfer'),
('nsw-fe', 27, 'tcp', 'NSW User System FE'),
('msg-icp', 29, 'tcp', 'MSG ICP'),
('msg-auth', 31, 'tcp', 'MSG Authentication'),
('dsp', 33, 'tcp', 'Display Support Protocol'),
('', 35, 'tcp', 'any private printer server'),
('time', 37, 'tcp', 'Time'),
('rap', 38, 'tcp', 'Route Access Protocol'),
('rlp', 39, 'tcp', 'Resource Location Protocol'),
('graphics', 41, 'tcp', 'Graphics'),
('nameserver', 42, 'tcp', 'Host Name Server'),
('nicname', 43, 'tcp', 'Who Is'),
('mpm-flags', 44, 'tcp', 'MPM FLAGS Protocol'),
('mpm', 45, 'tcp', 'Message Processing Module [recv]'),
('mpm-snd', 46, 'tcp', 'MPM [default send]'),
('ni-ftp', 47, 'tcp', 'NI FTP'),
('auditd', 48, 'tcp', 'Digital Audit Daemon'),
('tacacs', 49, 'tcp', 'Login Host Protocol (TACACS)'),
('re-mail-ck', 50, 'tcp', 'Remote Mail Checking Protocol'),
('la-maint', 51, 'tcp', 'IMP Logical Address Maintenance'),
('xns-time', 52, 'tcp', 'XNS Time Protocol'),
('domain', 53, 'tcp', 'Domain Name Server'),
('xns-ch', 54, 'tcp', 'XNS Clearinghouse'),
('isi-gl', 55, 'tcp', 'ISI Graphics Language'),
('xns-auth', 56, 'tcp', 'XNS Authentication'),
('', 57, 'tcp', 'any private terminal access'),
('xns-mail', 58, 'tcp', 'XNS Mail'),
('', 59, 'tcp', 'any private file service'),
('', 60, 'tcp', 'Unassigned'),
('ni-mail', 61, 'tcp', 'NI MAIL'),
('acas', 62, 'tcp', 'ACA Services'),
('whois++', 63, 'tcp', 'whois++'),
('covia', 64, 'tcp', 'Communications Integrator (CI)'),
('tacacs-ds', 65, 'tcp', 'TACACS-Database Service'),
('sql*net', 66, 'tcp', 'Oracle SQL*NET'),
('bootps', 67, 'tcp', 'Bootstrap Protocol Server'),
('bootpc', 68, 'tcp', 'Bootstrap Protocol Client'),
('tftp', 69, 'tcp', 'Trivial File Transfer'),
('gopher', 70, 'tcp', 'Gopher'),
('netrjs-1', 71, 'tcp', 'Remote Job Service'),
('netrjs-2', 72, 'tcp', 'Remote Job Service'),
('netrjs-3', 73, 'tcp', 'Remote Job Service'),
('netrjs-4', 74, 'tcp', 'Remote Job Service'),
('', 75, 'tcp', 'any private dial out service'),
('deos', 76, 'tcp', 'Distributed External Object Store'),
('', 77, 'tcp', 'any private RJE service'),
('vettcp', 78, 'tcp', 'vettcp'),
('finger', 79, 'tcp', 'Finger'),
('http', 80, 'tcp', 'World Wide Web HTTP'),
('hosts2-ns', 81, 'tcp', 'HOSTS2 Name Server'),
('xfer', 82, 'tcp', 'XFER Utility'),
('mit-ml-dev', 83, 'tcp', 'MIT ML Device'),
('ctf', 84, 'tcp', 'Common Trace Facility'),
('mit-ml-dev', 85, 'tcp', 'MIT ML Device'),
('mfcobol', 86, 'tcp', 'Micro Focus Cobol'),
('', 87, 'tcp', 'any private terminal link'),
('kerberos', 88, 'tcp', 'Kerberos'),
('su-mit-tg', 89, 'tcp', 'SU/MIT Telnet Gateway'),
('dnsix', 90, 'tcp', 'DNSIX Securit Attribute Token Map'),
('mit-dov', 91, 'tcp', 'MIT Dover Spooler'),
('npp', 92, 'tcp', 'Network Printing Protocol'),
('dcp', 93, 'tcp', 'Device Control Protocol'),
('objcall', 94, 'tcp', 'Tivoli Object Dispatcher'),
('supdup', 95, 'tcp', 'SUPDUP'),
('dixie', 96, 'tcp', 'DIXIE Protocol Specification'),
('swift-rvf', 97, 'tcp', 'Swift Remote Virtural File Protocol'),
('tacnews', 98, 'tcp', 'TAC News'),
('metagram', 99, 'tcp', 'Metagram Relay'),
('newacct', 100, 'tcp', '[unauthorized use]'),
('hostname', 101, 'tcp', 'NIC Host Name Server'),
('iso-tsap', 102, 'tcp', 'ISO-TSAP Class 0'),
('gppitnp', 103, 'tcp', 'Genesis Point-to-Point Trans Net'),
('acr-nema', 104, 'tcp', 'ACR-NEMA Digital Imag. & Comm. 300'),
('cso', 105, 'tcp', 'CCSO name server protocol'),
('csnet-ns', 105, 'tcp', 'Mailbox Name Nameserver'),
('3com-tsmux', 106, 'tcp', '3COM-TSMUX'),
('rtelnet', 107, 'tcp', 'Remote Telnet Service'),
('snagas', 108, 'tcp', 'SNA Gateway Access Server'),
('pop2', 109, 'tcp', 'Post Office Protocol - Version 2'),
('pop3', 110, 'tcp', 'Post Office Protocol - Version 3'),
('sunrpc', 111, 'tcp', 'SUN Remote Procedure Call'),
('mcidas', 112, 'tcp', 'McIDAS Data Transmission Protocol'),
('ident', 113, 'tcp', ''),
('auth', 113, 'tcp', 'Authentication Service'),
('audionews', 114, 'tcp', 'Audio News Multicast'),
('sftp', 115, 'tcp', 'Simple File Transfer Protocol'),
('ansanotify', 116, 'tcp', 'ANSA REX Notify'),
('uucp-path', 117, 'tcp', 'UUCP Path Service'),
('sqlserv', 118, 'tcp', 'SQL Services'),
('nntp', 119, 'tcp', 'Network News Transfer Protocol'),
('cfdptkt', 120, 'tcp', 'CFDPTKT'),
('erpc', 121, 'tcp', 'Encore Expedited Remote Pro.Call'),
('smakynet', 122, 'tcp', 'SMAKYNET'),
('ntp', 123, 'tcp', 'Network Time Protocol'),
('ansatrader', 124, 'tcp', 'ANSA REX Trader'),
('locus-map', 125, 'tcp', 'Locus PC-Interface Net Map Ser'),
('nxedit', 126, 'tcp', 'NXEdit'),
('locus-con', 127, 'tcp', 'Locus PC-Interface Conn Server'),
('gss-xlicen', 128, 'tcp', 'GSS X License Verification'),
('pwdgen', 129, 'tcp', 'Password Generator Protocol'),
('cisco-fna', 130, 'tcp', 'cisco FNATIVE'),
('cisco-tna', 131, 'tcp', 'cisco TNATIVE'),
('cisco-sys', 132, 'tcp', 'cisco SYSMAINT'),
('statsrv', 133, 'tcp', 'Statistics Service'),
('ingres-net', 134, 'tcp', 'INGRES-NET Service'),
('epmap', 135, 'tcp', 'DCE endpoint resolution'),
('profile', 136, 'tcp', 'PROFILE Naming System'),
('netbios-ns', 137, 'tcp', 'NETBIOS Name Service'),
('netbios-dgm', 138, 'tcp', 'NETBIOS Datagram Service'),
('netbios-ssn', 139, 'tcp', 'NETBIOS Session Service'),
('emfis-data', 140, 'tcp', 'EMFIS Data Service'),
('emfis-cntl', 141, 'tcp', 'EMFIS Control Service'),
('bl-idm', 142, 'tcp', 'Britton-Lee IDM'),
('imap', 143, 'tcp', 'Internet Message Access Protocol'),
('uma', 144, 'tcp', 'Universal Management Architecture'),
('uaac', 145, 'tcp', 'UAAC Protocol'),
('iso-tp0', 146, 'tcp', 'ISO-IP0'),
('iso-ip', 147, 'tcp', 'ISO-IP'),
('jargon', 148, 'tcp', 'Jargon'),
('aed-512', 149, 'tcp', 'AED 512 Emulation Service'),
('sql-net', 150, 'tcp', 'SQL-NET'),
('hems', 151, 'tcp', 'HEMS'),
('bftp', 152, 'tcp', 'Background File Transfer Program'),
('sgmp', 153, 'tcp', 'SGMP'),
('netsc-prod', 154, 'tcp', 'NETSC'),
('netsc-dev', 155, 'tcp', 'NETSC'),
('sqlsrv', 156, 'tcp', 'SQL Service'),
('knet-cmp', 157, 'tcp', 'KNET/VM Command/Message Protocol'),
('pcmail-srv', 158, 'tcp', 'PCMail Server'),
('nss-routing', 159, 'tcp', 'NSS-Routing'),
('sgmp-traps', 160, 'tcp', 'SGMP-TRAPS'),
('snmp', 161, 'tcp', 'SNMP'),
('snmptrap', 162, 'tcp', 'SNMPTRAP'),
('cmip-man', 163, 'tcp', 'CMIP/TCP Manager'),
('cmip-agent', 164, 'tcp', 'CMIP/TCP Agent'),
('xns-courier', 165, 'tcp', 'Xerox'),
('s-net', 166, 'tcp', 'Sirius Systems'),
('namp', 167, 'tcp', 'NAMP'),
('rsvd', 168, 'tcp', 'RSVD'),
('send', 169, 'tcp', 'SEND'),
('print-srv', 170, 'tcp', 'Network PostScript'),
('multiplex', 171, 'tcp', 'Network Innovations Multiplex'),
('cl/1', 172, 'tcp', 'Network Innovations CL/1'),
('xyplex-mux', 173, 'tcp', 'Xyplex'),
('mailq', 174, 'tcp', 'MAILQ'),
('vmnet', 175, 'tcp', 'VMNET'),
('genrad-mux', 176, 'tcp', 'GENRAD-MUX'),
('xdmcp', 177, 'tcp', 'X Display Manager Control Protocol'),
('nextstep', 178, 'tcp', 'NextStep Window Server'),
('bgp', 179, 'tcp', 'Border Gateway Protocol'),
('ris', 180, 'tcp', 'Intergraph'),
('unify', 181, 'tcp', 'Unify'),
('audit', 182, 'tcp', 'Unisys Audit SITP'),
('ocbinder', 183, 'tcp', 'OCBinder'),
('ocserver', 184, 'tcp', 'OCServer'),
('remote-kis', 185, 'tcp', 'Remote-KIS'),
('kis', 186, 'tcp', 'KIS Protocol'),
('aci', 187, 'tcp', 'Application Communication Interface'),
('mumps', 188, 'tcp', 'Plus Fives MUMPS'),
('qft', 189, 'tcp', 'Queued File Transport'),
('gacp', 190, 'tcp', 'Gateway Access Control Protocol'),
('prospero', 191, 'tcp', 'Prospero Directory Service'),
('osu-nms', 192, 'tcp', 'OSU Network Monitoring System'),
('srmp', 193, 'tcp', 'Spider Remote Monitoring Protocol'),
('irc', 194, 'tcp', 'Internet Relay Chat Protocol'),
('dn6-nlm-aud', 195, 'tcp', 'DNSIX Network Level Module Audit'),
('dn6-smm-red', 196, 'tcp', 'DNSIX Session Mgt Module Audit Redir'),
('dls', 197, 'tcp', 'Directory Location Service'),
('dls-mon', 198, 'tcp', 'Directory Location Service Monitor'),
('smux', 199, 'tcp', 'SMUX'),
('src', 200, 'tcp', 'IBM System Resource Controller'),
('at-rtmp', 201, 'tcp', 'AppleTalk Routing Maintenance'),
('at-nbp', 202, 'tcp', 'AppleTalk Name Binding'),
('at-3', 203, 'tcp', 'AppleTalk Unused'),
('at-echo', 204, 'tcp', 'AppleTalk Echo'),
('at-5', 205, 'tcp', 'AppleTalk Unused'),
('at-zis', 206, 'tcp', 'AppleTalk Zone Information'),
('at-7', 207, 'tcp', 'AppleTalk Unused'),
('at-8', 208, 'tcp', 'AppleTalk Unused'),
('qmtp', 209, 'tcp', 'The Quick Mail Transfer Protocol'),
('z39.50', 210, 'tcp', 'ANSI Z39.50'),
('914c/g', 211, 'tcp', 'Texas Instruments 914C/G Terminal'),
('anet', 212, 'tcp', 'ATEXSSTR'),
('ipx', 213, 'tcp', 'IPX'),
('vmpwscs', 214, 'tcp', 'VM PWSCS'),
('softpc', 215, 'tcp', 'Insignia Solutions'),
('CAIlic', 216, 'tcp', 'Computer Associates Intl License Server'),
('dbase', 217, 'tcp', 'dBASE Unix'),
('mpp', 218, 'tcp', 'Netix Message Posting Protocol'),
('uarps', 219, 'tcp', 'Unisys ARPs'),
('imap3', 220, 'tcp', 'Interactive Mail Access Protocol v3'),
('fln-spx', 221, 'tcp', 'Berkeley rlogind with SPX auth'),
('rsh-spx', 222, 'tcp', 'Berkeley rshd with SPX auth'),
('cdc', 223, 'tcp', 'Certificate Distribution Center'),
('masqdialer', 224, 'tcp', 'masqdialer'),
('direct', 242, 'tcp', 'Direct'),
('sur-meas', 243, 'tcp', 'Survey Measurement'),
('inbusiness', 244, 'tcp', 'inbusiness'),
('link', 245, 'tcp', 'LINK'),
('dsp3270', 246, 'tcp', 'Display Systems Protocol'),
('subntbcst_tftp', 247, 'tcp', 'SUBNTBCST_TFTP'),
('bhfhs', 248, 'tcp', 'bhfhs'),
('rap', 256, 'tcp', 'RAP'),
('set', 257, 'tcp', 'Secure Electronic Transaction'),
('yak-chat', 258, 'tcp', 'Yak Winsock Personal Chat'),
('esro-gen', 259, 'tcp', 'Efficient Short Remote Operations'),
('openport', 260, 'tcp', 'Openport'),
('nsiiops', 261, 'tcp', 'IIOP Name Service over TLS/SSL'),
('arcisdms', 262, 'tcp', 'Arcisdms'),
('hdap', 263, 'tcp', 'HDAP'),
('bgmp', 264, 'tcp', 'BGMP'),
('x-bone-ctl', 265, 'tcp', 'X-Bone CTL'),
('sst', 266, 'tcp', 'SCSI on ST'),
('td-service', 267, 'tcp', 'Tobit David Service Layer'),
('td-replica', 268, 'tcp', 'Tobit David Replica'),
('http-mgmt', 280, 'tcp', 'http-mgmt'),
('personal-link', 281, 'tcp', 'Personal Link'),
('cableport-ax', 282, 'tcp', 'Cable Port A/X'),
('rescap', 283, 'tcp', 'rescap'),
('corerjd', 284, 'tcp', 'corerjd'),
('fxp-1', 286, 'tcp', 'FXP-1'),
('k-block', 287, 'tcp', 'K-BLOCK'),
('novastorbakcup', 308, 'tcp', 'Novastor Backup'),
('entrusttime', 309, 'tcp', 'EntrustTime'),
('bhmds', 310, 'tcp', 'bhmds'),
('asip-webadmin', 311, 'tcp', 'AppleShare IP WebAdmin'),
('vslmp', 312, 'tcp', 'VSLMP'),
('magenta-logic', 313, 'tcp', 'Magenta Logic'),
('opalis-robot', 314, 'tcp', 'Opalis Robot'),
('dpsi', 315, 'tcp', 'DPSI'),
('decauth', 316, 'tcp', 'decAuth'),
('zannet', 317, 'tcp', 'Zannet'),
('pkix-timestamp', 318, 'tcp', 'PKIX TimeStamp'),
('ptp-event', 319, 'tcp', 'PTP Event'),
('ptp-general', 320, 'tcp', 'PTP General'),
('pip', 321, 'tcp', 'PIP'),
('rtsps', 322, 'tcp', 'RTSPS'),
('texar', 333, 'tcp', 'Texar Security Port'),
('pdap', 344, 'tcp', 'Prospero Data Access Protocol'),
('pawserv', 345, 'tcp', 'Perf Analysis Workbench'),
('zserv', 346, 'tcp', 'Zebra server'),
('fatserv', 347, 'tcp', 'Fatmen Server'),
('csi-sgwp', 348, 'tcp', 'Cabletron Management Protocol'),
('mftp', 349, 'tcp', 'mftp'),
('matip-type-a', 350, 'tcp', 'MATIP Type A'),
('matip-type-b', 351, 'tcp', 'MATIP Type B'),
('bhoetty', 351, 'tcp', 'bhoetty (added 5/21/97)'),
('dtag-ste-sb', 352, 'tcp', 'DTAG (assigned long ago)'),
('bhoedap4', 352, 'tcp', 'bhoedap4 (added 5/21/97)'),
('ndsauth', 353, 'tcp', 'NDSAUTH'),
('bh611', 354, 'tcp', 'bh611'),
('datex-asn', 355, 'tcp', 'DATEX-ASN'),
('cloanto-net-1', 356, 'tcp', 'Cloanto Net 1'),
('bhevent', 357, 'tcp', 'bhevent'),
('shrinkwrap', 358, 'tcp', 'Shrinkwrap'),
('nsrmp', 359, 'tcp', 'Network Security Risk Management Protocol'),
('scoi2odialog', 360, 'tcp', 'scoi2odialog'),
('semantix', 361, 'tcp', 'Semantix'),
('srssend', 362, 'tcp', 'SRS Send'),
('rsvp_tunnel', 363, 'tcp', 'RSVP Tunnel'),
('aurora-cmgr', 364, 'tcp', 'Aurora CMGR'),
('dtk', 365, 'tcp', 'DTK'),
('odmr', 366, 'tcp', 'ODMR'),
('mortgageware', 367, 'tcp', 'MortgageWare'),
('qbikgdp', 368, 'tcp', 'QbikGDP'),
('rpc2portmap', 369, 'tcp', 'rpc2portmap'),
('codaauth2', 370, 'tcp', 'codaauth2'),
('clearcase', 371, 'tcp', 'Clearcase'),
('ulistproc', 372, 'tcp', 'ListProcessor'),
('legent-1', 373, 'tcp', 'Legent Corporation'),
('legent-2', 374, 'tcp', 'Legent Corporation'),
('hassle', 375, 'tcp', 'Hassle'),
('nip', 376, 'tcp', 'Amiga Envoy Network Inquiry Proto'),
('tnETOS', 377, 'tcp', 'NEC Corporation'),
('dsETOS', 378, 'tcp', 'NEC Corporation'),
('is99c', 379, 'tcp', 'TIA/EIA/IS-99 modem client'),
('is99s', 380, 'tcp', 'TIA/EIA/IS-99 modem server'),
('hp-collector', 381, 'tcp', 'hp performance data collector'),
('hp-managed-node', 382, 'tcp', 'hp performance data managed node'),
('hp-alarm-mgr', 383, 'tcp', 'hp performance data alarm manager'),
('arns', 384, 'tcp', 'A Remote Network Server System'),
('ibm-app', 385, 'tcp', 'IBM Application'),
('asa', 386, 'tcp', 'ASA Message Router Object Def.'),
('aurp', 387, 'tcp', 'Appletalk Update-Based Routing Pro.'),
('unidata-ldm', 388, 'tcp', 'Unidata LDM'),
('ldap', 389, 'tcp', 'Lightweight Directory Access Protocol'),
('uis', 390, 'tcp', 'UIS'),
('synotics-relay', 391, 'tcp', 'SynOptics SNMP Relay Port'),
('synotics-broker', 392, 'tcp', 'SynOptics Port Broker Port'),
('meta5', 393, 'tcp', 'Meta5'),
('embl-ndt', 394, 'tcp', 'EMBL Nucleic Data Transfer'),
('netcp', 395, 'tcp', 'NETscout Control Protocol'),
('netware-ip', 396, 'tcp', 'Novell Netware over IP'),
('mptn', 397, 'tcp', 'Multi Protocol Trans. Net.'),
('kryptolan', 398, 'tcp', 'Kryptolan'),
('iso-tsap-c2', 399, 'tcp', 'ISO Transport Class 2 Non-Control over TCP'),
('work-sol', 400, 'tcp', 'Workstation Solutions'),
('ups', 401, 'tcp', 'Uninterruptible Power Supply'),
('genie', 402, 'tcp', 'Genie Protocol'),
('decap', 403, 'tcp', 'decap'),
('nced', 404, 'tcp', 'nced'),
('ncld', 405, 'tcp', 'ncld'),
('imsp', 406, 'tcp', 'Interactive Mail Support Protocol'),
('timbuktu', 407, 'tcp', 'Timbuktu'),
('prm-sm', 408, 'tcp', 'Prospero Resource Manager Sys. Man.'),
('prm-nm', 409, 'tcp', 'Prospero Resource Manager Node Man.'),
('decladebug', 410, 'tcp', 'DECLadebug Remote Debug Protocol'),
('rmt', 411, 'tcp', 'Remote MT Protocol'),
('synoptics-trap', 412, 'tcp', 'Trap Convention Port'),
('smsp', 413, 'tcp', 'Storage Management Services Protocol'),
('infoseek', 414, 'tcp', 'InfoSeek'),
('bnet', 415, 'tcp', 'BNet'),
('silverplatter', 416, 'tcp', 'Silverplatter'),
('onmux', 417, 'tcp', 'Onmux'),
('hyper-g', 418, 'tcp', 'Hyper-G'),
('ariel1', 419, 'tcp', 'Ariel'),
('smpte', 420, 'tcp', 'SMPTE'),
('ariel2', 421, 'tcp', 'Ariel'),
('ariel3', 422, 'tcp', 'Ariel'),
('opc-job-start', 423, 'tcp', 'IBM Operations Planning and Control Start'),
('opc-job-track', 424, 'tcp', 'IBM Operations Planning and Control Track'),
('icad-el', 425, 'tcp', 'ICAD'),
('smartsdp', 426, 'tcp', 'smartsdp'),
('svrloc', 427, 'tcp', 'Server Location'),
('ocs_cmu', 428, 'tcp', 'OCS_CMU'),
('ocs_amu', 429, 'tcp', 'OCS_AMU'),
('utmpsd', 430, 'tcp', 'UTMPSD'),
('utmpcd', 431, 'tcp', 'UTMPCD'),
('iasd', 432, 'tcp', 'IASD'),
('nnsp', 433, 'tcp', 'NNSP'),
('mobileip-agent', 434, 'tcp', 'MobileIP-Agent'),
('mobilip-mn', 435, 'tcp', 'MobilIP-MN'),
('dna-cml', 436, 'tcp', 'DNA-CML'),
('comscm', 437, 'tcp', 'comscm'),
('dsfgw', 438, 'tcp', 'dsfgw'),
('dasp', 439, 'tcp', 'dasp Thomas Obermair'),
('sgcp', 440, 'tcp', 'sgcp'),
('decvms-sysmgt', 441, 'tcp', 'decvms-sysmgt'),
('cvc_hostd', 442, 'tcp', 'cvc_hostd'),
('https', 443, 'tcp', 'http protocol over TLS/SSL'),
('snpp', 444, 'tcp', 'Simple Network Paging Protocol'),
('microsoft-ds', 445, 'tcp', 'Microsoft-DS'),
('ddm-rdb', 446, 'tcp', 'DDM-RDB'),
('ddm-dfm', 447, 'tcp', 'DDM-RFM'),
('ddm-ssl', 448, 'tcp', 'DDM-SSL'),
('as-servermap', 449, 'tcp', 'AS Server Mapper'),
('tserver', 450, 'tcp', 'Computer Supported Telecomunication Applications'),
('sfs-smp-net', 451, 'tcp', 'Cray Network Semaphore server'),
('sfs-config', 452, 'tcp', 'Cray SFS config server'),
('creativeserver', 453, 'tcp', 'CreativeServer'),
('contentserver', 454, 'tcp', 'ContentServer'),
('creativepartnr', 455, 'tcp', 'CreativePartnr'),
('macon-tcp', 456, 'tcp', 'macon-tcp'),
('scohelp', 457, 'tcp', 'scohelp'),
('appleqtc', 458, 'tcp', 'apple quick time'),
('ampr-rcmd', 459, 'tcp', 'ampr-rcmd'),
('skronk', 460, 'tcp', 'skronk'),
('datasurfsrv', 461, 'tcp', 'DataRampSrv'),
('datasurfsrvsec', 462, 'tcp', 'DataRampSrvSec'),
('alpes', 463, 'tcp', 'alpes'),
('kpasswd', 464, 'tcp', 'kpasswd'),
('urd', 465, 'tcp', 'URL Rendesvous Directory for SSM'),
('digital-vrc', 466, 'tcp', 'digital-vrc'),
('mylex-mapd', 467, 'tcp', 'mylex-mapd'),
('photuris', 468, 'tcp', 'proturis'),
('rcp', 469, 'tcp', 'Radio Control Protocol'),
('scx-proxy', 470, 'tcp', 'scx-proxy'),
('mondex', 471, 'tcp', 'Mondex'),
('ljk-login', 472, 'tcp', 'ljk-login'),
('hybrid-pop', 473, 'tcp', 'hybrid-pop'),
('tn-tl-w1', 474, 'tcp', 'tn-tl-w1'),
('tcpnethaspsrv', 475, 'tcp', 'tcpnethaspsrv'),
('tn-tl-fd1', 476, 'tcp', 'tn-tl-fd1'),
('ss7ns', 477, 'tcp', 'ss7ns'),
('spsc', 478, 'tcp', 'spsc'),
('iafserver', 479, 'tcp', 'iafserver'),
('iafdbase', 480, 'tcp', 'iafdbase'),
('ph', 481, 'tcp', 'Ph service'),
('bgs-nsi', 482, 'tcp', 'bgs-nsi'),
('ulpnet', 483, 'tcp', 'ulpnet'),
('integra-sme', 484, 'tcp', 'Integra Software Management Environment'),
('powerburst', 485, 'tcp', 'Air Soft Power Burst'),
('avian', 486, 'tcp', 'avian'),
('saft', 487, 'tcp', 'saft Simple Asynchronous File Transfer'),
('gss-http', 488, 'tcp', 'gss-http'),
('nest-protocol', 489, 'tcp', 'nest-protocol'),
('micom-pfs', 490, 'tcp', 'micom-pfs'),
('go-login', 491, 'tcp', 'go-login'),
('ticf-1', 492, 'tcp', 'Transport Independent Convergence for FNA'),
('ticf-2', 493, 'tcp', 'Transport Independent Convergence for FNA'),
('pov-ray', 494, 'tcp', 'POV-Ray'),
('intecourier', 495, 'tcp', 'intecourier'),
('pim-rp-disc', 496, 'tcp', 'PIM-RP-DISC'),
('dantz', 497, 'tcp', 'dantz'),
('siam', 498, 'tcp', 'siam'),
('iso-ill', 499, 'tcp', 'ISO ILL Protocol'),
('isakmp', 500, 'tcp', 'isakmp'),
('stmf', 501, 'tcp', 'STMF'),
('asa-appl-proto', 502, 'tcp', 'asa-appl-proto'),
('intrinsa', 503, 'tcp', 'Intrinsa'),
('citadel', 504, 'tcp', 'citadel'),
('mailbox-lm', 505, 'tcp', 'mailbox-lm'),
('ohimsrv', 506, 'tcp', 'ohimsrv'),
('crs', 507, 'tcp', 'crs'),
('xvttp', 508, 'tcp', 'xvttp'),
('snare', 509, 'tcp', 'snare'),
('fcp', 510, 'tcp', 'FirstClass Protocol'),
('passgo', 511, 'tcp', 'PassGo'),
('exec', 512, 'tcp', 'remote process execution;'),
('login', 513, 'tcp', 'remote login a la telnet;'),
('shell', 514, 'tcp', 'cmd'),
('printer', 515, 'tcp', 'spooler'),
('videotex', 516, 'tcp', 'videotex'),
('talk', 517, 'tcp', 'like tenex link, but across'),
('ntalk', 518, 'tcp', 'ntalk'),
('utime', 519, 'tcp', 'unixtime'),
('efs', 520, 'tcp', 'extended file name server'),
('ripng', 521, 'tcp', 'ripng'),
('ulp', 522, 'tcp', 'ULP'),
('ibm-db2', 523, 'tcp', 'IBM-DB2'),
('ncp', 524, 'tcp', 'NCP'),
('timed', 525, 'tcp', 'timeserver'),
('tempo', 526, 'tcp', 'newdate'),
('stx', 527, 'tcp', 'Stock IXChange'),
('custix', 528, 'tcp', 'Customer IXChange'),
('irc-serv', 529, 'tcp', 'IRC-SERV'),
('courier', 530, 'tcp', 'rpc'),
('conference', 531, 'tcp', 'chat'),
('netnews', 532, 'tcp', 'readnews'),
('netwall', 533, 'tcp', 'for emergency broadcasts'),
('mm-admin', 534, 'tcp', 'MegaMedia Admin'),
('iiop', 535, 'tcp', 'iiop'),
('opalis-rdv', 536, 'tcp', 'opalis-rdv'),
('nmsp', 537, 'tcp', 'Networked Media Streaming Protocol'),
('gdomap', 538, 'tcp', 'gdomap'),
('apertus-ldp', 539, 'tcp', 'Apertus Technologies Load Determination'),
('uucp', 540, 'tcp', 'uucpd'),
('uucp-rlogin', 541, 'tcp', 'uucp-rlogin'),
('commerce', 542, 'tcp', 'commerce'),
('klogin', 543, 'tcp', 'klogin'),
('kshell', 544, 'tcp', 'krcmd'),
('appleqtcsrvr', 545, 'tcp', 'appleqtcsrvr'),
('dhcpv6-client', 546, 'tcp', 'DHCPv6 Client'),
('dhcpv6-server', 547, 'tcp', 'DHCPv6 Server'),
('afpovertcp', 548, 'tcp', 'AFP over TCP'),
('idfp', 549, 'tcp', 'IDFP'),
('new-rwho', 550, 'tcp', 'new-who'),
('cybercash', 551, 'tcp', 'cybercash'),
('deviceshare', 552, 'tcp', 'deviceshare'),
('pirp', 553, 'tcp', 'pirp'),
('rtsp', 554, 'tcp', 'Real Time Stream Control Protocol'),
('dsf', 555, 'tcp', 'dsf'),
('remotefs', 556, 'tcp', 'rfs server'),
('openvms-sysipc', 557, 'tcp', 'openvms-sysipc'),
('sdnskmp', 558, 'tcp', 'SDNSKMP'),
('teedtap', 559, 'tcp', 'TEEDTAP'),
('rmonitor', 560, 'tcp', 'rmonitord'),
('monitor', 561, 'tcp', 'monitor'),
('chshell', 562, 'tcp', 'chcmd'),
('nntps', 563, 'tcp', 'nntp protocol over TLS/SSL (was snntp)'),
('9pfs', 564, 'tcp', 'plan 9 file service'),
('whoami', 565, 'tcp', 'whoami'),
('streettalk', 566, 'tcp', 'streettalk'),
('banyan-rpc', 567, 'tcp', 'banyan-rpc'),
('ms-shuttle', 568, 'tcp', 'microsoft shuttle'),
('ms-rome', 569, 'tcp', 'microsoft rome'),
('meter', 570, 'tcp', 'demon'),
('meter', 571, 'tcp', 'udemon'),
('sonar', 572, 'tcp', 'sonar'),
('banyan-vip', 573, 'tcp', 'banyan-vip'),
('ftp-agent', 574, 'tcp', 'FTP Software Agent System'),
('vemmi', 575, 'tcp', 'VEMMI'),
('ipcd', 576, 'tcp', 'ipcd'),
('vnas', 577, 'tcp', 'vnas'),
('ipdd', 578, 'tcp', 'ipdd'),
('decbsrv', 579, 'tcp', 'decbsrv'),
('sntp-heartbeat', 580, 'tcp', 'SNTP HEARTBEAT'),
('bdp', 581, 'tcp', 'Bundle Discovery Protocol'),
('scc-security', 582, 'tcp', 'SCC Security'),
('philips-vc', 583, 'tcp', 'Philips Video-Conferencing'),
('keyserver', 584, 'tcp', 'Key Server'),
('imap4-ssl', 585, 'tcp', 'IMAP4+SSL (use 993 instead)'),
('password-chg', 586, 'tcp', 'Password Change'),
('submission', 587, 'tcp', 'Submission'),
('cal', 588, 'tcp', 'CAL'),
('eyelink', 589, 'tcp', 'EyeLink'),
('tns-cml', 590, 'tcp', 'TNS CML'),
('http-alt', 591, 'tcp', 'FileMaker, Inc. - HTTP Alternate (see Port 80)'),
('eudora-set', 592, 'tcp', 'Eudora Set'),
('http-rpc-epmap', 593, 'tcp', 'HTTP RPC Ep Map'),
('tpip', 594, 'tcp', 'TPIP'),
('cab-protocol', 595, 'tcp', 'CAB Protocol'),
('smsd', 596, 'tcp', 'SMSD'),
('ptcnameservice', 597, 'tcp', 'PTC Name Service'),
('sco-websrvrmg3', 598, 'tcp', 'SCO Web Server Manager 3'),
('acp', 599, 'tcp', 'Aeolon Core Protocol'),
('ipcserver', 600, 'tcp', 'Sun IPC server'),
('syslog-conn', 601, 'tcp', 'Reliable Syslog Service'),
('soap-beep', 605, 'tcp', 'SOAP over BEEP'),
('urm', 606, 'tcp', 'Cray Unified Resource Manager'),
('nqs', 607, 'tcp', 'nqs'),
('sift-uft', 608, 'tcp', 'Sender-Initiated/Unsolicited File Transfer'),
('npmp-trap', 609, 'tcp', 'npmp-trap'),
('npmp-local', 610, 'tcp', 'npmp-local'),
('npmp-gui', 611, 'tcp', 'npmp-gui'),
('hmmp-ind', 612, 'tcp', 'HMMP Indication'),
('hmmp-op', 613, 'tcp', 'HMMP Operation'),
('sshell', 614, 'tcp', 'SSLshell'),
('sco-inetmgr', 615, 'tcp', 'Internet Configuration Manager'),
('sco-sysmgr', 616, 'tcp', 'SCO System Administration Server'),
('sco-dtmgr', 617, 'tcp', 'SCO Desktop Administration Server'),
('dei-icda', 618, 'tcp', 'DEI-ICDA'),
('compaq-evm', 619, 'tcp', 'Compaq EVM'),
('sco-websrvrmgr', 620, 'tcp', 'SCO WebServer Manager'),
('escp-ip', 621, 'tcp', 'ESCP'),
('collaborator', 622, 'tcp', 'Collaborator'),
('asf-rmcp', 623, 'tcp', 'ASF Remote Management and Control Protocol'),
('cryptoadmin', 624, 'tcp', 'Crypto Admin'),
('dec_dlm', 625, 'tcp', 'DEC DLM'),
('asia', 626, 'tcp', 'ASIA'),
('passgo-tivoli', 627, 'tcp', 'PassGo Tivoli'),
('qmqp', 628, 'tcp', 'QMQP'),
('3com-amp3', 629, 'tcp', '3Com AMP3'),
('rda', 630, 'tcp', 'RDA'),
('ipp', 631, 'tcp', 'IPP (Internet Printing Protocol)'),
('bmpp', 632, 'tcp', 'bmpp'),
('servstat', 633, 'tcp', 'Service Status update (Sterling Software)'),
('ginad', 634, 'tcp', 'ginad'),
('rlzdbase', 635, 'tcp', 'RLZ DBase'),
('ldaps', 636, 'tcp', 'ldap protocol over TLS/SSL (was sldap)'),
('lanserver', 637, 'tcp', 'lanserver'),
('mcns-sec', 638, 'tcp', 'mcns-sec'),
('msdp', 639, 'tcp', 'MSDP'),
('entrust-sps', 640, 'tcp', 'entrust-sps'),
('repcmd', 641, 'tcp', 'repcmd'),
('esro-emsdp', 642, 'tcp', 'ESRO-EMSDP V1.3'),
('sanity', 643, 'tcp', 'SANity'),
('dwr', 644, 'tcp', 'dwr'),
('pssc', 645, 'tcp', 'PSSC'),
('ldp', 646, 'tcp', 'LDP'),
('dhcp-failover', 647, 'tcp', 'DHCP Failover'),
('rrp', 648, 'tcp', 'Registry Registrar Protocol (RRP)'),
('cadview-3d', 649, 'tcp', 'Cadview-3d - streaming 3d models over the internet'),
('obex', 650, 'tcp', 'OBEX'),
('ieee-mms', 651, 'tcp', 'IEEE MMS'),
('hello-port', 652, 'tcp', 'HELLO_PORT'),
('repscmd', 653, 'tcp', 'RepCmd'),
('aodv', 654, 'tcp', 'AODV'),
('tinc', 655, 'tcp', 'TINC'),
('spmp', 656, 'tcp', 'SPMP'),
('rmc', 657, 'tcp', 'RMC'),
('tenfold', 658, 'tcp', 'TenFold'),
('mac-srvr-admin', 660, 'tcp', 'MacOS Server Admin'),
('hap', 661, 'tcp', 'HAP'),
('pftp', 662, 'tcp', 'PFTP'),
('purenoise', 663, 'tcp', 'PureNoise'),
('asf-secure-rmcp', 664, 'tcp', 'ASF Secure Remote Management and Control Protocol'),
('sun-dr', 665, 'tcp', 'Sun DR'),
('mdqs', 666, 'tcp', ''),
('doom', 666, 'tcp', 'doom Id Software'),
('disclose', 667, 'tcp', 'campaign contribution disclosures - SDR Technologies'),
('mecomm', 668, 'tcp', 'MeComm'),
('meregister', 669, 'tcp', 'MeRegister'),
('vacdsm-sws', 670, 'tcp', 'VACDSM-SWS'),
('vacdsm-app', 671, 'tcp', 'VACDSM-APP'),
('vpps-qua', 672, 'tcp', 'VPPS-QUA'),
('cimplex', 673, 'tcp', 'CIMPLEX'),
('acap', 674, 'tcp', 'ACAP'),
('dctp', 675, 'tcp', 'DCTP'),
('vpps-via', 676, 'tcp', 'VPPS Via'),
('vpp', 677, 'tcp', 'Virtual Presence Protocol'),
('ggf-ncp', 678, 'tcp', 'GNU Generation Foundation NCP'),
('mrm', 679, 'tcp', 'MRM'),
('entrust-aaas', 680, 'tcp', 'entrust-aaas'),
('entrust-aams', 681, 'tcp', 'entrust-aams'),
('xfr', 682, 'tcp', 'XFR'),
('corba-iiop', 683, 'tcp', 'CORBA IIOP'),
('corba-iiop-ssl', 684, 'tcp', 'CORBA IIOP SSL'),
('mdc-portmapper', 685, 'tcp', 'MDC Port Mapper'),
('hcp-wismar', 686, 'tcp', 'Hardware Control Protocol Wismar'),
('asipregistry', 687, 'tcp', 'asipregistry'),
('realm-rusd', 688, 'tcp', 'REALM-RUSD'),
('nmap', 689, 'tcp', 'NMAP'),
('vatp', 690, 'tcp', 'VATP'),
('msexch-routing', 691, 'tcp', 'MS Exchange Routing'),
('hyperwave-isp', 692, 'tcp', 'Hyperwave-ISP'),
('connendp', 693, 'tcp', 'connendp'),
('ha-cluster', 694, 'tcp', 'ha-cluster'),
('ieee-mms-ssl', 695, 'tcp', 'IEEE-MMS-SSL'),
('rushd', 696, 'tcp', 'RUSHD'),
('uuidgen', 697, 'tcp', 'UUIDGEN'),
('olsr', 698, 'tcp', 'OLSR'),
('accessnetwork', 699, 'tcp', 'Access Network'),
('elcsd', 704, 'tcp', 'errlog copy/server daemon'),
('agentx', 705, 'tcp', 'AgentX'),
('silc', 706, 'tcp', 'SILC'),
('borland-dsj', 707, 'tcp', 'Borland DSJ'),
('entrust-kmsh', 709, 'tcp', 'Entrust Key Management Service Handler'),
('entrust-ash', 710, 'tcp', 'Entrust Administration Service Handler'),
('cisco-tdp', 711, 'tcp', 'Cisco TDP'),
('netviewdm1', 729, 'tcp', 'IBM NetView DM/6000 Server/Client'),
('netviewdm2', 730, 'tcp', 'IBM NetView DM/6000 send/tcp'),
('netviewdm2', 730, 'udp', 'IBM NetView DM/6000 send/tcp'),
('netviewdm3', 731, 'tcp', 'IBM NetView DM/6000 receive/tcp'),
('netviewdm3', 731, 'udp', 'IBM NetView DM/6000 receive/tcp'),
('netgw', 741, 'tcp', 'netGW'),
('netrcs', 742, 'tcp', 'Network based Rev. Cont. Sys.'),
('flexlm', 744, 'tcp', 'Flexible License Manager'),
('fujitsu-dev', 747, 'tcp', 'Fujitsu Device Control'),
('ris-cm', 748, 'tcp', 'Russell Info Sci Calendar Manager'),
('kerberos-adm', 749, 'tcp', 'kerberos administration'),
('rfile', 750, 'tcp', ''),
('pump', 751, 'tcp', ''),
('qrh', 752, 'tcp', ''),
('rrh', 753, 'tcp', ''),
('tell', 754, 'tcp', 'send'),
('nlogin', 758, 'tcp', ''),
('con', 759, 'tcp', ''),
('ns', 760, 'tcp', ''),
('rxe', 761, 'tcp', ''),
('quotad', 762, 'tcp', ''),
('cycleserv', 763, 'tcp', ''),
('omserv', 764, 'tcp', ''),
('webster', 765, 'tcp', ''),
('phonebook', 767, 'tcp', 'phone'),
('vid', 769, 'tcp', ''),
('cadlock', 770, 'tcp', ''),
('rtip', 771, 'tcp', ''),
('cycleserv2', 772, 'tcp', ''),
('submit', 773, 'tcp', ''),
('rpasswd', 774, 'tcp', ''),
('entomb', 775, 'tcp', ''),
('wpages', 776, 'tcp', ''),
('multiling-http', 777, 'tcp', 'Multiling HTTP'),
('wpgs', 780, 'tcp', ''),
('qsc', 787, 'tcp', 'QSC'),
('mdbs_daemon', 800, 'tcp', ''),
('device', 801, 'tcp', ''),
('fcp-udp', 810, 'tcp', 'FCP'),
('itm-mcell-s', 828, 'tcp', 'itm-mcell-s'),
('pkix-3-ca-ra', 829, 'tcp', 'PKIX-3 CA/RA'),
('dhcp-failover2', 847, 'tcp', 'dhcp-failover 2'),
('rsync', 873, 'tcp', 'rsync'),
('iclcnet-locate', 886, 'tcp', 'ICL coNETion locate server'),
('iclcnet_svinfo', 887, 'tcp', 'ICL coNETion server info'),
('accessbuilder', 888, 'tcp', 'AccessBuilder'),
('cddbp', 888, 'tcp', 'CD Database Protocol'),
('omginitialrefs', 900, 'tcp', 'OMG Initial Refs'),
('smpnameres', 901, 'tcp', 'SMPNAMERES'),
('ideafarm-chat', 902, 'tcp', 'IDEAFARM-CHAT'),
('ideafarm-catch', 903, 'tcp', 'IDEAFARM-CATCH'),
('xact-backup', 911, 'tcp', 'xact-backup'),
('apex-mesh', 912, 'tcp', 'APEX relay-relay service'),
('apex-edge', 913, 'tcp', 'APEX endpoint-relay service'),
('ftps-data', 989, 'tcp', 'ftp protocol, data, over TLS/SSL'),
('ftps', 990, 'tcp', 'ftp protocol, control, over TLS/SSL'),
('nas', 991, 'tcp', 'Netnews Administration System'),
('telnets', 992, 'tcp', 'telnet protocol over TLS/SSL'),
('imaps', 993, 'tcp', 'imap4 protocol over TLS/SSL'),
('ircs', 994, 'tcp', 'irc protocol over TLS/SSL'),
('pop3s', 995, 'tcp', 'pop3 protocol over TLS/SSL (was spop3)'),
('vsinet', 996, 'tcp', 'vsinet'),
('maitrd', 997, 'tcp', ''),
('busboy', 998, 'tcp', ''),
('garcon', 999, 'tcp', ''),
('puprouter', 999, 'tcp', ''),
('cadlock2', 1000, 'tcp', ''),
('surf', 1010, 'tcp', 'surf'),
('', 1023, 'tcp', 'Reserved'),
('', 1024, 'tcp', 'Reserved'),
('blackjack', 1025, 'tcp', 'network blackjack'),
('cap', 1026, 'tcp', 'Calender Access Protocol'),
('iad1', 1030, 'tcp', 'BBN IAD'),
('iad2', 1031, 'tcp', 'BBN IAD'),
('iad3', 1032, 'tcp', 'BBN IAD'),
('pcg-radar', 1036, 'tcp', 'RADAR Service Protocol'),
('netarx', 1040, 'tcp', 'Netarx'),
('fpitp', 1045, 'tcp', 'Fingerprint Image Transfer Protocol'),
('neod1', 1047, 'tcp', 'Suns NEO Object Request Broker'),
('neod2', 1048, 'tcp', 'Suns NEO Object Request Broker'),
('td-postman', 1049, 'tcp', 'Tobit David Postman VPMN'),
('cma', 1050, 'tcp', 'CORBA Management Agent'),
('optima-vnet', 1051, 'tcp', 'Optima VNET'),
('ddt', 1052, 'tcp', 'Dynamic DNS Tools'),
('remote-as', 1053, 'tcp', 'Remote Assistant (RA)'),
('brvread', 1054, 'tcp', 'BRVREAD'),
('ansyslmd', 1055, 'tcp', 'ANSYS - License Manager'),
('vfo', 1056, 'tcp', 'VFO'),
('startron', 1057, 'tcp', 'STARTRON'),
('nim', 1058, 'tcp', 'nim'),
('nimreg', 1059, 'tcp', 'nimreg'),
('polestar', 1060, 'tcp', 'POLESTAR'),
('kiosk', 1061, 'tcp', 'KIOSK'),
('veracity', 1062, 'tcp', 'Veracity'),
('kyoceranetdev', 1063, 'tcp', 'KyoceraNetDev'),
('jstel', 1064, 'tcp', 'JSTEL'),
('syscomlan', 1065, 'tcp', 'SYSCOMLAN'),
('fpo-fns', 1066, 'tcp', 'FPO-FNS'),
('instl_boots', 1067, 'tcp', 'Installation Bootstrap Proto. Serv.'),
('instl_bootc', 1068, 'tcp', 'Installation Bootstrap Proto. Cli.'),
('cognex-insight', 1069, 'tcp', 'COGNEX-INSIGHT'),
('gmrupdateserv', 1070, 'tcp', 'GMRUpdateSERV'),
('bsquare-voip', 1071, 'tcp', 'BSQUARE-VOIP'),
('cardax', 1072, 'tcp', 'CARDAX'),
('bridgecontrol', 1073, 'tcp', 'Bridge Control'),
('fastechnologlm', 1074, 'tcp', 'FASTechnologies License Manager'),
('rdrmshc', 1075, 'tcp', 'RDRMSHC'),
('dab-sti-c', 1076, 'tcp', 'DAB STI-C'),
('imgames', 1077, 'tcp', 'IMGames'),
('emanagecstp', 1078, 'tcp', 'eManageCstp'),
('asprovatalk', 1079, 'tcp', 'ASPROVATalk'),
('socks', 1080, 'tcp', 'Socks'),
('pvuniwien', 1081, 'tcp', 'PVUNIWIEN'),
('amt-esd-prot', 1082, 'tcp', 'AMT-ESD-PROT'),
('ansoft-lm-1', 1083, 'tcp', 'Anasoft License Manager'),
('ansoft-lm-2', 1084, 'tcp', 'Anasoft License Manager'),
('webobjects', 1085, 'tcp', 'Web Objects'),
('cplscrambler-lg', 1086, 'tcp', 'CPL Scrambler Logging'),
('cplscrambler-in', 1087, 'tcp', 'CPL Scrambler Internal'),
('cplscrambler-al', 1088, 'tcp', 'CPL Scrambler Alarm Log'),
('ff-annunc', 1089, 'tcp', 'FF Annunciation'),
('ff-fms', 1090, 'tcp', 'FF Fieldbus Message Specification'),
('ff-sm', 1091, 'tcp', 'FF System Management'),
('obrpd', 1092, 'tcp', 'Open Business Reporting Protocol'),
('proofd', 1093, 'tcp', 'PROOFD'),
('rootd', 1094, 'tcp', 'ROOTD'),
('nicelink', 1095, 'tcp', 'NICELink'),
('cnrprotocol', 1096, 'tcp', 'Common Name Resolution Protocol'),
('sunclustermgr', 1097, 'tcp', 'Sun Cluster Manager'),
('rmiactivation', 1098, 'tcp', 'RMI Activation'),
('rmiregistry', 1099, 'tcp', 'RMI Registry'),
('mctp', 1100, 'tcp', 'MCTP'),
('pt2-discover', 1101, 'tcp', 'PT2-DISCOVER'),
('adobeserver-1', 1102, 'tcp', 'ADOBE SERVER 1'),
('adobeserver-2', 1103, 'tcp', 'ADOBE SERVER 2'),
('xrl', 1104, 'tcp', 'XRL'),
('ftranhc', 1105, 'tcp', 'FTRANHC'),
('isoipsigport-1', 1106, 'tcp', 'ISOIPSIGPORT-1'),
('isoipsigport-2', 1107, 'tcp', 'ISOIPSIGPORT-2'),
('ratio-adp', 1108, 'tcp', 'ratio-adp'),
('nfsd-status', 1110, 'tcp', 'Cluster status info'),
('lmsocialserver', 1111, 'tcp', 'LM Social Server'),
('icp', 1112, 'tcp', 'Intelligent Communication Protocol'),
('mini-sql', 1114, 'tcp', 'Mini SQL'),
('ardus-trns', 1115, 'tcp', 'ARDUS Transfer'),
('ardus-cntl', 1116, 'tcp', 'ARDUS Control'),
('ardus-mtrns', 1117, 'tcp', 'ARDUS Multicast Transfer'),
('availant-mgr', 1122, 'tcp', 'availant-mgr'),
('murray', 1123, 'tcp', 'Murray'),
('nfa', 1155, 'tcp', 'Network File Access'),
('health-polling', 1161, 'tcp', 'Health Polling'),
('health-trap', 1162, 'tcp', 'Health Trap'),
('tripwire', 1169, 'tcp', 'TRIPWIRE'),
('mc-client', 1180, 'tcp', 'Millicent Client Proxy'),
('llsurfup-http', 1183, 'tcp', 'LL Surfup HTTP'),
('llsurfup-https', 1184, 'tcp', 'LL Surfup HTTPS'),
('catchpole', 1185, 'tcp', 'Catchpole port'),
('hp-webadmin', 1188, 'tcp', 'HP Web Admin'),
('dmidi', 1199, 'tcp', 'DMIDI'),
('scol', 1200, 'tcp', 'SCOL'),
('nucleus-sand', 1201, 'tcp', 'Nucleus Sand'),
('caiccipc', 1202, 'tcp', 'caiccipc'),
('ssslic-mgr', 1203, 'tcp', 'License Validation'),
('ssslog-mgr', 1204, 'tcp', 'Log Request Listener'),
('accord-mgc', 1205, 'tcp', 'Accord-MGC'),
('anthony-data', 1206, 'tcp', 'Anthony Data'),
('metasage', 1207, 'tcp', 'MetaSage'),
('seagull-ais', 1208, 'tcp', 'SEAGULL AIS'),
('ipcd3', 1209, 'tcp', 'IPCD3'),
('eoss', 1210, 'tcp', 'EOSS'),
('groove-dpp', 1211, 'tcp', 'Groove DPP'),
('lupa', 1212, 'tcp', 'lupa'),
('mpc-lifenet', 1213, 'tcp', 'MPC LIFENET'),
('kazaa', 1214, 'tcp', 'KAZAA'),
('scanstat-1', 1215, 'tcp', 'scanSTAT 1.0'),
('etebac5', 1216, 'tcp', 'ETEBAC 5'),
('hpss-ndapi', 1217, 'tcp', 'HPSS-NDAPI'),
('aeroflight-ads', 1218, 'tcp', 'AeroFlight-ADs'),
('aeroflight-ret', 1219, 'tcp', 'AeroFlight-Ret'),
('qt-serveradmin', 1220, 'tcp', 'QT SERVER ADMIN'),
('sweetware-apps', 1221, 'tcp', 'SweetWARE Apps'),
('nerv', 1222, 'tcp', 'SNI R&D network'),
('tgp', 1223, 'tcp', 'TGP'),
('vpnz', 1224, 'tcp', 'VPNz'),
('slinkysearch', 1225, 'tcp', 'SLINKYSEARCH'),
('stgxfws', 1226, 'tcp', 'STGXFWS'),
('dns2go', 1227, 'tcp', 'DNS2Go'),
('florence', 1228, 'tcp', 'FLORENCE'),
('novell-zfs', 1229, 'tcp', 'Novell ZFS'),
('periscope', 1230, 'tcp', 'Periscope'),
('menandmice-lpm', 1231, 'tcp', 'menandmice-lpm'),
('univ-appserver', 1233, 'tcp', 'Universal App Server'),
('search-agent', 1234, 'tcp', 'Infoseek Search Agent'),
('mosaicsyssvc1', 1235, 'tcp', 'mosaicsyssvc1'),
('bvcontrol', 1236, 'tcp', 'bvcontrol'),
('tsdos390', 1237, 'tcp', 'tsdos390'),
('hacl-qs', 1238, 'tcp', 'hacl-qs'),
('nmsd', 1239, 'tcp', 'NMSD'),
('instantia', 1240, 'tcp', 'Instantia'),
('nessus', 1241, 'tcp', 'nessus'),
('nmasoverip', 1242, 'tcp', 'NMAS over IP'),
('serialgateway', 1243, 'tcp', 'SerialGateway'),
('isbconference1', 1244, 'tcp', 'isbconference1'),
('isbconference2', 1245, 'tcp', 'isbconference2'),
('payrouter', 1246, 'tcp', 'payrouter'),
('visionpyramid', 1247, 'tcp', 'VisionPyramid'),
('hermes', 1248, 'tcp', 'hermes'),
('mesavistaco', 1249, 'tcp', 'Mesa Vista Co'),
('swldy-sias', 1250, 'tcp', 'swldy-sias'),
('servergraph', 1251, 'tcp', 'servergraph'),
('bspne-pcc', 1252, 'tcp', 'bspne-pcc'),
('q55-pcc', 1253, 'tcp', 'q55-pcc'),
('de-noc', 1254, 'tcp', 'de-noc'),
('de-cache-query', 1255, 'tcp', 'de-cache-query'),
('de-server', 1256, 'tcp', 'de-server'),
('shockwave2', 1257, 'tcp', 'Shockwave 2'),
('opennl', 1258, 'tcp', 'Open Network Library'),
('opennl-voice', 1259, 'tcp', 'Open Network Library Voice'),
('ibm-ssd', 1260, 'tcp', 'ibm-ssd'),
('mpshrsv', 1261, 'tcp', 'mpshrsv'),
('qnts-orb', 1262, 'tcp', 'QNTS-ORB'),
('dka', 1263, 'tcp', 'dka'),
('prat', 1264, 'tcp', 'PRAT'),
('dssiapi', 1265, 'tcp', 'DSSIAPI'),
('dellpwrappks', 1266, 'tcp', 'DELLPWRAPPKS'),
('pcmlinux', 1267, 'tcp', 'pcmlinux'),
('propel-msgsys', 1268, 'tcp', 'PROPEL-MSGSYS'),
('watilapp', 1269, 'tcp', 'WATiLaPP'),
('opsman', 1270, 'tcp', 'opsman'),
('dabew', 1271, 'tcp', 'Dabew'),
('cspmlockmgr', 1272, 'tcp', 'CSPMLockMgr'),
('emc-gateway', 1273, 'tcp', 'EMC-Gateway'),
('t1distproc', 1274, 'tcp', 't1distproc'),
('ivcollector', 1275, 'tcp', 'ivcollector'),
('ivmanager', 1276, 'tcp', 'ivmanager'),
('miva-mqs', 1277, 'tcp', 'mqs'),
('dellwebadmin-1', 1278, 'tcp', 'Dell Web Admin 1'),
('dellwebadmin-2', 1279, 'tcp', 'Dell Web Admin 2'),
('pictrography', 1280, 'tcp', 'Pictrography'),
('healthd', 1281, 'tcp', 'healthd'),
('emperion', 1282, 'tcp', 'Emperion'),
('productinfo', 1283, 'tcp', 'ProductInfo'),
('iee-qfx', 1284, 'tcp', 'IEE-QFX'),
('neoiface', 1285, 'tcp', 'neoiface'),
('netuitive', 1286, 'tcp', 'netuitive'),
('navbuddy', 1288, 'tcp', 'NavBuddy'),
('jwalkserver', 1289, 'tcp', 'JWalkServer'),
('winjaserver', 1290, 'tcp', 'WinJaServer'),
('seagulllms', 1291, 'tcp', 'SEAGULLLMS'),
('dsdn', 1292, 'tcp', 'dsdn'),
('pkt-krb-ipsec', 1293, 'tcp', 'PKT-KRB-IPSec'),
('cmmdriver', 1294, 'tcp', 'CMMdriver'),
('ehtp', 1295, 'tcp', 'End-by-Hop Transmission Protocol'),
('dproxy', 1296, 'tcp', 'dproxy'),
('sdproxy', 1297, 'tcp', 'sdproxy'),
('lpcp', 1298, 'tcp', 'lpcp'),
('hp-sci', 1299, 'tcp', 'hp-sci'),
('h323hostcallsc', 1300, 'tcp', 'H323 Host Call Secure'),
('ci3-software-1', 1301, 'tcp', 'CI3-Software-1'),
('ci3-software-2', 1302, 'tcp', 'CI3-Software-2'),
('sftsrv', 1303, 'tcp', 'sftsrv'),
('boomerang', 1304, 'tcp', 'Boomerang'),
('pe-mike', 1305, 'tcp', 'pe-mike'),
('re-conn-proto', 1306, 'tcp', 'RE-Conn-Proto'),
('pacmand', 1307, 'tcp', 'Pacmand'),
('odsi', 1308, 'tcp', 'Optical Domain Service Interconnect (ODSI)'),
('jtag-server', 1309, 'tcp', 'JTAG server'),
('husky', 1310, 'tcp', 'Husky'),
('rxmon', 1311, 'tcp', 'RxMon'),
('sti-envision', 1312, 'tcp', 'STI Envision'),
('bmc_patroldb', 1313, 'tcp', 'BMC_PATROLDB'),
('pdps', 1314, 'tcp', 'Photoscript Distributed Printing System'),
('els', 1315, 'tcp', 'E.L.S., Event Listener Service'),
('exbit-escp', 1316, 'tcp', 'Exbit-ESCP'),
('vrts-ipcserver', 1317, 'tcp', 'vrts-ipcserver'),
('krb5gatekeeper', 1318, 'tcp', 'krb5gatekeeper'),
('panja-icsp', 1319, 'tcp', 'Panja-ICSP'),
('panja-axbnet', 1320, 'tcp', 'Panja-AXBNET'),
('pip', 1321, 'tcp', 'PIP'),
('novation', 1322, 'tcp', 'Novation'),
('brcd', 1323, 'tcp', 'brcd'),
('delta-mcp', 1324, 'tcp', 'delta-mcp'),
('dx-instrument', 1325, 'tcp', 'DX-Instrument'),
('wimsic', 1326, 'tcp', 'WIMSIC'),
('ultrex', 1327, 'tcp', 'Ultrex'),
('ewall', 1328, 'tcp', 'EWALL'),
('netdb-export', 1329, 'tcp', 'netdb-export'),
('streetperfect', 1330, 'tcp', 'StreetPerfect'),
('intersan', 1331, 'tcp', 'intersan'),
('pcia-rxp-b', 1332, 'tcp', 'PCIA RXP-B'),
('passwrd-policy', 1333, 'tcp', 'Password Policy'),
('writesrv', 1334, 'tcp', 'writesrv'),
('digital-notary', 1335, 'tcp', 'Digital Notary Protocol'),
('ischat', 1336, 'tcp', 'Instant Service Chat'),
('menandmice-dns', 1337, 'tcp', 'menandmice DNS'),
('wmc-log-svc', 1338, 'tcp', 'WMC-log-svr'),
('kjtsiteserver', 1339, 'tcp', 'kjtsiteserver'),
('naap', 1340, 'tcp', 'NAAP'),
('qubes', 1341, 'tcp', 'QuBES'),
('esbroker', 1342, 'tcp', 'ESBroker'),
('re101', 1343, 'tcp', 're101'),
('icap', 1344, 'tcp', 'ICAP'),
('vpjp', 1345, 'tcp', 'VPJP'),
('alta-ana-lm', 1346, 'tcp', 'Alta Analytics License Manager'),
('bbn-mmc', 1347, 'tcp', 'multi media conferencing'),
('bbn-mmx', 1348, 'tcp', 'multi media conferencing'),
('sbook', 1349, 'tcp', 'Registration Network Protocol'),
('editbench', 1350, 'tcp', 'Registration Network Protocol'),
('equationbuilder', 1351, 'tcp', 'Digital Tool Works (MIT)'),
('lotusnote', 1352, 'tcp', 'Lotus Note'),
('relief', 1353, 'tcp', 'Relief Consulting'),
('rightbrain', 1354, 'tcp', 'RightBrain Software'),
('intuitive-edge', 1355, 'tcp', 'Intuitive Edge'),
('cuillamartin', 1356, 'tcp', 'CuillaMartin Company'),
('pegboard', 1357, 'tcp', 'Electronic PegBoard'),
('connlcli', 1358, 'tcp', 'CONNLCLI'),
('ftsrv', 1359, 'tcp', 'FTSRV'),
('mimer', 1360, 'tcp', 'MIMER'),
('linx', 1361, 'tcp', 'LinX'),
('timeflies', 1362, 'tcp', 'TimeFlies'),
('ndm-requester', 1363, 'tcp', 'Network DataMover Requester'),
('ndm-server', 1364, 'tcp', 'Network DataMover Server'),
('adapt-sna', 1365, 'tcp', 'Network Software Associates'),
('netware-csp', 1366, 'tcp', 'Novell NetWare Comm Service Platform'),
('dcs', 1367, 'tcp', 'DCS'),
('screencast', 1368, 'tcp', 'ScreenCast'),
('gv-us', 1369, 'tcp', 'GlobalView to Unix Shell'),
('us-gv', 1370, 'tcp', 'Unix Shell to GlobalView'),
('fc-cli', 1371, 'tcp', 'Fujitsu Config Protocol'),
('fc-ser', 1372, 'tcp', 'Fujitsu Config Protocol'),
('chromagrafx', 1373, 'tcp', 'Chromagrafx'),
('molly', 1374, 'tcp', 'EPI Software Systems'),
('bytex', 1375, 'tcp', 'Bytex'),
('ibm-pps', 1376, 'tcp', 'IBM Person to Person Software'),
('cichlid', 1377, 'tcp', 'Cichlid License Manager'),
('elan', 1378, 'tcp', 'Elan License Manager'),
('dbreporter', 1379, 'tcp', 'Integrity Solutions'),
('telesis-licman', 1380, 'tcp', 'Telesis Network License Manager'),
('apple-licman', 1381, 'tcp', 'Apple Network License Manager'),
('udt_os', 1382, 'tcp', 'udt_os'),
('gwha', 1383, 'tcp', 'GW Hannaway Network License Manager'),
('os-licman', 1384, 'tcp', 'Objective Solutions License Manager'),
('atex_elmd', 1385, 'tcp', 'Atex Publishing License Manager'),
('checksum', 1386, 'tcp', 'CheckSum License Manager'),
('cadsi-lm', 1387, 'tcp', 'Computer Aided Design Software Inc LM'),
('objective-dbc', 1388, 'tcp', 'Objective Solutions DataBase Cache'),
('iclpv-dm', 1389, 'tcp', 'Document Manager'),
('iclpv-sc', 1390, 'tcp', 'Storage Controller'),
('iclpv-sas', 1391, 'tcp', 'Storage Access Server'),
('iclpv-pm', 1392, 'tcp', 'Print Manager'),
('iclpv-nls', 1393, 'tcp', 'Network Log Server'),
('iclpv-nlc', 1394, 'tcp', 'Network Log Client'),
('iclpv-wsm', 1395, 'tcp', 'PC Workstation Manager software'),
('dvl-activemail', 1396, 'tcp', 'DVL Active Mail'),
('audio-activmail', 1397, 'tcp', 'Audio Active Mail'),
('video-activmail', 1398, 'tcp', 'Video Active Mail'),
('cadkey-licman', 1399, 'tcp', 'Cadkey License Manager'),
('cadkey-tablet', 1400, 'tcp', 'Cadkey Tablet Daemon'),
('goldleaf-licman', 1401, 'tcp', 'Goldleaf License Manager'),
('prm-sm-np', 1402, 'tcp', 'Prospero Resource Manager'),
('prm-nm-np', 1403, 'tcp', 'Prospero Resource Manager'),
('igi-lm', 1404, 'tcp', 'Infinite Graphics License Manager'),
('ibm-res', 1405, 'tcp', 'IBM Remote Execution Starter'),
('netlabs-lm', 1406, 'tcp', 'NetLabs License Manager'),
('dbsa-lm', 1407, 'tcp', 'DBSA License Manager'),
('sophia-lm', 1408, 'tcp', 'Sophia License Manager'),
('here-lm', 1409, 'tcp', 'Here License Manager'),
('hiq', 1410, 'tcp', 'HiQ License Manager'),
('af', 1411, 'tcp', 'AudioFile'),
('innosys', 1412, 'tcp', 'InnoSys'),
('innosys-acl', 1413, 'tcp', 'Innosys-ACL'),
('ibm-mqseries', 1414, 'tcp', 'IBM MQSeries'),
('dbstar', 1415, 'tcp', 'DBStar'),
('novell-lu6.2', 1416, 'tcp', 'Novell LU6.2'),
('timbuktu-srv1', 1417, 'tcp', 'Timbuktu Service 1 Port'),
('timbuktu-srv2', 1418, 'tcp', 'Timbuktu Service 2 Port'),
('timbuktu-srv3', 1419, 'tcp', 'Timbuktu Service 3 Port'),
('timbuktu-srv4', 1420, 'tcp', 'Timbuktu Service 4 Port'),
('gandalf-lm', 1421, 'tcp', 'Gandalf License Manager'),
('autodesk-lm', 1422, 'tcp', 'Autodesk License Manager'),
('essbase', 1423, 'tcp', 'Essbase Arbor Software'),
('hybrid', 1424, 'tcp', 'Hybrid Encryption Protocol'),
('zion-lm', 1425, 'tcp', 'Zion Software License Manager'),
('sais', 1426, 'tcp', 'Satellite-data Acquisition System 1'),
('mloadd', 1427, 'tcp', 'mloadd monitoring tool'),
('informatik-lm', 1428, 'tcp', 'Informatik License Manager'),
('nms', 1429, 'tcp', 'Hypercom NMS'),
('tpdu', 1430, 'tcp', 'Hypercom TPDU'),
('rgtp', 1431, 'tcp', 'Reverse Gossip Transport'),
('blueberry-lm', 1432, 'tcp', 'Blueberry Software License Manager'),
('ms-sql-s', 1433, 'tcp', 'Microsoft-SQL-Server'),
('ms-sql-m', 1434, 'tcp', 'Microsoft-SQL-Monitor'),
('ibm-cics', 1435, 'tcp', 'IBM CICS'),
('saism', 1436, 'tcp', 'Satellite-data Acquisition System 2'),
('tabula', 1437, 'tcp', 'Tabula'),
('eicon-server', 1438, 'tcp', 'Eicon Security Agent/Server'),
('eicon-x25', 1439, 'tcp', 'Eicon X25/SNA Gateway'),
('eicon-slp', 1440, 'tcp', 'Eicon Service Location Protocol'),
('cadis-1', 1441, 'tcp', 'Cadis License Management'),
('cadis-2', 1442, 'tcp', 'Cadis License Management'),
('ies-lm', 1443, 'tcp', 'Integrated Engineering Software'),
('marcam-lm', 1444, 'tcp', 'Marcam License Management'),
('proxima-lm', 1445, 'tcp', 'Proxima License Manager'),
('ora-lm', 1446, 'tcp', 'Optical Research Associates License Manager'),
('apri-lm', 1447, 'tcp', 'Applied Parallel Research LM'),
('oc-lm', 1448, 'tcp', 'OpenConnect License Manager'),
('peport', 1449, 'tcp', 'PEport'),
('dwf', 1450, 'tcp', 'Tandem Distributed Workbench Facility'),
('infoman', 1451, 'tcp', 'IBM Information Management'),
('gtegsc-lm', 1452, 'tcp', 'GTE Government Systems License Man'),
('genie-lm', 1453, 'tcp', 'Genie License Manager'),
('interhdl_elmd', 1454, 'tcp', 'interHDL License Manager'),
('esl-lm', 1455, 'tcp', 'ESL License Manager'),
('dca', 1456, 'tcp', 'DCA'),
('valisys-lm', 1457, 'tcp', 'Valisys License Manager'),
('nrcabq-lm', 1458, 'tcp', 'Nichols Research Corp.'),
('proshare1', 1459, 'tcp', 'Proshare Notebook Application'),
('proshare2', 1460, 'tcp', 'Proshare Notebook Application'),
('ibm_wrless_lan', 1461, 'tcp', 'IBM Wireless LAN'),
('world-lm', 1462, 'tcp', 'World License Manager'),
('nucleus', 1463, 'tcp', 'Nucleus'),
('msl_lmd', 1464, 'tcp', 'MSL License Manager'),
('pipes', 1465, 'tcp', 'Pipes Platform'),
('oceansoft-lm', 1466, 'tcp', 'Ocean Software License Manager'),
('csdmbase', 1467, 'tcp', 'CSDMBASE'),
('csdm', 1468, 'tcp', 'CSDM'),
('aal-lm', 1469, 'tcp', 'Active Analysis Limited License Manager'),
('uaiact', 1470, 'tcp', 'Universal Analytics'),
('csdmbase', 1471, 'tcp', 'csdmbase'),
('csdm', 1472, 'tcp', 'csdm'),
('openmath', 1473, 'tcp', 'OpenMath'),
('telefinder', 1474, 'tcp', 'Telefinder'),
('taligent-lm', 1475, 'tcp', 'Taligent License Manager'),
('clvm-cfg', 1476, 'tcp', 'clvm-cfg'),
('ms-sna-server', 1477, 'tcp', 'ms-sna-server'),
('ms-sna-base', 1478, 'tcp', 'ms-sna-base'),
('dberegister', 1479, 'tcp', 'dberegister'),
('pacerforum', 1480, 'tcp', 'PacerForum'),
('airs', 1481, 'tcp', 'AIRS'),
('miteksys-lm', 1482, 'tcp', 'Miteksys License Manager'),
('afs', 1483, 'tcp', 'AFS License Manager'),
('confluent', 1484, 'tcp', 'Confluent License Manager'),
('lansource', 1485, 'tcp', 'LANSource'),
('nms_topo_serv', 1486, 'tcp', 'nms_topo_serv'),
('localinfosrvr', 1487, 'tcp', 'LocalInfoSrvr'),
('docstor', 1488, 'tcp', 'DocStor'),
('dmdocbroker', 1489, 'tcp', 'dmdocbroker'),
('insitu-conf', 1490, 'tcp', 'insitu-conf'),
('anynetgateway', 1491, 'tcp', 'anynetgateway'),
('stone-design-1', 1492, 'tcp', 'stone-design-1'),
('netmap_lm', 1493, 'tcp', 'netmap_lm'),
('ica', 1494, 'tcp', 'ica'),
('cvc', 1495, 'tcp', 'cvc'),
('liberty-lm', 1496, 'tcp', 'liberty-lm'),
('rfx-lm', 1497, 'tcp', 'rfx-lm'),
('sybase-sqlany', 1498, 'tcp', 'Sybase SQL Any'),
('fhc', 1499, 'tcp', 'Federico Heinz Consultora'),
('vlsi-lm', 1500, 'tcp', 'VLSI License Manager'),
('saiscm', 1501, 'tcp', 'Satellite-data Acquisition System 3'),
('shivadiscovery', 1502, 'tcp', 'Shiva'),
('imtc-mcs', 1503, 'tcp', 'Databeam'),
('evb-elm', 1504, 'tcp', 'EVB Software Engineering License Manager'),
('funkproxy', 1505, 'tcp', 'Funk Software, Inc.'),
('utcd', 1506, 'tcp', 'Universal Time daemon (utcd)'),
('symplex', 1507, 'tcp', 'symplex'),
('diagmond', 1508, 'tcp', 'diagmond'),
('robcad-lm', 1509, 'tcp', 'Robcad, Ltd. License Manager'),
('mvx-lm', 1510, 'tcp', 'Midland Valley Exploration Ltd. Lic. Man.'),
('3l-l1', 1511, 'tcp', '3l-l1'),
('wins', 1512, 'tcp', 'Microsofts Windows Internet Name Service'),
('fujitsu-dtc', 1513, 'tcp', 'Fujitsu Systems Business of America, Inc'),
('fujitsu-dtcns', 1514, 'tcp', 'Fujitsu Systems Business of America, Inc'),
('ifor-protocol', 1515, 'tcp', 'ifor-protocol'),
('vpad', 1516, 'tcp', 'Virtual Places Audio data'),
('vpac', 1517, 'tcp', 'Virtual Places Audio control'),
('vpvd', 1518, 'tcp', 'Virtual Places Video data'),
('vpvc', 1519, 'tcp', 'Virtual Places Video control'),
('atm-zip-office', 1520, 'tcp', 'atm zip office'),
('ncube-lm', 1521, 'tcp', 'nCube License Manager'),
('ricardo-lm', 1522, 'tcp', 'Ricardo North America License Manager'),
('cichild-lm', 1523, 'tcp', 'cichild'),
('ingreslock', 1524, 'tcp', 'ingres'),
('orasrv', 1525, 'tcp', 'oracle'),
('prospero-np', 1525, 'tcp', 'Prospero Directory Service non-priv'),
('pdap-np', 1526, 'tcp', 'Prospero Data Access Prot non-priv'),
('tlisrv', 1527, 'tcp', 'oracle'),
('mciautoreg', 1528, 'tcp', 'micautoreg'),
('coauthor', 1529, 'tcp', 'oracle'),
('rap-service', 1530, 'tcp', 'rap-service'),
('rap-listen', 1531, 'tcp', 'rap-listen'),
('miroconnect', 1532, 'tcp', 'miroconnect'),
('virtual-places', 1533, 'tcp', 'Virtual Places Software'),
('micromuse-lm', 1534, 'tcp', 'micromuse-lm'),
('ampr-info', 1535, 'tcp', 'ampr-info'),
('ampr-inter', 1536, 'tcp', 'ampr-inter'),
('sdsc-lm', 1537, 'tcp', 'isi-lm'),
('3ds-lm', 1538, 'tcp', '3ds-lm'),
('intellistor-lm', 1539, 'tcp', 'Intellistor License Manager'),
('rds', 1540, 'tcp', 'rds'),
('rds2', 1541, 'tcp', 'rds2'),
('gridgen-elmd', 1542, 'tcp', 'gridgen-elmd'),
('simba-cs', 1543, 'tcp', 'simba-cs'),
('aspeclmd', 1544, 'tcp', 'aspeclmd'),
('vistium-share', 1545, 'tcp', 'vistium-share'),
('abbaccuray', 1546, 'tcp', 'abbaccuray'),
('laplink', 1547, 'tcp', 'laplink'),
('axon-lm', 1548, 'tcp', 'Axon License Manager'),
('shivahose', 1549, 'tcp', 'Shiva Hose'),
('3m-image-lm', 1550, 'tcp', 'Image Storage license manager 3M Company'),
('hecmtl-db', 1551, 'tcp', 'HECMTL-DB'),
('pciarray', 1552, 'tcp', 'pciarray'),
('sna-cs', 1553, 'tcp', 'sna-cs'),
('caci-lm', 1554, 'tcp', 'CACI Products Company License Manager'),
('livelan', 1555, 'tcp', 'livelan'),
('ashwin', 1556, 'tcp', 'AshWin CI Tecnologies'),
('arbortext-lm', 1557, 'tcp', 'ArborText License Manager'),
('xingmpeg', 1558, 'tcp', 'xingmpeg'),
('web2host', 1559, 'tcp', 'web2host'),
('asci-val', 1560, 'tcp', 'asci-val'),
('facilityview', 1561, 'tcp', 'facilityview'),
('pconnectmgr', 1562, 'tcp', 'pconnectmgr'),
('cadabra-lm', 1563, 'tcp', 'Cadabra License Manager'),
('pay-per-view', 1564, 'tcp', 'Pay-Per-View'),
('winddlb', 1565, 'tcp', 'WinDD'),
('corelvideo', 1566, 'tcp', 'CORELVIDEO'),
('jlicelmd', 1567, 'tcp', 'jlicelmd'),
('tsspmap', 1568, 'tcp', 'tsspmap'),
('ets', 1569, 'tcp', 'ets'),
('orbixd', 1570, 'tcp', 'orbixd'),
('rdb-dbs-disp', 1571, 'tcp', 'Oracle Remote Data Base'),
('chip-lm', 1572, 'tcp', 'Chipcom License Manager'),
('itscomm-ns', 1573, 'tcp', 'itscomm-ns'),
('mvel-lm', 1574, 'tcp', 'mvel-lm'),
('oraclenames', 1575, 'tcp', 'oraclenames'),
('moldflow-lm', 1576, 'tcp', 'moldflow-lm'),
('hypercube-lm', 1577, 'tcp', 'hypercube-lm'),
('jacobus-lm', 1578, 'tcp', 'Jacobus License Manager'),
('ioc-sea-lm', 1579, 'tcp', 'ioc-sea-lm'),
('tn-tl-r1', 1580, 'tcp', 'tn-tl-r1'),
('mil-2045-47001', 1581, 'tcp', 'MIL-2045-47001'),
('msims', 1582, 'tcp', 'MSIMS'),
('simbaexpress', 1583, 'tcp', 'simbaexpress'),
('tn-tl-fd2', 1584, 'tcp', 'tn-tl-fd2'),
('intv', 1585, 'tcp', 'intv'),
('ibm-abtact', 1586, 'tcp', 'ibm-abtact'),
('pra_elmd', 1587, 'tcp', 'pra_elmd'),
('triquest-lm', 1588, 'tcp', 'triquest-lm'),
('vqp', 1589, 'tcp', 'VQP'),
('gemini-lm', 1590, 'tcp', 'gemini-lm'),
('ncpm-pm', 1591, 'tcp', 'ncpm-pm'),
('commonspace', 1592, 'tcp', 'commonspace'),
('mainsoft-lm', 1593, 'tcp', 'mainsoft-lm'),
('sixtrak', 1594, 'tcp', 'sixtrak'),
('radio', 1595, 'tcp', 'radio'),
('radio-sm', 1596, 'tcp', 'radio-sm'),
('orbplus-iiop', 1597, 'tcp', 'orbplus-iiop'),
('picknfs', 1598, 'tcp', 'picknfs'),
('simbaservices', 1599, 'tcp', 'simbaservices'),
('issd', 1600, 'tcp', ''),
('aas', 1601, 'tcp', 'aas'),
('inspect', 1602, 'tcp', 'inspect'),
('picodbc', 1603, 'tcp', 'pickodbc'),
('icabrowser', 1604, 'tcp', 'icabrowser'),
('slp', 1605, 'tcp', 'Salutation Manager (Salutation Protocol)'),
('slm-api', 1606, 'tcp', 'Salutation Manager (SLM-API)'),
('stt', 1607, 'tcp', 'stt'),
('smart-lm', 1608, 'tcp', 'Smart Corp. License Manager'),
('isysg-lm', 1609, 'tcp', 'isysg-lm'),
('taurus-wh', 1610, 'tcp', 'taurus-wh'),
('ill', 1611, 'tcp', 'Inter Library Loan'),
('netbill-trans', 1612, 'tcp', 'NetBill Transaction Server'),
('netbill-keyrep', 1613, 'tcp', 'NetBill Key Repository'),
('netbill-cred', 1614, 'tcp', 'NetBill Credential Server'),
('netbill-auth', 1615, 'tcp', 'NetBill Authorization Server'),
('netbill-prod', 1616, 'tcp', 'NetBill Product Server'),
('nimrod-agent', 1617, 'tcp', 'Nimrod Inter-Agent Communication'),
('skytelnet', 1618, 'tcp', 'skytelnet'),
('xs-openstorage', 1619, 'tcp', 'xs-openstorage'),
('faxportwinport', 1620, 'tcp', 'faxportwinport'),
('softdataphone', 1621, 'tcp', 'softdataphone'),
('ontime', 1622, 'tcp', 'ontime'),
('jaleosnd', 1623, 'tcp', 'jaleosnd'),
('udp-sr-port', 1624, 'tcp', 'udp-sr-port'),
('svs-omagent', 1625, 'tcp', 'svs-omagent'),
('shockwave', 1626, 'tcp', 'Shockwave'),
('t128-gateway', 1627, 'tcp', 'T.128 Gateway'),
('lontalk-norm', 1628, 'tcp', 'LonTalk normal'),
('lontalk-urgnt', 1629, 'tcp', 'LonTalk urgent'),
('oraclenet8cman', 1630, 'tcp', 'Oracle Net8 Cman'),
('visitview', 1631, 'tcp', 'Visit view'),
('pammratc', 1632, 'tcp', 'PAMMRATC'),
('pammrpc', 1633, 'tcp', 'PAMMRPC'),
('loaprobe', 1634, 'tcp', 'Log On America Probe'),
('edb-server1', 1635, 'tcp', 'EDB Server 1'),
('cncp', 1636, 'tcp', 'CableNet Control Protocol'),
('cnap', 1637, 'tcp', 'CableNet Admin Protocol'),
('cnip', 1638, 'tcp', 'CableNet Info Protocol'),
('cert-initiator', 1639, 'tcp', 'cert-initiator'),
('cert-responder', 1640, 'tcp', 'cert-responder'),
('invision', 1641, 'tcp', 'InVision'),
('isis-am', 1642, 'tcp', 'isis-am'),
('isis-ambc', 1643, 'tcp', 'isis-ambc'),
('saiseh', 1644, 'tcp', 'Satellite-data Acquisition System 4'),
('sightline', 1645, 'tcp', 'SightLine'),
('sa-msg-port', 1646, 'tcp', 'sa-msg-port'),
('rsap', 1647, 'tcp', 'rsap'),
('concurrent-lm', 1648, 'tcp', 'concurrent-lm'),
('kermit', 1649, 'tcp', 'kermit'),
('nkd', 1650, 'tcp', 'nkdn'),
('shiva_confsrvr', 1651, 'tcp', 'shiva_confsrvr'),
('xnmp', 1652, 'tcp', 'xnmp'),
('alphatech-lm', 1653, 'tcp', 'alphatech-lm'),
('stargatealerts', 1654, 'tcp', 'stargatealerts'),
('dec-mbadmin', 1655, 'tcp', 'dec-mbadmin'),
('dec-mbadmin-h', 1656, 'tcp', 'dec-mbadmin-h'),
('fujitsu-mmpdc', 1657, 'tcp', 'fujitsu-mmpdc'),
('sixnetudr', 1658, 'tcp', 'sixnetudr'),
('sg-lm', 1659, 'tcp', 'Silicon Grail License Manager'),
('skip-mc-gikreq', 1660, 'tcp', 'skip-mc-gikreq'),
('netview-aix-1', 1661, 'tcp', 'netview-aix-1'),
('netview-aix-2', 1662, 'tcp', 'netview-aix-2'),
('netview-aix-3', 1663, 'tcp', 'netview-aix-3'),
('netview-aix-4', 1664, 'tcp', 'netview-aix-4'),
('netview-aix-5', 1665, 'tcp', 'netview-aix-5'),
('netview-aix-6', 1666, 'tcp', 'netview-aix-6'),
('netview-aix-7', 1667, 'tcp', 'netview-aix-7'),
('netview-aix-8', 1668, 'tcp', 'netview-aix-8'),
('netview-aix-9', 1669, 'tcp', 'netview-aix-9'),
('netview-aix-10', 1670, 'tcp', 'netview-aix-10'),
('netview-aix-11', 1671, 'tcp', 'netview-aix-11'),
('netview-aix-12', 1672, 'tcp', 'netview-aix-12'),
('proshare-mc-1', 1673, 'tcp', 'Intel Proshare Multicast'),
('proshare-mc-2', 1674, 'tcp', 'Intel Proshare Multicast'),
('pdp', 1675, 'tcp', 'Pacific Data Products'),
('netcomm1', 1676, 'tcp', 'netcomm1'),
('groupwise', 1677, 'tcp', 'groupwise'),
('prolink', 1678, 'tcp', 'prolink'),
('darcorp-lm', 1679, 'tcp', 'darcorp-lm'),
('microcom-sbp', 1680, 'tcp', 'microcom-sbp'),
('sd-elmd', 1681, 'tcp', 'sd-elmd'),
('lanyon-lantern', 1682, 'tcp', 'lanyon-lantern'),
('ncpm-hip', 1683, 'tcp', 'ncpm-hip'),
('snaresecure', 1684, 'tcp', 'SnareSecure'),
('n2nremote', 1685, 'tcp', 'n2nremote'),
('cvmon', 1686, 'tcp', 'cvmon'),
('nsjtp-ctrl', 1687, 'tcp', 'nsjtp-ctrl'),
('nsjtp-data', 1688, 'tcp', 'nsjtp-data'),
('firefox', 1689, 'tcp', 'firefox'),
('ng-umds', 1690, 'tcp', 'ng-umds'),
('empire-empuma', 1691, 'tcp', 'empire-empuma'),
('sstsys-lm', 1692, 'tcp', 'sstsys-lm'),
('rrirtr', 1693, 'tcp', 'rrirtr'),
('rrimwm', 1694, 'tcp', 'rrimwm'),
('rrilwm', 1695, 'tcp', 'rrilwm'),
('rrifmm', 1696, 'tcp', 'rrifmm'),
('rrisat', 1697, 'tcp', 'rrisat'),
('rsvp-encap-1', 1698, 'tcp', 'RSVP-ENCAPSULATION-1'),
('rsvp-encap-2', 1699, 'tcp', 'RSVP-ENCAPSULATION-2'),
('mps-raft', 1700, 'tcp', 'mps-raft'),
('l2f', 1701, 'tcp', 'l2f'),
('l2tp', 1701, 'tcp', 'l2tp'),
('deskshare', 1702, 'tcp', 'deskshare'),
('hb-engine', 1703, 'tcp', 'hb-engine'),
('bcs-broker', 1704, 'tcp', 'bcs-broker'),
('slingshot', 1705, 'tcp', 'slingshot'),
('jetform', 1706, 'tcp', 'jetform'),
('vdmplay', 1707, 'tcp', 'vdmplay'),
('gat-lmd', 1708, 'tcp', 'gat-lmd'),
('centra', 1709, 'tcp', 'centra'),
('impera', 1710, 'tcp', 'impera'),
('pptconference', 1711, 'tcp', 'pptconference'),
('registrar', 1712, 'tcp', 'resource monitoring service'),
('conferencetalk', 1713, 'tcp', 'ConferenceTalk'),
('sesi-lm', 1714, 'tcp', 'sesi-lm'),
('houdini-lm', 1715, 'tcp', 'houdini-lm'),
('xmsg', 1716, 'tcp', 'xmsg'),
('fj-hdnet', 1717, 'tcp', 'fj-hdnet'),
('h323gatedisc', 1718, 'tcp', 'h323gatedisc'),
('h323gatestat', 1719, 'tcp', 'h323gatestat'),
('h323hostcall', 1720, 'tcp', 'h323hostcall'),
('caicci', 1721, 'tcp', 'caicci'),
('hks-lm', 1722, 'tcp', 'HKS License Manager'),
('pptp', 1723, 'tcp', 'pptp'),
('csbphonemaster', 1724, 'tcp', 'csbphonemaster'),
('iden-ralp', 1725, 'tcp', 'iden-ralp'),
('iberiagames', 1726, 'tcp', 'IBERIAGAMES'),
('winddx', 1727, 'tcp', 'winddx'),
('telindus', 1728, 'tcp', 'TELINDUS'),
('citynl', 1729, 'tcp', 'CityNL License Management'),
('roketz', 1730, 'tcp', 'roketz'),
('msiccp', 1731, 'tcp', 'MSICCP'),
('proxim', 1732, 'tcp', 'proxim'),
('siipat', 1733, 'tcp', 'SIMS - SIIPAT Protocol for Alarm Transmission'),
('cambertx-lm', 1734, 'tcp', 'Camber Corporation License Management'),
('privatechat', 1735, 'tcp', 'PrivateChat'),
('street-stream', 1736, 'tcp', 'street-stream'),
('ultimad', 1737, 'tcp', 'ultimad'),
('gamegen1', 1738, 'tcp', 'GameGen1'),
('webaccess', 1739, 'tcp', 'webaccess'),
('encore', 1740, 'tcp', 'encore'),
('cisco-net-mgmt', 1741, 'tcp', 'cisco-net-mgmt'),
('3Com-nsd', 1742, 'tcp', '3Com-nsd'),
('cinegrfx-lm', 1743, 'tcp', 'Cinema Graphics License Manager'),
('ncpm-ft', 1744, 'tcp', 'ncpm-ft'),
('remote-winsock', 1745, 'tcp', 'remote-winsock'),
('ftrapid-1', 1746, 'tcp', 'ftrapid-1'),
('ftrapid-2', 1747, 'tcp', 'ftrapid-2'),
('oracle-em1', 1748, 'tcp', 'oracle-em1'),
('aspen-services', 1749, 'tcp', 'aspen-services'),
('sslp', 1750, 'tcp', 'Simple Socket Librarys PortMaster'),
('swiftnet', 1751, 'tcp', 'SwiftNet'),
('lofr-lm', 1752, 'tcp', 'Leap of Faith Research License Manager'),
('translogic-lm', 1753, 'tcp', 'Translogic License Manager'),
('oracle-em2', 1754, 'tcp', 'oracle-em2'),
('ms-streaming', 1755, 'tcp', 'ms-streaming'),
('capfast-lmd', 1756, 'tcp', 'capfast-lmd'),
('cnhrp', 1757, 'tcp', 'cnhrp'),
('tftp-mcast', 1758, 'tcp', 'tftp-mcast'),
('spss-lm', 1759, 'tcp', 'SPSS License Manager'),
('www-ldap-gw', 1760, 'tcp', 'www-ldap-gw'),
('cft-0', 1761, 'tcp', 'cft-0'),
('cft-1', 1762, 'tcp', 'cft-1'),
('cft-2', 1763, 'tcp', 'cft-2'),
('cft-3', 1764, 'tcp', 'cft-3'),
('cft-4', 1765, 'tcp', 'cft-4'),
('cft-5', 1766, 'tcp', 'cft-5'),
('cft-6', 1767, 'tcp', 'cft-6'),
('cft-7', 1768, 'tcp', 'cft-7'),
('bmc-net-adm', 1769, 'tcp', 'bmc-net-adm'),
('bmc-net-svc', 1770, 'tcp', 'bmc-net-svc'),
('vaultbase', 1771, 'tcp', 'vaultbase'),
('essweb-gw', 1772, 'tcp', 'EssWeb Gateway'),
('kmscontrol', 1773, 'tcp', 'KMSControl'),
('global-dtserv', 1774, 'tcp', 'global-dtserv'),
('femis', 1776, 'tcp', 'Federal Emergency Management Information System'),
('powerguardian', 1777, 'tcp', 'powerguardian'),
('prodigy-intrnet', 1778, 'tcp', 'prodigy-internet'),
('pharmasoft', 1779, 'tcp', 'pharmasoft'),
('dpkeyserv', 1780, 'tcp', 'dpkeyserv'),
('answersoft-lm', 1781, 'tcp', 'answersoft-lm'),
('hp-hcip', 1782, 'tcp', 'hp-hcip'),
('finle-lm', 1784, 'tcp', 'Finle License Manager'),
('windlm', 1785, 'tcp', 'Wind River Systems License Manager'),
('funk-logger', 1786, 'tcp', 'funk-logger'),
('funk-license', 1787, 'tcp', 'funk-license'),
('psmond', 1788, 'tcp', 'psmond'),
('hello', 1789, 'tcp', 'hello'),
('nmsp', 1790, 'tcp', 'Narrative Media Streaming Protocol'),
('ea1', 1791, 'tcp', 'EA1'),
('ibm-dt-2', 1792, 'tcp', 'ibm-dt-2'),
('rsc-robot', 1793, 'tcp', 'rsc-robot'),
('cera-bcm', 1794, 'tcp', 'cera-bcm'),
('dpi-proxy', 1795, 'tcp', 'dpi-proxy'),
('vocaltec-admin', 1796, 'tcp', 'Vocaltec Server Administration'),
('uma', 1797, 'tcp', 'UMA'),
('etp', 1798, 'tcp', 'Event Transfer Protocol'),
('netrisk', 1799, 'tcp', 'NETRISK'),
('ansys-lm', 1800, 'tcp', 'ANSYS-License manager'),
('msmq', 1801, 'tcp', 'Microsoft Message Que'),
('concomp1', 1802, 'tcp', 'ConComp1'),
('hp-hcip-gwy', 1803, 'tcp', 'HP-HCIP-GWY'),
('enl', 1804, 'tcp', 'ENL'),
('enl-name', 1805, 'tcp', 'ENL-Name'),
('musiconline', 1806, 'tcp', 'Musiconline'),
('fhsp', 1807, 'tcp', 'Fujitsu Hot Standby Protocol'),
('oracle-vp2', 1808, 'tcp', 'Oracle-VP2'),
('oracle-vp1', 1809, 'tcp', 'Oracle-VP1'),
('jerand-lm', 1810, 'tcp', 'Jerand License Manager'),
('scientia-sdb', 1811, 'tcp', 'Scientia-SDB'),
('radius', 1812, 'tcp', 'RADIUS'),
('radius-acct', 1813, 'tcp', 'RADIUS Accounting'),
('tdp-suite', 1814, 'tcp', 'TDP Suite'),
('mmpft', 1815, 'tcp', 'MMPFT'),
('harp', 1816, 'tcp', 'HARP'),
('rkb-oscs', 1817, 'tcp', 'RKB-OSCS'),
('etftp', 1818, 'tcp', 'Enhanced Trivial File Transfer Protocol'),
('plato-lm', 1819, 'tcp', 'Plato License Manager'),
('mcagent', 1820, 'tcp', 'mcagent'),
('donnyworld', 1821, 'tcp', 'donnyworld'),
('es-elmd', 1822, 'tcp', 'es-elmd'),
('unisys-lm', 1823, 'tcp', 'Unisys Natural Language License Manager'),
('metrics-pas', 1824, 'tcp', 'metrics-pas'),
('direcpc-video', 1825, 'tcp', 'DirecPC Video'),
('ardt', 1826, 'tcp', 'ARDT'),
('asi', 1827, 'tcp', 'ASI'),
('itm-mcell-u', 1828, 'tcp', 'itm-mcell-u'),
('optika-emedia', 1829, 'tcp', 'Optika eMedia'),
('net8-cman', 1830, 'tcp', 'Oracle Net8 CMan Admin'),
('myrtle', 1831, 'tcp', 'Myrtle'),
('tht-treasure', 1832, 'tcp', 'ThoughtTreasure'),
('udpradio', 1833, 'tcp', 'udpradio'),
('ardusuni', 1834, 'tcp', 'ARDUS Unicast'),
('ardusmul', 1835, 'tcp', 'ARDUS Multicast'),
('ste-smsc', 1836, 'tcp', 'ste-smsc'),
('csoft1', 1837, 'tcp', 'csoft1'),
('talnet', 1838, 'tcp', 'TALNET'),
('netopia-vo1', 1839, 'tcp', 'netopia-vo1'),
('netopia-vo2', 1840, 'tcp', 'netopia-vo2'),
('netopia-vo3', 1841, 'tcp', 'netopia-vo3'),
('netopia-vo4', 1842, 'tcp', 'netopia-vo4'),
('netopia-vo5', 1843, 'tcp', 'netopia-vo5'),
('direcpc-dll', 1844, 'tcp', 'DirecPC-DLL'),
('altalink', 1845, 'tcp', 'altalink'),
('tunstall-pnc', 1846, 'tcp', 'Tunstall PNC'),
('slp-notify', 1847, 'tcp', 'SLP Notification'),
('fjdocdist', 1848, 'tcp', 'fjdocdist'),
('alpha-sms', 1849, 'tcp', 'ALPHA-SMS'),
('gsi', 1850, 'tcp', 'GSI'),
('ctcd', 1851, 'tcp', 'ctcd'),
('virtual-time', 1852, 'tcp', 'Virtual Time'),
('vids-avtp', 1853, 'tcp', 'VIDS-AVTP'),
('buddy-draw', 1854, 'tcp', 'Buddy Draw'),
('fiorano-rtrsvc', 1855, 'tcp', 'Fiorano RtrSvc'),
('fiorano-msgsvc', 1856, 'tcp', 'Fiorano MsgSvc'),
('datacaptor', 1857, 'tcp', 'DataCaptor'),
('privateark', 1858, 'tcp', 'PrivateArk'),
('gammafetchsvr', 1859, 'tcp', 'Gamma Fetcher Server'),
('sunscalar-svc', 1860, 'tcp', 'SunSCALAR Services'),
('lecroy-vicp', 1861, 'tcp', 'LeCroy VICP'),
('techra-server', 1862, 'tcp', 'techra-server'),
('msnp', 1863, 'tcp', 'MSNP'),
('paradym-31port', 1864, 'tcp', 'Paradym 31 Port'),
('entp', 1865, 'tcp', 'ENTP'),
('swrmi', 1866, 'tcp', 'swrmi'),
('udrive', 1867, 'tcp', 'UDRIVE'),
('viziblebrowser', 1868, 'tcp', 'VizibleBrowser'),
('yestrader', 1869, 'tcp', 'YesTrader'),
('sunscalar-dns', 1870, 'tcp', 'SunSCALAR DNS Service'),
('canocentral0', 1871, 'tcp', 'Cano Central 0'),
('canocentral1', 1872, 'tcp', 'Cano Central 1'),
('fjmpjps', 1873, 'tcp', 'Fjmpjps'),
('fjswapsnp', 1874, 'tcp', 'Fjswapsnp'),
('westell-stats', 1875, 'tcp', 'westell stats'),
('ewcappsrv', 1876, 'tcp', 'ewcappsrv'),
('hp-webqosdb', 1877, 'tcp', 'hp-webqosdb'),
('drmsmc', 1878, 'tcp', 'drmsmc'),
('nettgain-nms', 1879, 'tcp', 'NettGain NMS'),
('vsat-control', 1880, 'tcp', 'Gilat VSAT Control'),
('ibm-mqseries2', 1881, 'tcp', 'IBM MQSeries'),
('ecsqdmn', 1882, 'tcp', 'ecsqdmn'),
('ibm-mqisdp', 1883, 'tcp', 'IBM MQSeries SCADA'),
('idmaps', 1884, 'tcp', 'Internet Distance Map Svc'),
('vrtstrapserver', 1885, 'tcp', 'Veritas Trap Server'),
('leoip', 1886, 'tcp', 'Leonardo over IP'),
('filex-lport', 1887, 'tcp', 'FileX Listening Port'),
('ncconfig', 1888, 'tcp', 'NC Config Port'),
('unify-adapter', 1889, 'tcp', 'Unify Web Adapter Service'),
('wilkenlistener', 1890, 'tcp', 'wilkenListener'),
('childkey-notif', 1891, 'tcp', 'ChildKey Notification'),
('childkey-ctrl', 1892, 'tcp', 'ChildKey Control'),
('elad', 1893, 'tcp', 'ELAD Protocol'),
('o2server-port', 1894, 'tcp', 'O2Server Port'),
('b-novative-ls', 1896, 'tcp', 'b-novative license server'),
('metaagent', 1897, 'tcp', 'MetaAgent'),
('cymtec-port', 1898, 'tcp', 'Cymtec secure management'),
('mc2studios', 1899, 'tcp', 'MC2Studios'),
('ssdp', 1900, 'tcp', 'SSDP'),
('fjicl-tep-a', 1901, 'tcp', 'Fujitsu ICL Terminal Emulator Program A'),
('fjicl-tep-b', 1902, 'tcp', 'Fujitsu ICL Terminal Emulator Program B'),
('linkname', 1903, 'tcp', 'Local Link Name Resolution'),
('fjicl-tep-c', 1904, 'tcp', 'Fujitsu ICL Terminal Emulator Program C'),
('sugp', 1905, 'tcp', 'Secure UP.Link Gateway Protocol'),
('tpmd', 1906, 'tcp', 'TPortMapperReq'),
('intrastar', 1907, 'tcp', 'IntraSTAR'),
('dawn', 1908, 'tcp', 'Dawn'),
('global-wlink', 1909, 'tcp', 'Global World Link'),
('ultrabac', 1910, 'tcp', 'UltraBac Software communications port'),
('mtp', 1911, 'tcp', 'Starlight Networks Multimedia Transport Protocol'),
('rhp-iibp', 1912, 'tcp', 'rhp-iibp'),
('armadp', 1913, 'tcp', 'armadp'),
('elm-momentum', 1914, 'tcp', 'Elm-Momentum'),
('facelink', 1915, 'tcp', 'FACELINK'),
('persona', 1916, 'tcp', 'Persoft Persona'),
('noagent', 1917, 'tcp', 'nOAgent'),
('can-nds', 1918, 'tcp', 'Candle Directory Service - NDS'),
('can-dch', 1919, 'tcp', 'Candle Directory Service - DCH'),
('can-ferret', 1920, 'tcp', 'Candle Directory Service - FERRET'),
('noadmin', 1921, 'tcp', 'NoAdmin'),
('tapestry', 1922, 'tcp', 'Tapestry'),
('spice', 1923, 'tcp', 'SPICE'),
('xiip', 1924, 'tcp', 'XIIP'),
('discovery-port', 1925, 'tcp', 'Surrogate Discovery Port'),
('egs', 1926, 'tcp', 'Evolution Game Server'),
('videte-cipc', 1927, 'tcp', 'Videte CIPC Port'),
('emsd-port', 1928, 'tcp', 'Expnd Maui Srvr Dscovr'),
('bandwiz-system', 1929, 'tcp', 'Bandwiz System - Server'),
('driveappserver', 1930, 'tcp', 'Drive AppServer'),
('amdsched', 1931, 'tcp', 'AMD SCHED'),
('ctt-broker', 1932, 'tcp', 'CTT Broker'),
('xmapi', 1933, 'tcp', 'IBM LM MT Agent'),
('xaapi', 1934, 'tcp', 'IBM LM Appl Agent'),
('tincan', 1935, 'tcp', 'TinCan'),
('jetcmeserver', 1936, 'tcp', 'JetCmeServer Server Port'),
('jwserver', 1937, 'tcp', 'JetVWay Server Port'),
('jwclient', 1938, 'tcp', 'JetVWay Client Port'),
('jvserver', 1939, 'tcp', 'JetVision Server Port'),
('jvclient', 1940, 'tcp', 'JetVision Client Port'),
('dic-aida', 1941, 'tcp', 'DIC-Aida'),
('res', 1942, 'tcp', 'Real Enterprise Service'),
('beeyond-media', 1943, 'tcp', 'Beeyond Media'),
('close-combat', 1944, 'tcp', 'close-combat'),
('dialogic-elmd', 1945, 'tcp', 'dialogic-elmd'),
('tekpls', 1946, 'tcp', 'tekpls'),
('hlserver', 1947, 'tcp', 'hlserver'),
('eye2eye', 1948, 'tcp', 'eye2eye'),
('ismaeasdaqlive', 1949, 'tcp', 'ISMA Easdaq Live'),
('ismaeasdaqtest', 1950, 'tcp', 'ISMA Easdaq Test'),
('bcs-lmserver', 1951, 'tcp', 'bcs-lmserver'),
('mpnjsc', 1952, 'tcp', 'mpnjsc'),
('rapidbase', 1953, 'tcp', 'Rapid Base'),
('abr-basic', 1954, 'tcp', 'ABR-Basic Data'),
('abr-secure', 1955, 'tcp', 'ABR-Secure Data'),
('vrtl-vmf-ds', 1956, 'tcp', 'Vertel VMF DS'),
('unix-status', 1957, 'tcp', 'unix-status'),
('dxadmind', 1958, 'tcp', 'CA Administration Daemon'),
('simp-all', 1959, 'tcp', 'SIMP Channel'),
('nasmanager', 1960, 'tcp', 'Merit DAC NASmanager'),
('bts-appserver', 1961, 'tcp', 'BTS APPSERVER'),
('biap-mp', 1962, 'tcp', 'BIAP-MP'),
('webmachine', 1963, 'tcp', 'WebMachine'),
('solid-e-engine', 1964, 'tcp', 'SOLID E ENGINE'),
('tivoli-npm', 1965, 'tcp', 'Tivoli NPM'),
('slush', 1966, 'tcp', 'Slush'),
('sns-quote', 1967, 'tcp', 'SNS Quote'),
('lipsinc', 1968, 'tcp', 'LIPSinc'),
('lipsinc1', 1969, 'tcp', 'LIPSinc 1'),
('netop-rc', 1970, 'tcp', 'NetOp Remote Control'),
('netop-school', 1971, 'tcp', 'NetOp School'),
('intersys-cache', 1972, 'tcp', 'Cache'),
('dlsrap', 1973, 'tcp', 'Data Link Switching Remote Access Protocol'),
('drp', 1974, 'tcp', 'DRP'),
('tcoflashagent', 1975, 'tcp', 'TCO Flash Agent'),
('tcoregagent', 1976, 'tcp', 'TCO Reg Agent'),
('tcoaddressbook', 1977, 'tcp', 'TCO Address Book'),
('unisql', 1978, 'tcp', 'UniSQL'),
('unisql-java', 1979, 'tcp', 'UniSQL Java'),
('pearldoc-xact', 1980, 'tcp', 'PearlDoc XACT'),
('p2pq', 1981, 'tcp', 'p2pQ'),
('estamp', 1982, 'tcp', 'Evidentiary Timestamp'),
('lhtp', 1983, 'tcp', 'Loophole Test Protocol'),
('bb', 1984, 'tcp', 'BB'),
('hsrp', 1985, 'tcp', 'Hot Standby Router Protocol'),
('licensedaemon', 1986, 'tcp', 'cisco license management'),
('tr-rsrb-p1', 1987, 'tcp', 'cisco RSRB Priority 1 port'),
('tr-rsrb-p2', 1988, 'tcp', 'cisco RSRB Priority 2 port'),
('tr-rsrb-p3', 1989, 'tcp', 'cisco RSRB Priority 3 port'),
('mshnet', 1989, 'tcp', 'MHSnet system'),
('stun-p1', 1990, 'tcp', 'cisco STUN Priority 1 port'),
('stun-p2', 1991, 'tcp', 'cisco STUN Priority 2 port'),
('stun-p3', 1992, 'tcp', 'cisco STUN Priority 3 port'),
('ipsendmsg', 1992, 'tcp', 'IPsendmsg'),
('snmp-tcp-port', 1993, 'tcp', 'cisco SNMP TCP port'),
('stun-port', 1994, 'tcp', 'cisco serial tunnel port'),
('perf-port', 1995, 'tcp', 'cisco perf port'),
('tr-rsrb-port', 1996, 'tcp', 'cisco Remote SRB port'),
('gdp-port', 1997, 'tcp', 'cisco Gateway Discovery Protocol'),
('x25-svc-port', 1998, 'tcp', 'cisco X.25 service (XOT)'),
('tcp-id-port', 1999, 'tcp', 'cisco identification port'),
('callbook', 2000, 'tcp', ''),
('dc', 2001, 'tcp', ''),
('globe', 2002, 'tcp', ''),
('mailbox', 2004, 'tcp', ''),
('berknet', 2005, 'tcp', ''),
('invokator', 2006, 'tcp', ''),
('dectalk', 2007, 'tcp', ''),
('conf', 2008, 'tcp', ''),
('news', 2009, 'tcp', ''),
('search', 2010, 'tcp', ''),
('raid-cc', 2011, 'tcp', 'raid'),
('ttyinfo', 2012, 'tcp', ''),
('raid-am', 2013, 'tcp', ''),
('troff', 2014, 'tcp', ''),
('cypress', 2015, 'tcp', ''),
('bootserver', 2016, 'tcp', ''),
('cypress-stat', 2017, 'tcp', ''),
('terminaldb', 2018, 'tcp', ''),
('whosockami', 2019, 'tcp', ''),
('xinupageserver', 2020, 'tcp', ''),
('servexec', 2021, 'tcp', ''),
('down', 2022, 'tcp', ''),
('xinuexpansion3', 2023, 'tcp', ''),
('xinuexpansion4', 2024, 'tcp', ''),
('ellpack', 2025, 'tcp', ''),
('scrabble', 2026, 'tcp', ''),
('shadowserver', 2027, 'tcp', ''),
('submitserver', 2028, 'tcp', ''),
('device2', 2030, 'tcp', ''),
('blackboard', 2032, 'tcp', ''),
('glogger', 2033, 'tcp', ''),
('scoremgr', 2034, 'tcp', ''),
('imsldoc', 2035, 'tcp', ''),
('p2plus', 2037, 'tcp', 'P2plus Application Server'),
('objectmanager', 2038, 'tcp', ''),
('lam', 2040, 'tcp', ''),
('interbase', 2041, 'tcp', ''),
('isis', 2042, 'tcp', 'isis'),
('isis-bcast', 2043, 'tcp', 'isis-bcast'),
('rimsl', 2044, 'tcp', ''),
('cdfunc', 2045, 'tcp', ''),
('sdfunc', 2046, 'tcp', ''),
('dls', 2047, 'tcp', ''),
('dls-monitor', 2048, 'tcp', ''),
('shilp', 2049, 'tcp', ''),
('nfs', 2049, 'tcp', 'Network File System - Sun Microsystems'),
('av-emb-config', 2050, 'tcp', 'Avaya EMB Config Port'),
('epnsdp', 2051, 'tcp', 'EPNSDP'),
('clearvisn', 2052, 'tcp', 'clearVisn Services Port'),
('lot105-ds-upd', 2053, 'tcp', 'Lot105 DSuper Updates'),
('weblogin', 2054, 'tcp', 'Weblogin Port'),
('iop', 2055, 'tcp', 'Iliad-Odyssey Protocol'),
('omnisky', 2056, 'tcp', 'OmniSky Port'),
('rich-cp', 2057, 'tcp', 'Rich Content Protocol'),
('newwavesearch', 2058, 'tcp', 'NewWaveSearchables RMI'),
('bmc-messaging', 2059, 'tcp', 'BMC Messaging Service'),
('teleniumdaemon', 2060, 'tcp', 'Telenium Daemon IF'),
('netmount', 2061, 'tcp', 'NetMount'),
('icg-swp', 2062, 'tcp', 'ICG SWP Port'),
('icg-bridge', 2063, 'tcp', 'ICG Bridge Port'),
('icg-iprelay', 2064, 'tcp', 'ICG IP Relay Port'),
('dlsrpn', 2065, 'tcp', 'Data Link Switch Read Port Number'),
('dlswpn', 2067, 'tcp', 'Data Link Switch Write Port Number'),
('avauthsrvprtcl', 2068, 'tcp', 'Avocent AuthSrv Protocol'),
('event-port', 2069, 'tcp', 'HTTP Event Port'),
('ah-esp-encap', 2070, 'tcp', 'AH and ESP Encapsulated in UDP packet'),
('acp-port', 2071, 'tcp', 'Axon Control Protocol'),
('msync', 2072, 'tcp', 'GlobeCast mSync'),
('gxs-data-port', 2073, 'tcp', 'DataReel Database Socket'),
('vrtl-vmf-sa', 2074, 'tcp', 'Vertel VMF SA'),
('newlixengine', 2075, 'tcp', 'Newlix ServerWare Engine'),
('newlixconfig', 2076, 'tcp', 'Newlix JSPConfig'),
('trellisagt', 2077, 'tcp', 'TrelliSoft Agent'),
('trellissvr', 2078, 'tcp', 'TrelliSoft Server'),
('idware-router', 2079, 'tcp', 'IDWARE Router Port'),
('autodesk-nlm', 2080, 'tcp', 'Autodesk NLM (FLEXlm)'),
('kme-trap-port', 2081, 'tcp', 'KME PRINTER TRAP PORT'),
('infowave', 2082, 'tcp', 'Infowave Mobility Server'),
('eli', 2087, 'tcp', 'ELI - Event Logging Integration'),
('sep', 2089, 'tcp', 'Security Encapsulation Protocol - SEP'),
('lrp', 2090, 'tcp', 'Load Report Protocol'),
('prp', 2091, 'tcp', 'PRP'),
('descent3', 2092, 'tcp', 'Descent 3'),
('nbx-cc', 2093, 'tcp', 'NBX CC'),
('nbx-au', 2094, 'tcp', 'NBX AU'),
('nbx-ser', 2095, 'tcp', 'NBX SER'),
('nbx-dir', 2096, 'tcp', 'NBX DIR'),
('jetformpreview', 2097, 'tcp', 'Jet Form Preview'),
('dialog-port', 2098, 'tcp', 'Dialog Port'),
('h2250-annex-g', 2099, 'tcp', 'H.225.0 Annex G'),
('amiganetfs', 2100, 'tcp', 'Amiga Network Filesystem'),
('rtcm-sc104', 2101, 'tcp', 'rtcm-sc104'),
('zephyr-srv', 2102, 'tcp', 'Zephyr server'),
('zephyr-clt', 2103, 'tcp', 'Zephyr serv-hm connection'),
('zephyr-hm', 2104, 'tcp', 'Zephyr hostmanager'),
('minipay', 2105, 'tcp', 'MiniPay'),
('mzap', 2106, 'tcp', 'MZAP'),
('bintec-admin', 2107, 'tcp', 'BinTec Admin'),
('comcam', 2108, 'tcp', 'Comcam'),
('ergolight', 2109, 'tcp', 'Ergolight'),
('umsp', 2110, 'tcp', 'UMSP'),
('dsatp', 2111, 'tcp', 'DSATP'),
('idonix-metanet', 2112, 'tcp', 'Idonix MetaNet'),
('hsl-storm', 2113, 'tcp', 'HSL StoRM'),
('newheights', 2114, 'tcp', 'NEWHEIGHTS'),
('kdm', 2115, 'tcp', 'Key Distribution Manager'),
('ccowcmr', 2116, 'tcp', 'CCOWCMR'),
('mentaclient', 2117, 'tcp', 'MENTACLIENT'),
('mentaserver', 2118, 'tcp', 'MENTASERVER'),
('gsigatekeeper', 2119, 'tcp', 'GSIGATEKEEPER'),
('qencp', 2120, 'tcp', 'Quick Eagle Networks CP'),
('scientia-ssdb', 2121, 'tcp', 'SCIENTIA-SSDB'),
('caupc-remote', 2122, 'tcp', 'CauPC Remote Control'),
('gtp-control', 2123, 'tcp', 'GTP-Control Plane (3GPP)'),
('elatelink', 2124, 'tcp', 'ELATELINK'),
('lockstep', 2125, 'tcp', 'LOCKSTEP'),
('pktcable-cops', 2126, 'tcp', 'PktCable-COPS'),
('index-pc-wb', 2127, 'tcp', 'INDEX-PC-WB'),
('net-steward', 2128, 'tcp', 'Net Steward Control'),
('cs-live', 2129, 'tcp', 'cs-live.com'),
('swc-xds', 2130, 'tcp', 'SWC-XDS'),
('avantageb2b', 2131, 'tcp', 'Avantageb2b'),
('avail-epmap', 2132, 'tcp', 'AVAIL-EPMAP'),
('zymed-zpp', 2133, 'tcp', 'ZYMED-ZPP'),
('avenue', 2134, 'tcp', 'AVENUE'),
('gris', 2135, 'tcp', 'Grid Resource Information Server'),
('appworxsrv', 2136, 'tcp', 'APPWORXSRV'),
('connect', 2137, 'tcp', 'CONNECT'),
('unbind-cluster', 2138, 'tcp', 'UNBIND-CLUSTER'),
('ias-auth', 2139, 'tcp', 'IAS-AUTH'),
('ias-reg', 2140, 'tcp', 'IAS-REG'),
('ias-admind', 2141, 'tcp', 'IAS-ADMIND'),
('tdm-over-ip', 2142, 'tcp', 'TDM-OVER-IP'),
('lv-jc', 2143, 'tcp', 'Live Vault Job Control'),
('lv-ffx', 2144, 'tcp', 'Live Vault Fast Object Transfer'),
('lv-pici', 2145, 'tcp', 'Live Vault Remote Diagnostic Console Support'),
('lv-not', 2146, 'tcp', 'Live Vault Admin Event Notification'),
('lv-auth', 2147, 'tcp', 'Live Vault Authentication'),
('veritas-ucl', 2148, 'tcp', 'VERITAS UNIVERSAL COMMUNICATION LAYER'),
('acptsys', 2149, 'tcp', 'ACPTSYS'),
('dynamic3d', 2150, 'tcp', 'DYNAMIC3D'),
('docent', 2151, 'tcp', 'DOCENT'),
('gtp-user', 2152, 'tcp', 'GTP-User Plane (3GPP)'),
('gdbremote', 2159, 'tcp', 'GDB Remote Debug Port'),
('apc-cms', 2160, 'tcp', 'APC Central Mgmt Server'),
('apc-agent', 2161, 'tcp', 'APC Agent'),
('navisphere', 2162, 'tcp', 'Navisphere'),
('navisphere-sec', 2163, 'tcp', 'Navisphere Secure'),
('ddns-v3', 2164, 'tcp', 'Dynamic DNS Version 3'),
('x-bone-api', 2165, 'tcp', 'X-Bone API'),
('iwserver', 2166, 'tcp', 'iwserver'),
('raw-serial', 2167, 'tcp', 'Raw Async Serial Link'),
('mc-gt-srv', 2180, 'tcp', 'Millicent Vendor Gateway Server'),
('eforward', 2181, 'tcp', 'eforward'),
('tivoconnect', 2190, 'tcp', 'TiVoConnect Beacon'),
('ici', 2200, 'tcp', 'ICI'),
('ats', 2201, 'tcp', 'Advanced Training System Program'),
('imtc-map', 2202, 'tcp', 'Int. Multimedia Teleconferencing Cosortium'),
('kali', 2213, 'tcp', 'Kali'),
('netiq', 2220, 'tcp', 'NetIQ End2End'),
('rockwell-csp1', 2221, 'tcp', 'Rockwell CSP1'),
('rockwell-csp2', 2222, 'tcp', 'Rockwell CSP2'),
('rockwell-csp3', 2223, 'tcp', 'Rockwell CSP3'),
('ivs-video', 2232, 'tcp', 'IVS Video default'),
('infocrypt', 2233, 'tcp', 'INFOCRYPT'),
('directplay', 2234, 'tcp', 'DirectPlay'),
('sercomm-wlink', 2235, 'tcp', 'Sercomm-WLink'),
('nani', 2236, 'tcp', 'Nani'),
('optech-port1-lm', 2237, 'tcp', 'Optech Port1 License Manager'),
('aviva-sna', 2238, 'tcp', 'AVIVA SNA SERVER'),
('imagequery', 2239, 'tcp', 'Image Query'),
('recipe', 2240, 'tcp', 'RECIPe'),
('ivsd', 2241, 'tcp', 'IVS Daemon'),
('foliocorp', 2242, 'tcp', 'Folio Remote Server'),
('magicom', 2243, 'tcp', 'Magicom Protocol'),
('nmsserver', 2244, 'tcp', 'NMS Server'),
('hao', 2245, 'tcp', 'HaO'),
('pc-mta-addrmap', 2246, 'tcp', 'PacketCable MTA Addr Map'),
('ums', 2248, 'tcp', 'User Management Service'),
('rfmp', 2249, 'tcp', 'RISO File Manager Protocol'),
('remote-collab', 2250, 'tcp', 'remote-collab'),
('dif-port', 2251, 'tcp', 'Distributed Framework Port'),
('njenet-ssl', 2252, 'tcp', 'NJENET using SSL'),
('dtv-chan-req', 2253, 'tcp', 'DTV Channel Request'),
('seispoc', 2254, 'tcp', 'Seismic P.O.C. Port'),
('vrtp', 2255, 'tcp', 'VRTP - ViRtue Transfer Protocol'),
('apc-pbeconsole', 2260, 'tcp', 'APC Console Comm Port'),
('xmquery', 2279, 'tcp', 'xmquery'),
('lnvpoller', 2280, 'tcp', 'LNVPOLLER'),
('lnvconsole', 2281, 'tcp', 'LNVCONSOLE'),
('lnvalarm', 2282, 'tcp', 'LNVALARM'),
('lnvstatus', 2283, 'tcp', 'LNVSTATUS'),
('lnvmaps', 2284, 'tcp', 'LNVMAPS'),
('lnvmailmon', 2285, 'tcp', 'LNVMAILMON'),
('nas-metering', 2286, 'tcp', 'NAS-Metering'),
('dna', 2287, 'tcp', 'DNA'),
('netml', 2288, 'tcp', 'NETML'),
('konshus-lm', 2294, 'tcp', 'Konshus License Manager (FLEX)'),
('advant-lm', 2295, 'tcp', 'Advant License Manager'),
('theta-lm', 2296, 'tcp', 'Theta License Manager (Rainbow)'),
('d2k-datamover1', 2297, 'tcp', 'D2K DataMover 1'),
('d2k-datamover2', 2298, 'tcp', 'D2K DataMover 2'),
('pc-telecommute', 2299, 'tcp', 'PC Telecommute'),
('cvmmon', 2300, 'tcp', 'CVMMON'),
('cpq-wbem', 2301, 'tcp', 'Compaq HTTP'),
('binderysupport', 2302, 'tcp', 'Bindery Support'),
('proxy-gateway', 2303, 'tcp', 'Proxy Gateway'),
('attachmate-uts', 2304, 'tcp', 'Attachmate UTS'),
('mt-scaleserver', 2305, 'tcp', 'MT ScaleServer'),
('tappi-boxnet', 2306, 'tcp', 'TAPPI BoxNet'),
('pehelp', 2307, 'tcp', 'pehelp'),
('sdhelp', 2308, 'tcp', 'sdhelp'),
('sdserver', 2309, 'tcp', 'SD Server'),
('sdclient', 2310, 'tcp', 'SD Client'),
('messageservice', 2311, 'tcp', 'Message Service'),
('iapp', 2313, 'tcp', 'IAPP (Inter Access Point Protocol)'),
('cr-websystems', 2314, 'tcp', 'CR WebSystems'),
('precise-sft', 2315, 'tcp', 'Precise Sft.'),
('sent-lm', 2316, 'tcp', 'SENT License Manager'),
('attachmate-g32', 2317, 'tcp', 'Attachmate G32'),
('cadencecontrol', 2318, 'tcp', 'Cadence Control'),
('infolibria', 2319, 'tcp', 'InfoLibria'),
('siebel-ns', 2320, 'tcp', 'Siebel NS'),
('rdlap', 2321, 'tcp', 'RDLAP'),
('ofsd', 2322, 'tcp', 'ofsd'),
('3d-nfsd', 2323, 'tcp', '3d-nfsd'),
('cosmocall', 2324, 'tcp', 'Cosmocall'),
('designspace-lm', 2325, 'tcp', 'Design Space License Management'),
('idcp', 2326, 'tcp', 'IDCP'),
('xingcsm', 2327, 'tcp', 'xingcsm'),
('netrix-sftm', 2328, 'tcp', 'Netrix SFTM'),
('nvd', 2329, 'tcp', 'NVD'),
('tscchat', 2330, 'tcp', 'TSCCHAT'),
('agentview', 2331, 'tcp', 'AGENTVIEW'),
('rcc-host', 2332, 'tcp', 'RCC Host'),
('snapp', 2333, 'tcp', 'SNAPP'),
('ace-client', 2334, 'tcp', 'ACE Client Auth'),
('ace-proxy', 2335, 'tcp', 'ACE Proxy'),
('appleugcontrol', 2336, 'tcp', 'Apple UG Control'),
('ideesrv', 2337, 'tcp', 'ideesrv'),
('norton-lambert', 2338, 'tcp', 'Norton Lambert'),
('3com-webview', 2339, 'tcp', '3Com WebView'),
('wrs_registry', 2340, 'tcp', 'WRS Registry'),
('xiostatus', 2341, 'tcp', 'XIO Status'),
('manage-exec', 2342, 'tcp', 'Seagate Manage Exec'),
('nati-logos', 2343, 'tcp', 'nati logos'),
('fcmsys', 2344, 'tcp', 'fcmsys'),
('dbm', 2345, 'tcp', 'dbm'),
('redstorm_join', 2346, 'tcp', 'Game Connection Port'),
('redstorm_find', 2347, 'tcp', 'Game Announcement and Location'),
('redstorm_info', 2348, 'tcp', 'Information to query for game status'),
('redstorm_diag', 2349, 'tcp', 'Diagnostics Port'),
('psbserver', 2350, 'tcp', 'psbserver'),
('psrserver', 2351, 'tcp', 'psrserver'),
('pslserver', 2352, 'tcp', 'pslserver'),
('pspserver', 2353, 'tcp', 'pspserver'),
('psprserver', 2354, 'tcp', 'psprserver'),
('psdbserver', 2355, 'tcp', 'psdbserver'),
('gxtelmd', 2356, 'tcp', 'GXT License Managemant'),
('unihub-server', 2357, 'tcp', 'UniHub Server'),
('futrix', 2358, 'tcp', 'Futrix'),
('flukeserver', 2359, 'tcp', 'FlukeServer'),
('nexstorindltd', 2360, 'tcp', 'NexstorIndLtd'),
('tl1', 2361, 'tcp', 'TL1'),
('digiman', 2362, 'tcp', 'digiman'),
('mediacntrlnfsd', 2363, 'tcp', 'Media Central NFSD'),
('oi-2000', 2364, 'tcp', 'OI-2000'),
('dbref', 2365, 'tcp', 'dbref'),
('qip-login', 2366, 'tcp', 'qip-login'),
('service-ctrl', 2367, 'tcp', 'Service Control'),
('opentable', 2368, 'tcp', 'OpenTable'),
('acs2000-dsp', 2369, 'tcp', 'ACS2000 DSP'),
('l3-hbmon', 2370, 'tcp', 'L3-HBMon'),
('worldwire', 2371, 'tcp', 'Compaq WorldWire Port'),
('compaq-https', 2381, 'tcp', 'Compaq HTTPS'),
('ms-olap3', 2382, 'tcp', 'Microsoft OLAP'),
('ms-olap4', 2383, 'tcp', 'Microsoft OLAP'),
('sd-request', 2384, 'tcp', 'SD-REQUEST'),
('sd-data', 2385, 'tcp', 'SD-DATA'),
('virtualtape', 2386, 'tcp', 'Virtual Tape'),
('vsamredirector', 2387, 'tcp', 'VSAM Redirector'),
('mynahautostart', 2388, 'tcp', 'MYNAH AutoStart'),
('ovsessionmgr', 2389, 'tcp', 'OpenView Session Mgr'),
('rsmtp', 2390, 'tcp', 'RSMTP'),
('3com-net-mgmt', 2391, 'tcp', '3COM Net Management'),
('tacticalauth', 2392, 'tcp', 'Tactical Auth'),
('ms-olap1', 2393, 'tcp', 'MS OLAP 1'),
('ms-olap2', 2394, 'tcp', 'MS OLAP 2'),
('lan900_remote', 2395, 'tcp', 'LAN900 Remote'),
('wusage', 2396, 'tcp', 'Wusage'),
('ncl', 2397, 'tcp', 'NCL'),
('orbiter', 2398, 'tcp', 'Orbiter'),
('fmpro-fdal', 2399, 'tcp', 'FileMaker, Inc. - Data Access Layer'),
('opequus-server', 2400, 'tcp', 'OpEquus Server'),
('cvspserver', 2401, 'tcp', 'cvspserver'),
('taskmaster2000', 2402, 'tcp', 'TaskMaster 2000 Server'),
('taskmaster2000', 2403, 'tcp', 'TaskMaster 2000 Web'),
('iec870-5-104', 2404, 'tcp', 'IEC870-5-104'),
('trc-netpoll', 2405, 'tcp', 'TRC Netpoll'),
('jediserver', 2406, 'tcp', 'JediServer'),
('orion', 2407, 'tcp', 'Orion'),
('optimanet', 2408, 'tcp', 'OptimaNet'),
('sns-protocol', 2409, 'tcp', 'SNS Protocol'),
('vrts-registry', 2410, 'tcp', 'VRTS Registry'),
('netwave-ap-mgmt', 2411, 'tcp', 'Netwave AP Management'),
('cdn', 2412, 'tcp', 'CDN'),
('orion-rmi-reg', 2413, 'tcp', 'orion-rmi-reg'),
('beeyond', 2414, 'tcp', 'Beeyond'),
('comtest', 2415, 'tcp', 'COMTEST'),
('rmtserver', 2416, 'tcp', 'RMT Server'),
('composit-server', 2417, 'tcp', 'Composit Server'),
('cas', 2418, 'tcp', 'cas'),
('attachmate-s2s', 2419, 'tcp', 'Attachmate S2S'),
('dslremote-mgmt', 2420, 'tcp', 'DSL Remote Management'),
('g-talk', 2421, 'tcp', 'G-Talk'),
('crmsbits', 2422, 'tcp', 'CRMSBITS'),
('rnrp', 2423, 'tcp', 'RNRP'),
('kofax-svr', 2424, 'tcp', 'KOFAX-SVR'),
('fjitsuappmgr', 2425, 'tcp', 'Fujitsu App Manager'),
('mgcp-gateway', 2427, 'tcp', 'Media Gateway Control Protocol Gateway'),
('ott', 2428, 'tcp', 'One Way Trip Time'),
('ft-role', 2429, 'tcp', 'FT-ROLE'),
('venus', 2430, 'tcp', 'venus'),
('venus-se', 2431, 'tcp', 'venus-se'),
('codasrv', 2432, 'tcp', 'codasrv'),
('codasrv-se', 2433, 'tcp', 'codasrv-se'),
('pxc-epmap', 2434, 'tcp', 'pxc-epmap'),
('optilogic', 2435, 'tcp', 'OptiLogic'),
('topx', 2436, 'tcp', 'TOP/X'),
('unicontrol', 2437, 'tcp', 'UniControl'),
('msp', 2438, 'tcp', 'MSP'),
('sybasedbsynch', 2439, 'tcp', 'SybaseDBSynch'),
('spearway', 2440, 'tcp', 'Spearway Lockers'),
('pvsw-inet', 2441, 'tcp', 'pvsw-inet'),
('netangel', 2442, 'tcp', 'Netangel'),
('powerclientcsf', 2443, 'tcp', 'PowerClient Central Storage Facility'),
('btpp2sectrans', 2444, 'tcp', 'BT PP2 Sectrans'),
('dtn1', 2445, 'tcp', 'DTN1'),
('bues_service', 2446, 'tcp', 'bues_service'),
('ovwdb', 2447, 'tcp', 'OpenView NNM daemon'),
('hpppssvr', 2448, 'tcp', 'hpppsvr'),
('ratl', 2449, 'tcp', 'RATL'),
('netadmin', 2450, 'tcp', 'netadmin'),
('netchat', 2451, 'tcp', 'netchat'),
('snifferclient', 2452, 'tcp', 'SnifferClient'),
('madge-om', 2453, 'tcp', 'madge-om'),
('indx-dds', 2454, 'tcp', 'IndX-DDS'),
('wago-io-system', 2455, 'tcp', 'WAGO-IO-SYSTEM'),
('altav-remmgt', 2456, 'tcp', 'altav-remmgt'),
('rapido-ip', 2457, 'tcp', 'Rapido_IP'),
('griffin', 2458, 'tcp', 'griffin'),
('community', 2459, 'tcp', 'Community'),
('ms-theater', 2460, 'tcp', 'ms-theater'),
('qadmifoper', 2461, 'tcp', 'qadmifoper'),
('qadmifevent', 2462, 'tcp', 'qadmifevent'),
('symbios-raid', 2463, 'tcp', 'Symbios Raid'),
('direcpc-si', 2464, 'tcp', 'DirecPC SI'),
('lbm', 2465, 'tcp', 'Load Balance Management'),
('lbf', 2466, 'tcp', 'Load Balance Forwarding'),
('high-criteria', 2467, 'tcp', 'High Criteria'),
('qip-msgd', 2468, 'tcp', 'qip_msgd'),
('mti-tcs-comm', 2469, 'tcp', 'MTI-TCS-COMM'),
('taskman-port', 2470, 'tcp', 'taskman port'),
('seaodbc', 2471, 'tcp', 'SeaODBC'),
('c3', 2472, 'tcp', 'C3'),
('aker-cdp', 2473, 'tcp', 'Aker-cdp'),
('vitalanalysis', 2474, 'tcp', 'Vital Analysis'),
('ace-server', 2475, 'tcp', 'ACE Server'),
('ace-svr-prop', 2476, 'tcp', 'ACE Server Propagation'),
('ssm-cvs', 2477, 'tcp', 'SecurSight Certificate Valifation Service'),
('ssm-cssps', 2478, 'tcp', 'SecurSight Authentication Server (SSL)'),
('ssm-els', 2479, 'tcp', 'SecurSight Event Logging Server (SSL)'),
('lingwood', 2480, 'tcp', 'Lingwoods Detail'),
('giop', 2481, 'tcp', 'Oracle GIOP'),
('giop-ssl', 2482, 'tcp', 'Oracle GIOP SSL'),
('ttc', 2483, 'tcp', 'Oracle TTC'),
('ttc-ssl', 2484, 'tcp', 'Oracle TTC SSL'),
('netobjects1', 2485, 'tcp', 'Net Objects1'),
('netobjects2', 2486, 'tcp', 'Net Objects2'),
('pns', 2487, 'tcp', 'Policy Notice Service'),
('moy-corp', 2488, 'tcp', 'Moy Corporation'),
('tsilb', 2489, 'tcp', 'TSILB'),
('qip-qdhcp', 2490, 'tcp', 'qip_qdhcp'),
('conclave-cpp', 2491, 'tcp', 'Conclave CPP'),
('groove', 2492, 'tcp', 'GROOVE'),
('talarian-mqs', 2493, 'tcp', 'Talarian MQS'),
('bmc-ar', 2494, 'tcp', 'BMC AR'),
('fast-rem-serv', 2495, 'tcp', 'Fast Remote Services'),
('dirgis', 2496, 'tcp', 'DIRGIS'),
('quaddb', 2497, 'tcp', 'Quad DB'),
('odn-castraq', 2498, 'tcp', 'ODN-CasTraq'),
('unicontrol', 2499, 'tcp', 'UniControl'),
('rtsserv', 2500, 'tcp', 'Resource Tracking system server'),
('rtsclient', 2501, 'tcp', 'Resource Tracking system client'),
('kentrox-prot', 2502, 'tcp', 'Kentrox Protocol'),
('nms-dpnss', 2503, 'tcp', 'NMS-DPNSS'),
('wlbs', 2504, 'tcp', 'WLBS'),
('jbroker', 2506, 'tcp', 'jbroker'),
('spock', 2507, 'tcp', 'spock'),
('jdatastore', 2508, 'tcp', 'JDataStore'),
('fjmpss', 2509, 'tcp', 'fjmpss'),
('fjappmgrbulk', 2510, 'tcp', 'fjappmgrbulk'),
('metastorm', 2511, 'tcp', 'Metastorm'),
('citrixima', 2512, 'tcp', 'Citrix IMA'),
('citrixadmin', 2513, 'tcp', 'Citrix ADMIN'),
('facsys-ntp', 2514, 'tcp', 'Facsys NTP'),
('facsys-router', 2515, 'tcp', 'Facsys Router'),
('maincontrol', 2516, 'tcp', 'Main Control'),
('call-sig-trans', 2517, 'tcp', 'H.323 Annex E call signaling transport'),
('willy', 2518, 'tcp', 'Willy'),
('globmsgsvc', 2519, 'tcp', 'globmsgsvc'),
('pvsw', 2520, 'tcp', 'pvsw'),
('adaptecmgr', 2521, 'tcp', 'Adaptec Manager'),
('windb', 2522, 'tcp', 'WinDb'),
('qke-llc-v3', 2523, 'tcp', 'Qke LLC V.3'),
('optiwave-lm', 2524, 'tcp', 'Optiwave License Management'),
('ms-v-worlds', 2525, 'tcp', 'MS V-Worlds'),
('ema-sent-lm', 2526, 'tcp', 'EMA License Manager'),
('iqserver', 2527, 'tcp', 'IQ Server'),
('ncr_ccl', 2528, 'tcp', 'NCR CCL'),
('utsftp', 2529, 'tcp', 'UTS FTP'),
('vrcommerce', 2530, 'tcp', 'VR Commerce'),
('ito-e-gui', 2531, 'tcp', 'ITO-E GUI'),
('ovtopmd', 2532, 'tcp', 'OVTOPMD'),
('snifferserver', 2533, 'tcp', 'SnifferServer'),
('combox-web-acc', 2534, 'tcp', 'Combox Web Access'),
('madcap', 2535, 'tcp', 'MADCAP'),
('btpp2audctr1', 2536, 'tcp', 'btpp2audctr1'),
('upgrade', 2537, 'tcp', 'Upgrade Protocol'),
('vnwk-prapi', 2538, 'tcp', 'vnwk-prapi'),
('vsiadmin', 2539, 'tcp', 'VSI Admin'),
('lonworks', 2540, 'tcp', 'LonWorks'),
('lonworks2', 2541, 'tcp', 'LonWorks2'),
('davinci', 2542, 'tcp', 'daVinci Presenter'),
('reftek', 2543, 'tcp', 'REFTEK'),
('novell-zen', 2544, 'tcp', 'Novell ZEN'),
('sis-emt', 2545, 'tcp', 'sis-emt'),
('vytalvaultbrtp', 2546, 'tcp', 'vytalvaultbrtp'),
('vytalvaultvsmp', 2547, 'tcp', 'vytalvaultvsmp'),
('vytalvaultpipe', 2548, 'tcp', 'vytalvaultpipe'),
('ipass', 2549, 'tcp', 'IPASS'),
('ads', 2550, 'tcp', 'ADS'),
('isg-uda-server', 2551, 'tcp', 'ISG UDA Server'),
('call-logging', 2552, 'tcp', 'Call Logging'),
('efidiningport', 2553, 'tcp', 'efidiningport'),
('vcnet-link-v10', 2554, 'tcp', 'VCnet-Link v10'),
('compaq-wcp', 2555, 'tcp', 'Compaq WCP'),
('nicetec-nmsvc', 2556, 'tcp', 'nicetec-nmsvc'),
('nicetec-mgmt', 2557, 'tcp', 'nicetec-mgmt'),
('pclemultimedia', 2558, 'tcp', 'PCLE Multi Media'),
('lstp', 2559, 'tcp', 'LSTP'),
('labrat', 2560, 'tcp', 'labrat'),
('mosaixcc', 2561, 'tcp', 'MosaixCC'),
('delibo', 2562, 'tcp', 'Delibo'),
('cti-redwood', 2563, 'tcp', 'CTI Redwood'),
('hp-3000-telnet', 2564, 'tcp', 'HP 3000 NS/VT block mode telnet'),
('coord-svr', 2565, 'tcp', 'Coordinator Server'),
('pcs-pcw', 2566, 'tcp', 'pcs-pcw'),
('clp', 2567, 'tcp', 'Cisco Line Protocol'),
('spamtrap', 2568, 'tcp', 'SPAM TRAP'),
('sonuscallsig', 2569, 'tcp', 'Sonus Call Signal'),
('hs-port', 2570, 'tcp', 'HS Port'),
('cecsvc', 2571, 'tcp', 'CECSVC'),
('ibp', 2572, 'tcp', 'IBP'),
('trustestablish', 2573, 'tcp', 'Trust Establish'),
('blockade-bpsp', 2574, 'tcp', 'Blockade BPSP'),
('hl7', 2575, 'tcp', 'HL7'),
('tclprodebugger', 2576, 'tcp', 'TCL Pro Debugger'),
('scipticslsrvr', 2577, 'tcp', 'Scriptics Lsrvr'),
('rvs-isdn-dcp', 2578, 'tcp', 'RVS ISDN DCP'),
('mpfoncl', 2579, 'tcp', 'mpfoncl'),
('tributary', 2580, 'tcp', 'Tributary'),
('argis-te', 2581, 'tcp', 'ARGIS TE'),
('argis-ds', 2582, 'tcp', 'ARGIS DS'),
('mon', 2583, 'tcp', 'MON'),
('cyaserv', 2584, 'tcp', 'cyaserv'),
('netx-server', 2585, 'tcp', 'NETX Server'),
('netx-agent', 2586, 'tcp', 'NETX Agent'),
('masc', 2587, 'tcp', 'MASC'),
('privilege', 2588, 'tcp', 'Privilege'),
('quartus-tcl', 2589, 'tcp', 'quartus tcl'),
('idotdist', 2590, 'tcp', 'idotdist'),
('maytagshuffle', 2591, 'tcp', 'Maytag Shuffle'),
('netrek', 2592, 'tcp', 'netrek'),
('mns-mail', 2593, 'tcp', 'MNS Mail Notice Service'),
('dts', 2594, 'tcp', 'Data Base Server'),
('worldfusion1', 2595, 'tcp', 'World Fusion 1'),
('worldfusion2', 2596, 'tcp', 'World Fusion 2'),
('homesteadglory', 2597, 'tcp', 'Homestead Glory'),
('citriximaclient', 2598, 'tcp', 'Citrix MA Client'),
('meridiandata', 2599, 'tcp', 'Meridian Data'),
('hpstgmgr', 2600, 'tcp', 'HPSTGMGR'),
('discp-client', 2601, 'tcp', 'discp client'),
('discp-server', 2602, 'tcp', 'discp server'),
('servicemeter', 2603, 'tcp', 'Service Meter'),
('nsc-ccs', 2604, 'tcp', 'NSC CCS'),
('nsc-posa', 2605, 'tcp', 'NSC POSA'),
('netmon', 2606, 'tcp', 'Dell Netmon'),
('connection', 2607, 'tcp', 'Dell Connection'),
('wag-service', 2608, 'tcp', 'Wag Service'),
('system-monitor', 2609, 'tcp', 'System Monitor'),
('versa-tek', 2610, 'tcp', 'VersaTek'),
('lionhead', 2611, 'tcp', 'LIONHEAD'),
('qpasa-agent', 2612, 'tcp', 'Qpasa Agent'),
('smntubootstrap', 2613, 'tcp', 'SMNTUBootstrap'),
('neveroffline', 2614, 'tcp', 'Never Offline'),
('firepower', 2615, 'tcp', 'firepower'),
('appswitch-emp', 2616, 'tcp', 'appswitch-emp'),
('cmadmin', 2617, 'tcp', 'Clinical Context Managers'),
('priority-e-com', 2618, 'tcp', 'Priority E-Com'),
('bruce', 2619, 'tcp', 'bruce'),
('lpsrecommender', 2620, 'tcp', 'LPSRecommender'),
('miles-apart', 2621, 'tcp', 'Miles Apart Jukebox Server'),
('metricadbc', 2622, 'tcp', 'MetricaDBC'),
('lmdp', 2623, 'tcp', 'LMDP'),
('aria', 2624, 'tcp', 'Aria'),
('blwnkl-port', 2625, 'tcp', 'Blwnkl Port'),
('gbjd816', 2626, 'tcp', 'gbjd816'),
('moshebeeri', 2627, 'tcp', 'Moshe Beeri'),
('dict', 2628, 'tcp', 'DICT'),
('sitaraserver', 2629, 'tcp', 'Sitara Server'),
('sitaramgmt', 2630, 'tcp', 'Sitara Management'),
('sitaradir', 2631, 'tcp', 'Sitara Dir'),
('irdg-post', 2632, 'tcp', 'IRdg Post'),
('interintelli', 2633, 'tcp', 'InterIntelli'),
('pk-electronics', 2634, 'tcp', 'PK Electronics'),
('backburner', 2635, 'tcp', 'Back Burner'),
('solve', 2636, 'tcp', 'Solve'),
('imdocsvc', 2637, 'tcp', 'Import Document Service'),
('sybaseanywhere', 2638, 'tcp', 'Sybase Anywhere'),
('aminet', 2639, 'tcp', 'AMInet'),
('sai_sentlm', 2640, 'tcp', 'Sabbagh Associates Licence Manager'),
('hdl-srv', 2641, 'tcp', 'HDL Server'),
('tragic', 2642, 'tcp', 'Tragic'),
('gte-samp', 2643, 'tcp', 'GTE-SAMP'),
('travsoft-ipx-t', 2644, 'tcp', 'Travsoft IPX Tunnel'),
('novell-ipx-cmd', 2645, 'tcp', 'Novell IPX CMD'),
('and-lm', 2646, 'tcp', 'AND License Manager'),
('syncserver', 2647, 'tcp', 'SyncServer'),
('upsnotifyprot', 2648, 'tcp', 'Upsnotifyprot'),
('vpsipport', 2649, 'tcp', 'VPSIPPORT'),
('eristwoguns', 2650, 'tcp', 'eristwoguns'),
('ebinsite', 2651, 'tcp', 'EBInSite'),
('interpathpanel', 2652, 'tcp', 'InterPathPanel'),
('sonus', 2653, 'tcp', 'Sonus'),
('corel_vncadmin', 2654, 'tcp', 'Corel VNC Admin'),
('unglue', 2655, 'tcp', 'UNIX Nt Glue'),
('kana', 2656, 'tcp', 'Kana'),
('sns-dispatcher', 2657, 'tcp', 'SNS Dispatcher'),
('sns-admin', 2658, 'tcp', 'SNS Admin'),
('sns-query', 2659, 'tcp', 'SNS Query'),
('gcmonitor', 2660, 'tcp', 'GC Monitor'),
('olhost', 2661, 'tcp', 'OLHOST'),
('bintec-capi', 2662, 'tcp', 'BinTec-CAPI'),
('bintec-tapi', 2663, 'tcp', 'BinTec-TAPI'),
('patrol-mq-gm', 2664, 'tcp', 'Patrol for MQ GM'),
('patrol-mq-nm', 2665, 'tcp', 'Patrol for MQ NM'),
('extensis', 2666, 'tcp', 'extensis'),
('alarm-clock-s', 2667, 'tcp', 'Alarm Clock Server'),
('alarm-clock-c', 2668, 'tcp', 'Alarm Clock Client'),
('toad', 2669, 'tcp', 'TOAD'),
('tve-announce', 2670, 'tcp', 'TVE Announce'),
('newlixreg', 2671, 'tcp', 'newlixreg'),
('nhserver', 2672, 'tcp', 'nhserver'),
('firstcall42', 2673, 'tcp', 'First Call 42'),
('ewnn', 2674, 'tcp', 'ewnn'),
('ttc-etap', 2675, 'tcp', 'TTC ETAP'),
('simslink', 2676, 'tcp', 'SIMSLink'),
('gadgetgate1way', 2677, 'tcp', 'Gadget Gate 1 Way'),
('gadgetgate2way', 2678, 'tcp', 'Gadget Gate 2 Way'),
('syncserverssl', 2679, 'tcp', 'Sync Server SSL'),
('pxc-sapxom', 2680, 'tcp', 'pxc-sapxom'),
('mpnjsomb', 2681, 'tcp', 'mpnjsomb'),
('ncdloadbalance', 2683, 'tcp', 'NCDLoadBalance'),
('mpnjsosv', 2684, 'tcp', 'mpnjsosv'),
('mpnjsocl', 2685, 'tcp', 'mpnjsocl'),
('mpnjsomg', 2686, 'tcp', 'mpnjsomg'),
('pq-lic-mgmt', 2687, 'tcp', 'pq-lic-mgmt'),
('md-cg-http', 2688, 'tcp', 'md-cf-http'),
('fastlynx', 2689, 'tcp', 'FastLynx'),
('hp-nnm-data', 2690, 'tcp', 'HP NNM Embedded Database'),
('itinternet', 2691, 'tcp', 'ITInternet ISM Server'),
('admins-lms', 2692, 'tcp', 'Admins LMS'),
('belarc-http', 2693, 'tcp', 'belarc-http'),
('pwrsevent', 2694, 'tcp', 'pwrsevent'),
('vspread', 2695, 'tcp', 'VSPREAD'),
('unifyadmin', 2696, 'tcp', 'Unify Admin'),
('oce-snmp-trap', 2697, 'tcp', 'Oce SNMP Trap Port'),
('mck-ivpip', 2698, 'tcp', 'MCK-IVPIP'),
('csoft-plusclnt', 2699, 'tcp', 'Csoft Plus Client'),
('tqdata', 2700, 'tcp', 'tqdata'),
('sms-rcinfo', 2701, 'tcp', 'SMS RCINFO'),
('sms-xfer', 2702, 'tcp', 'SMS XFER'),
('sms-chat', 2703, 'tcp', 'SMS CHAT'),
('sms-remctrl', 2704, 'tcp', 'SMS REMCTRL'),
('sds-admin', 2705, 'tcp', 'SDS Admin'),
('ncdmirroring', 2706, 'tcp', 'NCD Mirroring'),
('emcsymapiport', 2707, 'tcp', 'EMCSYMAPIPORT'),
('banyan-net', 2708, 'tcp', 'Banyan-Net'),
('supermon', 2709, 'tcp', 'Supermon'),
('sso-service', 2710, 'tcp', 'SSO Service'),
('sso-control', 2711, 'tcp', 'SSO Control'),
('aocp', 2712, 'tcp', 'Axapta Object Communication Protocol'),
('raven1', 2713, 'tcp', 'Raven1'),
('raven2', 2714, 'tcp', 'Raven2'),
('hpstgmgr2', 2715, 'tcp', 'HPSTGMGR2'),
('inova-ip-disco', 2716, 'tcp', 'Inova IP Disco'),
('pn-requester', 2717, 'tcp', 'PN REQUESTER'),
('pn-requester2', 2718, 'tcp', 'PN REQUESTER 2'),
('scan-change', 2719, 'tcp', 'Scan & Change'),
('wkars', 2720, 'tcp', 'wkars'),
('smart-diagnose', 2721, 'tcp', 'Smart Diagnose'),
('proactivesrvr', 2722, 'tcp', 'Proactive Server'),
('watchdognt', 2723, 'tcp', 'WatchDog NT'),
('qotps', 2724, 'tcp', 'qotps'),
('msolap-ptp2', 2725, 'tcp', 'MSOLAP PTP2'),
('tams', 2726, 'tcp', 'TAMS'),
('mgcp-callagent', 2727, 'tcp', 'Media Gateway Control Protocol Call Agent'),
('sqdr', 2728, 'tcp', 'SQDR'),
('tcim-control', 2729, 'tcp', 'TCIM Control'),
('nec-raidplus', 2730, 'tcp', 'NEC RaidPlus'),
('fyre-messanger', 2731, 'tcp', 'Fyre Messanger'),
('g5m', 2732, 'tcp', 'G5M'),
('signet-ctf', 2733, 'tcp', 'Signet CTF'),
('ccs-software', 2734, 'tcp', 'CCS Software'),
('netiq-mc', 2735, 'tcp', 'NetIQ Monitor Console'),
('radwiz-nms-srv', 2736, 'tcp', 'RADWIZ NMS SRV'),
('srp-feedback', 2737, 'tcp', 'SRP Feedback'),
('ndl-tcp-ois-gw', 2738, 'tcp', 'NDL TCP-OSI Gateway'),
('tn-timing', 2739, 'tcp', 'TN Timing'),
('alarm', 2740, 'tcp', 'Alarm'),
('tsb', 2741, 'tcp', 'TSB'),
('tsb2', 2742, 'tcp', 'TSB2'),
('murx', 2743, 'tcp', 'murx'),
('honyaku', 2744, 'tcp', 'honyaku'),
('urbisnet', 2745, 'tcp', 'URBISNET'),
('cpudpencap', 2746, 'tcp', 'CPUDPENCAP'),
('fjippol-swrly', 2747, 'tcp', ''),
('fjippol-polsvr', 2748, 'tcp', ''),
('fjippol-cnsl', 2749, 'tcp', ''),
('fjippol-port1', 2750, 'tcp', ''),
('fjippol-port2', 2751, 'tcp', ''),
('rsisysaccess', 2752, 'tcp', 'RSISYS ACCESS'),
('de-spot', 2753, 'tcp', 'de-spot'),
('apollo-cc', 2754, 'tcp', 'APOLLO CC'),
('expresspay', 2755, 'tcp', 'Express Pay'),
('simplement-tie', 2756, 'tcp', 'simplement-tie'),
('cnrp', 2757, 'tcp', 'CNRP'),
('apollo-status', 2758, 'tcp', 'APOLLO Status'),
('apollo-gms', 2759, 'tcp', 'APOLLO GMS'),
('sabams', 2760, 'tcp', 'Saba MS'),
('dicom-iscl', 2761, 'tcp', 'DICOM ISCL'),
('dicom-tls', 2762, 'tcp', 'DICOM TLS'),
('desktop-dna', 2763, 'tcp', 'Desktop DNA'),
('data-insurance', 2764, 'tcp', 'Data Insurance'),
('qip-audup', 2765, 'tcp', 'qip-audup'),
('compaq-scp', 2766, 'tcp', 'Compaq SCP'),
('uadtc', 2767, 'tcp', 'UADTC'),
('uacs', 2768, 'tcp', 'UACS'),
('singlept-mvs', 2769, 'tcp', 'Single Point MVS'),
('veronica', 2770, 'tcp', 'Veronica'),
('vergencecm', 2771, 'tcp', 'Vergence CM'),
('auris', 2772, 'tcp', 'auris'),
('pcbakcup1', 2773, 'tcp', 'PC Backup'),
('pcbakcup2', 2774, 'tcp', 'PC Backup'),
('smpp', 2775, 'tcp', 'SMPP'),
('ridgeway1', 2776, 'tcp', 'Ridgeway Systems & Software'),
('ridgeway2', 2777, 'tcp', 'Ridgeway Systems & Software'),
('gwen-sonya', 2778, 'tcp', 'Gwen-Sonya'),
('lbc-sync', 2779, 'tcp', 'LBC Sync'),
('lbc-control', 2780, 'tcp', 'LBC Control'),
('whosells', 2781, 'tcp', 'whosells'),
('everydayrc', 2782, 'tcp', 'everydayrc'),
('aises', 2783, 'tcp', 'AISES'),
('www-dev', 2784, 'tcp', 'world wide web - development'),
('aic-np', 2785, 'tcp', 'aic-np'),
('aic-oncrpc', 2786, 'tcp', 'aic-oncrpc - Destiny MCD database'),
('piccolo', 2787, 'tcp', 'piccolo - Cornerstone Software'),
('fryeserv', 2788, 'tcp', 'NetWare Loadable Module - Seagate Software'),
('media-agent', 2789, 'tcp', 'Media Agent'),
('plgproxy', 2790, 'tcp', 'PLG Proxy'),
('mtport-regist', 2791, 'tcp', 'MT Port Registrator'),
('f5-globalsite', 2792, 'tcp', 'f5-globalsite'),
('initlsmsad', 2793, 'tcp', 'initlsmsad'),
('aaftp', 2794, 'tcp', 'aaftp'),
('livestats', 2795, 'tcp', 'LiveStats'),
('ac-tech', 2796, 'tcp', 'ac-tech'),
('esp-encap', 2797, 'tcp', 'esp-encap'),
('tmesis-upshot', 2798, 'tcp', 'TMESIS-UPShot'),
('icon-discover', 2799, 'tcp', 'ICON Discover'),
('acc-raid', 2800, 'tcp', 'ACC RAID'),
('igcp', 2801, 'tcp', 'IGCP'),
('veritas-tcp1', 2802, 'tcp', 'Veritas TCP1'),
('btprjctrl', 2803, 'tcp', 'btprjctrl'),
('telexis-vtu', 2804, 'tcp', 'Telexis VTU'),
('wta-wsp-s', 2805, 'tcp', 'WTA WSP-S'),
('cspuni', 2806, 'tcp', 'cspuni'),
('cspmulti', 2807, 'tcp', 'cspmulti'),
('j-lan-p', 2808, 'tcp', 'J-LAN-P'),
('corbaloc', 2809, 'tcp', 'CORBA LOC'),
('netsteward', 2810, 'tcp', 'Active Net Steward'),
('gsiftp', 2811, 'tcp', 'GSI FTP'),
('atmtcp', 2812, 'tcp', 'atmtcp'),
('llm-pass', 2813, 'tcp', 'llm-pass'),
('llm-csv', 2814, 'tcp', 'llm-csv'),
('lbc-measure', 2815, 'tcp', 'LBC Measurement'),
('lbc-watchdog', 2816, 'tcp', 'LBC Watchdog'),
('nmsigport', 2817, 'tcp', 'NMSig Port'),
('rmlnk', 2818, 'tcp', 'rmlnk'),
('fc-faultnotify', 2819, 'tcp', 'FC Fault Notification'),
('univision', 2820, 'tcp', 'UniVision'),
('vml-dms', 2821, 'tcp', 'vml_dms'),
('ka0wuc', 2822, 'tcp', 'ka0wuc'),
('cqg-netlan', 2823, 'tcp', 'CQG Net/LAN'),
('cqg-netlan-1', 2824, 'tcp', 'CQG Net/LAN 1'),
('slc-systemlog', 2826, 'tcp', 'slc systemlog'),
('slc-ctrlrloops', 2827, 'tcp', 'slc ctrlrloops'),
('itm-lm', 2828, 'tcp', 'ITM License Manager'),
('silkp1', 2829, 'tcp', 'silkp1'),
('silkp2', 2830, 'tcp', 'silkp2'),
('silkp3', 2831, 'tcp', 'silkp3'),
('silkp4', 2832, 'tcp', 'silkp4'),
('glishd', 2833, 'tcp', 'glishd'),
('evtp', 2834, 'tcp', 'EVTP'),
('evtp-data', 2835, 'tcp', 'EVTP-DATA'),
('catalyst', 2836, 'tcp', 'catalyst'),
('repliweb', 2837, 'tcp', 'Repliweb'),
('starbot', 2838, 'tcp', 'Starbot'),
('nmsigport', 2839, 'tcp', 'NMSigPort'),
('l3-exprt', 2840, 'tcp', 'l3-exprt'),
('l3-ranger', 2841, 'tcp', 'l3-ranger'),
('l3-hawk', 2842, 'tcp', 'l3-hawk'),
('pdnet', 2843, 'tcp', 'PDnet'),
('bpcp-poll', 2844, 'tcp', 'BPCP POLL'),
('bpcp-trap', 2845, 'tcp', 'BPCP TRAP'),
('aimpp-hello', 2846, 'tcp', 'AIMPP Hello'),
('aimpp-port-req', 2847, 'tcp', 'AIMPP Port Req'),
('amt-blc-port', 2848, 'tcp', 'AMT-BLC-PORT'),
('fxp', 2849, 'tcp', 'FXP'),
('metaconsole', 2850, 'tcp', 'MetaConsole'),
('webemshttp', 2851, 'tcp', 'webemshttp'),
('bears-01', 2852, 'tcp', 'bears-01'),
('ispipes', 2853, 'tcp', 'ISPipes'),
('infomover', 2854, 'tcp', 'InfoMover'),
('cesdinv', 2856, 'tcp', 'cesdinv'),
('simctlp', 2857, 'tcp', 'SimCtIP'),
('ecnp', 2858, 'tcp', 'ECNP'),
('activememory', 2859, 'tcp', 'Active Memory'),
('dialpad-voice1', 2860, 'tcp', 'Dialpad Voice 1'),
('dialpad-voice2', 2861, 'tcp', 'Dialpad Voice 2'),
('ttg-protocol', 2862, 'tcp', 'TTG Protocol'),
('sonardata', 2863, 'tcp', 'Sonar Data'),
('astromed-main', 2864, 'tcp', 'main 5001 cmd'),
('pit-vpn', 2865, 'tcp', 'pit-vpn'),
('iwlistener', 2866, 'tcp', 'iwlistener'),
('esps-portal', 2867, 'tcp', 'esps-portal'),
('npep-messaging', 2868, 'tcp', 'NPEP Messaging'),
('icslap', 2869, 'tcp', 'ICSLAP'),
('daishi', 2870, 'tcp', 'daishi'),
('msi-selectplay', 2871, 'tcp', 'MSI Select Play'),
('radix', 2872, 'tcp', 'RADIX'),
('paspar2-zoomin', 2873, 'tcp', 'PASPAR2 ZoomIn'),
('dxmessagebase1', 2874, 'tcp', 'dxmessagebase1'),
('dxmessagebase2', 2875, 'tcp', 'dxmessagebase2'),
('sps-tunnel', 2876, 'tcp', 'SPS Tunnel'),
('bluelance', 2877, 'tcp', 'BLUELANCE'),
('aap', 2878, 'tcp', 'AAP'),
('ucentric-ds', 2879, 'tcp', 'ucentric-ds'),
('synapse', 2880, 'tcp', 'Synapse Transport'),
('ndsp', 2881, 'tcp', 'NDSP'),
('ndtp', 2882, 'tcp', 'NDTP'),
('ndnp', 2883, 'tcp', 'NDNP'),
('flashmsg', 2884, 'tcp', 'Flash Msg'),
('topflow', 2885, 'tcp', 'TopFlow'),
('responselogic', 2886, 'tcp', 'RESPONSELOGIC'),
('aironetddp', 2887, 'tcp', 'aironet'),
('spcsdlobby', 2888, 'tcp', 'SPCSDLOBBY'),
('rsom', 2889, 'tcp', 'RSOM'),
('cspclmulti', 2890, 'tcp', 'CSPCLMULTI'),
('cinegrfx-elmd', 2891, 'tcp', 'CINEGRFX-ELMD License Manager'),
('snifferdata', 2892, 'tcp', 'SNIFFERDATA'),
('vseconnector', 2893, 'tcp', 'VSECONNECTOR'),
('abacus-remote', 2894, 'tcp', 'ABACUS-REMOTE'),
('natuslink', 2895, 'tcp', 'NATUS LINK'),
('ecovisiong6-1', 2896, 'tcp', 'ECOVISIONG6-1'),
('citrix-rtmp', 2897, 'tcp', 'Citrix RTMP'),
('appliance-cfg', 2898, 'tcp', 'APPLIANCE-CFG'),
('powergemplus', 2899, 'tcp', 'POWERGEMPLUS'),
('quicksuite', 2900, 'tcp', 'QUICKSUITE'),
('allstorcns', 2901, 'tcp', 'ALLSTORCNS'),
('netaspi', 2902, 'tcp', 'NET ASPI'),
('suitcase', 2903, 'tcp', 'SUITCASE'),
('m2ua', 2904, 'tcp', 'M2UA'),
('m3ua', 2905, 'tcp', 'M3UA'),
('caller9', 2906, 'tcp', 'CALLER9'),
('webmethods-b2b', 2907, 'tcp', 'WEBMETHODS B2B'),
('mao', 2908, 'tcp', 'mao'),
('funk-dialout', 2909, 'tcp', 'Funk Dialout'),
('tdaccess', 2910, 'tcp', 'TDAccess'),
('blockade', 2911, 'tcp', 'Blockade'),
('epicon', 2912, 'tcp', 'Epicon'),
('boosterware', 2913, 'tcp', 'Booster Ware'),
('gamelobby', 2914, 'tcp', 'Game Lobby'),
('tksocket', 2915, 'tcp', 'TK Socket'),
('elvin_server', 2916, 'tcp', 'Elvin Server'),
('elvin_client', 2917, 'tcp', 'Elvin Client'),
('kastenchasepad', 2918, 'tcp', 'Kasten Chase Pad'),
('roboer', 2919, 'tcp', 'ROBOER'),
('roboeda', 2920, 'tcp', 'ROBOEDA'),
('cesdcdman', 2921, 'tcp', 'CESD Contents Delivery Management'),
('cesdcdtrn', 2922, 'tcp', 'CESD Contents Delivery Data Transfer'),
('wta-wsp-wtp-s', 2923, 'tcp', 'WTA-WSP-WTP-S'),
('precise-vip', 2924, 'tcp', 'PRECISE-VIP'),
('mobile-file-dl', 2926, 'tcp', 'MOBILE-FILE-DL'),
('unimobilectrl', 2927, 'tcp', 'UNIMOBILECTRL'),
('redstone-cpss', 2928, 'tcp', 'REDSTONE-CPSS'),
('panja-webadmin', 2929, 'tcp', 'PANJA-WEBADMIN'),
('panja-weblinx', 2930, 'tcp', 'PANJA-WEBLINX'),
('circle-x', 2931, 'tcp', 'Circle-X'),
('incp', 2932, 'tcp', 'INCP'),
('4-tieropmgw', 2933, 'tcp', '4-TIER OPM GW'),
('4-tieropmcli', 2934, 'tcp', '4-TIER OPM CLI'),
('qtp', 2935, 'tcp', 'QTP'),
('otpatch', 2936, 'tcp', 'OTPatch'),
('pnaconsult-lm', 2937, 'tcp', 'PNACONSULT-LM'),
('sm-pas-1', 2938, 'tcp', 'SM-PAS-1'),
('sm-pas-2', 2939, 'tcp', 'SM-PAS-2'),
('sm-pas-3', 2940, 'tcp', 'SM-PAS-3'),
('sm-pas-4', 2941, 'tcp', 'SM-PAS-4'),
('sm-pas-5', 2942, 'tcp', 'SM-PAS-5'),
('ttnrepository', 2943, 'tcp', 'TTNRepository'),
('megaco-h248', 2944, 'tcp', 'Megaco H-248'),
('h248-binary', 2945, 'tcp', 'H248 Binary'),
('fjsvmpor', 2946, 'tcp', 'FJSVmpor'),
('gpsd', 2947, 'tcp', 'GPSD'),
('wap-push', 2948, 'tcp', 'WAP PUSH'),
('wap-pushsecure', 2949, 'tcp', 'WAP PUSH SECURE'),
('esip', 2950, 'tcp', 'ESIP'),
('ottp', 2951, 'tcp', 'OTTP'),
('mpfwsas', 2952, 'tcp', 'MPFWSAS'),
('ovalarmsrv', 2953, 'tcp', 'OVALARMSRV'),
('ovalarmsrv-cmd', 2954, 'tcp', 'OVALARMSRV-CMD'),
('csnotify', 2955, 'tcp', 'CSNOTIFY'),
('ovrimosdbman', 2956, 'tcp', 'OVRIMOSDBMAN'),
('jmact5', 2957, 'tcp', 'JAMCT5'),
('jmact6', 2958, 'tcp', 'JAMCT6'),
('rmopagt', 2959, 'tcp', 'RMOPAGT'),
('dfoxserver', 2960, 'tcp', 'DFOXSERVER'),
('boldsoft-lm', 2961, 'tcp', 'BOLDSOFT-LM'),
('iph-policy-cli', 2962, 'tcp', 'IPH-POLICY-CLI'),
('iph-policy-adm', 2963, 'tcp', 'IPH-POLICY-ADM'),
('bullant-srap', 2964, 'tcp', 'BULLANT SRAP'),
('bullant-rap', 2965, 'tcp', 'BULLANT RAP'),
('idp-infotrieve', 2966, 'tcp', 'IDP-INFOTRIEVE'),
('ssc-agent', 2967, 'tcp', 'SSC-AGENT'),
('enpp', 2968, 'tcp', 'ENPP'),
('essp', 2969, 'tcp', 'ESSP'),
('index-net', 2970, 'tcp', 'INDEX-NET'),
('netclip', 2971, 'tcp', 'NetClip clipboard daemon'),
('pmsm-webrctl', 2972, 'tcp', 'PMSM Webrctl'),
('svnetworks', 2973, 'tcp', 'SV Networks'),
('signal', 2974, 'tcp', 'Signal'),
('fjmpcm', 2975, 'tcp', 'Fujitsu Configuration Management Service'),
('cns-srv-port', 2976, 'tcp', 'CNS Server Port'),
('ttc-etap-ns', 2977, 'tcp', 'TTCs Enterprise Test Access Protocol - NS'),
('ttc-etap-ds', 2978, 'tcp', 'TTCs Enterprise Test Access Protocol - DS'),
('h263-video', 2979, 'tcp', 'H.263 Video Streaming'),
('wimd', 2980, 'tcp', 'Instant Messaging Service'),
('mylxamport', 2981, 'tcp', 'MYLXAMPORT'),
('iwb-whiteboard', 2982, 'tcp', 'IWB-WHITEBOARD'),
('netplan', 2983, 'tcp', 'NETPLAN'),
('hpidsadmin', 2984, 'tcp', 'HPIDSADMIN'),
('hpidsagent', 2985, 'tcp', 'HPIDSAGENT'),
('stonefalls', 2986, 'tcp', 'STONEFALLS'),
('identify', 2987, 'tcp', 'identify'),
('hippad', 2988, 'tcp', 'HIPPA Reporting Protocol'),
('zarkov', 2989, 'tcp', 'ZARKOV'),
('boscap', 2990, 'tcp', 'BOSCAP'),
('wkstn-mon', 2991, 'tcp', 'WKSTN-MON'),
('itb301', 2992, 'tcp', 'ITB301'),
('veritas-vis1', 2993, 'tcp', 'VERITAS VIS1'),
('veritas-vis2', 2994, 'tcp', 'VERITAS VIS2'),
('idrs', 2995, 'tcp', 'IDRS'),
('vsixml', 2996, 'tcp', 'vsixml'),
('rebol', 2997, 'tcp', 'REBOL'),
('realsecure', 2998, 'tcp', 'Real Secure'),
('remoteware-un', 2999, 'tcp', 'RemoteWare Unassigned'),
('hbci', 3000, 'tcp', 'HBCI'),
('remoteware-cl', 3000, 'tcp', 'RemoteWare Client'),
('redwood-broker', 3001, 'tcp', 'Redwood Broker'),
('exlm-agent', 3002, 'tcp', 'EXLM Agent'),
('remoteware-srv', 3002, 'tcp', 'RemoteWare Server'),
('cgms', 3003, 'tcp', 'CGMS'),
('csoftragent', 3004, 'tcp', 'Csoft Agent'),
('geniuslm', 3005, 'tcp', 'Genius License Manager'),
('ii-admin', 3006, 'tcp', 'Instant Internet Admin'),
('lotusmtap', 3007, 'tcp', 'Lotus Mail Tracking Agent Protocol'),
('midnight-tech', 3008, 'tcp', 'Midnight Technologies'),
('pxc-ntfy', 3009, 'tcp', 'PXC-NTFY'),
('gw', 3010, 'tcp', 'Telerate Workstation'),
('trusted-web', 3011, 'tcp', 'Trusted Web'),
('twsdss', 3012, 'tcp', 'Trusted Web Client'),
('gilatskysurfer', 3013, 'tcp', 'Gilat Sky Surfer'),
('broker_service', 3014, 'tcp', 'Broker Service'),
('nati-dstp', 3015, 'tcp', 'NATI DSTP'),
('notify_srvr', 3016, 'tcp', 'Notify Server'),
('event_listener', 3017, 'tcp', 'Event Listener'),
('srvc_registry', 3018, 'tcp', 'Service Registry'),
('resource_mgr', 3019, 'tcp', 'Resource Manager'),
('cifs', 3020, 'tcp', 'CIFS'),
('agriserver', 3021, 'tcp', 'AGRI Server'),
('csregagent', 3022, 'tcp', 'CSREGAGENT'),
('magicnotes', 3023, 'tcp', 'magicnotes'),
('nds_sso', 3024, 'tcp', 'NDS_SSO'),
('arepa-raft', 3025, 'tcp', 'Arepa Raft'),
('agri-gateway', 3026, 'tcp', 'AGRI Gateway'),
('LiebDevMgmt_C', 3027, 'tcp', 'LiebDevMgmt_C'),
('LiebDevMgmt_DM', 3028, 'tcp', 'LiebDevMgmt_DM'),
('LiebDevMgmt_A', 3029, 'tcp', 'LiebDevMgmt_A'),
('arepa-cas', 3030, 'tcp', 'Arepa Cas'),
('eppc', 3031, 'tcp', 'Remote AppleEvents/PPC Toolbox'),
('redwood-chat', 3032, 'tcp', 'Redwood Chat'),
('pdb', 3033, 'tcp', 'PDB'),
('osmosis-aeea', 3034, 'tcp', 'Osmosis / Helix (R) AEEA Port'),
('fjsv-gssagt', 3035, 'tcp', 'FJSV gssagt'),
('hagel-dump', 3036, 'tcp', 'Hagel DUMP'),
('hp-san-mgmt', 3037, 'tcp', 'HP SAN Mgmt'),
('santak-ups', 3038, 'tcp', 'Santak UPS'),
('cogitate', 3039, 'tcp', 'Cogitate, Inc.'),
('tomato-springs', 3040, 'tcp', 'Tomato Springs'),
('di-traceware', 3041, 'tcp', 'di-traceware'),
('journee', 3042, 'tcp', 'journee'),
('brp', 3043, 'tcp', 'BRP'),
('epp', 3044, 'tcp', 'EndPoint Protocol'),
('responsenet', 3045, 'tcp', 'ResponseNet'),
('di-ase', 3046, 'tcp', 'di-ase'),
('hlserver', 3047, 'tcp', 'Fast Security HL Server'),
('pctrader', 3048, 'tcp', 'Sierra Net PC Trader'),
('nsws', 3049, 'tcp', 'NSWS'),
('gds_db', 3050, 'tcp', 'gds_db'),
('galaxy-server', 3051, 'tcp', 'Galaxy Server'),
('apcpcns', 3052, 'tcp', 'APCPCNS'),
('dsom-server', 3053, 'tcp', 'dsom-server'),
('amt-cnf-prot', 3054, 'tcp', 'AMT CNF PROT'),
('policyserver', 3055, 'tcp', 'Policy Server'),
('cdl-server', 3056, 'tcp', 'CDL Server'),
('goahead-fldup', 3057, 'tcp', 'GoAhead FldUp'),
('videobeans', 3058, 'tcp', 'videobeans'),
('qsoft', 3059, 'tcp', 'qsoft'),
('interserver', 3060, 'tcp', 'interserver'),
('cautcpd', 3061, 'tcp', 'cautcpd'),
('ncacn-ip-tcp', 3062, 'tcp', 'ncacn-ip-tcp'),
('ncadg-ip-udp', 3063, 'tcp', 'ncadg-ip-udp'),
('rprt', 3064, 'tcp', 'Remote Port Redirector'),
('slinterbase', 3065, 'tcp', 'slinterbase'),
('netattachsdmp', 3066, 'tcp', 'NETATTACHSDMP'),
('fjhpjp', 3067, 'tcp', 'FJHPJP'),
('ls3bcast', 3068, 'tcp', 'ls3 Broadcast'),
('ls3', 3069, 'tcp', 'ls3'),
('mgxswitch', 3070, 'tcp', 'MGXSWITCH'),
('csd-mgmt-port', 3071, 'tcp', 'ContinuStor Manager Port'),
('csd-monitor', 3072, 'tcp', 'ContinuStor Monitor Port'),
('vcrp', 3073, 'tcp', 'Very simple chatroom prot'),
('xbox', 3074, 'tcp', 'Xbox game port'),
('orbix-locator', 3075, 'tcp', 'Orbix 2000 Locator'),
('orbix-config', 3076, 'tcp', 'Orbix 2000 Config'),
('orbix-loc-ssl', 3077, 'tcp', 'Orbix 2000 Locator SSL'),
('orbix-cfg-ssl', 3078, 'tcp', 'Orbix 2000 Locator SSL'),
('lv-frontpanel', 3079, 'tcp', 'LV Front Panel'),
('stm_pproc', 3080, 'tcp', 'stm_pproc'),
('tl1-lv', 3081, 'tcp', 'TL1-LV'),
('tl1-raw', 3082, 'tcp', 'TL1-RAW'),
('tl1-telnet', 3083, 'tcp', 'TL1-TELNET'),
('itm-mccs', 3084, 'tcp', 'ITM-MCCS'),
('pcihreq', 3085, 'tcp', 'PCIHReq'),
('jdl-dbkitchen', 3086, 'tcp', 'JDL-DBKitchen'),
('asoki-sma', 3087, 'tcp', 'Asoki SMA'),
('xdtp', 3088, 'tcp', 'eXtensible Data Transfer Protocol'),
('ptk-alink', 3089, 'tcp', 'ParaTek Agent Linking'),
('rtss', 3090, 'tcp', 'Rappore Session Services'),
('1ci-smcs', 3091, 'tcp', '1Ci Server Management'),
('njfss', 3092, 'tcp', 'Netware sync services'),
('rapidmq-center', 3093, 'tcp', 'Jiiva RapidMQ Center'),
('rapidmq-reg', 3094, 'tcp', 'Jiiva RapidMQ Registry'),
('panasas', 3095, 'tcp', 'Panasas rendevous port'),
('ndl-aps', 3096, 'tcp', 'Active Print Server Port'),
('umm-port', 3098, 'tcp', 'Universal Message Manager'),
('chmd', 3099, 'tcp', 'CHIPSY Machine Daemon'),
('opcon-xps', 3100, 'tcp', 'OpCon/xps'),
('hp-pxpib', 3101, 'tcp', 'HP PolicyXpert PIB Server'),
('slslavemon', 3102, 'tcp', 'SoftlinK Slave Mon Port'),
('autocuesmi', 3103, 'tcp', 'Autocue SMI Protocol'),
('autocuelog', 3104, 'tcp', 'Autocue Logger Protocol'),
('cardbox', 3105, 'tcp', 'Cardbox'),
('cardbox-http', 3106, 'tcp', 'Cardbox HTTP'),
('business', 3107, 'tcp', 'Business protocol'),
('geolocate', 3108, 'tcp', 'Geolocate protocol'),
('personnel', 3109, 'tcp', 'Personnel protocol'),
('sim-control', 3110, 'tcp', 'simulator control port'),
('wsynch', 3111, 'tcp', 'Web Synchronous Services'),
('ksysguard', 3112, 'tcp', 'KDE System Guard'),
('cs-auth-svr', 3113, 'tcp', 'CS-Authenticate Svr Port'),
('ccmad', 3114, 'tcp', 'CCM AutoDiscover'),
('mctet-master', 3115, 'tcp', 'MCTET Master'),
('mctet-gateway', 3116, 'tcp', 'MCTET Gateway'),
('mctet-jserv', 3117, 'tcp', 'MCTET Jserv'),
('pkagent', 3118, 'tcp', 'PKAgent'),
('d2000kernel', 3119, 'tcp', 'D2000 Kernel Port'),
('d2000webserver', 3120, 'tcp', 'D2000 Webserver Port'),
('epp-temp', 3121, 'tcp', 'Extensible Provisioning Protocol'),
('vtr-emulator', 3122, 'tcp', 'MTI VTR Emulator port'),
('edix', 3123, 'tcp', 'EDI Translation Protocol'),
('beacon-port', 3124, 'tcp', 'Beacon Port'),
('a13-an', 3125, 'tcp', 'A13-AN Interface'),
('ms-dotnetster', 3126, 'tcp', 'Microsoft .NETster Port'),
('ctx-bridge', 3127, 'tcp', 'CTX Bridge Port'),
('ndl-aas', 3128, 'tcp', 'Active API Server Port'),
('netport-id', 3129, 'tcp', 'NetPort Discovery Port'),
('icpv2', 3130, 'tcp', 'ICPv2'),
('netbookmark', 3131, 'tcp', 'Net Book Mark'),
('ms-slipstream', 3132, 'tcp', 'MS-Slipstream'),
('prism-deploy', 3133, 'tcp', 'Prism Deploy User Port'),
('ecp', 3134, 'tcp', 'Extensible Code Protocol'),
('peerbook-port', 3135, 'tcp', 'PeerBook Port'),
('grubd', 3136, 'tcp', 'Grub Server Port'),
('rtnt-1', 3137, 'tcp', 'rtnt-1 data packets'),
('rtnt-2', 3138, 'tcp', 'rtnt-2 data packets'),
('incognitorv', 3139, 'tcp', 'Incognito Rendez-Vous'),
('ariliamulti', 3140, 'tcp', 'Arilia Multiplexor'),
('vmodem', 3141, 'tcp', 'VMODEM'),
('rdc-wh-eos', 3142, 'tcp', 'RDC WH EOS'),
('seaview', 3143, 'tcp', 'Sea View'),
('tarantella', 3144, 'tcp', 'Tarantella'),
('csi-lfap', 3145, 'tcp', 'CSI-LFAP'),
('bears-02', 3146, 'tcp', 'bears-02'),
('rfio', 3147, 'tcp', 'RFIO'),
('nm-game-admin', 3148, 'tcp', 'NetMike Game Administrator'),
('nm-game-server', 3149, 'tcp', 'NetMike Game Server'),
('nm-asses-admin', 3150, 'tcp', 'NetMike Assessor Administrator'),
('nm-assessor', 3151, 'tcp', 'NetMike Assessor'),
('feitianrockey', 3152, 'tcp', 'FeiTian Port'),
('s8-client-port', 3153, 'tcp', 'S8Cargo Client Port'),
('ccmrmi', 3154, 'tcp', 'ON RMI Registry'),
('jpegmpeg', 3155, 'tcp', 'JpegMpeg Port'),
('indura', 3156, 'tcp', 'Indura Collector'),
('e3consultants', 3157, 'tcp', 'CCC Listener Port'),
('stvp', 3158, 'tcp', 'SmashTV Protocol'),
('navegaweb-port', 3159, 'tcp', 'NavegaWeb Tarification'),
('tip-app-server', 3160, 'tcp', 'TIP Application Server'),
('doc1lm', 3161, 'tcp', 'DOC1 License Manager'),
('sflm', 3162, 'tcp', 'SFLM'),
('res-sap', 3163, 'tcp', 'RES-SAP'),
('imprs', 3164, 'tcp', 'IMPRS'),
('newgenpay', 3165, 'tcp', 'Newgenpay Engine Service'),
('qrepos', 3166, 'tcp', 'Quest Repository'),
('poweroncontact', 3167, 'tcp', 'poweroncontact'),
('poweronnud', 3168, 'tcp', 'poweronnud'),
('serverview-as', 3169, 'tcp', 'SERVERVIEW-AS'),
('serverview-asn', 3170, 'tcp', 'SERVERVIEW-ASN'),
('serverview-gf', 3171, 'tcp', 'SERVERVIEW-GF'),
('serverview-rm', 3172, 'tcp', 'SERVERVIEW-RM'),
('serverview-icc', 3173, 'tcp', 'SERVERVIEW-ICC'),
('armi-server', 3174, 'tcp', 'ARMI Server'),
('t1-e1-over-ip', 3175, 'tcp', 'T1_E1_Over_IP'),
('ars-master', 3176, 'tcp', 'ARS Master'),
('phonex-port', 3177, 'tcp', 'Phonex Protocol'),
('radclientport', 3178, 'tcp', 'Radiance UltraEdge Port'),
('h2gf-w-2m', 3179, 'tcp', 'H2GF W.2m Handover prot.'),
('mc-brk-srv', 3180, 'tcp', 'Millicent Broker Server'),
('bmcpatrolagent', 3181, 'tcp', 'BMC Patrol Agent'),
('bmcpatrolrnvu', 3182, 'tcp', 'BMC Patrol Rendezvous'),
('cops-tls', 3183, 'tcp', 'COPS/TLS'),
('apogeex-port', 3184, 'tcp', 'ApogeeX Port'),
('smpppd', 3185, 'tcp', 'SuSE Meta PPPD'),
('iiw-port', 3186, 'tcp', 'IIW Monitor User Port'),
('odi-port', 3187, 'tcp', 'Open Design Listen Port'),
('brcm-comm-port', 3188, 'tcp', 'Broadcom Port'),
('pcle-infex', 3189, 'tcp', 'Pinnacle Sys InfEx Port'),
('csvr-proxy', 3190, 'tcp', 'ConServR Proxy'),
('csvr-sslproxy', 3191, 'tcp', 'ConServR SSL Proxy'),
('firemonrcc', 3192, 'tcp', 'FireMon Revision Control'),
('cordataport', 3193, 'tcp', 'Cordaxis Data Port'),
('magbind', 3194, 'tcp', 'Rockstorm MAG protocol'),
('ncu-1', 3195, 'tcp', 'Network Control Unit'),
('ncu-2', 3196, 'tcp', 'Network Control Unit'),
('embrace-dp-s', 3197, 'tcp', 'Embrace Device Protocol Server'),
('embrace-dp-c', 3198, 'tcp', 'Embrace Device Protocol Client'),
('dmod-workspace', 3199, 'tcp', 'DMOD WorkSpace'),
('tick-port', 3200, 'tcp', 'Press-sense Tick Port'),
('cpq-tasksmart', 3201, 'tcp', 'CPQ-TaskSmart'),
('intraintra', 3202, 'tcp', 'IntraIntra'),
('netwatcher-mon', 3203, 'tcp', 'Network Watcher Monitor'),
('netwatcher-db', 3204, 'tcp', 'Network Watcher DB Access'),
('isns', 3205, 'tcp', 'iSNS Server Port'),
('ironmail', 3206, 'tcp', 'IronMail POP Proxy'),
('vx-auth-port', 3207, 'tcp', 'Veritas Authentication Port'),
('pfu-prcallback', 3208, 'tcp', 'PFU PR Callback'),
('netwkpathengine', 3209, 'tcp', 'HP OpenView Network Path Engine Server'),
('flamenco-proxy', 3210, 'tcp', 'Flamenco Networks Proxy'),
('avsecuremgmt', 3211, 'tcp', 'Avocent Secure Management'),
('surveyinst', 3212, 'tcp', 'Survey Instrument'),
('neon24x7', 3213, 'tcp', 'NEON 24X7 Mission Control'),
('jmq-daemon-1', 3214, 'tcp', 'JMQ Daemon Port 1'),
('jmq-daemon-2', 3215, 'tcp', 'JMQ Daemon Port 2'),
('ferrari-foam', 3216, 'tcp', 'Ferrari electronic FOAM'),
('unite', 3217, 'tcp', 'Unified IP & Telecomm Env'),
('smartpackets', 3218, 'tcp', 'EMC SmartPackets'),
('wms-messenger', 3219, 'tcp', 'WMS Messenger'),
('xnm-ssl', 3220, 'tcp', 'XML NM over SSL'),
('xnm-clear-text', 3221, 'tcp', 'XML NM over TCP'),
('glbp', 3222, 'tcp', 'Gateway Load Balancing Pr'),
('digivote', 3223, 'tcp', 'DIGIVOTE (R) Vote-Server'),
('aes-discovery', 3224, 'tcp', 'AES Discovery Port'),
('fcip-port', 3225, 'tcp', 'FCIP'),
('isi-irp', 3226, 'tcp', 'ISI Industry Software IRP'),
('dwnmshttp', 3227, 'tcp', 'DiamondWave NMS Server'),
('dwmsgserver', 3228, 'tcp', 'DiamondWave MSG Server'),
('global-cd-port', 3229, 'tcp', 'Global CD Port'),
('sftdst-port', 3230, 'tcp', 'Software Distributor Port'),
('dsnl', 3231, 'tcp', 'Delta Solutions Direct'),
('mdtp', 3232, 'tcp', 'MDT port'),
('whisker', 3233, 'tcp', 'WhiskerControl main port'),
('alchemy', 3234, 'tcp', 'Alchemy Server'),
('mdap-port', 3235, 'tcp', 'MDAP port'),
('apparenet-ts', 3236, 'tcp', 'appareNet Test Server'),
('apparenet-tps', 3237, 'tcp', 'appareNet Test Packet Sequencer'),
('apparenet-as', 3238, 'tcp', 'appareNet Analysis Server'),
('apparenet-ui', 3239, 'tcp', 'appareNet User Interface'),
('triomotion', 3240, 'tcp', 'Trio Motion Control Port'),
('sysorb', 3241, 'tcp', 'SysOrb Monitoring Server'),
('sdp-id-port', 3242, 'tcp', 'Session Description ID'),
('timelot', 3243, 'tcp', 'Timelot Port'),
('onesaf', 3244, 'tcp', 'OneSAF'),
('vieo-fe', 3245, 'tcp', 'VIEO Fabric Executive'),
('dvt-system', 3246, 'tcp', 'DVT SYSTEM PORT'),
('dvt-data', 3247, 'tcp', 'DVT DATA LINK'),
('procos-lm', 3248, 'tcp', 'PROCOS LM'),
('ssp', 3249, 'tcp', 'State Sync Protocol'),
('hicp', 3250, 'tcp', 'HMS hicp port'),
('sysscanner', 3251, 'tcp', 'Sys Scanner'),
('dhe', 3252, 'tcp', 'DHE port'),
('pda-data', 3253, 'tcp', 'PDA Data'),
('pda-sys', 3254, 'tcp', 'PDA System'),
('semaphore', 3255, 'tcp', 'Semaphore Connection Port'),
('cpqrpm-agent', 3256, 'tcp', 'Compaq RPM Agent Port'),
('cpqrpm-server', 3257, 'tcp', 'Compaq RPM Server Port'),
('ivecon-port', 3258, 'tcp', 'Ivecon Server Port'),
('epncdp2', 3259, 'tcp', 'Epson Network Common Devi'),
('iscsi-target', 3260, 'tcp', 'iSCSI port'),
('winshadow', 3261, 'tcp', 'winShadow'),
('necp', 3262, 'tcp', 'NECP'),
('ecolor-imager', 3263, 'tcp', 'E-Color Enterprise Imager'),
('ccmail', 3264, 'tcp', 'cc:mail/lotus'),
('altav-tunnel', 3265, 'tcp', 'Altav Tunnel'),
('ns-cfg-server', 3266, 'tcp', 'NS CFG Server'),
('ibm-dial-out', 3267, 'tcp', 'IBM Dial Out'),
('msft-gc', 3268, 'tcp', 'Microsoft Global Catalog'),
('msft-gc-ssl', 3269, 'tcp', 'Microsoft Global Catalog with LDAP/SSL'),
('verismart', 3270, 'tcp', 'Verismart'),
('csoft-prev', 3271, 'tcp', 'CSoft Prev Port'),
('user-manager', 3272, 'tcp', 'Fujitsu User Manager'),
('sxmp', 3273, 'tcp', 'Simple Extensible Multiplexed Protocol'),
('ordinox-server', 3274, 'tcp', 'Ordinox Server'),
('samd', 3275, 'tcp', 'SAMD'),
('maxim-asics', 3276, 'tcp', 'Maxim ASICs'),
('awg-proxy', 3277, 'tcp', 'AWG Proxy'),
('lkcmserver', 3278, 'tcp', 'LKCM Server'),
('admind', 3279, 'tcp', 'admind'),
('vs-server', 3280, 'tcp', 'VS Server'),
('sysopt', 3281, 'tcp', 'SYSOPT'),
('datusorb', 3282, 'tcp', 'Datusorb'),
('net-assistant', 3283, 'tcp', 'Net Assistant'),
('4talk', 3284, 'tcp', '4Talk'),
('plato', 3285, 'tcp', 'Plato'),
('e-net', 3286, 'tcp', 'E-Net'),
('directvdata', 3287, 'tcp', 'DIRECTVDATA'),
('cops', 3288, 'tcp', 'COPS'),
('enpc', 3289, 'tcp', 'ENPC'),
('caps-lm', 3290, 'tcp', 'CAPS LOGISTICS TOOLKIT - LM'),
('sah-lm', 3291, 'tcp', 'S A Holditch & Associates - LM'),
('cart-o-rama', 3292, 'tcp', 'Cart O Rama'),
('fg-fps', 3293, 'tcp', 'fg-fps'),
('fg-gip', 3294, 'tcp', 'fg-gip'),
('dyniplookup', 3295, 'tcp', 'Dynamic IP Lookup'),
('rib-slm', 3296, 'tcp', 'Rib License Manager'),
('cytel-lm', 3297, 'tcp', 'Cytel License Manager'),
('transview', 3298, 'tcp', 'Transview'),
('pdrncs', 3299, 'tcp', 'pdrncs'),
('mcs-fastmail', 3302, 'tcp', 'MCS Fastmail'),
('opsession-clnt', 3303, 'tcp', 'OP Session Client'),
('opsession-srvr', 3304, 'tcp', 'OP Session Server'),
('odette-ftp', 3305, 'tcp', 'ODETTE-FTP'),
('mysql', 3306, 'tcp', 'MySQL'),
('opsession-prxy', 3307, 'tcp', 'OP Session Proxy'),
('tns-server', 3308, 'tcp', 'TNS Server'),
('tns-adv', 3309, 'tcp', 'TNS ADV'),
('dyna-access', 3310, 'tcp', 'Dyna Access'),
('mcns-tel-ret', 3311, 'tcp', 'MCNS Tel Ret'),
('appman-server', 3312, 'tcp', 'Application Management Server'),
('uorb', 3313, 'tcp', 'Unify Object Broker'),
('uohost', 3314, 'tcp', 'Unify Object Host'),
('cdid', 3315, 'tcp', 'CDID'),
('aicc-cmi', 3316, 'tcp', 'AICC/CMI'),
('vsaiport', 3317, 'tcp', 'VSAI PORT'),
('ssrip', 3318, 'tcp', 'Swith to Swith Routing Information Protocol'),
('sdt-lmd', 3319, 'tcp', 'SDT License Manager'),
('officelink2000', 3320, 'tcp', 'Office Link 2000'),
('vnsstr', 3321, 'tcp', 'VNSSTR'),
('sftu', 3326, 'tcp', 'SFTU'),
('bbars', 3327, 'tcp', 'BBARS'),
('egptlm', 3328, 'tcp', 'Eaglepoint License Manager'),
('hp-device-disc', 3329, 'tcp', 'HP Device Disc'),
('mcs-calypsoicf', 3330, 'tcp', 'MCS Calypso ICF'),
('mcs-messaging', 3331, 'tcp', 'MCS Messaging'),
('mcs-mailsvr', 3332, 'tcp', 'MCS Mail Server'),
('dec-notes', 3333, 'tcp', 'DEC Notes'),
('directv-web', 3334, 'tcp', 'Direct TV Webcasting'),
('directv-soft', 3335, 'tcp', 'Direct TV Software Updates'),
('directv-tick', 3336, 'tcp', 'Direct TV Tickers'),
('directv-catlg', 3337, 'tcp', 'Direct TV Data Catalog'),
('anet-b', 3338, 'tcp', 'OMF data b'),
('anet-l', 3339, 'tcp', 'OMF data l'),
('anet-m', 3340, 'tcp', 'OMF data m'),
('anet-h', 3341, 'tcp', 'OMF data h'),
('webtie', 3342, 'tcp', 'WebTIE'),
('ms-cluster-net', 3343, 'tcp', 'MS Cluster Net'),
('bnt-manager', 3344, 'tcp', 'BNT Manager'),
('influence', 3345, 'tcp', 'Influence'),
('trnsprntproxy', 3346, 'tcp', 'Trnsprnt Proxy'),
('phoenix-rpc', 3347, 'tcp', 'Phoenix RPC'),
('pangolin-laser', 3348, 'tcp', 'Pangolin Laser'),
('chevinservices', 3349, 'tcp', 'Chevin Services'),
('findviatv', 3350, 'tcp', 'FINDVIATV'),
('btrieve', 3351, 'tcp', 'BTRIEVE'),
('ssql', 3352, 'tcp', 'SSQL'),
('fatpipe', 3353, 'tcp', 'FATPIPE'),
('suitjd', 3354, 'tcp', 'SUITJD'),
('ordinox-dbase', 3355, 'tcp', 'Ordinox Dbase'),
('upnotifyps', 3356, 'tcp', 'UPNOTIFYPS'),
('adtech-test', 3357, 'tcp', 'Adtech Test IP'),
('mpsysrmsvr', 3358, 'tcp', 'Mp Sys Rmsvr'),
('wg-netforce', 3359, 'tcp', 'WG NetForce'),
('kv-server', 3360, 'tcp', 'KV Server'),
('kv-agent', 3361, 'tcp', 'KV Agent'),
('dj-ilm', 3362, 'tcp', 'DJ ILM'),
('nati-vi-server', 3363, 'tcp', 'NATI Vi Server'),
('creativeserver', 3364, 'tcp', 'Creative Server'),
('contentserver', 3365, 'tcp', 'Content Server'),
('creativepartnr', 3366, 'tcp', 'Creative Partner'),
('tip2', 3372, 'tcp', 'TIP 2'),
('lavenir-lm', 3373, 'tcp', 'Lavenir License Manager'),
('cluster-disc', 3374, 'tcp', 'Cluster Disc'),
('vsnm-agent', 3375, 'tcp', 'VSNM Agent'),
('cdbroker', 3376, 'tcp', 'CD Broker'),
('cogsys-lm', 3377, 'tcp', 'Cogsys Network License Manager'),
('wsicopy', 3378, 'tcp', 'WSICOPY'),
('socorfs', 3379, 'tcp', 'SOCORFS'),
('sns-channels', 3380, 'tcp', 'SNS Channels'),
('geneous', 3381, 'tcp', 'Geneous'),
('fujitsu-neat', 3382, 'tcp', 'Fujitsu Network Enhanced Antitheft function'),
('esp-lm', 3383, 'tcp', 'Enterprise Software Products License Manager'),
('hp-clic', 3384, 'tcp', 'Cluster Management Services'),
('qnxnetman', 3385, 'tcp', 'qnxnetman'),
('gprs-data', 3386, 'tcp', 'GPRS Data'),
('backroomnet', 3387, 'tcp', 'Back Room Net'),
('cbserver', 3388, 'tcp', 'CB Server'),
('ms-wbt-server', 3389, 'tcp', 'MS WBT Server'),
('dsc', 3390, 'tcp', 'Distributed Service Coordinator'),
('savant', 3391, 'tcp', 'SAVANT'),
('efi-lm', 3392, 'tcp', 'EFI License Management'),
('d2k-tapestry1', 3393, 'tcp', 'D2K Tapestry Client to Server'),
('d2k-tapestry2', 3394, 'tcp', 'D2K Tapestry Server to Server'),
('dyna-lm', 3395, 'tcp', 'Dyna License Manager (Elam)'),
('printer_agent', 3396, 'tcp', 'Printer Agent'),
('cloanto-lm', 3397, 'tcp', 'Cloanto License Manager'),
('mercantile', 3398, 'tcp', 'Mercantile'),
('csms', 3399, 'tcp', 'CSMS'),
('csms2', 3400, 'tcp', 'CSMS2'),
('filecast', 3401, 'tcp', 'filecast'),
('fxaengine-net', 3402, 'tcp', 'FXa Engine Network Port'),
('copysnap', 3403, 'tcp', 'CopySnap Server Port'),
('nokia-ann-ch1', 3405, 'tcp', 'Nokia Announcement ch 1'),
('nokia-ann-ch2', 3406, 'tcp', 'Nokia Announcement ch 2'),
('ldap-admin', 3407, 'tcp', 'LDAP admin server port'),
('issapi', 3408, 'tcp', 'POWERpack API Port'),
('networklens', 3409, 'tcp', 'NetworkLens Event Port'),
('networklenss', 3410, 'tcp', 'NetworkLens SSL Event'),
('biolink-auth', 3411, 'tcp', 'BioLink Authenteon'),
('xmlblaster', 3412, 'tcp', 'xmlBlaster'),
('svnet', 3413, 'tcp', 'SpecView Networking'),
('wip-port', 3414, 'tcp', 'BroadCloud WIP Port'),
('bcinameservice', 3415, 'tcp', 'BCI Name Service'),
('commandport', 3416, 'tcp', 'AirMobile IS Command Port'),
('csvr', 3417, 'tcp', 'ConServR file translation'),
('rnmap', 3418, 'tcp', 'Remote nmap'),
('softaudit', 3419, 'tcp', 'Isogon SoftAudit'),
('ifcp-port', 3420, 'tcp', 'iFCP User Port'),
('bmap', 3421, 'tcp', 'Bull Apprise portmapper'),
('rusb-sys-port', 3422, 'tcp', 'Remote USB System Port'),
('xtrm', 3423, 'tcp', 'xTrade Reliable Messaging'),
('xtrms', 3424, 'tcp', 'xTrade over TLS/SSL'),
('agps-port', 3425, 'tcp', 'AGPS Access Port'),
('arkivio', 3426, 'tcp', 'Arkivio Storage Protocol'),
('websphere-snmp', 3427, 'tcp', 'WebSphere SNMP'),
('twcss', 3428, 'tcp', '2Wire CSS'),
('gcsp', 3429, 'tcp', 'GCSP user port'),
('ssdispatch', 3430, 'tcp', 'Scott Studios Dispatch'),
('ndl-als', 3431, 'tcp', 'Active License Server Port'),
('osdcp', 3432, 'tcp', 'Secure Device Protocol'),
('alta-smp', 3433, 'tcp', 'Altaworks Service Management Platform'),
('opencm', 3434, 'tcp', 'OpenCM Server'),
('pacom', 3435, 'tcp', 'Pacom Security User Port'),
('gc-config', 3436, 'tcp', 'GuardControl Exchange Protocol'),
('autocueds', 3437, 'tcp', 'Autocue Directory Service'),
('spiral-admin', 3438, 'tcp', 'Spiralcraft Admin'),
('hri-port', 3439, 'tcp', 'HRI Interface Port'),
('ans-console', 3440, 'tcp', 'Net Steward Mgmt Console'),
('connect-client', 3441, 'tcp', 'OC Connect Client'),
('connect-server', 3442, 'tcp', 'OC Connect Server'),
('ov-nnm-websrv', 3443, 'tcp', 'OpenView Network Node Manager WEB Server'),
('denali-server', 3444, 'tcp', 'Denali Server'),
('monp', 3445, 'tcp', 'Media Object Network'),
('3comfaxrpc', 3446, 'tcp', '3Com FAX RPC port'),
('cddn', 3447, 'tcp', 'CompuDuo DirectNet'),
('dnc-port', 3448, 'tcp', 'Discovery and Net Config'),
('hotu-chat', 3449, 'tcp', 'HotU Chat'),
('castorproxy', 3450, 'tcp', 'CAStorProxy'),
('asam', 3451, 'tcp', 'ASAM Services'),
('sabp-signal', 3452, 'tcp', 'SABP-Signalling Protocol'),
('pscupd', 3453, 'tcp', 'PSC Update Port'),
('mira', 3454, 'tcp', 'Apple Remote Access Protocol'),
('prsvp', 3455, 'tcp', 'RSVP Port'),
('vat', 3456, 'tcp', 'VAT default data'),
('vat-control', 3457, 'tcp', 'VAT default control'),
('d3winosfi', 3458, 'tcp', 'D3WinOSFI'),
('integral', 3459, 'tcp', 'TIP Integral'),
('edm-manager', 3460, 'tcp', 'EDM Manger'),
('edm-stager', 3461, 'tcp', 'EDM Stager'),
('edm-std-notify', 3462, 'tcp', 'EDM STD Notify'),
('edm-adm-notify', 3463, 'tcp', 'EDM ADM Notify'),
('edm-mgr-sync', 3464, 'tcp', 'EDM MGR Sync'),
('edm-mgr-cntrl', 3465, 'tcp', 'EDM MGR Cntrl'),
('workflow', 3466, 'tcp', 'WORKFLOW'),
('rcst', 3467, 'tcp', 'RCST'),
('ttcmremotectrl', 3468, 'tcp', 'TTCM Remote Controll'),
('pluribus', 3469, 'tcp', 'Pluribus'),
('jt400', 3470, 'tcp', 'jt400'),
('jt400-ssl', 3471, 'tcp', 'jt400-ssl'),
('jaugsremotec-1', 3472, 'tcp', 'JAUGS N-G Remotec 1'),
('jaugsremotec-2', 3473, 'tcp', 'JAUGS N-G Remotec 2'),
('ttntspauto', 3474, 'tcp', 'TSP Automation'),
('genisar-port', 3475, 'tcp', 'Genisar Comm Port'),
('nppmp', 3476, 'tcp', 'NVIDIA Mgmt Protocol'),
('ecomm', 3477, 'tcp', 'eComm link port'),
('nat-stun-port', 3478, 'tcp', 'Simple Traversal of UDP Through NAT (STUN) port'),
('twrpc', 3479, 'tcp', '2Wire RPC'),
('plethora', 3480, 'tcp', 'Secure Virtual Workspace'),
('cleanerliverc', 3481, 'tcp', 'CleanerLive remote ctrl'),
('vulture', 3482, 'tcp', 'Vulture Monitoring System'),
('slim-devices', 3483, 'tcp', 'Slim Devices Protocol'),
('gbs-stp', 3484, 'tcp', 'GBS SnapTalk Protocol'),
('celatalk', 3485, 'tcp', 'CelaTalk'),
('ifsf-hb-port', 3486, 'tcp', 'IFSF Heartbeat Port'),
('ltctcp', 3487, 'tcp', 'LISA TCP Transfer Channel'),
('fs-rh-srv', 3488, 'tcp', 'FS Remote Host Server'),
('dtp-dia', 3489, 'tcp', 'DTP/DIA'),
('colubris', 3490, 'tcp', 'Colubris Management Port'),
('swr-port', 3491, 'tcp', 'SWR Port'),
('tvdumtray-port', 3492, 'tcp', 'TVDUM Tray Port'),
('nut', 3493, 'tcp', 'Network UPS Tools'),
('ibm3494', 3494, 'tcp', 'IBM 3494'),
('seclayer-tcp', 3495, 'tcp', 'securitylayer over tcp'),
('seclayer-tls', 3496, 'tcp', 'securitylayer over tls'),
('ipether232port', 3497, 'tcp', 'ipEther232Port'),
('dashpas-port', 3498, 'tcp', 'DASHPAS user port'),
('sccip-media', 3499, 'tcp', 'SccIP Media'),
('rtmp-port', 3500, 'tcp', 'RTMP Port'),
('isoft-p2p', 3501, 'tcp', 'iSoft-P2P'),
('avinstalldisc', 3502, 'tcp', 'Avocent Install Discovery'),
('lsp-ping', 3503, 'tcp', 'MPLS LSP-echo Port'),
('ironstorm', 3504, 'tcp', 'IronStorm game server'),
('ccmcomm', 3505, 'tcp', 'CCM communications port'),
('apc-aem-status', 3506, 'tcp', 'APC Device Status Port'),
('nesh-broker', 3507, 'tcp', 'Nesh Broker Port'),
('interactionweb', 3508, 'tcp', 'Interaction Web'),
('vt-ssl', 3509, 'tcp', 'Virtual Token SSL Port'),
('xss-port', 3510, 'tcp', 'XSS Port'),
('webmail-2', 3511, 'tcp', 'WebMail/2'),
('aztec', 3512, 'tcp', 'Aztec Distribution Port'),
('arcpd', 3513, 'tcp', 'Adaptec Remote Protocol'),
('must-p2p', 3514, 'tcp', 'MUST Peer to Peer'),
('must-backplane', 3515, 'tcp', 'MUST Backplane'),
('smartcard-port', 3516, 'tcp', 'Smartcard Port'),
('802-11-iapp', 3517, 'tcp', 'IEEE 802.11 WLANs WG IAPP'),
('artifact-msg', 3518, 'tcp', 'Artifact Message Server'),
('nvmsgd', 3519, 'tcp', 'Netvion Messenger Port'),
('galileolog', 3520, 'tcp', 'Netvion Galileo Log Port'),
('mc3ss', 3521, 'tcp', 'Telequip Labs MC3SS'),
('nssocketport', 3522, 'tcp', 'DO over NSSocketPort'),
('odeumservlink', 3523, 'tcp', 'Odeum Serverlink'),
('ecmport', 3524, 'tcp', 'ECM Server port'),
('eisport', 3525, 'tcp', 'EIS Server port'),
('starquiz-port', 3526, 'tcp', 'starQuiz Port'),
('beserver-msg-q', 3527, 'tcp', 'VERITAS Backup Exec Server'),
('jboss-iiop', 3528, 'tcp', 'JBoss IIOP'),
('jboss-iiop-ssl', 3529, 'tcp', 'JBoss IIOP/SSL'),
('gf', 3530, 'tcp', 'Grid Friendly'),
('joltid', 3531, 'tcp', 'Joltid'),
('raven-rmp', 3532, 'tcp', 'Raven Remote Management Control'),
('raven-rdp', 3533, 'tcp', 'Raven Remote Management Data'),
('urld-port', 3534, 'tcp', 'URL Daemon Port'),
('ms-la', 3535, 'tcp', 'MS-LA'),
('snac', 3536, 'tcp', 'SNAC'),
('ni-visa-remote', 3537, 'tcp', 'Remote NI-VISA port'),
('ibm-diradm', 3538, 'tcp', 'IBM Directory Server'),
('ibm-diradm-ssl', 3539, 'tcp', 'IBM Directory Server SSL'),
('pnrp-port', 3540, 'tcp', 'PNRP User Port'),
('voispeed-port', 3541, 'tcp', 'VoiSpeed Port'),
('hacl-monitor', 3542, 'tcp', 'HA cluster monitor'),
('qftest-lookup', 3543, 'tcp', 'qftest Lookup Port'),
('teredo', 3544, 'tcp', 'Teredo Port'),
('camac', 3545, 'tcp', 'CAMAC equipment'),
('kopek-httphead', 3546, 'tcp', 'Kopek HTTP Head Port'),
('symantec-sim', 3547, 'tcp', 'Symantec SIM'),
('interworld', 3548, 'tcp', 'Interworld'),
('tellumat-nms', 3549, 'tcp', 'Tellumat MDR NMS'),
('ssmpp', 3550, 'tcp', 'Secure SMPP'),
('apcupsd', 3551, 'tcp', 'Apcupsd Information Port'),
('taserver', 3552, 'tcp', 'TeamAgenda Server Port'),
('rbr-discovery', 3553, 'tcp', 'Red Box Recorder ADP'),
('questnotify', 3554, 'tcp', 'Quest Notification Server'),
('razor', 3555, 'tcp', 'Vipuls Razor'),
('sky-transport', 3556, 'tcp', 'Sky Transport Protocol'),
('personalos-001', 3557, 'tcp', 'PersonalOS Comm Port'),
('mcp-port', 3558, 'tcp', 'MCP user port'),
('cctv-port', 3559, 'tcp', 'CCTV control port'),
('iniserve-port', 3560, 'tcp', 'INIServe port'),
('bmc-onekey', 3561, 'tcp', 'BMC-OneKey'),
('sdbproxy', 3562, 'tcp', 'SDBProxy'),
('watcomdebug', 3563, 'tcp', 'Watcom Debug'),
('esimport', 3564, 'tcp', 'Electromed SIM port'),
('m2pa', 3565, 'tcp', 'M2PA'),
('qsintelliagent', 3566, 'tcp', 'Quest Intelliagent'),
('emware-oft', 3567, 'tcp', 'emWare OFT Services'),
('gamesmith-port', 3568, 'tcp', 'GameSmith Port'),
('mbg-ctrl', 3569, 'tcp', 'Meinberg Control Service'),
('mccwebsvr-port', 3570, 'tcp', 'MCC Web Server Port'),
('megardsvr-port', 3571, 'tcp', 'MegaRAID Server Port'),
('megaregsvrport', 3572, 'tcp', 'Registration Server Port'),
('tag-ups-1', 3573, 'tcp', 'Advantage Group UPS Suite'),
('dmaf-server', 3574, 'tcp', 'DMAF Server'),
('ccm-port', 3575, 'tcp', 'Coalsere CCM Port'),
('cmc-port', 3576, 'tcp', 'Coalsere CMC Port'),
('config-port', 3577, 'tcp', 'Configuration Port'),
('data-port', 3578, 'tcp', 'Data Port'),
('ttat3lb', 3579, 'tcp', 'Tarantella Load Balancing'),
('sharp-server', 3617, 'tcp', 'ATI SHARP Logic Engine'),
('lispworks-orb', 3672, 'tcp', 'LispWorks ORB'),
('ca-idms', 3709, 'tcp', 'CA-IDMS Server'),
('sphidia-port', 3737, 'tcp', 'Sphidia Game Port'),
('vhd', 3802, 'tcp', 'VHD'),
('v-one-spp', 3845, 'tcp', 'V-ONE Single Port Proxy'),
('giga-pocket', 3862, 'tcp', 'GIGA-POCKET'),
('pnbscada', 3875, 'tcp', 'PNBSCADA'),
('topflow-ssl', 3885, 'tcp', 'TopFlow SSL'),
('udt_os', 3900, 'tcp', 'Unidata UDT OS'),
('aamp', 3939, 'tcp', 'Anti-virus Application Management Port'),
('mapper-nodemgr', 3984, 'tcp', 'MAPPER network node manager'),
('mapper-mapethd', 3985, 'tcp', 'MAPPER TCP/IP server'),
('mapper-ws_ethd', 3986, 'tcp', 'MAPPER workstation server'),
('centerline', 3987, 'tcp', 'Centerline'),
('terabase', 4000, 'tcp', 'Terabase'),
('newoak', 4001, 'tcp', 'NewOak'),
('pxc-spvr-ft', 4002, 'tcp', 'pxc-spvr-ft'),
('pxc-splr-ft', 4003, 'tcp', 'pxc-splr-ft'),
('pxc-roid', 4004, 'tcp', 'pxc-roid'),
('pxc-pin', 4005, 'tcp', 'pxc-pin'),
('pxc-spvr', 4006, 'tcp', 'pxc-spvr'),
('pxc-splr', 4007, 'tcp', 'pxc-splr'),
('netcheque', 4008, 'tcp', 'NetCheque accounting'),
('chimera-hwm', 4009, 'tcp', 'Chimera HWM'),
('samsung-unidex', 4010, 'tcp', 'Samsung Unidex'),
('altserviceboot', 4011, 'tcp', 'Alternate Service Boot'),
('pda-gate', 4012, 'tcp', 'PDA Gate'),
('acl-manager', 4013, 'tcp', 'ACL Manager'),
('taiclock', 4014, 'tcp', 'TAICLOCK'),
('talarian-mcast1', 4015, 'tcp', 'Talarian Mcast'),
('talarian-mcast2', 4016, 'tcp', 'Talarian Mcast'),
('talarian-mcast3', 4017, 'tcp', 'Talarian Mcast'),
('talarian-mcast4', 4018, 'tcp', 'Talarian Mcast'),
('talarian-mcast5', 4019, 'tcp', 'Talarian Mcast'),
('trap', 4020, 'tcp', 'TRAP Port'),
('nexus-portal', 4021, 'tcp', 'Nexus Portal'),
('dnox', 4022, 'tcp', 'DNOX'),
('esnm-zoning', 4023, 'tcp', 'ESNM Zoning Port'),
('tnp1-port', 4024, 'tcp', 'TNP1 User Port'),
('partimage', 4025, 'tcp', 'Partition Image Port'),
('as-debug', 4026, 'tcp', 'Graphical Debug Server'),
('bxp', 4027, 'tcp', 'bitxpress'),
('dtserver-port', 4028, 'tcp', 'DTServer Port'),
('ip-qsig', 4029, 'tcp', 'IP Q signaling protocol'),
('jdmn-port', 4030, 'tcp', 'Accell/JSP Daemon Port'),
('jdmn-port', 4030, 'tcp', 'Accell/JSP Daemon Port'),
('suucp', 4031, 'tcp', 'UUCP over SSL'),
('vrts-auth-port', 4032, 'tcp', 'VERITAS Authorize Server'),
('sanavigator', 4033, 'tcp', 'SANavigator Peer Port'),
('ubxd', 4034, 'tcp', 'Ubiquinox Daemon'),
('wap-push-http', 4035, 'tcp', 'WAP Push OTA-HTTP port'),
('wap-push-https', 4036, 'tcp', 'WAP Push OTA-HTTP secure'),
('yo-main', 4040, 'tcp', 'Yo.net main service'),
('houston', 4041, 'tcp', 'Rocketeer-Houston'),
('ldxp', 4042, 'tcp', 'LDXP'),
('bre', 4096, 'tcp', 'BRE (Bridge Relay Element)'),
('patrolview', 4097, 'tcp', 'Patrol View'),
('drmsfsd', 4098, 'tcp', 'drmsfsd'),
('dpcp', 4099, 'tcp', 'DPCP'),
('igo-incognito', 4100, 'tcp', 'IGo Incognito Data Port'),
('nuts_dem', 4132, 'tcp', 'NUTS Daemon'),
('nuts_bootp', 4133, 'tcp', 'NUTS Bootp Server'),
('nifty-hmi', 4134, 'tcp', 'NIFTY-Serve HMI protocol'),
('oirtgsvc', 4141, 'tcp', 'Workflow Server'),
('oidocsvc', 4142, 'tcp', 'Document Server'),
('oidsr', 4143, 'tcp', 'Document Replication'),
('vvr-control', 4145, 'tcp', 'VVR Control'),
('jini-discovery', 4160, 'tcp', 'Jini Discovery'),
('eims-admin', 4199, 'tcp', 'EIMS ADMIN'),
('corelccam', 4300, 'tcp', 'Corel CCam'),
('rwhois', 4321, 'tcp', 'Remote Who Is'),
('unicall', 4343, 'tcp', 'UNICALL'),
('vinainstall', 4344, 'tcp', 'VinaInstall'),
('m4-network-as', 4345, 'tcp', 'Macro 4 Network AS'),
('elanlm', 4346, 'tcp', 'ELAN LM'),
('lansurveyor', 4347, 'tcp', 'LAN Surveyor'),
('itose', 4348, 'tcp', 'ITOSE'),
('fsportmap', 4349, 'tcp', 'File System Port Map'),
('net-device', 4350, 'tcp', 'Net Device'),
('plcy-net-svcs', 4351, 'tcp', 'PLCY Net Services'),
('f5-iquery', 4353, 'tcp', 'F5 iQuery'),
('qsnet-trans', 4354, 'tcp', 'QSNet Transmitter'),
('qsnet-workst', 4355, 'tcp', 'QSNet Workstation'),
('qsnet-assist', 4356, 'tcp', 'QSNet Assistant'),
('qsnet-cond', 4357, 'tcp', 'QSNet Conductor'),
('qsnet-nucl', 4358, 'tcp', 'QSNet Nucleus'),
('saris', 4442, 'tcp', 'Saris'),
('pharos', 4443, 'tcp', 'Pharos'),
('krb524', 4444, 'tcp', 'KRB524'),
('nv-video', 4444, 'tcp', 'NV Video default'),
('upnotifyp', 4445, 'tcp', 'UPNOTIFYP'),
('n1-fwp', 4446, 'tcp', 'N1-FWP'),
('n1-rmgmt', 4447, 'tcp', 'N1-RMGMT'),
('asc-slmd', 4448, 'tcp', 'ASC Licence Manager'),
('privatewire', 4449, 'tcp', 'PrivateWire'),
('camp', 4450, 'tcp', 'Camp'),
('ctisystemmsg', 4451, 'tcp', 'CTI System Msg'),
('ctiprogramload', 4452, 'tcp', 'CTI Program Load'),
('nssalertmgr', 4453, 'tcp', 'NSS Alert Manager'),
('nssagentmgr', 4454, 'tcp', 'NSS Agent Manager'),
('prchat-user', 4455, 'tcp', 'PR Chat User'),
('prchat-server', 4456, 'tcp', 'PR Chat Server'),
('prRegister', 4457, 'tcp', 'PR Register'),
('ipsec-msft', 4500, 'tcp', 'Microsoft IPsec NAT-T'),
('worldscores', 4545, 'tcp', 'WorldScores'),
('sf-lm', 4546, 'tcp', 'SF License Manager (Sentinel)'),
('lanner-lm', 4547, 'tcp', 'Lanner License Manager'),
('rsip', 4555, 'tcp', 'RSIP Port'),
('hylafax', 4559, 'tcp', 'HylaFAX'),
('tram', 4567, 'tcp', 'TRAM'),
('bmc-reporting', 4568, 'tcp', 'BMC Reporting'),
('piranha1', 4600, 'tcp', 'Piranha1'),
('piranha2', 4601, 'tcp', 'Piranha2'),
('smaclmgr', 4660, 'tcp', 'smaclmgr'),
('kar2ouche', 4661, 'tcp', 'Kar2ouche Peer location service'),
('rfa', 4672, 'tcp', 'remote file access server'),
('snap', 4752, 'tcp', 'Simple Network Audio Protocol'),
('iims', 4800, 'tcp', 'Icona Instant Messenging System'),
('iwec', 4801, 'tcp', 'Icona Web Embedded Chat'),
('ilss', 4802, 'tcp', 'Icona License System Server'),
('htcp', 4827, 'tcp', 'HTCP'),
('varadero-0', 4837, 'tcp', 'Varadero-0'),
('varadero-1', 4838, 'tcp', 'Varadero-1'),
('varadero-2', 4839, 'tcp', 'Varadero-2'),
('appserv-http', 4848, 'tcp', 'App Server - Admin HTTP'),
('appserv-https', 4849, 'tcp', 'App Server - Admin HTTPS'),
('phrelay', 4868, 'tcp', 'Photon Relay'),
('phrelaydbg', 4869, 'tcp', 'Photon Relay Debug'),
('abbs', 4885, 'tcp', 'ABBS'),
('lyskom', 4894, 'tcp', 'LysKOM Protocol A'),
('att-intercom', 4983, 'tcp', 'AT&T Intercom'),
('smar-se-port1', 4987, 'tcp', 'SMAR Ethernet Port 1'),
('smar-se-port2', 4988, 'tcp', 'SMAR Ethernet Port 2'),
('commplex-main', 5000, 'tcp', ''),
('commplex-link', 5001, 'tcp', ''),
('rfe', 5002, 'tcp', 'radio free ethernet'),
('fmpro-internal', 5003, 'tcp', 'FileMaker, Inc. - Proprietary transport'),
('avt-profile-1', 5004, 'tcp', 'avt-profile-1'),
('avt-profile-2', 5005, 'tcp', 'avt-profile-2'),
('wsm-server', 5006, 'tcp', 'wsm server'),
('wsm-server-ssl', 5007, 'tcp', 'wsm server ssl'),
('synapsis-edge', 5008, 'tcp', 'Synapsis EDGE'),
('telelpathstart', 5010, 'tcp', 'TelepathStart'),
('telelpathattack', 5011, 'tcp', 'TelepathAttack'),
('zenginkyo-1', 5020, 'tcp', 'zenginkyo-1'),
('zenginkyo-2', 5021, 'tcp', 'zenginkyo-2'),
('mice', 5022, 'tcp', 'mice server'),
('htuilsrv', 5023, 'tcp', 'Htuil Server for PLD2'),
('asnaacceler8db', 5042, 'tcp', 'asnaacceler8db'),
('mmcc', 5050, 'tcp', 'multimedia conference control tool'),
('ita-agent', 5051, 'tcp', 'ITA Agent'),
('ita-manager', 5052, 'tcp', 'ITA Manager'),
('unot', 5055, 'tcp', 'UNOT'),
('intecom-ps1', 5056, 'tcp', 'Intecom PS 1'),
('intecom-ps2', 5057, 'tcp', 'Intecom PS 2'),
('sip', 5060, 'tcp', 'SIP'),
('sip-tls', 5061, 'tcp', 'SIP-TLS'),
('ca-1', 5064, 'tcp', 'Channel Access 1'),
('ca-2', 5065, 'tcp', 'Channel Access 2'),
('stanag-5066', 5066, 'tcp', 'STANAG-5066-SUBNET-INTF'),
('i-net-2000-npr', 5069, 'tcp', 'I/Net 2000-NPR'),
('powerschool', 5071, 'tcp', 'PowerSchool'),
('sdl-ets', 5081, 'tcp', 'SDL - Ent Trans Server'),
('sentinel-lm', 5093, 'tcp', 'Sentinel LM'),
('sentlm-srv2srv', 5099, 'tcp', 'SentLM Srv2Srv'),
('talarian-tcp', 5101, 'tcp', 'Talarian_TCP'),
('ctsd', 5137, 'tcp', 'MyCTS server port'),
('rmonitor_secure', 5145, 'tcp', 'RMONITOR SECURE'),
('atmp', 5150, 'tcp', 'Ascend Tunnel Management Protocol'),
('esri_sde', 5151, 'tcp', 'ESRI SDE Instance'),
('sde-discovery', 5152, 'tcp', 'ESRI SDE Instance Discovery'),
('ife_icorp', 5165, 'tcp', 'ife_1corp'),
('aol', 5190, 'tcp', 'America-Online'),
('aol-1', 5191, 'tcp', 'AmericaOnline1'),
('aol-2', 5192, 'tcp', 'AmericaOnline2'),
('aol-3', 5193, 'tcp', 'AmericaOnline3'),
('targus-getdata', 5200, 'tcp', 'TARGUS GetData'),
('targus-getdata1', 5201, 'tcp', 'TARGUS GetData 1'),
('targus-getdata2', 5202, 'tcp', 'TARGUS GetData 2'),
('targus-getdata3', 5203, 'tcp', 'TARGUS GetData 3'),
('jabber-client', 5222, 'tcp', 'Jabber Client Connection'),
('hp-server', 5225, 'tcp', 'HP Server'),
('hp-status', 5226, 'tcp', 'HP Status'),
('padl2sim', 5236, 'tcp', ''),
('igateway', 5250, 'tcp', 'iGateway'),
('jabber-server', 5269, 'tcp', 'Jabber Server Connection'),
('pk', 5272, 'tcp', 'PK'),
('transmit-port', 5282, 'tcp', 'Marimba Transmitter Port'),
('hacl-hb', 5300, 'tcp', '# HA cluster heartbeat'),
('hacl-gs', 5301, 'tcp', '# HA cluster general services'),
('hacl-cfg', 5302, 'tcp', '# HA cluster configuration'),
('hacl-probe', 5303, 'tcp', '# HA cluster probing'),
('hacl-local', 5304, 'tcp', '# HA Cluster Commands'),
('hacl-test', 5305, 'tcp', '# HA Cluster Test'),
('sun-mc-grp', 5306, 'tcp', 'Sun MC Group'),
('sco-aip', 5307, 'tcp', 'SCO AIP'),
('cfengine', 5308, 'tcp', 'CFengine'),
('jprinter', 5309, 'tcp', 'J Printer'),
('outlaws', 5310, 'tcp', 'Outlaws'),
('tmlogin', 5311, 'tcp', 'TM Login'),
('opalis-rbt-ipc', 5314, 'tcp', 'opalis-rbt-ipc'),
('hacl-poll', 5315, 'tcp', 'HA Cluster UDP Polling'),
('mdns', 5353, 'tcp', 'Multicast DNS'),
('excerpt', 5400, 'tcp', 'Excerpt Search'),
('excerpts', 5401, 'tcp', 'Excerpt Search Secure'),
('mftp', 5402, 'tcp', 'MFTP'),
('hpoms-ci-lstn', 5403, 'tcp', 'HPOMS-CI-LSTN'),
('hpoms-dps-lstn', 5404, 'tcp', 'HPOMS-DPS-LSTN'),
('netsupport', 5405, 'tcp', 'NetSupport'),
('systemics-sox', 5406, 'tcp', 'Systemics Sox'),
('foresyte-clear', 5407, 'tcp', 'Foresyte-Clear'),
('foresyte-sec', 5408, 'tcp', 'Foresyte-Sec'),
('salient-dtasrv', 5409, 'tcp', 'Salient Data Server'),
('salient-usrmgr', 5410, 'tcp', 'Salient User Manager'),
('actnet', 5411, 'tcp', 'ActNet'),
('continuus', 5412, 'tcp', 'Continuus'),
('wwiotalk', 5413, 'tcp', 'WWIOTALK'),
('statusd', 5414, 'tcp', 'StatusD'),
('ns-server', 5415, 'tcp', 'NS Server'),
('sns-gateway', 5416, 'tcp', 'SNS Gateway'),
('sns-agent', 5417, 'tcp', 'SNS Agent'),
('mcntp', 5418, 'tcp', 'MCNTP'),
('dj-ice', 5419, 'tcp', 'DJ-ICE'),
('cylink-c', 5420, 'tcp', 'Cylink-C'),
('netsupport2', 5421, 'tcp', 'Net Support 2'),
('salient-mux', 5422, 'tcp', 'Salient MUX'),
('virtualuser', 5423, 'tcp', 'VIRTUALUSER'),
('devbasic', 5426, 'tcp', 'DEVBASIC'),
('sco-peer-tta', 5427, 'tcp', 'SCO-PEER-TTA'),
('telaconsole', 5428, 'tcp', 'TELACONSOLE'),
('base', 5429, 'tcp', 'Billing and Accounting System Exchange'),
('radec-corp', 5430, 'tcp', 'RADEC CORP'),
('park-agent', 5431, 'tcp', 'PARK AGENT'),
('postgresql', 5432, 'tcp', 'PostgreSQL Database'),
('dttl', 5435, 'tcp', 'Data Tunneling Transceiver Linking (DTTL)'),
('apc-tcp-udp-4', 5454, 'tcp', 'apc-tcp-udp-4'),
('apc-tcp-udp-5', 5455, 'tcp', 'apc-tcp-udp-5'),
('apc-tcp-udp-6', 5456, 'tcp', 'apc-tcp-udp-6'),
('silkmeter', 5461, 'tcp', 'SILKMETER'),
('ttl-publisher', 5462, 'tcp', 'TTL Publisher'),
('ttlpriceproxy', 5463, 'tcp', 'TTL Price Proxy'),
('netops-broker', 5465, 'tcp', 'NETOPS-BROKER'),
('fcp-addr-srvr1', 5500, 'tcp', 'fcp-addr-srvr1'),
('fcp-addr-srvr2', 5501, 'tcp', 'fcp-addr-srvr2'),
('fcp-srvr-inst1', 5502, 'tcp', 'fcp-srvr-inst1'),
('fcp-srvr-inst2', 5503, 'tcp', 'fcp-srvr-inst2'),
('fcp-cics-gw1', 5504, 'tcp', 'fcp-cics-gw1'),
('sgi-esphttp', 5554, 'tcp', 'SGI ESP HTTP'),
('personal-agent', 5555, 'tcp', 'Personal Agent'),
('udpplus', 5566, 'tcp', 'UDPPlus'),
('esinstall', 5599, 'tcp', 'Enterprise Security Remote Install'),
('esmmanager', 5600, 'tcp', 'Enterprise Security Manager'),
('esmagent', 5601, 'tcp', 'Enterprise Security Agent'),
('a1-msc', 5602, 'tcp', 'A1-MSC'),
('a1-bs', 5603, 'tcp', 'A1-BS'),
('a3-sdunode', 5604, 'tcp', 'A3-SDUNode'),
('a4-sdunode', 5605, 'tcp', 'A4-SDUNode'),
('pcanywheredata', 5631, 'tcp', 'pcANYWHEREdata'),
('pcanywherestat', 5632, 'tcp', 'pcANYWHEREstat'),
('jms', 5673, 'tcp', 'JACL Message Server'),
('hyperscsi-port', 5674, 'tcp', 'HyperSCSI Port'),
('v5ua', 5675, 'tcp', 'V5UA application port'),
('raadmin', 5676, 'tcp', 'RA Administration'),
('questdb2-lnchr', 5677, 'tcp', 'Quest Central DB2 Launchr'),
('rrac', 5678, 'tcp', 'Remote Replication Agent Connection'),
('dccm', 5679, 'tcp', 'Direct Cable Connect Manager'),
('proshareaudio', 5713, 'tcp', 'proshare conf audio'),
('prosharevideo', 5714, 'tcp', 'proshare conf video'),
('prosharedata', 5715, 'tcp', 'proshare conf data'),
('prosharerequest', 5716, 'tcp', 'proshare conf request'),
('prosharenotify', 5717, 'tcp', 'proshare conf notify'),
('openmail', 5729, 'tcp', 'Openmail User Agent Layer'),
('unieng', 5730, 'tcp', 'Steltors calendar access'),
('ida-discover1', 5741, 'tcp', 'IDA Discover Port 1'),
('ida-discover2', 5742, 'tcp', 'IDA Discover Port 2'),
('fcopy-server', 5745, 'tcp', 'fcopy-server'),
('fcopys-server', 5746, 'tcp', 'fcopys-server'),
('openmailg', 5755, 'tcp', 'OpenMail Desk Gateway server'),
('x500ms', 5757, 'tcp', 'OpenMail X.500 Directory Server'),
('openmailns', 5766, 'tcp', 'OpenMail NewMail Server'),
('s-openmail', 5767, 'tcp', 'OpenMail Suer Agent Layer (Secure)'),
('openmailpxy', 5768, 'tcp', 'OpenMail CMTS Server'),
('netagent', 5771, 'tcp', 'NetAgent'),
('icmpd', 5813, 'tcp', 'ICMPD'),
('wherehoo', 5859, 'tcp', 'WHEREHOO'),
('mppolicy-v5', 5968, 'tcp', 'mppolicy-v5'),
('mppolicy-mgr', 5969, 'tcp', 'mppolicy-mgr'),
('wbem-rmi', 5987, 'tcp', 'WBEM RMI'),
('wbem-http', 5988, 'tcp', 'WBEM HTTP'),
('wbem-https', 5989, 'tcp', 'WBEM HTTPS'),
('wbem-local', 5990, 'tcp', 'HP WBEM Local Connection'),
('nuxsl', 5991, 'tcp', 'NUXSL'),
('cvsup', 5999, 'tcp', 'CVSup'),
('x11', -63, 'tcp', 'X Window System'),
('ndl-ahp-svc', 6064, 'tcp', 'NDL-AHP-SVC'),
('winpharaoh', 6065, 'tcp', 'WinPharaoh'),
('ewctsp', 6066, 'tcp', 'EWCTSP'),
('srb', 6067, 'tcp', 'SRB'),
('gsmp', 6068, 'tcp', 'GSMP'),
('trip', 6069, 'tcp', 'TRIP'),
('messageasap', 6070, 'tcp', 'Messageasap'),
('ssdtp', 6071, 'tcp', 'SSDTP'),
('diagnose-proc', 6072, 'tcp', 'DIAGNOSE-PROC'),
('directplay8', 6073, 'tcp', 'DirectPlay8'),
('synchronet-db', 6100, 'tcp', 'SynchroNet-db'),
('synchronet-rtc', 6101, 'tcp', 'SynchroNet-rtc'),
('synchronet-upd', 6102, 'tcp', 'SynchroNet-upd'),
('rets', 6103, 'tcp', 'RETS'),
('dbdb', 6104, 'tcp', 'DBDB'),
('primaserver', 6105, 'tcp', 'Prima Server'),
('mpsserver', 6106, 'tcp', 'MPS Server'),
('etc-control', 6107, 'tcp', 'ETC Control'),
('sercomm-scadmin', 6108, 'tcp', 'Sercomm-SCAdmin'),
('globecast-id', 6109, 'tcp', 'GLOBECAST-ID'),
('softcm', 6110, 'tcp', 'HP SoftBench CM'),
('spc', 6111, 'tcp', 'HP SoftBench Sub-Process Control'),
('dtspcd', 6112, 'tcp', 'dtspcd'),
('backup-express', 6123, 'tcp', 'Backup Express'),
('meta-corp', 6141, 'tcp', 'Meta Corporation License Manager'),
('aspentec-lm', 6142, 'tcp', 'Aspen Technology License Manager'),
('watershed-lm', 6143, 'tcp', 'Watershed License Manager'),
('statsci1-lm', 6144, 'tcp', 'StatSci License Manager - 1'),
('statsci2-lm', 6145, 'tcp', 'StatSci License Manager - 2'),
('lonewolf-lm', 6146, 'tcp', 'Lone Wolf Systems License Manager'),
('montage-lm', 6147, 'tcp', 'Montage License Manager'),
('ricardo-lm', 6148, 'tcp', 'Ricardo North America License Manager'),
('tal-pod', 6149, 'tcp', 'tal-pod'),
('crip', 6253, 'tcp', 'CRIP'),
('bmc-grx', 6300, 'tcp', 'BMC GRX'),
('emp-server1', 6321, 'tcp', 'Empress Software Connectivity Server 1'),
('emp-server2', 6322, 'tcp', 'Empress Software Connectivity Server 2'),
('gnutella-svc', 6346, 'tcp', 'gnutella-svc'),
('gnutella-rtr', 6347, 'tcp', 'gnutella-rtr'),
('metatude-mds', 6382, 'tcp', 'Metatude Dialogue Server'),
('clariion-evr01', 6389, 'tcp', 'clariion-evr01'),
('skip-cert-recv', 6455, 'tcp', 'SKIP Certificate Receive'),
('skip-cert-send', 6456, 'tcp', 'SKIP Certificate Send'),
('lvision-lm', 6471, 'tcp', 'LVision License Manager'),
('boks', 6500, 'tcp', 'BoKS Master'),
('boks_servc', 6501, 'tcp', 'BoKS Servc'),
('boks_servm', 6502, 'tcp', 'BoKS Servm'),
('boks_clntd', 6503, 'tcp', 'BoKS Clntd'),
('badm_priv', 6505, 'tcp', 'BoKS Admin Private Port'),
('badm_pub', 6506, 'tcp', 'BoKS Admin Public Port'),
('bdir_priv', 6507, 'tcp', 'BoKS Dir Server, Private Port'),
('bdir_pub', 6508, 'tcp', 'BoKS Dir Server, Public Port'),
('mgcs-mfp-port', 6509, 'tcp', 'MGCS-MFP Port'),
('mcer-port', 6510, 'tcp', 'MCER Port'),
('apc-tcp-udp-1', 6547, 'tcp', 'apc-tcp-udp-1'),
('apc-tcp-udp-2', 6548, 'tcp', 'apc-tcp-udp-2'),
('apc-tcp-udp-3', 6549, 'tcp', 'apc-tcp-udp-3'),
('fg-sysupdate', 6550, 'tcp', 'fg-sysupdate'),
('xdsxdm', 6558, 'tcp', ''),
('parsec-master', 6580, 'tcp', 'Parsec Masterserver'),
('parsec-peer', 6581, 'tcp', 'Parsec Peer-to-Peer'),
('parsec-game', 6582, 'tcp', 'Parsec Gameserver'),
('ircu', -4, 'tcp', 'IRCU'),
('vocaltec-gold', 6670, 'tcp', 'Vocaltec Global Online Directory'),
('vision_server', 6672, 'tcp', 'vision_server'),
('vision_elmd', 6673, 'tcp', 'vision_elmd'),
('kti-icad-srvr', 6701, 'tcp', 'KTI/ICAD Nameserver'),
('ibprotocol', 6714, 'tcp', 'Internet Backplane Protocol'),
('bmc-perf-agent', 6767, 'tcp', 'BMC PERFORM AGENT'),
('bmc-perf-mgrd', 6768, 'tcp', 'BMC PERFORM MGRD'),
('smc-https', 6789, 'tcp', 'SMC-HTTPS'),
('hnmp', 6790, 'tcp', 'HNMP'),
('ambit-lm', 6831, 'tcp', 'ambit-lm'),
('netmo-default', 6841, 'tcp', 'Netmo Default'),
('netmo-http', 6842, 'tcp', 'Netmo HTTP'),
('iccrushmore', 6850, 'tcp', 'ICCRUSHMORE'),
('muse', 6888, 'tcp', 'MUSE'),
('jmact3', 6961, 'tcp', 'JMACT3'),
('jmevt2', 6962, 'tcp', 'jmevt2'),
('swismgr1', 6963, 'tcp', 'swismgr1'),
('swismgr2', 6964, 'tcp', 'swismgr2'),
('swistrap', 6965, 'tcp', 'swistrap'),
('swispol', 6966, 'tcp', 'swispol'),
('acmsoda', 6969, 'tcp', 'acmsoda'),
('iatp-highpri', 6998, 'tcp', 'IATP-highPri'),
('iatp-normalpri', 6999, 'tcp', 'IATP-normalPri'),
('afs3-fileserver', 7000, 'tcp', 'file server itself'),
('afs3-callback', 7001, 'tcp', 'callbacks to cache managers'),
('afs3-prserver', 7002, 'tcp', 'users & groups database'),
('afs3-vlserver', 7003, 'tcp', 'volume location database'),
('afs3-kaserver', 7004, 'tcp', 'AFS/Kerberos authentication service'),
('afs3-volser', 7005, 'tcp', 'volume managment server'),
('afs3-errors', 7006, 'tcp', 'error interpretation service'),
('afs3-bos', 7007, 'tcp', 'basic overseer process'),
('afs3-update', 7008, 'tcp', 'server-to-server updater'),
('afs3-rmtsys', 7009, 'tcp', 'remote cache manager service'),
('ups-onlinet', 7010, 'tcp', 'onlinet uninterruptable power supplies'),
('talon-disc', 7011, 'tcp', 'Talon Discovery Port'),
('talon-engine', 7012, 'tcp', 'Talon Engine'),
('microtalon-dis', 7013, 'tcp', 'Microtalon Discovery'),
('microtalon-com', 7014, 'tcp', 'Microtalon Communications'),
('talon-webserver', 7015, 'tcp', 'Talon Webserver'),
('dpserve', 7020, 'tcp', 'DP Serve'),
('dpserveadmin', 7021, 'tcp', 'DP Serve Admin'),
('op-probe', 7030, 'tcp', 'ObjectPlanet probe'),
('arcp', 7070, 'tcp', 'ARCP'),
('lazy-ptop', 7099, 'tcp', 'lazy-ptop'),
('font-service', 7100, 'tcp', 'X Font Service'),
('virprot-lm', 7121, 'tcp', 'Virtual Prototypes License Manager'),
('clutild', 7174, 'tcp', 'Clutild'),
('fodms', 7200, 'tcp', 'FODMS FLIP'),
('dlip', 7201, 'tcp', 'DLIP'),
('itactionserver1', 7280, 'tcp', 'ITACTIONSERVER 1'),
('itactionserver2', 7281, 'tcp', 'ITACTIONSERVER 2'),
('mindfilesys', 7391, 'tcp', 'mind-file system server'),
('mrssrendezvous', 7392, 'tcp', 'mrss-rendezvous server'),
('winqedit', 7395, 'tcp', 'winqedit'),
('pmdmgr', 7426, 'tcp', 'OpenView DM Postmaster Manager'),
('oveadmgr', 7427, 'tcp', 'OpenView DM Event Agent Manager'),
('ovladmgr', 7428, 'tcp', 'OpenView DM Log Agent Manager'),
('opi-sock', 7429, 'tcp', 'OpenView DM rqt communication'),
('xmpv7', 7430, 'tcp', 'OpenView DM xmpv7 api pipe'),
('pmd', 7431, 'tcp', 'OpenView DM ovc/xmpv3 api pipe'),
('faximum', 7437, 'tcp', 'Faximum'),
('telops-lmd', 7491, 'tcp', 'telops-lmd'),
('ovbus', 7501, 'tcp', 'HP OpenView Bus Daemon'),
('ovhpas', 7510, 'tcp', 'HP OpenView Application Server'),
('pafec-lm', 7511, 'tcp', 'pafec-lm'),
('nta-ds', 7544, 'tcp', 'FlowAnalyzer DisplayServer'),
('nta-us', 7545, 'tcp', 'FlowAnalyzer UtilityServer'),
('vsi-omega', 7566, 'tcp', 'VSI Omega'),
('aries-kfinder', 7570, 'tcp', 'Aries Kfinder'),
('sun-lm', 7588, 'tcp', 'Sun License Manager'),
('indi', 7624, 'tcp', 'Instrument Neutral Distributed Interface'),
('pmdfmgt', 7633, 'tcp', 'PMDF Management'),
('imqtunnels', 7674, 'tcp', 'iMQ SSL tunnel'),
('imqtunnel', 7675, 'tcp', 'iMQ Tunnel'),
('imqbrokerd', 7676, 'tcp', 'iMQ Broker Rendezvous'),
('sstp-1', 7743, 'tcp', 'Sakura Script Transfer Protocol'),
('cbt', 7777, 'tcp', 'cbt'),
('interwise', 7778, 'tcp', 'Interwise'),
('vstat', 7779, 'tcp', 'VSTAT'),
('accu-lmgr', 7781, 'tcp', 'accu-lmgr'),
('minivend', 7786, 'tcp', 'MINIVEND'),
('pnet-conn', 7797, 'tcp', 'Propel Connector port'),
('pnet-enc', 7798, 'tcp', 'Propel Encoder port'),
('apc-snmptrap', 7845, 'tcp', 'APC SNMP Trap Proxy'),
('apc-snmp', 7846, 'tcp', 'APC SNMP Proxy'),
('qo-secure', 7913, 'tcp', 'QuickObjects secure port'),
('t2-drm', 7932, 'tcp', 'Tier 2 Data Resource Manager'),
('t2-brm', 7933, 'tcp', 'Tier 2 Business Rules Manager'),
('supercell', 7967, 'tcp', 'Supercell'),
('micromuse-ncps', 7979, 'tcp', 'Micromuse-ncps'),
('quest-vista', 7980, 'tcp', 'Quest Vista'),
('irdmi2', 7999, 'tcp', 'iRDMI2'),
('irdmi', 8000, 'tcp', 'iRDMI'),
('vcom-tunnel', 8001, 'tcp', 'VCOM Tunnel'),
('teradataordbms', 8002, 'tcp', 'Teradata ORDBMS'),
('http-alt', 8008, 'tcp', 'HTTP Alternate'),
('oa-system', 8022, 'tcp', 'oa-system'),
('pro-ed', 8032, 'tcp', 'ProEd'),
('mindprint', 8033, 'tcp', 'MindPrint'),
('http-alt', 8080, 'tcp', 'HTTP Alternate (see port 80)'),
('radan-http', 8088, 'tcp', 'Radan HTTP'),
('xprint-server', 8100, 'tcp', 'Xprint Server'),
('mtl8000-matrix', 8115, 'tcp', 'MTL8000 Matrix'),
('cp-cluster', 8116, 'tcp', 'Check Point Clustering'),
('privoxy', 8118, 'tcp', 'Privoxy HTTP proxy'),
('indigo-vrmi', 8130, 'tcp', 'INDIGO-VRMI'),
('indigo-vbcp', 8131, 'tcp', 'INDIGO-VBCP'),
('dbabble', 8132, 'tcp', 'dbabble'),
('patrol', 8160, 'tcp', 'Patrol'),
('patrol-snmp', 8161, 'tcp', 'Patrol SNMP'),
('vvr-data', 8199, 'tcp', 'VVR DATA'),
('trivnet1', 8200, 'tcp', 'TRIVNET'),
('trivnet2', 8201, 'tcp', 'TRIVNET'),
('lm-perfworks', 8204, 'tcp', 'LM Perfworks'),
('lm-instmgr', 8205, 'tcp', 'LM Instmgr'),
('lm-dta', 8206, 'tcp', 'LM Dta'),
('lm-sserver', 8207, 'tcp', 'LM SServer'),
('lm-webwatcher', 8208, 'tcp', 'LM Webwatcher'),
('server-find', 8351, 'tcp', 'Server Find'),
('cruise-enum', 8376, 'tcp', 'Cruise ENUM'),
('cruise-swroute', 8377, 'tcp', 'Cruise SWROUTE'),
('cruise-config', 8378, 'tcp', 'Cruise CONFIG'),
('cruise-diags', 8379, 'tcp', 'Cruise DIAGS'),
('cruise-update', 8380, 'tcp', 'Cruise UPDATE'),
('cvd', 8400, 'tcp', 'cvd'),
('sabarsd', 8401, 'tcp', 'sabarsd'),
('abarsd', 8402, 'tcp', 'abarsd'),
('admind', 8403, 'tcp', 'admind'),
('pcsync-https', 8443, 'tcp', 'PCsync HTTPS'),
('pcsync-http', 8444, 'tcp', 'PCsync HTTP'),
('npmp', 8450, 'tcp', 'npmp'),
('vp2p', 8473, 'tcp', 'Virtual Point to Point'),
('rtsp-alt', 8554, 'tcp', 'RTSP Alternate (see port 554)'),
('ibus', 8733, 'tcp', 'iBus'),
('mc-appserver', 8763, 'tcp', 'MC-APPSERVER'),
('openqueue', 8764, 'tcp', 'OPENQUEUE'),
('ultraseek-http', 8765, 'tcp', 'Ultraseek HTTP'),
('truecm', 8804, 'tcp', 'truecm'),
('cddbp-alt', 8880, 'tcp', 'CDDBP'),
('ddi-tcp-1', 8888, 'tcp', 'NewsEDGE server TCP (TCP 1)'),
('ddi-tcp-2', 8889, 'tcp', 'Desktop Data TCP 1'),
('ddi-tcp-3', 8890, 'tcp', 'Desktop Data TCP 2'),
('ddi-tcp-4', 8891, 'tcp', 'Desktop Data TCP 3: NESS application'),
('ddi-tcp-5', 8892, 'tcp', 'Desktop Data TCP 4: FARM product'),
('ddi-tcp-6', 8893, 'tcp', 'Desktop Data TCP 5: NewsEDGE/Web application'),
('ddi-tcp-7', 8894, 'tcp', 'Desktop Data TCP 6: COAL application'),
('jmb-cds1', 8900, 'tcp', 'JMB-CDS 1'),
('jmb-cds2', 8901, 'tcp', 'JMB-CDS 2'),
('manyone-http', 8910, 'tcp', 'manyone-http'),
('manyone-xml', 8911, 'tcp', 'manyone-xml'),
('cumulus-admin', 8954, 'tcp', 'Cumulus Admin Port'),
('bctp', 8999, 'tcp', 'Brodos Crypto Trade Protocol'),
('cslistener', 9000, 'tcp', 'CSlistener'),
('etlservicemgr', 9001, 'tcp', 'ETL Service Manager'),
('dynamid', 9002, 'tcp', 'DynamID authentication'),
('tambora', 9020, 'tcp', 'TAMBORA'),
('panagolin-ident', 9021, 'tcp', 'Pangolin Identification'),
('paragent', 9022, 'tcp', 'PrivateArk Remote Agent'),
('swa-1', 9023, 'tcp', 'Secure Web Access - 1'),
('swa-2', 9024, 'tcp', 'Secure Web Access - 2'),
('swa-3', 9025, 'tcp', 'Secure Web Access - 3'),
('swa-4', 9026, 'tcp', 'Secure Web Access - 4'),
('websm', 9090, 'tcp', 'WebSM'),
('xmltec-xmlmail', 9091, 'tcp', 'xmltec-xmlmail'),
('hp-pdl-datastr', 9100, 'tcp', 'PDL Data Streaming Port'),
('bacula-dir', 9101, 'tcp', 'Bacula Director'),
('bacula-fd', 9102, 'tcp', 'Bacula File Daemon'),
('bacula-sd', 9103, 'tcp', 'Bacula Storage Daemon'),
('netlock1', 9160, 'tcp', 'NetLOCK1'),
('netlock2', 9161, 'tcp', 'NetLOCK2'),
('netlock3', 9162, 'tcp', 'NetLOCK3'),
('netlock4', 9163, 'tcp', 'NetLOCK4'),
('netlock5', 9164, 'tcp', 'NetLOCK5'),
('wap-wsp', 9200, 'tcp', 'WAP connectionless session service'),
('wap-wsp-wtp', 9201, 'tcp', 'WAP session service'),
('wap-wsp-s', 9202, 'tcp', 'WAP secure connectionless session service'),
('wap-wsp-wtp-s', 9203, 'tcp', 'WAP secure session service'),
('wap-vcard', 9204, 'tcp', 'WAP vCard'),
('wap-vcal', 9205, 'tcp', 'WAP vCal'),
('wap-vcard-s', 9206, 'tcp', 'WAP vCard Secure'),
('wap-vcal-s', 9207, 'tcp', 'WAP vCal Secure'),
('lif-mlp', 9210, 'tcp', 'LIF Mobile Locn Protocol'),
('lif-mlp-s', 9211, 'tcp', 'LIF Mobile Locn Secure'),
('fsc-port', 9217, 'tcp', 'FSC Communication Port'),
('swtp-port1', 9281, 'tcp', 'SofaWare transport port 1'),
('swtp-port2', 9282, 'tcp', 'SofaWare transport port 2'),
('callwaveiam', 9283, 'tcp', 'CallWaveIAM'),
('visd', 9284, 'tcp', 'VERITAS Information Serve'),
('n2h2server', 9285, 'tcp', 'N2H2 Filter Service Port'),
('cumulus', 9287, 'tcp', 'Cumulus'),
('armtechdaemon', 9292, 'tcp', 'ArmTech Daemon'),
('guibase', 9321, 'tcp', 'guibase'),
('mpidcmgr', 9343, 'tcp', 'MpIdcMgr'),
('mphlpdmc', 9344, 'tcp', 'Mphlpdmc'),
('ctechlicensing', 9346, 'tcp', 'C Tech Licensing'),
('fjdmimgr', 9374, 'tcp', 'fjdmimgr'),
('fjinvmgr', 9396, 'tcp', 'fjinvmgr'),
('mpidcagt', 9397, 'tcp', 'MpIdcAgt'),
('ismserver', 9500, 'tcp', 'ismserver'),
('mngsuite', 9535, 'tcp', ''),
('msgsys', 9594, 'tcp', 'Message System'),
('pds', 9595, 'tcp', 'Ping Discovery Service'),
('micromuse-ncpw', 9600, 'tcp', 'MICROMUSE-NCPW'),
('streamcomm-ds', 9612, 'tcp', 'StreamComm User Directory'),
('l5nas-parchan', 9747, 'tcp', 'L5NAS Parallel Channel'),
('rasadv', 9753, 'tcp', 'rasadv'),
('davsrc', 9800, 'tcp', 'WebDav Source Port'),
('sstp-2', 9801, 'tcp', 'Sakura Script Transfer Protocol-2'),
('sapv1', 9875, 'tcp', 'Session Announcement v1'),
('sd', 9876, 'tcp', 'Session Director'),
('cyborg-systems', 9888, 'tcp', 'CYBORG Systems'),
('monkeycom', 9898, 'tcp', 'MonkeyCom'),
('sctp-tunneling', 9899, 'tcp', 'SCTP TUNNELING'),
('iua', 9900, 'tcp', 'IUA'),
('domaintime', 9909, 'tcp', 'domaintime'),
('apcpcpluswin1', 9950, 'tcp', 'APCPCPLUSWIN1'),
('apcpcpluswin2', 9951, 'tcp', 'APCPCPLUSWIN2'),
('apcpcpluswin3', 9952, 'tcp', 'APCPCPLUSWIN3'),
('palace-1', 9992, 'tcp', 'OnLive-1'),
('palace-2', 9993, 'tcp', 'OnLive-2'),
('palace-3', 9994, 'tcp', 'OnLive-3'),
('palace-4', 9995, 'tcp', 'Palace-4'),
('palace-5', 9996, 'tcp', 'Palace-5'),
('palace-6', 9997, 'tcp', 'Palace-6'),
('distinct32', 9998, 'tcp', 'Distinct32'),
('distinct', 9999, 'tcp', 'distinct'),
('ndmp', 10000, 'tcp', 'Network Data Management Protocol'),
('scp-config', 10001, 'tcp', 'SCP Configuration Port'),
('mvs-capacity', 10007, 'tcp', 'MVS Capacity'),
('amanda', 10080, 'tcp', 'Amanda'),
('ezmeeting-2', 10101, 'tcp', 'eZmeeting'),
('ezproxy-2', 10102, 'tcp', 'eZproxy'),
('ezrelay', 10103, 'tcp', 'eZrelay'),
('netiq-endpoint', 10113, 'tcp', 'NetIQ Endpoint'),
('netiq-qcheck', 10114, 'tcp', 'NetIQ Qcheck'),
('netiq-endpt', 10115, 'tcp', 'NetIQ Endpoint'),
('netiq-voipa', 10116, 'tcp', 'NetIQ VoIP Assessor'),
('bmc-perf-sd', 10128, 'tcp', 'BMC-PERFORM-SERVICE DAEMON'),
('axis-wimp-port', 10260, 'tcp', 'Axis WIMP Port'),
('blocks', 10288, 'tcp', 'Blocks'),
('rmiaux', 10990, 'tcp', 'Auxiliary RMI Port'),
('irisa', 11000, 'tcp', 'IRISA'),
('metasys', 11001, 'tcp', 'Metasys'),
('vce', 11111, 'tcp', 'Viral Computing Environment (VCE)'),
('smsqp', 11201, 'tcp', 'smsqp'),
('imip', 11319, 'tcp', 'IMIP'),
('imip-channels', 11320, 'tcp', 'IMIP Channels Port'),
('arena-server', 11321, 'tcp', 'Arena Server Listen'),
('atm-uhas', 11367, 'tcp', 'ATM UHAS'),
('tempest-port', 11600, 'tcp', 'Tempest Protocol Port'),
('h323callsigalt', 11720, 'tcp', 'h323 Call Signal Alternate'),
('entextxid', 12000, 'tcp', 'IBM Enterprise Extender SNA XID Exchange'),
('entextnetwk', 12001, 'tcp', 'IBM Enterprise Extender SNA COS Network Priority'),
('entexthigh', 12002, 'tcp', 'IBM Enterprise Extender SNA COS High Priority'),
('entextmed', 12003, 'tcp', 'IBM Enterprise Extender SNA COS Medium Priority'),
('entextlow', 12004, 'tcp', 'IBM Enterprise Extender SNA COS Low Priority'),
('dbisamserver1', 12005, 'tcp', 'DBISAM Database Server - Regular'),
('dbisamserver2', 12006, 'tcp', 'DBISAM Database Server - Admin'),
('hivep', 12172, 'tcp', 'HiveP'),
('italk', 12345, 'tcp', 'Italk Chat System'),
('tsaf', 12753, 'tcp', 'tsaf port'),
('i-zipqd', 13160, 'tcp', 'I-ZIPQD'),
('powwow-client', 13223, 'tcp', 'PowWow Client'),
('powwow-server', 13224, 'tcp', 'PowWow Server'),
('bprd', 13720, 'tcp', 'BPRD Protocol (VERITAS NetBackup)'),
('bpdbm', 13721, 'tcp', 'BPDBM Protocol (VERITAS NetBackup)'),
('bpjava-msvc', 13722, 'tcp', 'BP Java MSVC Protocol'),
('vnetd', 13724, 'tcp', 'Veritas Network Utility'),
('bpcd', 13782, 'tcp', 'VERITAS NetBackup'),
('vopied', 13783, 'tcp', 'VOPIED Protocol'),
('dsmcc-config', 13818, 'tcp', 'DSMCC Config'),
('dsmcc-session', 13819, 'tcp', 'DSMCC Session Messages'),
('dsmcc-passthru', 13820, 'tcp', 'DSMCC Pass-Thru Messages'),
('dsmcc-download', 13821, 'tcp', 'DSMCC Download Protocol'),
('dsmcc-ccp', 13822, 'tcp', 'DSMCC Channel Change Protocol'),
('sua', 14001, 'tcp', 'SUA'),
('sage-best-com1', 14033, 'tcp', 'sage Best! Config Server 1'),
('sage-best-com2', 14034, 'tcp', 'sage Best! Config Server 2'),
('vcs-app', 14141, 'tcp', 'VCS Application'),
('gcm-app', 14145, 'tcp', 'GCM Application'),
('vrts-tdd', 14149, 'tcp', 'Veritas Traffic Director'),
('hde-lcesrvr-1', 14936, 'tcp', 'hde-lcesrvr-1'),
('hde-lcesrvr-2', 14937, 'tcp', 'hde-lcesrvr-2'),
('hydap', 15000, 'tcp', 'Hypack Data Aquisition'),
('xpilot', 15345, 'tcp', 'XPilot Contact Port'),
('netserialext1', 16360, 'tcp', 'netserialext1'),
('netserialext2', 16361, 'tcp', 'netserialext2'),
('netserialext3', 16367, 'tcp', 'netserialext3'),
('netserialext4', 16368, 'tcp', 'netserialext4'),
('intel-rci-mp', 16991, 'tcp', 'INTEL-RCI-MP'),
('isode-dua', 17007, 'tcp', ''),
('soundsvirtual', 17185, 'tcp', 'Sounds Virtual'),
('chipper', 17219, 'tcp', 'Chipper'),
('biimenu', 18000, 'tcp', 'Beckman Instruments, Inc.'),
('opsec-cvp', 18181, 'tcp', 'OPSEC CVP'),
('opsec-ufp', 18182, 'tcp', 'OPSEC UFP'),
('opsec-sam', 18183, 'tcp', 'OPSEC SAM'),
('opsec-lea', 18184, 'tcp', 'OPSEC LEA'),
('opsec-omi', 18185, 'tcp', 'OPSEC OMI'),
('opsec-ela', 18187, 'tcp', 'OPSEC ELA'),
('checkpoint-rtm', 18241, 'tcp', 'Check Point RTM'),
('ac-cluster', 18463, 'tcp', 'AC Cluster'),
('ique', 18769, 'tcp', 'IQue Protocol'),
('apc-necmp', 18888, 'tcp', 'APCNECMP'),
('opsec-uaa', 19191, 'tcp', 'opsec-uaa'),
('keysrvr', 19283, 'tcp', 'Key Server for SASSAFRAS'),
('keyshadow', 19315, 'tcp', 'Key Shadow for SASSAFRAS'),
('mtrgtrans', 19398, 'tcp', 'mtrgtrans'),
('hp-sco', 19410, 'tcp', 'hp-sco'),
('hp-sca', 19411, 'tcp', 'hp-sca'),
('hp-sessmon', 19412, 'tcp', 'HP-SESSMON'),
('sxuptp', 19540, 'tcp', 'SXUPTP'),
('jcp', 19541, 'tcp', 'JCP Client'),
('dnp', 20000, 'tcp', 'DNP'),
('ipulse-ics', 20222, 'tcp', 'iPulse-ICS'),
('track', 20670, 'tcp', 'Track'),
('athand-mmp', 20999, 'tcp', 'At Hand MMP'),
('vofr-gateway', 21590, 'tcp', 'VoFR Gateway'),
('tvpm', 21800, 'tcp', 'TVNC Pro Multiplexing'),
('webphone', 21845, 'tcp', 'webphone'),
('netspeak-is', 21846, 'tcp', 'NetSpeak Corp. Directory Services'),
('netspeak-cs', 21847, 'tcp', 'NetSpeak Corp. Connection Services'),
('netspeak-acd', 21848, 'tcp', 'NetSpeak Corp. Automatic Call Distribution'),
('netspeak-cps', 21849, 'tcp', 'NetSpeak Corp. Credit Processing System'),
('snapenetio', 22000, 'tcp', 'SNAPenetIO'),
('optocontrol', 22001, 'tcp', 'OptoControl'),
('wnn6', 22273, 'tcp', 'wnn6'),
('vocaltec-wconf', 22555, 'tcp', 'Vocaltec Web Conference'),
('aws-brf', 22800, 'tcp', 'Telerate Information Platform LAN'),
('brf-gw', 22951, 'tcp', 'Telerate Information Platform WAN'),
('med-ltp', 24000, 'tcp', 'med-ltp'),
('med-fsp-rx', 24001, 'tcp', 'med-fsp-rx'),
('med-fsp-tx', 24002, 'tcp', 'med-fsp-tx'),
('med-supp', 24003, 'tcp', 'med-supp'),
('med-ovw', 24004, 'tcp', 'med-ovw'),
('med-ci', 24005, 'tcp', 'med-ci'),
('med-net-svc', 24006, 'tcp', 'med-net-svc'),
('filesphere', 24242, 'tcp', 'fileSphere'),
('vista-4gl', 24249, 'tcp', 'Vista 4GL'),
('intel_rci', 24386, 'tcp', 'Intel RCI'),
('binkp', 24554, 'tcp', 'BINKP'),
('flashfiler', 24677, 'tcp', 'FlashFiler'),
('proactivate', 24678, 'tcp', 'Turbopower Proactivate'),
('snip', 24922, 'tcp', 'Simple Net Ident Protocol'),
('icl-twobase1', 25000, 'tcp', 'icl-twobase1'),
('icl-twobase2', 25001, 'tcp', 'icl-twobase2'),
('icl-twobase3', 25002, 'tcp', 'icl-twobase3'),
('icl-twobase4', 25003, 'tcp', 'icl-twobase4'),
('icl-twobase5', 25004, 'tcp', 'icl-twobase5'),
('icl-twobase6', 25005, 'tcp', 'icl-twobase6'),
('icl-twobase7', 25006, 'tcp', 'icl-twobase7'),
('icl-twobase8', 25007, 'tcp', 'icl-twobase8'),
('icl-twobase9', 25008, 'tcp', 'icl-twobase9'),
('icl-twobase10', 25009, 'tcp', 'icl-twobase10'),
('vocaltec-hos', 25793, 'tcp', 'Vocaltec Address Server'),
('niobserver', 25901, 'tcp', 'NIObserver'),
('niprobe', 25903, 'tcp', 'NIProbe'),
('quake', 26000, 'tcp', 'quake'),
('wnn6-ds', 26208, 'tcp', 'wnn6-ds'),
('ezproxy', 26260, 'tcp', 'eZproxy'),
('ezmeeting', 26261, 'tcp', 'eZmeeting'),
('k3software-svr', 26262, 'tcp', 'K3 Software-Server'),
('k3software-cli', 26263, 'tcp', 'K3 Software-Client'),
('gserver', 26264, 'tcp', 'Gserver'),
('imagepump', 27345, 'tcp', 'ImagePump'),
('tw-auth-key', 27999, 'tcp', 'TW Authentication/Key Distribution and'),
('pago-services1', 30001, 'tcp', 'Pago Services 1'),
('pago-services2', 30002, 'tcp', 'Pago Services 2'),
('xqosd', 31416, 'tcp', 'XQoS network monitor'),
('filenet-tms', 32768, 'tcp', 'Filenet TMS'),
('filenet-rpc', 32769, 'tcp', 'Filenet RPC'),
('filenet-nch', 32770, 'tcp', 'Filenet NCH'),
('filenet-rmi', 32771, 'tcp', 'FileNET RMI'),
('diamondport', 33331, 'tcp', 'DiamondCentral Interface'),
('traceroute', 33434, 'tcp', 'traceroute use'),
('turbonote-2', 34249, 'tcp', 'TurboNote Relay Server Default Port'),
('kastenxpipe', 36865, 'tcp', 'KastenX Pipe'),
('neckar', 37475, 'tcp', 'science + computings Venus Administration Port'),
('turbonote-1', 39681, 'tcp', 'TurboNote Default Port'),
('cscp', 40841, 'tcp', 'CSCP'),
('csccredir', 40842, 'tcp', 'CSCCREDIR'),
('csccfirewall', 40843, 'tcp', 'CSCCFIREWALL'),
('fs-qos', 41111, 'tcp', 'Foursticks QoS Protocol'),
('reachout', 43188, 'tcp', 'REACHOUT'),
('ndm-agent-port', 43189, 'tcp', 'NDM-AGENT-PORT'),
('ip-provision', 43190, 'tcp', 'IP-PROVISION'),
('pmcd', 44321, 'tcp', 'PCP server (pmcd)'),
('rockwell-encap', 44818, 'tcp', 'Rockwell Encapsulation'),
('invision-ag', 45054, 'tcp', 'InVision AG'),
('eba', 45678, 'tcp', 'EBA PRISE'),
('ssr-servermgr', 45966, 'tcp', 'SSRServerMgr'),
('mbus', 47000, 'tcp', 'Message Bus'),
('dbbrowse', 47557, 'tcp', 'Databeam Corporation'),
('directplaysrvr', 47624, 'tcp', 'Direct Play Server'),
('ap', 47806, 'tcp', 'ALC Protocol'),
('bacnet', 47808, 'tcp', 'Building Automation and Control Networks'),
('nimcontroller', 48000, 'tcp', 'Nimbus Controller'),
('nimspooler', 48001, 'tcp', 'Nimbus Spooler'),
('nimhub', 48002, 'tcp', 'Nimbus Hub'),
('nimgtw', 48003, 'tcp', 'Nimbus Gateway'),
('com-bardac-dw', 48556, 'tcp', 'com-bardac-dw'),
('', 0, 'udp', 'Reserved'),
('tcpmux', 1, 'udp', 'TCP Port Service Multiplexer'),
('compressnet', 2, 'udp', 'Management Utility'),
('compressnet', 3, 'udp', 'Compression Process'),
('rje', 5, 'udp', 'Remote Job Entry'),
('echo', 7, 'udp', 'Echo'),
('discard', 9, 'udp', 'Discard'),
('systat', 11, 'udp', 'Active Users'),
('daytime', 13, 'udp', 'Daytime (RFC 867)'),
('qotd', 17, 'udp', 'Quote of the Day'),
('msp', 18, 'udp', 'Message Send Protocol'),
('chargen', 19, 'udp', 'Character Generator'),
('ftp-data', 20, 'udp', 'File Transfer [Default Data]'),
('ftp', 21, 'udp', 'File Transfer [Control]'),
('ssh', 22, 'udp', 'SSH Remote Login Protocol'),
('telnet', 23, 'udp', 'Telnet'),
('', 24, 'udp', 'any private mail system'),
('smtp', 25, 'udp', 'Simple Mail Transfer'),
('nsw-fe', 27, 'udp', 'NSW User System FE'),
('msg-icp', 29, 'udp', 'MSG ICP'),
('msg-auth', 31, 'udp', 'MSG Authentication'),
('dsp', 33, 'udp', 'Display Support Protocol'),
('', 35, 'udp', 'any private printer server'),
('time', 37, 'udp', 'Time'),
('rap', 38, 'udp', 'Route Access Protocol'),
('rlp', 39, 'udp', 'Resource Location Protocol'),
('graphics', 41, 'udp', 'Graphics'),
('nameserver', 42, 'udp', 'Host Name Server'),
('nicname', 43, 'udp', 'Who Is'),
('mpm-flags', 44, 'udp', 'MPM FLAGS Protocol'),
('mpm', 45, 'udp', 'Message Processing Module [recv]'),
('mpm-snd', 46, 'udp', 'MPM [default send]'),
('ni-ftp', 47, 'udp', 'NI FTP'),
('auditd', 48, 'udp', 'Digital Audit Daemon'),
('tacacs', 49, 'udp', 'Login Host Protocol (TACACS)'),
('re-mail-ck', 50, 'udp', 'Remote Mail Checking Protocol'),
('la-maint', 51, 'udp', 'IMP Logical Address Maintenance'),
('xns-time', 52, 'udp', 'XNS Time Protocol'),
('domain', 53, 'udp', 'Domain Name Server'),
('xns-ch', 54, 'udp', 'XNS Clearinghouse'),
('isi-gl', 55, 'udp', 'ISI Graphics Language'),
('xns-auth', 56, 'udp', 'XNS Authentication'),
('', 57, 'udp', 'any private terminal access'),
('xns-mail', 58, 'udp', 'XNS Mail'),
('', 59, 'udp', 'any private file service'),
('', 60, 'udp', 'Unassigned'),
('ni-mail', 61, 'udp', 'NI MAIL'),
('acas', 62, 'udp', 'ACA Services'),
('whois++', 63, 'udp', 'whois++'),
('covia', 64, 'udp', 'Communications Integrator (CI)'),
('tacacs-ds', 65, 'udp', 'TACACS-Database Service'),
('sql*net', 66, 'udp', 'Oracle SQL*NET'),
('bootps', 67, 'udp', 'Bootstrap Protocol Server'),
('bootpc', 68, 'udp', 'Bootstrap Protocol Client'),
('tftp', 69, 'udp', 'Trivial File Transfer'),
('gopher', 70, 'udp', 'Gopher'),
('netrjs-1', 71, 'udp', 'Remote Job Service'),
('netrjs-2', 72, 'udp', 'Remote Job Service'),
('netrjs-3', 73, 'udp', 'Remote Job Service'),
('netrjs-4', 74, 'udp', 'Remote Job Service'),
('', 75, 'udp', 'any private dial out service'),
('deos', 76, 'udp', 'Distributed External Object Store'),
('', 77, 'udp', 'any private RJE service'),
('vettcp', 78, 'udp', 'vettcp'),
('finger', 79, 'udp', 'Finger'),
('http', 80, 'udp', 'World Wide Web HTTP'),
('hosts2-ns', 81, 'udp', 'HOSTS2 Name Server'),
('xfer', 82, 'udp', 'XFER Utility'),
('mit-ml-dev', 83, 'udp', 'MIT ML Device'),
('ctf', 84, 'udp', 'Common Trace Facility'),
('mit-ml-dev', 85, 'udp', 'MIT ML Device'),
('mfcobol', 86, 'udp', 'Micro Focus Cobol'),
('', 87, 'udp', 'any private terminal link'),
('kerberos', 88, 'udp', 'Kerberos'),
('su-mit-tg', 89, 'udp', 'SU/MIT Telnet Gateway'),
('dnsix', 90, 'udp', 'DNSIX Securit Attribute Token Map'),
('mit-dov', 91, 'udp', 'MIT Dover Spooler'),
('npp', 92, 'udp', 'Network Printing Protocol'),
('dcp', 93, 'udp', 'Device Control Protocol'),
('objcall', 94, 'udp', 'Tivoli Object Dispatcher'),
('supdup', 95, 'udp', 'SUPDUP'),
('dixie', 96, 'udp', 'DIXIE Protocol Specification'),
('swift-rvf', 97, 'udp', 'Swift Remote Virtural File Protocol'),
('tacnews', 98, 'udp', 'TAC News'),
('metagram', 99, 'udp', 'Metagram Relay'),
('hostname', 101, 'udp', 'NIC Host Name Server'),
('iso-tsap', 102, 'udp', 'ISO-TSAP Class 0'),
('gppitnp', 103, 'udp', 'Genesis Point-to-Point Trans Net'),
('acr-nema', 104, 'udp', 'ACR-NEMA Digital Imag. & Comm. 300'),
('cso', 105, 'udp', 'CCSO name server protocol'),
('csnet-ns', 105, 'udp', 'Mailbox Name Nameserver'),
('3com-tsmux', 106, 'udp', '3COM-TSMUX'),
('rtelnet', 107, 'udp', 'Remote Telnet Service'),
('snagas', 108, 'udp', 'SNA Gateway Access Server'),
('pop2', 109, 'udp', 'Post Office Protocol - Version 2'),
('pop3', 110, 'udp', 'Post Office Protocol - Version 3'),
('sunrpc', 111, 'udp', 'SUN Remote Procedure Call'),
('mcidas', 112, 'udp', 'McIDAS Data Transmission Protocol'),
('auth', 113, 'udp', 'Authentication Service'),
('audionews', 114, 'udp', 'Audio News Multicast'),
('sftp', 115, 'udp', 'Simple File Transfer Protocol'),
('ansanotify', 116, 'udp', 'ANSA REX Notify'),
('uucp-path', 117, 'udp', 'UUCP Path Service'),
('sqlserv', 118, 'udp', 'SQL Services'),
('nntp', 119, 'udp', 'Network News Transfer Protocol'),
('cfdptkt', 120, 'udp', 'CFDPTKT'),
('erpc', 121, 'udp', 'Encore Expedited Remote Pro.Call'),
('smakynet', 122, 'udp', 'SMAKYNET'),
('ntp', 123, 'udp', 'Network Time Protocol'),
('ansatrader', 124, 'udp', 'ANSA REX Trader'),
('locus-map', 125, 'udp', 'Locus PC-Interface Net Map Ser'),
('nxedit', 126, 'udp', 'NXEdit'),
('locus-con', 127, 'udp', 'Locus PC-Interface Conn Server'),
('gss-xlicen', 128, 'udp', 'GSS X License Verification'),
('pwdgen', 129, 'udp', 'Password Generator Protocol'),
('cisco-fna', 130, 'udp', 'cisco FNATIVE'),
('cisco-tna', 131, 'udp', 'cisco TNATIVE'),
('cisco-sys', 132, 'udp', 'cisco SYSMAINT'),
('statsrv', 133, 'udp', 'Statistics Service'),
('ingres-net', 134, 'udp', 'INGRES-NET Service'),
('epmap', 135, 'udp', 'DCE endpoint resolution'),
('profile', 136, 'udp', 'PROFILE Naming System'),
('netbios-ns', 137, 'udp', 'NETBIOS Name Service'),
('netbios-dgm', 138, 'udp', 'NETBIOS Datagram Service'),
('netbios-ssn', 139, 'udp', 'NETBIOS Session Service'),
('emfis-data', 140, 'udp', 'EMFIS Data Service'),
('emfis-cntl', 141, 'udp', 'EMFIS Control Service'),
('bl-idm', 142, 'udp', 'Britton-Lee IDM'),
('imap', 143, 'udp', 'Internet Message Access Protocol'),
('uma', 144, 'udp', 'Universal Management Architecture'),
('uaac', 145, 'udp', 'UAAC Protocol'),
('iso-tp0', 146, 'udp', 'ISO-IP0'),
('iso-ip', 147, 'udp', 'ISO-IP'),
('jargon', 148, 'udp', 'Jargon'),
('aed-512', 149, 'udp', 'AED 512 Emulation Service'),
('sql-net', 150, 'udp', 'SQL-NET'),
('hems', 151, 'udp', 'HEMS'),
('bftp', 152, 'udp', 'Background File Transfer Program'),
('sgmp', 153, 'udp', 'SGMP'),
('netsc-prod', 154, 'udp', 'NETSC'),
('netsc-dev', 155, 'udp', 'NETSC'),
('sqlsrv', 156, 'udp', 'SQL Service'),
('knet-cmp', 157, 'udp', 'KNET/VM Command/Message Protocol'),
('pcmail-srv', 158, 'udp', 'PCMail Server'),
('nss-routing', 159, 'udp', 'NSS-Routing'),
('sgmp-traps', 160, 'udp', 'SGMP-TRAPS'),
('snmp', 161, 'udp', 'SNMP'),
('snmptrap', 162, 'udp', 'SNMPTRAP'),
('cmip-man', 163, 'udp', 'CMIP/TCP Manager'),
('cmip-agent', 164, 'udp', 'CMIP/TCP Agent'),
('xns-courier', 165, 'udp', 'Xerox'),
('s-net', 166, 'udp', 'Sirius Systems'),
('namp', 167, 'udp', 'NAMP'),
('rsvd', 168, 'udp', 'RSVD'),
('send', 169, 'udp', 'SEND'),
('print-srv', 170, 'udp', 'Network PostScript'),
('multiplex', 171, 'udp', 'Network Innovations Multiplex'),
('cl/1', 172, 'udp', 'Network Innovations CL/1'),
('xyplex-mux', 173, 'udp', 'Xyplex'),
('mailq', 174, 'udp', 'MAILQ'),
('vmnet', 175, 'udp', 'VMNET'),
('genrad-mux', 176, 'udp', 'GENRAD-MUX'),
('xdmcp', 177, 'udp', 'X Display Manager Control Protocol'),
('nextstep', 178, 'udp', 'NextStep Window Server'),
('bgp', 179, 'udp', 'Border Gateway Protocol'),
('ris', 180, 'udp', 'Intergraph'),
('unify', 181, 'udp', 'Unify'),
('audit', 182, 'udp', 'Unisys Audit SITP'),
('ocbinder', 183, 'udp', 'OCBinder'),
('ocserver', 184, 'udp', 'OCServer'),
('remote-kis', 185, 'udp', 'Remote-KIS'),
('kis', 186, 'udp', 'KIS Protocol'),
('aci', 187, 'udp', 'Application Communication Interface'),
('mumps', 188, 'udp', 'Plus Fives MUMPS'),
('qft', 189, 'udp', 'Queued File Transport'),
('gacp', 190, 'udp', 'Gateway Access Control Protocol'),
('prospero', 191, 'udp', 'Prospero Directory Service'),
('osu-nms', 192, 'udp', 'OSU Network Monitoring System'),
('srmp', 193, 'udp', 'Spider Remote Monitoring Protocol'),
('irc', 194, 'udp', 'Internet Relay Chat Protocol'),
('dn6-nlm-aud', 195, 'udp', 'DNSIX Network Level Module Audit'),
('dn6-smm-red', 196, 'udp', 'DNSIX Session Mgt Module Audit Redir'),
('dls', 197, 'udp', 'Directory Location Service'),
('dls-mon', 198, 'udp', 'Directory Location Service Monitor'),
('smux', 199, 'udp', 'SMUX'),
('src', 200, 'udp', 'IBM System Resource Controller'),
('at-rtmp', 201, 'udp', 'AppleTalk Routing Maintenance'),
('at-nbp', 202, 'udp', 'AppleTalk Name Binding'),
('at-3', 203, 'udp', 'AppleTalk Unused'),
('at-echo', 204, 'udp', 'AppleTalk Echo'),
('at-5', 205, 'udp', 'AppleTalk Unused'),
('at-zis', 206, 'udp', 'AppleTalk Zone Information'),
('at-7', 207, 'udp', 'AppleTalk Unused'),
('at-8', 208, 'udp', 'AppleTalk Unused'),
('qmtp', 209, 'udp', 'The Quick Mail Transfer Protocol'),
('z39.50', 210, 'udp', 'ANSI Z39.50'),
('914c/g', 211, 'udp', 'Texas Instruments 914C/G Terminal'),
('anet', 212, 'udp', 'ATEXSSTR'),
('ipx', 213, 'udp', 'IPX'),
('vmpwscs', 214, 'udp', 'VM PWSCS'),
('softpc', 215, 'udp', 'Insignia Solutions'),
('CAIlic', 216, 'udp', 'Computer Associates Intl License Server'),
('dbase', 217, 'udp', 'dBASE Unix'),
('mpp', 218, 'udp', 'Netix Message Posting Protocol'),
('uarps', 219, 'udp', 'Unisys ARPs'),
('imap3', 220, 'udp', 'Interactive Mail Access Protocol v3'),
('fln-spx', 221, 'udp', 'Berkeley rlogind with SPX auth'),
('rsh-spx', 222, 'udp', 'Berkeley rshd with SPX auth'),
('cdc', 223, 'udp', 'Certificate Distribution Center'),
('masqdialer', 224, 'udp', 'masqdialer'),
('direct', 242, 'udp', 'Direct'),
('sur-meas', 243, 'udp', 'Survey Measurement'),
('inbusiness', 244, 'udp', 'inbusiness'),
('link', 245, 'udp', 'LINK'),
('dsp3270', 246, 'udp', 'Display Systems Protocol'),
('subntbcst_tftp', 247, 'udp', 'SUBNTBCST_TFTP'),
('bhfhs', 248, 'udp', 'bhfhs'),
('rap', 256, 'udp', 'RAP'),
('set', 257, 'udp', 'Secure Electronic Transaction'),
('yak-chat', 258, 'udp', 'Yak Winsock Personal Chat'),
('esro-gen', 259, 'udp', 'Efficient Short Remote Operations'),
('openport', 260, 'udp', 'Openport'),
('nsiiops', 261, 'udp', 'IIOP Name Service over TLS/SSL'),
('arcisdms', 262, 'udp', 'Arcisdms'),
('hdap', 263, 'udp', 'HDAP'),
('bgmp', 264, 'udp', 'BGMP'),
('x-bone-ctl', 265, 'udp', 'X-Bone CTL'),
('sst', 266, 'udp', 'SCSI on ST'),
('td-service', 267, 'udp', 'Tobit David Service Layer'),
('td-replica', 268, 'udp', 'Tobit David Replica'),
('http-mgmt', 280, 'udp', 'http-mgmt'),
('personal-link', 281, 'udp', 'Personal Link'),
('cableport-ax', 282, 'udp', 'Cable Port A/X'),
('rescap', 283, 'udp', 'rescap'),
('corerjd', 284, 'udp', 'corerjd'),
('fxp-1', 286, 'udp', 'FXP-1'),
('k-block', 287, 'udp', 'K-BLOCK'),
('novastorbakcup', 308, 'udp', 'Novastor Backup'),
('entrusttime', 309, 'udp', 'EntrustTime'),
('bhmds', 310, 'udp', 'bhmds'),
('asip-webadmin', 311, 'udp', 'AppleShare IP WebAdmin'),
('vslmp', 312, 'udp', 'VSLMP'),
('magenta-logic', 313, 'udp', 'Magenta Logic'),
('opalis-robot', 314, 'udp', 'Opalis Robot'),
('dpsi', 315, 'udp', 'DPSI'),
('decauth', 316, 'udp', 'decAuth'),
('zannet', 317, 'udp', 'Zannet'),
('pkix-timestamp', 318, 'udp', 'PKIX TimeStamp'),
('ptp-event', 319, 'udp', 'PTP Event'),
('ptp-general', 320, 'udp', 'PTP General'),
('pip', 321, 'udp', 'PIP'),
('rtsps', 322, 'udp', 'RTSPS'),
('texar', 333, 'udp', 'Texar Security Port'),
('pdap', 344, 'udp', 'Prospero Data Access Protocol'),
('pawserv', 345, 'udp', 'Perf Analysis Workbench'),
('zserv', 346, 'udp', 'Zebra server'),
('fatserv', 347, 'udp', 'Fatmen Server'),
('csi-sgwp', 348, 'udp', 'Cabletron Management Protocol'),
('mftp', 349, 'udp', 'mftp'),
('matip-type-a', 350, 'udp', 'MATIP Type A'),
('matip-type-b', 351, 'udp', 'MATIP Type B'),
('bhoetty', 351, 'udp', 'bhoetty'),
('dtag-ste-sb', 352, 'udp', 'DTAG'),
('bhoedap4', 352, 'udp', 'bhoedap4'),
('ndsauth', 353, 'udp', 'NDSAUTH'),
('bh611', 354, 'udp', 'bh611'),
('datex-asn', 355, 'udp', 'DATEX-ASN'),
('cloanto-net-1', 356, 'udp', 'Cloanto Net 1'),
('bhevent', 357, 'udp', 'bhevent'),
('shrinkwrap', 358, 'udp', 'Shrinkwrap'),
('nsrmp', 359, 'udp', 'Network Security Risk Management Protocol'),
('scoi2odialog', 360, 'udp', 'scoi2odialog'),
('semantix', 361, 'udp', 'Semantix'),
('srssend', 362, 'udp', 'SRS Send'),
('rsvp_tunnel', 363, 'udp', 'RSVP Tunnel'),
('aurora-cmgr', 364, 'udp', 'Aurora CMGR'),
('dtk', 365, 'udp', 'DTK'),
('odmr', 366, 'udp', 'ODMR'),
('mortgageware', 367, 'udp', 'MortgageWare'),
('qbikgdp', 368, 'udp', 'QbikGDP'),
('rpc2portmap', 369, 'udp', 'rpc2portmap'),
('codaauth2', 370, 'udp', 'codaauth2'),
('clearcase', 371, 'udp', 'Clearcase'),
('ulistproc', 372, 'udp', 'ListProcessor'),
('legent-1', 373, 'udp', 'Legent Corporation'),
('legent-2', 374, 'udp', 'Legent Corporation'),
('hassle', 375, 'udp', 'Hassle'),
('nip', 376, 'udp', 'Amiga Envoy Network Inquiry Proto'),
('tnETOS', 377, 'udp', 'NEC Corporation'),
('dsETOS', 378, 'udp', 'NEC Corporation'),
('is99c', 379, 'udp', 'TIA/EIA/IS-99 modem client'),
('is99s', 380, 'udp', 'TIA/EIA/IS-99 modem server'),
('hp-collector', 381, 'udp', 'hp performance data collector'),
('hp-managed-node', 382, 'udp', 'hp performance data managed node'),
('hp-alarm-mgr', 383, 'udp', 'hp performance data alarm manager'),
('arns', 384, 'udp', 'A Remote Network Server System'),
('ibm-app', 385, 'udp', 'IBM Application'),
('asa', 386, 'udp', 'ASA Message Router Object Def.'),
('aurp', 387, 'udp', 'Appletalk Update-Based Routing Pro.'),
('unidata-ldm', 388, 'udp', 'Unidata LDM'),
('ldap', 389, 'udp', 'Lightweight Directory Access Protocol'),
('uis', 390, 'udp', 'UIS'),
('synotics-relay', 391, 'udp', 'SynOptics SNMP Relay Port'),
('synotics-broker', 392, 'udp', 'SynOptics Port Broker Port'),
('meta5', 393, 'udp', 'Meta5'),
('embl-ndt', 394, 'udp', 'EMBL Nucleic Data Transfer'),
('netcp', 395, 'udp', 'NETscout Control Protocol'),
('netware-ip', 396, 'udp', 'Novell Netware over IP'),
('mptn', 397, 'udp', 'Multi Protocol Trans. Net.'),
('kryptolan', 398, 'udp', 'Kryptolan'),
('iso-tsap-c2', 399, 'udp', 'ISO Transport Class 2 Non-Control over UDP'),
('work-sol', 400, 'udp', 'Workstation Solutions'),
('ups', 401, 'udp', 'Uninterruptible Power Supply'),
('genie', 402, 'udp', 'Genie Protocol'),
('decap', 403, 'udp', 'decap'),
('nced', 404, 'udp', 'nced'),
('ncld', 405, 'udp', 'ncld'),
('imsp', 406, 'udp', 'Interactive Mail Support Protocol'),
('timbuktu', 407, 'udp', 'Timbuktu'),
('prm-sm', 408, 'udp', 'Prospero Resource Manager Sys. Man.'),
('prm-nm', 409, 'udp', 'Prospero Resource Manager Node Man.'),
('decladebug', 410, 'udp', 'DECLadebug Remote Debug Protocol'),
('rmt', 411, 'udp', 'Remote MT Protocol'),
('synoptics-trap', 412, 'udp', 'Trap Convention Port'),
('smsp', 413, 'udp', 'Storage Management Services Protocol'),
('infoseek', 414, 'udp', 'InfoSeek'),
('bnet', 415, 'udp', 'BNet'),
('silverplatter', 416, 'udp', 'Silverplatter'),
('onmux', 417, 'udp', 'Onmux'),
('hyper-g', 418, 'udp', 'Hyper-G'),
('ariel1', 419, 'udp', 'Ariel'),
('smpte', 420, 'udp', 'SMPTE'),
('ariel2', 421, 'udp', 'Ariel'),
('ariel3', 422, 'udp', 'Ariel'),
('opc-job-start', 423, 'udp', 'IBM Operations Planning and Control Start'),
('opc-job-track', 424, 'udp', 'IBM Operations Planning and Control Track'),
('icad-el', 425, 'udp', 'ICAD'),
('smartsdp', 426, 'udp', 'smartsdp'),
('svrloc', 427, 'udp', 'Server Location'),
('ocs_cmu', 428, 'udp', 'OCS_CMU'),
('ocs_amu', 429, 'udp', 'OCS_AMU'),
('utmpsd', 430, 'udp', 'UTMPSD'),
('utmpcd', 431, 'udp', 'UTMPCD'),
('iasd', 432, 'udp', 'IASD'),
('nnsp', 433, 'udp', 'NNSP'),
('mobileip-agent', 434, 'udp', 'MobileIP-Agent'),
('mobilip-mn', 435, 'udp', 'MobilIP-MN'),
('dna-cml', 436, 'udp', 'DNA-CML'),
('comscm', 437, 'udp', 'comscm'),
('dsfgw', 438, 'udp', 'dsfgw'),
('dasp', 439, 'udp', 'dasp tommy@inlab.m.eunet.de'),
('sgcp', 440, 'udp', 'sgcp'),
('decvms-sysmgt', 441, 'udp', 'decvms-sysmgt'),
('cvc_hostd', 442, 'udp', 'cvc_hostd'),
('https', 443, 'udp', 'http protocol over TLS/SSL'),
('snpp', 444, 'udp', 'Simple Network Paging Protocol'),
('microsoft-ds', 445, 'udp', 'Microsoft-DS'),
('ddm-rdb', 446, 'udp', 'DDM-RDB'),
('ddm-dfm', 447, 'udp', 'DDM-RFM'),
('ddm-ssl', 448, 'udp', 'DDM-SSL'),
('as-servermap', 449, 'udp', 'AS Server Mapper'),
('tserver', 450, 'udp', 'Computer Supported Telecomunication Applications'),
('sfs-smp-net', 451, 'udp', 'Cray Network Semaphore server'),
('sfs-config', 452, 'udp', 'Cray SFS config server'),
('creativeserver', 453, 'udp', 'CreativeServer'),
('contentserver', 454, 'udp', 'ContentServer'),
('creativepartnr', 455, 'udp', 'CreativePartnr'),
('macon-udp', 456, 'udp', 'macon-udp'),
('scohelp', 457, 'udp', 'scohelp'),
('appleqtc', 458, 'udp', 'apple quick time'),
('ampr-rcmd', 459, 'udp', 'ampr-rcmd'),
('skronk', 460, 'udp', 'skronk'),
('datasurfsrv', 461, 'udp', 'DataRampSrv'),
('datasurfsrvsec', 462, 'udp', 'DataRampSrvSec'),
('alpes', 463, 'udp', 'alpes'),
('kpasswd', 464, 'udp', 'kpasswd'),
('igmpv3lite', 465, 'udp', 'IGMP over UDP for SSM'),
('digital-vrc', 466, 'udp', 'digital-vrc'),
('mylex-mapd', 467, 'udp', 'mylex-mapd'),
('photuris', 468, 'udp', 'proturis'),
('rcp', 469, 'udp', 'Radio Control Protocol'),
('scx-proxy', 470, 'udp', 'scx-proxy'),
('mondex', 471, 'udp', 'Mondex'),
('ljk-login', 472, 'udp', 'ljk-login'),
('hybrid-pop', 473, 'udp', 'hybrid-pop'),
('tn-tl-w2', 474, 'udp', 'tn-tl-w2'),
('tcpnethaspsrv', 475, 'udp', 'tcpnethaspsrv'),
('tn-tl-fd1', 476, 'udp', 'tn-tl-fd1'),
('ss7ns', 477, 'udp', 'ss7ns'),
('spsc', 478, 'udp', 'spsc'),
('iafserver', 479, 'udp', 'iafserver'),
('iafdbase', 480, 'udp', 'iafdbase'),
('ph', 481, 'udp', 'Ph service'),
('bgs-nsi', 482, 'udp', 'bgs-nsi'),
('ulpnet', 483, 'udp', 'ulpnet'),
('integra-sme', 484, 'udp', 'Integra Software Management Environment'),
('powerburst', 485, 'udp', 'Air Soft Power Burst'),
('avian', 486, 'udp', 'avian'),
('saft', 487, 'udp', 'saft Simple Asynchronous File Transfer'),
('gss-http', 488, 'udp', 'gss-http'),
('nest-protocol', 489, 'udp', 'nest-protocol'),
('micom-pfs', 490, 'udp', 'micom-pfs'),
('go-login', 491, 'udp', 'go-login'),
('ticf-1', 492, 'udp', 'Transport Independent Convergence for FNA'),
('ticf-2', 493, 'udp', 'Transport Independent Convergence for FNA'),
('pov-ray', 494, 'udp', 'POV-Ray'),
('intecourier', 495, 'udp', 'intecourier'),
('pim-rp-disc', 496, 'udp', 'PIM-RP-DISC'),
('dantz', 497, 'udp', 'dantz'),
('siam', 498, 'udp', 'siam'),
('iso-ill', 499, 'udp', 'ISO ILL Protocol'),
('isakmp', 500, 'udp', 'isakmp'),
('stmf', 501, 'udp', 'STMF'),
('asa-appl-proto', 502, 'udp', 'asa-appl-proto'),
('intrinsa', 503, 'udp', 'Intrinsa'),
('citadel', 504, 'udp', 'citadel'),
('mailbox-lm', 505, 'udp', 'mailbox-lm'),
('ohimsrv', 506, 'udp', 'ohimsrv'),
('crs', 507, 'udp', 'crs'),
('xvttp', 508, 'udp', 'xvttp'),
('snare', 509, 'udp', 'snare'),
('fcp', 510, 'udp', 'FirstClass Protocol'),
('passgo', 511, 'udp', 'PassGo'),
('comsat', 512, 'udp', ''),
('biff', 512, 'udp', 'used by mail system to notify users'),
('who', 513, 'udp', 'maintains data bases showing whos'),
('syslog', 514, 'udp', ''),
('printer', 515, 'udp', 'spooler'),
('videotex', 516, 'udp', 'videotex'),
('talk', 517, 'udp', 'like tenex link, but across'),
('ntalk', 518, 'udp', ''),
('utime', 519, 'udp', 'unixtime'),
('router', 520, 'udp', 'local routing process (on site);'),
('ripng', 521, 'udp', 'ripng'),
('ulp', 522, 'udp', 'ULP'),
('ibm-db2', 523, 'udp', 'IBM-DB2'),
('ncp', 524, 'udp', 'NCP'),
('timed', 525, 'udp', 'timeserver'),
('tempo', 526, 'udp', 'newdate'),
('stx', 527, 'udp', 'Stock IXChange'),
('custix', 528, 'udp', 'Customer IXChange'),
('irc-serv', 529, 'udp', 'IRC-SERV'),
('courier', 530, 'udp', 'rpc'),
('conference', 531, 'udp', 'chat'),
('netnews', 532, 'udp', 'readnews'),
('netwall', 533, 'udp', 'for emergency broadcasts'),
('mm-admin', 534, 'udp', 'MegaMedia Admin'),
('iiop', 535, 'udp', 'iiop'),
('opalis-rdv', 536, 'udp', 'opalis-rdv'),
('nmsp', 537, 'udp', 'Networked Media Streaming Protocol'),
('gdomap', 538, 'udp', 'gdomap'),
('apertus-ldp', 539, 'udp', 'Apertus Technologies Load Determination'),
('uucp', 540, 'udp', 'uucpd'),
('uucp-rlogin', 541, 'udp', 'uucp-rlogin'),
('commerce', 542, 'udp', 'commerce'),
('klogin', 543, 'udp', ''),
('kshell', 544, 'udp', 'krcmd'),
('appleqtcsrvr', 545, 'udp', 'appleqtcsrvr'),
('dhcpv6-client', 546, 'udp', 'DHCPv6 Client'),
('dhcpv6-server', 547, 'udp', 'DHCPv6 Server'),
('afpovertcp', 548, 'udp', 'AFP over TCP'),
('idfp', 549, 'udp', 'IDFP'),
('new-rwho', 550, 'udp', 'new-who'),
('cybercash', 551, 'udp', 'cybercash'),
('deviceshare', 552, 'udp', 'deviceshare'),
('pirp', 553, 'udp', 'pirp'),
('rtsp', 554, 'udp', 'Real Time Stream Control Protocol'),
('dsf', 555, 'udp', ''),
('remotefs', 556, 'udp', 'rfs server'),
('openvms-sysipc', 557, 'udp', 'openvms-sysipc'),
('sdnskmp', 558, 'udp', 'SDNSKMP'),
('teedtap', 559, 'udp', 'TEEDTAP'),
('rmonitor', 560, 'udp', 'rmonitord'),
('monitor', 561, 'udp', ''),
('chshell', 562, 'udp', 'chcmd'),
('nntps', 563, 'udp', 'nntp protocol over TLS/SSL (was snntp)'),
('9pfs', 564, 'udp', 'plan 9 file service'),
('whoami', 565, 'udp', 'whoami'),
('streettalk', 566, 'udp', 'streettalk'),
('banyan-rpc', 567, 'udp', 'banyan-rpc'),
('ms-shuttle', 568, 'udp', 'microsoft shuttle'),
('ms-rome', 569, 'udp', 'microsoft rome'),
('meter', 570, 'udp', 'demon'),
('meter', 571, 'udp', 'udemon'),
('sonar', 572, 'udp', 'sonar'),
('banyan-vip', 573, 'udp', 'banyan-vip'),
('ftp-agent', 574, 'udp', 'FTP Software Agent System'),
('vemmi', 575, 'udp', 'VEMMI'),
('ipcd', 576, 'udp', 'ipcd'),
('vnas', 577, 'udp', 'vnas'),
('ipdd', 578, 'udp', 'ipdd'),
('decbsrv', 579, 'udp', 'decbsrv'),
('sntp-heartbeat', 580, 'udp', 'SNTP HEARTBEAT'),
('bdp', 581, 'udp', 'Bundle Discovery Protocol'),
('scc-security', 582, 'udp', 'SCC Security'),
('philips-vc', 583, 'udp', 'Philips Video-Conferencing'),
('keyserver', 584, 'udp', 'Key Server'),
('imap4-ssl', 585, 'udp', 'IMAP4+SSL (use 993 instead)'),
('password-chg', 586, 'udp', 'Password Change'),
('submission', 587, 'udp', 'Submission'),
('cal', 588, 'udp', 'CAL'),
('eyelink', 589, 'udp', 'EyeLink'),
('tns-cml', 590, 'udp', 'TNS CML'),
('http-alt', 591, 'udp', 'FileMaker, Inc. - HTTP Alternate (see Port 80)'),
('eudora-set', 592, 'udp', 'Eudora Set'),
('http-rpc-epmap', 593, 'udp', 'HTTP RPC Ep Map'),
('tpip', 594, 'udp', 'TPIP'),
('cab-protocol', 595, 'udp', 'CAB Protocol'),
('smsd', 596, 'udp', 'SMSD'),
('ptcnameservice', 597, 'udp', 'PTC Name Service'),
('sco-websrvrmg3', 598, 'udp', 'SCO Web Server Manager 3'),
('acp', 599, 'udp', 'Aeolon Core Protocol'),
('ipcserver', 600, 'udp', 'Sun IPC server'),
('syslog-conn', 601, 'udp', 'Reliable Syslog Service'),
('soap-beep', 605, 'udp', 'SOAP over BEEP'),
('urm', 606, 'udp', 'Cray Unified Resource Manager'),
('nqs', 607, 'udp', 'nqs'),
('sift-uft', 608, 'udp', 'Sender-Initiated/Unsolicited File Transfer'),
('npmp-trap', 609, 'udp', 'npmp-trap'),
('npmp-local', 610, 'udp', 'npmp-local'),
('npmp-gui', 611, 'udp', 'npmp-gui'),
('hmmp-ind', 612, 'udp', 'HMMP Indication'),
('hmmp-op', 613, 'udp', 'HMMP Operation'),
('sshell', 614, 'udp', 'SSLshell'),
('sco-inetmgr', 615, 'udp', 'Internet Configuration Manager'),
('sco-sysmgr', 616, 'udp', 'SCO System Administration Server'),
('sco-dtmgr', 617, 'udp', 'SCO Desktop Administration Server'),
('dei-icda', 618, 'udp', 'DEI-ICDA'),
('compaq-evm', 619, 'udp', 'Compaq EVM'),
('sco-websrvrmgr', 620, 'udp', 'SCO WebServer Manager'),
('escp-ip', 621, 'udp', 'ESCP'),
('collaborator', 622, 'udp', 'Collaborator'),
('asf-rmcp', 623, 'udp', 'ASF Remote Management and Control Protocol'),
('cryptoadmin', 624, 'udp', 'Crypto Admin'),
('dec_dlm', 625, 'udp', 'DEC DLM'),
('asia', 626, 'udp', 'ASIA'),
('passgo-tivoli', 627, 'udp', 'PassGo Tivoli'),
('qmqp', 628, 'udp', 'QMQP'),
('3com-amp3', 629, 'udp', '3Com AMP3'),
('rda', 630, 'udp', 'RDA'),
('ipp', 631, 'udp', 'IPP (Internet Printing Protocol)'),
('bmpp', 632, 'udp', 'bmpp'),
('servstat', 633, 'udp', 'Service Status update (Sterling Software)'),
('ginad', 634, 'udp', 'ginad'),
('rlzdbase', 635, 'udp', 'RLZ DBase'),
('ldaps', 636, 'udp', 'ldap protocol over TLS/SSL (was sldap)'),
('lanserver', 637, 'udp', 'lanserver'),
('mcns-sec', 638, 'udp', 'mcns-sec'),
('msdp', 639, 'udp', 'MSDP'),
('entrust-sps', 640, 'udp', 'entrust-sps'),
('repcmd', 641, 'udp', 'repcmd'),
('esro-emsdp', 642, 'udp', 'ESRO-EMSDP V1.3'),
('sanity', 643, 'udp', 'SANity'),
('dwr', 644, 'udp', 'dwr'),
('pssc', 645, 'udp', 'PSSC'),
('ldp', 646, 'udp', 'LDP'),
('dhcp-failover', 647, 'udp', 'DHCP Failover'),
('rrp', 648, 'udp', 'Registry Registrar Protocol (RRP)'),
('cadview-3d', 649, 'udp', 'Cadview-3d - streaming 3d models over the internet'),
('obex', 650, 'udp', 'OBEX'),
('ieee-mms', 651, 'udp', 'IEEE MMS'),
('hello-port', 652, 'udp', 'HELLO_PORT'),
('repscmd', 653, 'udp', 'RepCmd'),
('aodv', 654, 'udp', 'AODV'),
('tinc', 655, 'udp', 'TINC'),
('spmp', 656, 'udp', 'SPMP'),
('rmc', 657, 'udp', 'RMC'),
('tenfold', 658, 'udp', 'TenFold'),
('mac-srvr-admin', 660, 'udp', 'MacOS Server Admin'),
('hap', 661, 'udp', 'HAP'),
('pftp', 662, 'udp', 'PFTP'),
('purenoise', 663, 'udp', 'PureNoise'),
('asf-secure-rmcp', 664, 'udp', 'ASF Secure Remote Management and Control Protocol'),
('sun-dr', 665, 'udp', 'Sun DR'),
('mdqs', 666, 'udp', ''),
('doom', 666, 'udp', 'doom Id Software'),
('disclose', 667, 'udp', 'campaign contribution disclosures - SDR Technologies'),
('mecomm', 668, 'udp', 'MeComm'),
('meregister', 669, 'udp', 'MeRegister'),
('vacdsm-sws', 670, 'udp', 'VACDSM-SWS'),
('vacdsm-app', 671, 'udp', 'VACDSM-APP'),
('vpps-qua', 672, 'udp', 'VPPS-QUA'),
('cimplex', 673, 'udp', 'CIMPLEX'),
('acap', 674, 'udp', 'ACAP'),
('dctp', 675, 'udp', 'DCTP'),
('vpps-via', 676, 'udp', 'VPPS Via'),
('vpp', 677, 'udp', 'Virtual Presence Protocol'),
('ggf-ncp', 678, 'udp', 'GNU Generation Foundation NCP'),
('mrm', 679, 'udp', 'MRM'),
('entrust-aaas', 680, 'udp', 'entrust-aaas'),
('entrust-aams', 681, 'udp', 'entrust-aams'),
('xfr', 682, 'udp', 'XFR'),
('corba-iiop', 683, 'udp', 'CORBA IIOP'),
('corba-iiop-ssl', 684, 'udp', 'CORBA IIOP SSL'),
('mdc-portmapper', 685, 'udp', 'MDC Port Mapper'),
('hcp-wismar', 686, 'udp', 'Hardware Control Protocol Wismar'),
('asipregistry', 687, 'udp', 'asipregistry'),
('realm-rusd', 688, 'udp', 'REALM-RUSD'),
('nmap', 689, 'udp', 'NMAP'),
('vatp', 690, 'udp', 'VATP'),
('msexch-routing', 691, 'udp', 'MS Exchange Routing'),
('hyperwave-isp', 692, 'udp', 'Hyperwave-ISP'),
('connendp', 693, 'udp', 'connendp'),
('ha-cluster', 694, 'udp', 'ha-cluster'),
('ieee-mms-ssl', 695, 'udp', 'IEEE-MMS-SSL'),
('rushd', 696, 'udp', 'RUSHD'),
('uuidgen', 697, 'udp', 'UUIDGEN'),
('olsr', 698, 'udp', 'OLSR'),
('accessnetwork', 699, 'udp', 'Access Network'),
('elcsd', 704, 'udp', 'errlog copy/server daemon'),
('agentx', 705, 'udp', 'AgentX'),
('silc', 706, 'udp', 'SILC'),
('borland-dsj', 707, 'udp', 'Borland DSJ'),
('entrust-kmsh', 709, 'udp', 'Entrust Key Management Service Handler'),
('entrust-ash', 710, 'udp', 'Entrust Administration Service Handler'),
('cisco-tdp', 711, 'udp', 'Cisco TDP'),
('netviewdm1', 729, 'udp', 'IBM NetView DM/6000 Server/Client'),
('netviewdm2', 730, 'udp', 'IBM NetView DM/6000 send/tcp'),
('netviewdm3', 731, 'udp', 'IBM NetView DM/6000 receive/tcp'),
('netgw', 741, 'udp', 'netGW'),
('netrcs', 742, 'udp', 'Network based Rev. Cont. Sys.'),
('flexlm', 744, 'udp', 'Flexible License Manager'),
('fujitsu-dev', 747, 'udp', 'Fujitsu Device Control'),
('ris-cm', 748, 'udp', 'Russell Info Sci Calendar Manager'),
('kerberos-adm', 749, 'udp', 'kerberos administration'),
('loadav', 750, 'udp', ''),
('kerberos-iv', 750, 'udp', 'kerberos version iv'),
('pump', 751, 'udp', ''),
('qrh', 752, 'udp', ''),
('rrh', 753, 'udp', ''),
('tell', 754, 'udp', 'send'),
('nlogin', 758, 'udp', ''),
('con', 759, 'udp', ''),
('ns', 760, 'udp', ''),
('rxe', 761, 'udp', ''),
('quotad', 762, 'udp', ''),
('cycleserv', 763, 'udp', ''),
('omserv', 764, 'udp', ''),
('webster', 765, 'udp', ''),
('phonebook', 767, 'udp', 'phone'),
('vid', 769, 'udp', ''),
('cadlock', 770, 'udp', ''),
('rtip', 771, 'udp', ''),
('cycleserv2', 772, 'udp', ''),
('notify', 773, 'udp', ''),
('acmaint_dbd', 774, 'udp', ''),
('acmaint_transd', 775, 'udp', ''),
('wpages', 776, 'udp', ''),
('multiling-http', 777, 'udp', 'Multiling HTTP'),
('wpgs', 780, 'udp', ''),
('qsc', 787, 'udp', 'QSC'),
('mdbs_daemon', 800, 'udp', ''),
('device', 801, 'udp', ''),
('fcp-udp', 810, 'udp', 'FCP Datagram'),
('itm-mcell-s', 828, 'udp', 'itm-mcell-s'),
('pkix-3-ca-ra', 829, 'udp', 'PKIX-3 CA/RA'),
('dhcp-failover2', 847, 'udp', 'dhcp-failover 2'),
('rsync', 873, 'udp', 'rsync'),
('iclcnet-locate', 886, 'udp', 'ICL coNETion locate server'),
('iclcnet_svinfo', 887, 'udp', 'ICL coNETion server info'),
('accessbuilder', 888, 'udp', 'AccessBuilder'),
('omginitialrefs', 900, 'udp', 'OMG Initial Refs'),
('smpnameres', 901, 'udp', 'SMPNAMERES'),
('ideafarm-chat', 902, 'udp', 'IDEAFARM-CHAT'),
('ideafarm-catch', 903, 'udp', 'IDEAFARM-CATCH'),
('xact-backup', 911, 'udp', 'xact-backup'),
('apex-mesh', 912, 'udp', 'APEX relay-relay service'),
('apex-edge', 913, 'udp', 'APEX endpoint-relay service'),
('ftps-data', 989, 'udp', 'ftp protocol, data, over TLS/SSL'),
('ftps', 990, 'udp', 'ftp protocol, control, over TLS/SSL'),
('nas', 991, 'udp', 'Netnews Administration System'),
('telnets', 992, 'udp', 'telnet protocol over TLS/SSL'),
('imaps', 993, 'udp', 'imap4 protocol over TLS/SSL'),
('ircs', 994, 'udp', 'irc protocol over TLS/SSL'),
('pop3s', 995, 'udp', 'pop3 protocol over TLS/SSL (was spop3)'),
('vsinet', 996, 'udp', 'vsinet'),
('maitrd', 997, 'udp', ''),
('puparp', 998, 'udp', ''),
('applix', 999, 'udp', 'Applix ac'),
('puprouter', 999, 'udp', ''),
('cadlock2', 1000, 'udp', ''),
('surf', 1010, 'udp', 'surf'),
('', 1023, 'udp', 'Reserved'),
('', 1024, 'udp', 'Reserved'),
('blackjack', 1025, 'udp', 'network blackjack'),
('cap', 1026, 'udp', 'Calender Access Protocol'),
('iad1', 1030, 'udp', 'BBN IAD'),
('iad2', 1031, 'udp', 'BBN IAD'),
('iad3', 1032, 'udp', 'BBN IAD'),
('pcg-radar', 1036, 'udp', 'RADAR Service Protocol'),
('netarx', 1040, 'udp', 'Netarx'),
('fpitp', 1045, 'udp', 'Fingerprint Image Transfer Protocol'),
('neod1', 1047, 'udp', 'Suns NEO Object Request Broker'),
('neod2', 1048, 'udp', 'Suns NEO Object Request Broker'),
('td-postman', 1049, 'udp', 'Tobit David Postman VPMN'),
('cma', 1050, 'udp', 'CORBA Management Agent'),
('optima-vnet', 1051, 'udp', 'Optima VNET'),
('ddt', 1052, 'udp', 'Dynamic DNS Tools'),
('remote-as', 1053, 'udp', 'Remote Assistant (RA)'),
('brvread', 1054, 'udp', 'BRVREAD'),
('ansyslmd', 1055, 'udp', 'ANSYS - License Manager'),
('vfo', 1056, 'udp', 'VFO'),
('startron', 1057, 'udp', 'STARTRON'),
('nim', 1058, 'udp', 'nim'),
('nimreg', 1059, 'udp', 'nimreg'),
('polestar', 1060, 'udp', 'POLESTAR'),
('kiosk', 1061, 'udp', 'KIOSK'),
('veracity', 1062, 'udp', 'Veracity'),
('kyoceranetdev', 1063, 'udp', 'KyoceraNetDev'),
('jstel', 1064, 'udp', 'JSTEL'),
('syscomlan', 1065, 'udp', 'SYSCOMLAN'),
('fpo-fns', 1066, 'udp', 'FPO-FNS'),
('instl_boots', 1067, 'udp', 'Installation Bootstrap Proto. Serv.'),
('instl_bootc', 1068, 'udp', 'Installation Bootstrap Proto. Cli.'),
('cognex-insight', 1069, 'udp', 'COGNEX-INSIGHT'),
('gmrupdateserv', 1070, 'udp', 'GMRUpdateSERV'),
('bsquare-voip', 1071, 'udp', 'BSQUARE-VOIP'),
('cardax', 1072, 'udp', 'CARDAX'),
('bridgecontrol', 1073, 'udp', 'Bridge Control'),
('fastechnologlm', 1074, 'udp', 'FASTechnologies License Manager'),
('rdrmshc', 1075, 'udp', 'RDRMSHC'),
('dab-sti-c', 1076, 'udp', 'DAB STI-C'),
('imgames', 1077, 'udp', 'IMGames'),
('emanagecstp', 1078, 'udp', 'eManageCstp'),
('asprovatalk', 1079, 'udp', 'ASPROVATalk'),
('socks', 1080, 'udp', 'Socks'),
('pvuniwien', 1081, 'udp', 'PVUNIWIEN'),
('amt-esd-prot', 1082, 'udp', 'AMT-ESD-PROT'),
('ansoft-lm-1', 1083, 'udp', 'Anasoft License Manager'),
('ansoft-lm-2', 1084, 'udp', 'Anasoft License Manager'),
('webobjects', 1085, 'udp', 'Web Objects'),
('cplscrambler-lg', 1086, 'udp', 'CPL Scrambler Logging'),
('cplscrambler-in', 1087, 'udp', 'CPL Scrambler Internal'),
('cplscrambler-al', 1088, 'udp', 'CPL Scrambler Alarm Log'),
('ff-annunc', 1089, 'udp', 'FF Annunciation'),
('ff-fms', 1090, 'udp', 'FF Fieldbus Message Specification'),
('ff-sm', 1091, 'udp', 'FF System Management'),
('obrpd', 1092, 'udp', 'Open Business Reporting Protocol'),
('proofd', 1093, 'udp', 'PROOFD'),
('rootd', 1094, 'udp', 'ROOTD'),
('nicelink', 1095, 'udp', 'NICELink'),
('cnrprotocol', 1096, 'udp', 'Common Name Resolution Protocol'),
('sunclustermgr', 1097, 'udp', 'Sun Cluster Manager'),
('rmiactivation', 1098, 'udp', 'RMI Activation'),
('rmiregistry', 1099, 'udp', 'RMI Registry'),
('mctp', 1100, 'udp', 'MCTP'),
('pt2-discover', 1101, 'udp', 'PT2-DISCOVER'),
('adobeserver-1', 1102, 'udp', 'ADOBE SERVER 1'),
('adobeserver-2', 1103, 'udp', 'ADOBE SERVER 2'),
('xrl', 1104, 'udp', 'XRL'),
('ftranhc', 1105, 'udp', 'FTRANHC'),
('isoipsigport-1', 1106, 'udp', 'ISOIPSIGPORT-1'),
('isoipsigport-2', 1107, 'udp', 'ISOIPSIGPORT-2'),
('ratio-adp', 1108, 'udp', 'ratio-adp'),
('nfsd-keepalive', 1110, 'udp', 'Client status info'),
('lmsocialserver', 1111, 'udp', 'LM Social Server'),
('icp', 1112, 'udp', 'Intelligent Communication Protocol'),
('mini-sql', 1114, 'udp', 'Mini SQL'),
('ardus-trns', 1115, 'udp', 'ARDUS Transfer'),
('ardus-cntl', 1116, 'udp', 'ARDUS Control'),
('ardus-mtrns', 1117, 'udp', 'ARDUS Multicast Transfer'),
('availant-mgr', 1122, 'udp', 'availant-mgr'),
('murray', 1123, 'udp', 'Murray'),
('nfa', 1155, 'udp', 'Network File Access'),
('health-polling', 1161, 'udp', 'Health Polling'),
('health-trap', 1162, 'udp', 'Health Trap'),
('tripwire', 1169, 'udp', 'TRIPWIRE'),
('mc-client', 1180, 'udp', 'Millicent Client Proxy'),
('llsurfup-http', 1183, 'udp', 'LL Surfup HTTP'),
('llsurfup-https', 1184, 'udp', 'LL Surfup HTTPS'),
('catchpole', 1185, 'udp', 'Catchpole port'),
('hp-webadmin', 1188, 'udp', 'HP Web Admin'),
('dmidi', 1199, 'udp', 'DMIDI'),
('scol', 1200, 'udp', 'SCOL'),
('nucleus-sand', 1201, 'udp', 'Nucleus Sand'),
('caiccipc', 1202, 'udp', 'caiccipc'),
('ssslic-mgr', 1203, 'udp', 'License Validation'),
('ssslog-mgr', 1204, 'udp', 'Log Request Listener'),
('accord-mgc', 1205, 'udp', 'Accord-MGC'),
('anthony-data', 1206, 'udp', 'Anthony Data'),
('metasage', 1207, 'udp', 'MetaSage'),
('seagull-ais', 1208, 'udp', 'SEAGULL AIS'),
('ipcd3', 1209, 'udp', 'IPCD3'),
('eoss', 1210, 'udp', 'EOSS'),
('groove-dpp', 1211, 'udp', 'Groove DPP'),
('lupa', 1212, 'udp', 'lupa'),
('mpc-lifenet', 1213, 'udp', 'MPC LIFENET'),
('kazaa', 1214, 'udp', 'KAZAA'),
('scanstat-1', 1215, 'udp', 'scanSTAT 1.0'),
('etebac5', 1216, 'udp', 'ETEBAC 5'),
('hpss-ndapi', 1217, 'udp', 'HPSS-NDAPI'),
('aeroflight-ads', 1218, 'udp', 'AeroFlight-ADs'),
('aeroflight-ret', 1219, 'udp', 'AeroFlight-Ret'),
('qt-serveradmin', 1220, 'udp', 'QT SERVER ADMIN'),
('sweetware-apps', 1221, 'udp', 'SweetWARE Apps'),
('nerv', 1222, 'udp', 'SNI R&D network'),
('tgp', 1223, 'udp', 'TGP'),
('vpnz', 1224, 'udp', 'VPNz'),
('slinkysearch', 1225, 'udp', 'SLINKYSEARCH'),
('stgxfws', 1226, 'udp', 'STGXFWS'),
('dns2go', 1227, 'udp', 'DNS2Go'),
('florence', 1228, 'udp', 'FLORENCE'),
('novell-zfs', 1229, 'udp', 'Novell ZFS'),
('periscope', 1230, 'udp', 'Periscope'),
('menandmice-lpm', 1231, 'udp', 'menandmice-lpm'),
('univ-appserver', 1233, 'udp', 'Universal App Server'),
('search-agent', 1234, 'udp', 'Infoseek Search Agent'),
('mosaicsyssvc1', 1235, 'udp', 'mosaicsyssvc1'),
('bvcontrol', 1236, 'udp', 'bvcontrol'),
('tsdos390', 1237, 'udp', 'tsdos390'),
('hacl-qs', 1238, 'udp', 'hacl-qs'),
('nmsd', 1239, 'udp', 'NMSD'),
('instantia', 1240, 'udp', 'Instantia'),
('nessus', 1241, 'udp', 'nessus'),
('nmasoverip', 1242, 'udp', 'NMAS over IP'),
('serialgateway', 1243, 'udp', 'SerialGateway'),
('isbconference1', 1244, 'udp', 'isbconference1'),
('isbconference2', 1245, 'udp', 'isbconference2'),
('payrouter', 1246, 'udp', 'payrouter'),
('visionpyramid', 1247, 'udp', 'VisionPyramid'),
('hermes', 1248, 'udp', 'hermes'),
('mesavistaco', 1249, 'udp', 'Mesa Vista Co'),
('swldy-sias', 1250, 'udp', 'swldy-sias'),
('servergraph', 1251, 'udp', 'servergraph'),
('bspne-pcc', 1252, 'udp', 'bspne-pcc'),
('q55-pcc', 1253, 'udp', 'q55-pcc'),
('de-noc', 1254, 'udp', 'de-noc'),
('de-cache-query', 1255, 'udp', 'de-cache-query'),
('de-server', 1256, 'udp', 'de-server'),
('shockwave2', 1257, 'udp', 'Shockwave 2'),
('opennl', 1258, 'udp', 'Open Network Library'),
('opennl-voice', 1259, 'udp', 'Open Network Library Voice'),
('ibm-ssd', 1260, 'udp', 'ibm-ssd'),
('mpshrsv', 1261, 'udp', 'mpshrsv'),
('qnts-orb', 1262, 'udp', 'QNTS-ORB'),
('dka', 1263, 'udp', 'dka'),
('prat', 1264, 'udp', 'PRAT'),
('dssiapi', 1265, 'udp', 'DSSIAPI'),
('dellpwrappks', 1266, 'udp', 'DELLPWRAPPKS'),
('pcmlinux', 1267, 'udp', 'pcmlinux'),
('propel-msgsys', 1268, 'udp', 'PROPEL-MSGSYS'),
('watilapp', 1269, 'udp', 'WATiLaPP'),
('opsman', 1270, 'udp', 'opsman'),
('dabew', 1271, 'udp', 'Dabew'),
('cspmlockmgr', 1272, 'udp', 'CSPMLockMgr'),
('emc-gateway', 1273, 'udp', 'EMC-Gateway'),
('t1distproc', 1274, 'udp', 't1distproc'),
('ivcollector', 1275, 'udp', 'ivcollector'),
('ivmanager', 1276, 'udp', 'ivmanager'),
('miva-mqs', 1277, 'udp', 'mqs'),
('dellwebadmin-1', 1278, 'udp', 'Dell Web Admin 1'),
('dellwebadmin-2', 1279, 'udp', 'Dell Web Admin 2'),
('pictrography', 1280, 'udp', 'Pictrography'),
('healthd', 1281, 'udp', 'healthd'),
('emperion', 1282, 'udp', 'Emperion'),
('productinfo', 1283, 'udp', 'ProductInfo'),
('iee-qfx', 1284, 'udp', 'IEE-QFX'),
('neoiface', 1285, 'udp', 'neoiface'),
('netuitive', 1286, 'udp', 'netuitive'),
('navbuddy', 1288, 'udp', 'NavBuddy'),
('jwalkserver', 1289, 'udp', 'JWalkServer'),
('winjaserver', 1290, 'udp', 'WinJaServer'),
('seagulllms', 1291, 'udp', 'SEAGULLLMS'),
('dsdn', 1292, 'udp', 'dsdn'),
('pkt-krb-ipsec', 1293, 'udp', 'PKT-KRB-IPSec'),
('cmmdriver', 1294, 'udp', 'CMMdriver'),
('ehtp', 1295, 'udp', 'End-by-Hop Transmission Protocol'),
('dproxy', 1296, 'udp', 'dproxy'),
('sdproxy', 1297, 'udp', 'sdproxy'),
('lpcp', 1298, 'udp', 'lpcp'),
('hp-sci', 1299, 'udp', 'hp-sci'),
('h323hostcallsc', 1300, 'udp', 'H323 Host Call Secure'),
('ci3-software-1', 1301, 'udp', 'CI3-Software-1'),
('ci3-software-2', 1302, 'udp', 'CI3-Software-2'),
('sftsrv', 1303, 'udp', 'sftsrv'),
('boomerang', 1304, 'udp', 'Boomerang'),
('pe-mike', 1305, 'udp', 'pe-mike'),
('re-conn-proto', 1306, 'udp', 'RE-Conn-Proto'),
('pacmand', 1307, 'udp', 'Pacmand'),
('odsi', 1308, 'udp', 'Optical Domain Service Interconnect (ODSI)'),
('jtag-server', 1309, 'udp', 'JTAG server'),
('husky', 1310, 'udp', 'Husky'),
('rxmon', 1311, 'udp', 'RxMon'),
('sti-envision', 1312, 'udp', 'STI Envision'),
('bmc_patroldb', 1313, 'udp', 'BMC_PATROLDB'),
('pdps', 1314, 'udp', 'Photoscript Distributed Printing System'),
('els', 1315, 'udp', 'E.L.S., Event Listener Service'),
('exbit-escp', 1316, 'udp', 'Exbit-ESCP'),
('vrts-ipcserver', 1317, 'udp', 'vrts-ipcserver'),
('krb5gatekeeper', 1318, 'udp', 'krb5gatekeeper'),
('panja-icsp', 1319, 'udp', 'Panja-ICSP'),
('panja-axbnet', 1320, 'udp', 'Panja-AXBNET'),
('pip', 1321, 'udp', 'PIP'),
('novation', 1322, 'udp', 'Novation'),
('brcd', 1323, 'udp', 'brcd'),
('delta-mcp', 1324, 'udp', 'delta-mcp'),
('dx-instrument', 1325, 'udp', 'DX-Instrument'),
('wimsic', 1326, 'udp', 'WIMSIC'),
('ultrex', 1327, 'udp', 'Ultrex'),
('ewall', 1328, 'udp', 'EWALL'),
('netdb-export', 1329, 'udp', 'netdb-export'),
('streetperfect', 1330, 'udp', 'StreetPerfect'),
('intersan', 1331, 'udp', 'intersan'),
('pcia-rxp-b', 1332, 'udp', 'PCIA RXP-B'),
('passwrd-policy', 1333, 'udp', 'Password Policy'),
('writesrv', 1334, 'udp', 'writesrv'),
('digital-notary', 1335, 'udp', 'Digital Notary Protocol'),
('ischat', 1336, 'udp', 'Instant Service Chat'),
('menandmice-dns', 1337, 'udp', 'menandmice DNS'),
('wmc-log-svc', 1338, 'udp', 'WMC-log-svr'),
('kjtsiteserver', 1339, 'udp', 'kjtsiteserver'),
('naap', 1340, 'udp', 'NAAP'),
('qubes', 1341, 'udp', 'QuBES'),
('esbroker', 1342, 'udp', 'ESBroker'),
('re101', 1343, 'udp', 're101'),
('icap', 1344, 'udp', 'ICAP'),
('vpjp', 1345, 'udp', 'VPJP'),
('alta-ana-lm', 1346, 'udp', 'Alta Analytics License Manager'),
('bbn-mmc', 1347, 'udp', 'multi media conferencing'),
('bbn-mmx', 1348, 'udp', 'multi media conferencing'),
('sbook', 1349, 'udp', 'Registration Network Protocol'),
('editbench', 1350, 'udp', 'Registration Network Protocol'),
('equationbuilder', 1351, 'udp', 'Digital Tool Works (MIT)'),
('lotusnote', 1352, 'udp', 'Lotus Note'),
('relief', 1353, 'udp', 'Relief Consulting'),
('rightbrain', 1354, 'udp', 'RightBrain Software'),
('intuitive-edge', 1355, 'udp', 'Intuitive Edge'),
('cuillamartin', 1356, 'udp', 'CuillaMartin Company'),
('pegboard', 1357, 'udp', 'Electronic PegBoard'),
('connlcli', 1358, 'udp', 'CONNLCLI'),
('ftsrv', 1359, 'udp', 'FTSRV'),
('mimer', 1360, 'udp', 'MIMER'),
('linx', 1361, 'udp', 'LinX'),
('timeflies', 1362, 'udp', 'TimeFlies'),
('ndm-requester', 1363, 'udp', 'Network DataMover Requester'),
('ndm-server', 1364, 'udp', 'Network DataMover Server'),
('adapt-sna', 1365, 'udp', 'Network Software Associates'),
('netware-csp', 1366, 'udp', 'Novell NetWare Comm Service Platform'),
('dcs', 1367, 'udp', 'DCS'),
('screencast', 1368, 'udp', 'ScreenCast'),
('gv-us', 1369, 'udp', 'GlobalView to Unix Shell'),
('us-gv', 1370, 'udp', 'Unix Shell to GlobalView'),
('fc-cli', 1371, 'udp', 'Fujitsu Config Protocol'),
('fc-ser', 1372, 'udp', 'Fujitsu Config Protocol'),
('chromagrafx', 1373, 'udp', 'Chromagrafx'),
('molly', 1374, 'udp', 'EPI Software Systems'),
('bytex', 1375, 'udp', 'Bytex'),
('ibm-pps', 1376, 'udp', 'IBM Person to Person Software'),
('cichlid', 1377, 'udp', 'Cichlid License Manager'),
('elan', 1378, 'udp', 'Elan License Manager'),
('dbreporter', 1379, 'udp', 'Integrity Solutions'),
('telesis-licman', 1380, 'udp', 'Telesis Network License Manager'),
('apple-licman', 1381, 'udp', 'Apple Network License Manager'),
('udt_os', 1382, 'udp', 'udt_os'),
('gwha', 1383, 'udp', 'GW Hannaway Network License Manager'),
('os-licman', 1384, 'udp', 'Objective Solutions License Manager'),
('atex_elmd', 1385, 'udp', 'Atex Publishing License Manager'),
('checksum', 1386, 'udp', 'CheckSum License Manager'),
('cadsi-lm', 1387, 'udp', 'Computer Aided Design Software Inc LM'),
('objective-dbc', 1388, 'udp', 'Objective Solutions DataBase Cache'),
('iclpv-dm', 1389, 'udp', 'Document Manager'),
('iclpv-sc', 1390, 'udp', 'Storage Controller'),
('iclpv-sas', 1391, 'udp', 'Storage Access Server'),
('iclpv-pm', 1392, 'udp', 'Print Manager'),
('iclpv-nls', 1393, 'udp', 'Network Log Server'),
('iclpv-nlc', 1394, 'udp', 'Network Log Client'),
('iclpv-wsm', 1395, 'udp', 'PC Workstation Manager software'),
('dvl-activemail', 1396, 'udp', 'DVL Active Mail'),
('audio-activmail', 1397, 'udp', 'Audio Active Mail'),
('video-activmail', 1398, 'udp', 'Video Active Mail'),
('cadkey-licman', 1399, 'udp', 'Cadkey License Manager'),
('cadkey-tablet', 1400, 'udp', 'Cadkey Tablet Daemon'),
('goldleaf-licman', 1401, 'udp', 'Goldleaf License Manager'),
('prm-sm-np', 1402, 'udp', 'Prospero Resource Manager'),
('prm-nm-np', 1403, 'udp', 'Prospero Resource Manager'),
('igi-lm', 1404, 'udp', 'Infinite Graphics License Manager'),
('ibm-res', 1405, 'udp', 'IBM Remote Execution Starter'),
('netlabs-lm', 1406, 'udp', 'NetLabs License Manager'),
('dbsa-lm', 1407, 'udp', 'DBSA License Manager'),
('sophia-lm', 1408, 'udp', 'Sophia License Manager'),
('here-lm', 1409, 'udp', 'Here License Manager'),
('hiq', 1410, 'udp', 'HiQ License Manager'),
('af', 1411, 'udp', 'AudioFile'),
('innosys', 1412, 'udp', 'InnoSys'),
('innosys-acl', 1413, 'udp', 'Innosys-ACL'),
('ibm-mqseries', 1414, 'udp', 'IBM MQSeries'),
('dbstar', 1415, 'udp', 'DBStar'),
('novell-lu6.2', 1416, 'udp', 'Novell LU6.2'),
('timbuktu-srv1', 1417, 'udp', 'Timbuktu Service 1 Port'),
('timbuktu-srv2', 1418, 'udp', 'Timbuktu Service 2 Port'),
('timbuktu-srv3', 1419, 'udp', 'Timbuktu Service 3 Port'),
('timbuktu-srv4', 1420, 'udp', 'Timbuktu Service 4 Port'),
('gandalf-lm', 1421, 'udp', 'Gandalf License Manager'),
('autodesk-lm', 1422, 'udp', 'Autodesk License Manager'),
('essbase', 1423, 'udp', 'Essbase Arbor Software'),
('hybrid', 1424, 'udp', 'Hybrid Encryption Protocol'),
('zion-lm', 1425, 'udp', 'Zion Software License Manager'),
('sais', 1426, 'udp', 'Satellite-data Acquisition System 1'),
('mloadd', 1427, 'udp', 'mloadd monitoring tool'),
('informatik-lm', 1428, 'udp', 'Informatik License Manager'),
('nms', 1429, 'udp', 'Hypercom NMS'),
('tpdu', 1430, 'udp', 'Hypercom TPDU'),
('rgtp', 1431, 'udp', 'Reverse Gossip Transport'),
('blueberry-lm', 1432, 'udp', 'Blueberry Software License Manager'),
('ms-sql-s', 1433, 'udp', 'Microsoft-SQL-Server'),
('ms-sql-m', 1434, 'udp', 'Microsoft-SQL-Monitor'),
('ibm-cics', 1435, 'udp', 'IBM CICS'),
('saism', 1436, 'udp', 'Satellite-data Acquisition System 2'),
('tabula', 1437, 'udp', 'Tabula'),
('eicon-server', 1438, 'udp', 'Eicon Security Agent/Server'),
('eicon-x25', 1439, 'udp', 'Eicon X25/SNA Gateway'),
('eicon-slp', 1440, 'udp', 'Eicon Service Location Protocol'),
('cadis-1', 1441, 'udp', 'Cadis License Management'),
('cadis-2', 1442, 'udp', 'Cadis License Management'),
('ies-lm', 1443, 'udp', 'Integrated Engineering Software'),
('marcam-lm', 1444, 'udp', 'Marcam License Management'),
('proxima-lm', 1445, 'udp', 'Proxima License Manager'),
('ora-lm', 1446, 'udp', 'Optical Research Associates License Manager'),
('apri-lm', 1447, 'udp', 'Applied Parallel Research LM'),
('oc-lm', 1448, 'udp', 'OpenConnect License Manager'),
('peport', 1449, 'udp', 'PEport'),
('dwf', 1450, 'udp', 'Tandem Distributed Workbench Facility'),
('infoman', 1451, 'udp', 'IBM Information Management'),
('gtegsc-lm', 1452, 'udp', 'GTE Government Systems License Man'),
('genie-lm', 1453, 'udp', 'Genie License Manager'),
('interhdl_elmd', 1454, 'udp', 'interHDL License Manager'),
('esl-lm', 1455, 'udp', 'ESL License Manager'),
('dca', 1456, 'udp', 'DCA'),
('valisys-lm', 1457, 'udp', 'Valisys License Manager'),
('nrcabq-lm', 1458, 'udp', 'Nichols Research Corp.'),
('proshare1', 1459, 'udp', 'Proshare Notebook Application'),
('proshare2', 1460, 'udp', 'Proshare Notebook Application'),
('ibm_wrless_lan', 1461, 'udp', 'IBM Wireless LAN'),
('world-lm', 1462, 'udp', 'World License Manager'),
('nucleus', 1463, 'udp', 'Nucleus'),
('msl_lmd', 1464, 'udp', 'MSL License Manager'),
('pipes', 1465, 'udp', 'Pipes Platform mfarlin@peerlogic.com'),
('oceansoft-lm', 1466, 'udp', 'Ocean Software License Manager'),
('csdmbase', 1467, 'udp', 'CSDMBASE'),
('csdm', 1468, 'udp', 'CSDM'),
('aal-lm', 1469, 'udp', 'Active Analysis Limited License Manager'),
('uaiact', 1470, 'udp', 'Universal Analytics'),
('csdmbase', 1471, 'udp', 'csdmbase'),
('csdm', 1472, 'udp', 'csdm'),
('openmath', 1473, 'udp', 'OpenMath'),
('telefinder', 1474, 'udp', 'Telefinder'),
('taligent-lm', 1475, 'udp', 'Taligent License Manager'),
('clvm-cfg', 1476, 'udp', 'clvm-cfg'),
('ms-sna-server', 1477, 'udp', 'ms-sna-server'),
('ms-sna-base', 1478, 'udp', 'ms-sna-base'),
('dberegister', 1479, 'udp', 'dberegister'),
('pacerforum', 1480, 'udp', 'PacerForum'),
('airs', 1481, 'udp', 'AIRS'),
('miteksys-lm', 1482, 'udp', 'Miteksys License Manager'),
('afs', 1483, 'udp', 'AFS License Manager'),
('confluent', 1484, 'udp', 'Confluent License Manager'),
('lansource', 1485, 'udp', 'LANSource'),
('nms_topo_serv', 1486, 'udp', 'nms_topo_serv'),
('localinfosrvr', 1487, 'udp', 'LocalInfoSrvr'),
('docstor', 1488, 'udp', 'DocStor'),
('dmdocbroker', 1489, 'udp', 'dmdocbroker'),
('insitu-conf', 1490, 'udp', 'insitu-conf'),
('anynetgateway', 1491, 'udp', 'anynetgateway'),
('stone-design-1', 1492, 'udp', 'stone-design-1'),
('netmap_lm', 1493, 'udp', 'netmap_lm'),
('ica', 1494, 'udp', 'ica'),
('cvc', 1495, 'udp', 'cvc'),
('liberty-lm', 1496, 'udp', 'liberty-lm'),
('rfx-lm', 1497, 'udp', 'rfx-lm'),
('sybase-sqlany', 1498, 'udp', 'Sybase SQL Any'),
('fhc', 1499, 'udp', 'Federico Heinz Consultora'),
('vlsi-lm', 1500, 'udp', 'VLSI License Manager'),
('saiscm', 1501, 'udp', 'Satellite-data Acquisition System 3'),
('shivadiscovery', 1502, 'udp', 'Shiva'),
('imtc-mcs', 1503, 'udp', 'Databeam'),
('evb-elm', 1504, 'udp', 'EVB Software Engineering License Manager'),
('funkproxy', 1505, 'udp', 'Funk Software, Inc.'),
('utcd', 1506, 'udp', 'Universal Time daemon (utcd)'),
('symplex', 1507, 'udp', 'symplex'),
('diagmond', 1508, 'udp', 'diagmond'),
('robcad-lm', 1509, 'udp', 'Robcad, Ltd. License Manager'),
('mvx-lm', 1510, 'udp', 'Midland Valley Exploration Ltd. Lic. Man.'),
('3l-l1', 1511, 'udp', '3l-l1'),
('wins', 1512, 'udp', 'Microsofts Windows Internet Name Service'),
('fujitsu-dtc', 1513, 'udp', 'Fujitsu Systems Business of America, Inc'),
('fujitsu-dtcns', 1514, 'udp', 'Fujitsu Systems Business of America, Inc'),
('ifor-protocol', 1515, 'udp', 'ifor-protocol'),
('vpad', 1516, 'udp', 'Virtual Places Audio data'),
('vpac', 1517, 'udp', 'Virtual Places Audio control'),
('vpvd', 1518, 'udp', 'Virtual Places Video data'),
('vpvc', 1519, 'udp', 'Virtual Places Video control'),
('atm-zip-office', 1520, 'udp', 'atm zip office'),
('ncube-lm', 1521, 'udp', 'nCube License Manager'),
('ricardo-lm', 1522, 'udp', 'Ricardo North America License Manager'),
('cichild-lm', 1523, 'udp', 'cichild'),
('ingreslock', 1524, 'udp', 'ingres'),
('orasrv', 1525, 'udp', 'oracle'),
('prospero-np', 1525, 'udp', 'Prospero Directory Service non-priv'),
('pdap-np', 1526, 'udp', 'Prospero Data Access Prot non-priv'),
('tlisrv', 1527, 'udp', 'oracle'),
('mciautoreg', 1528, 'udp', 'micautoreg'),
('coauthor', 1529, 'udp', 'oracle'),
('rap-service', 1530, 'udp', 'rap-service'),
('rap-listen', 1531, 'udp', 'rap-listen'),
('miroconnect', 1532, 'udp', 'miroconnect'),
('virtual-places', 1533, 'udp', 'Virtual Places Software'),
('micromuse-lm', 1534, 'udp', 'micromuse-lm'),
('ampr-info', 1535, 'udp', 'ampr-info'),
('ampr-inter', 1536, 'udp', 'ampr-inter'),
('sdsc-lm', 1537, 'udp', 'isi-lm'),
('3ds-lm', 1538, 'udp', '3ds-lm'),
('intellistor-lm', 1539, 'udp', 'Intellistor License Manager'),
('rds', 1540, 'udp', 'rds'),
('rds2', 1541, 'udp', 'rds2'),
('gridgen-elmd', 1542, 'udp', 'gridgen-elmd'),
('simba-cs', 1543, 'udp', 'simba-cs'),
('aspeclmd', 1544, 'udp', 'aspeclmd'),
('vistium-share', 1545, 'udp', 'vistium-share'),
('abbaccuray', 1546, 'udp', 'abbaccuray'),
('laplink', 1547, 'udp', 'laplink'),
('axon-lm', 1548, 'udp', 'Axon License Manager'),
('shivasound', 1549, 'udp', 'Shiva Sound'),
('3m-image-lm', 1550, 'udp', 'Image Storage license manager 3M Company'),
('hecmtl-db', 1551, 'udp', 'HECMTL-DB'),
('pciarray', 1552, 'udp', 'pciarray'),
('sna-cs', 1553, 'udp', 'sna-cs'),
('caci-lm', 1554, 'udp', 'CACI Products Company License Manager'),
('livelan', 1555, 'udp', 'livelan'),
('ashwin', 1556, 'udp', 'AshWin CI Tecnologies'),
('arbortext-lm', 1557, 'udp', 'ArborText License Manager'),
('xingmpeg', 1558, 'udp', 'xingmpeg'),
('web2host', 1559, 'udp', 'web2host'),
('asci-val', 1560, 'udp', 'asci-val'),
('facilityview', 1561, 'udp', 'facilityview'),
('pconnectmgr', 1562, 'udp', 'pconnectmgr'),
('cadabra-lm', 1563, 'udp', 'Cadabra License Manager'),
('pay-per-view', 1564, 'udp', 'Pay-Per-View'),
('winddlb', 1565, 'udp', 'WinDD'),
('corelvideo', 1566, 'udp', 'CORELVIDEO'),
('jlicelmd', 1567, 'udp', 'jlicelmd'),
('tsspmap', 1568, 'udp', 'tsspmap'),
('ets', 1569, 'udp', 'ets'),
('orbixd', 1570, 'udp', 'orbixd'),
('rdb-dbs-disp', 1571, 'udp', 'Oracle Remote Data Base'),
('chip-lm', 1572, 'udp', 'Chipcom License Manager'),
('itscomm-ns', 1573, 'udp', 'itscomm-ns'),
('mvel-lm', 1574, 'udp', 'mvel-lm'),
('oraclenames', 1575, 'udp', 'oraclenames'),
('moldflow-lm', 1576, 'udp', 'moldflow-lm'),
('hypercube-lm', 1577, 'udp', 'hypercube-lm'),
('jacobus-lm', 1578, 'udp', 'Jacobus License Manager'),
('ioc-sea-lm', 1579, 'udp', 'ioc-sea-lm'),
('tn-tl-r2', 1580, 'udp', 'tn-tl-r2'),
('mil-2045-47001', 1581, 'udp', 'MIL-2045-47001'),
('msims', 1582, 'udp', 'MSIMS'),
('simbaexpress', 1583, 'udp', 'simbaexpress'),
('tn-tl-fd2', 1584, 'udp', 'tn-tl-fd2'),
('intv', 1585, 'udp', 'intv'),
('ibm-abtact', 1586, 'udp', 'ibm-abtact'),
('pra_elmd', 1587, 'udp', 'pra_elmd'),
('triquest-lm', 1588, 'udp', 'triquest-lm'),
('vqp', 1589, 'udp', 'VQP'),
('gemini-lm', 1590, 'udp', 'gemini-lm'),
('ncpm-pm', 1591, 'udp', 'ncpm-pm'),
('commonspace', 1592, 'udp', 'commonspace'),
('mainsoft-lm', 1593, 'udp', 'mainsoft-lm'),
('sixtrak', 1594, 'udp', 'sixtrak'),
('radio', 1595, 'udp', 'radio'),
('radio-bc', 1596, 'udp', 'radio-bc'),
('orbplus-iiop', 1597, 'udp', 'orbplus-iiop'),
('picknfs', 1598, 'udp', 'picknfs'),
('simbaservices', 1599, 'udp', 'simbaservices'),
('issd', 1600, 'udp', ''),
('aas', 1601, 'udp', 'aas'),
('inspect', 1602, 'udp', 'inspect'),
('picodbc', 1603, 'udp', 'pickodbc'),
('icabrowser', 1604, 'udp', 'icabrowser'),
('slp', 1605, 'udp', 'Salutation Manager (Salutation Protocol)'),
('slm-api', 1606, 'udp', 'Salutation Manager (SLM-API)'),
('stt', 1607, 'udp', 'stt'),
('smart-lm', 1608, 'udp', 'Smart Corp. License Manager'),
('isysg-lm', 1609, 'udp', 'isysg-lm'),
('taurus-wh', 1610, 'udp', 'taurus-wh'),
('ill', 1611, 'udp', 'Inter Library Loan'),
('netbill-trans', 1612, 'udp', 'NetBill Transaction Server'),
('netbill-keyrep', 1613, 'udp', 'NetBill Key Repository'),
('netbill-cred', 1614, 'udp', 'NetBill Credential Server'),
('netbill-auth', 1615, 'udp', 'NetBill Authorization Server'),
('netbill-prod', 1616, 'udp', 'NetBill Product Server'),
('nimrod-agent', 1617, 'udp', 'Nimrod Inter-Agent Communication'),
('skytelnet', 1618, 'udp', 'skytelnet'),
('xs-openstorage', 1619, 'udp', 'xs-openstorage'),
('faxportwinport', 1620, 'udp', 'faxportwinport'),
('softdataphone', 1621, 'udp', 'softdataphone'),
('ontime', 1622, 'udp', 'ontime'),
('jaleosnd', 1623, 'udp', 'jaleosnd'),
('udp-sr-port', 1624, 'udp', 'udp-sr-port'),
('svs-omagent', 1625, 'udp', 'svs-omagent'),
('shockwave', 1626, 'udp', 'Shockwave'),
('t128-gateway', 1627, 'udp', 'T.128 Gateway'),
('lontalk-norm', 1628, 'udp', 'LonTalk normal'),
('lontalk-urgnt', 1629, 'udp', 'LonTalk urgent'),
('oraclenet8cman', 1630, 'udp', 'Oracle Net8 Cman'),
('visitview', 1631, 'udp', 'Visit view'),
('pammratc', 1632, 'udp', 'PAMMRATC'),
('pammrpc', 1633, 'udp', 'PAMMRPC'),
('loaprobe', 1634, 'udp', 'Log On America Probe'),
('edb-server1', 1635, 'udp', 'EDB Server 1'),
('cncp', 1636, 'udp', 'CableNet Control Protocol'),
('cnap', 1637, 'udp', 'CableNet Admin Protocol'),
('cnip', 1638, 'udp', 'CableNet Info Protocol'),
('cert-initiator', 1639, 'udp', 'cert-initiator'),
('cert-responder', 1640, 'udp', 'cert-responder'),
('invision', 1641, 'udp', 'InVision'),
('isis-am', 1642, 'udp', 'isis-am'),
('isis-ambc', 1643, 'udp', 'isis-ambc'),
('sightline', 1645, 'udp', 'SightLine'),
('sa-msg-port', 1646, 'udp', 'sa-msg-port'),
('rsap', 1647, 'udp', 'rsap'),
('concurrent-lm', 1648, 'udp', 'concurrent-lm'),
('kermit', 1649, 'udp', 'kermit'),
('nkd', 1650, 'udp', 'nkd'),
('shiva_confsrvr', 1651, 'udp', 'shiva_confsrvr'),
('xnmp', 1652, 'udp', 'xnmp'),
('alphatech-lm', 1653, 'udp', 'alphatech-lm'),
('stargatealerts', 1654, 'udp', 'stargatealerts'),
('dec-mbadmin', 1655, 'udp', 'dec-mbadmin'),
('dec-mbadmin-h', 1656, 'udp', 'dec-mbadmin-h'),
('fujitsu-mmpdc', 1657, 'udp', 'fujitsu-mmpdc'),
('sixnetudr', 1658, 'udp', 'sixnetudr'),
('sg-lm', 1659, 'udp', 'Silicon Grail License Manager'),
('skip-mc-gikreq', 1660, 'udp', 'skip-mc-gikreq'),
('netview-aix-1', 1661, 'udp', 'netview-aix-1'),
('netview-aix-2', 1662, 'udp', 'netview-aix-2'),
('netview-aix-3', 1663, 'udp', 'netview-aix-3'),
('netview-aix-4', 1664, 'udp', 'netview-aix-4'),
('netview-aix-5', 1665, 'udp', 'netview-aix-5'),
('netview-aix-6', 1666, 'udp', 'netview-aix-6'),
('netview-aix-7', 1667, 'udp', 'netview-aix-7'),
('netview-aix-8', 1668, 'udp', 'netview-aix-8'),
('netview-aix-9', 1669, 'udp', 'netview-aix-9'),
('netview-aix-10', 1670, 'udp', 'netview-aix-10'),
('netview-aix-11', 1671, 'udp', 'netview-aix-11'),
('netview-aix-12', 1672, 'udp', 'netview-aix-12'),
('proshare-mc-1', 1673, 'udp', 'Intel Proshare Multicast'),
('proshare-mc-2', 1674, 'udp', 'Intel Proshare Multicast'),
('pdp', 1675, 'udp', 'Pacific Data Products'),
('netcomm2', 1676, 'udp', 'netcomm2'),
('groupwise', 1677, 'udp', 'groupwise'),
('prolink', 1678, 'udp', 'prolink'),
('darcorp-lm', 1679, 'udp', 'darcorp-lm'),
('microcom-sbp', 1680, 'udp', 'microcom-sbp'),
('sd-elmd', 1681, 'udp', 'sd-elmd'),
('lanyon-lantern', 1682, 'udp', 'lanyon-lantern'),
('ncpm-hip', 1683, 'udp', 'ncpm-hip'),
('snaresecure', 1684, 'udp', 'SnareSecure'),
('n2nremote', 1685, 'udp', 'n2nremote'),
('cvmon', 1686, 'udp', 'cvmon'),
('nsjtp-ctrl', 1687, 'udp', 'nsjtp-ctrl'),
('nsjtp-data', 1688, 'udp', 'nsjtp-data'),
('firefox', 1689, 'udp', 'firefox'),
('ng-umds', 1690, 'udp', 'ng-umds'),
('empire-empuma', 1691, 'udp', 'empire-empuma'),
('sstsys-lm', 1692, 'udp', 'sstsys-lm'),
('rrirtr', 1693, 'udp', 'rrirtr'),
('rrimwm', 1694, 'udp', 'rrimwm'),
('rrilwm', 1695, 'udp', 'rrilwm'),
('rrifmm', 1696, 'udp', 'rrifmm'),
('rrisat', 1697, 'udp', 'rrisat'),
('rsvp-encap-1', 1698, 'udp', 'RSVP-ENCAPSULATION-1'),
('rsvp-encap-2', 1699, 'udp', 'RSVP-ENCAPSULATION-2'),
('mps-raft', 1700, 'udp', 'mps-raft'),
('l2f', 1701, 'udp', 'l2f'),
('l2tp', 1701, 'udp', 'l2tp'),
('deskshare', 1702, 'udp', 'deskshare'),
('hb-engine', 1703, 'udp', 'hb-engine'),
('bcs-broker', 1704, 'udp', 'bcs-broker'),
('slingshot', 1705, 'udp', 'slingshot'),
('jetform', 1706, 'udp', 'jetform'),
('vdmplay', 1707, 'udp', 'vdmplay'),
('gat-lmd', 1708, 'udp', 'gat-lmd'),
('centra', 1709, 'udp', 'centra'),
('impera', 1710, 'udp', 'impera'),
('pptconference', 1711, 'udp', 'pptconference'),
('registrar', 1712, 'udp', 'resource monitoring service'),
('conferencetalk', 1713, 'udp', 'ConferenceTalk'),
('sesi-lm', 1714, 'udp', 'sesi-lm'),
('houdini-lm', 1715, 'udp', 'houdini-lm'),
('xmsg', 1716, 'udp', 'xmsg'),
('fj-hdnet', 1717, 'udp', 'fj-hdnet'),
('h323gatedisc', 1718, 'udp', 'h323gatedisc'),
('h323gatestat', 1719, 'udp', 'h323gatestat'),
('h323hostcall', 1720, 'udp', 'h323hostcall'),
('caicci', 1721, 'udp', 'caicci'),
('hks-lm', 1722, 'udp', 'HKS License Manager'),
('pptp', 1723, 'udp', 'pptp'),
('csbphonemaster', 1724, 'udp', 'csbphonemaster'),
('iden-ralp', 1725, 'udp', 'iden-ralp'),
('iberiagames', 1726, 'udp', 'IBERIAGAMES'),
('winddx', 1727, 'udp', 'winddx'),
('telindus', 1728, 'udp', 'TELINDUS'),
('citynl', 1729, 'udp', 'CityNL License Management'),
('roketz', 1730, 'udp', 'roketz'),
('msiccp', 1731, 'udp', 'MSICCP'),
('proxim', 1732, 'udp', 'proxim'),
('siipat', 1733, 'udp', 'SIMS - SIIPAT Protocol for Alarm Transmission'),
('cambertx-lm', 1734, 'udp', 'Camber Corporation License Management'),
('privatechat', 1735, 'udp', 'PrivateChat'),
('street-stream', 1736, 'udp', 'street-stream'),
('ultimad', 1737, 'udp', 'ultimad'),
('gamegen1', 1738, 'udp', 'GameGen1'),
('webaccess', 1739, 'udp', 'webaccess'),
('encore', 1740, 'udp', 'encore'),
('cisco-net-mgmt', 1741, 'udp', 'cisco-net-mgmt'),
('3Com-nsd', 1742, 'udp', '3Com-nsd'),
('cinegrfx-lm', 1743, 'udp', 'Cinema Graphics License Manager'),
('ncpm-ft', 1744, 'udp', 'ncpm-ft'),
('remote-winsock', 1745, 'udp', 'remote-winsock'),
('ftrapid-1', 1746, 'udp', 'ftrapid-1'),
('ftrapid-2', 1747, 'udp', 'ftrapid-2'),
('oracle-em1', 1748, 'udp', 'oracle-em1'),
('aspen-services', 1749, 'udp', 'aspen-services'),
('sslp', 1750, 'udp', 'Simple Socket Librarys PortMaster'),
('swiftnet', 1751, 'udp', 'SwiftNet'),
('lofr-lm', 1752, 'udp', 'Leap of Faith Research License Manager'),
('translogic-lm', 1753, 'udp', 'Translogic License Manager'),
('oracle-em2', 1754, 'udp', 'oracle-em2'),
('ms-streaming', 1755, 'udp', 'ms-streaming'),
('capfast-lmd', 1756, 'udp', 'capfast-lmd'),
('cnhrp', 1757, 'udp', 'cnhrp'),
('tftp-mcast', 1758, 'udp', 'tftp-mcast'),
('spss-lm', 1759, 'udp', 'SPSS License Manager'),
('www-ldap-gw', 1760, 'udp', 'www-ldap-gw'),
('cft-0', 1761, 'udp', 'cft-0'),
('cft-1', 1762, 'udp', 'cft-1'),
('cft-2', 1763, 'udp', 'cft-2'),
('cft-3', 1764, 'udp', 'cft-3'),
('cft-4', 1765, 'udp', 'cft-4'),
('cft-5', 1766, 'udp', 'cft-5'),
('cft-6', 1767, 'udp', 'cft-6'),
('cft-7', 1768, 'udp', 'cft-7'),
('bmc-net-adm', 1769, 'udp', 'bmc-net-adm'),
('bmc-net-svc', 1770, 'udp', 'bmc-net-svc'),
('vaultbase', 1771, 'udp', 'vaultbase'),
('essweb-gw', 1772, 'udp', 'EssWeb Gateway'),
('kmscontrol', 1773, 'udp', 'KMSControl'),
('global-dtserv', 1774, 'udp', 'global-dtserv'),
('femis', 1776, 'udp', 'Federal Emergency Management Information System'),
('powerguardian', 1777, 'udp', 'powerguardian'),
('prodigy-intrnet', 1778, 'udp', 'prodigy-internet'),
('pharmasoft', 1779, 'udp', 'pharmasoft'),
('dpkeyserv', 1780, 'udp', 'dpkeyserv'),
('answersoft-lm', 1781, 'udp', 'answersoft-lm'),
('hp-hcip', 1782, 'udp', 'hp-hcip'),
('finle-lm', 1784, 'udp', 'Finle License Manager'),
('windlm', 1785, 'udp', 'Wind River Systems License Manager'),
('funk-logger', 1786, 'udp', 'funk-logger'),
('funk-license', 1787, 'udp', 'funk-license'),
('psmond', 1788, 'udp', 'psmond'),
('hello', 1789, 'udp', 'hello'),
('nmsp', 1790, 'udp', 'Narrative Media Streaming Protocol'),
('ea1', 1791, 'udp', 'EA1'),
('ibm-dt-2', 1792, 'udp', 'ibm-dt-2'),
('rsc-robot', 1793, 'udp', 'rsc-robot'),
('cera-bcm', 1794, 'udp', 'cera-bcm'),
('dpi-proxy', 1795, 'udp', 'dpi-proxy'),
('vocaltec-admin', 1796, 'udp', 'Vocaltec Server Administration'),
('uma', 1797, 'udp', 'UMA'),
('etp', 1798, 'udp', 'Event Transfer Protocol'),
('netrisk', 1799, 'udp', 'NETRISK'),
('ansys-lm', 1800, 'udp', 'ANSYS-License manager'),
('msmq', 1801, 'udp', 'Microsoft Message Que'),
('concomp1', 1802, 'udp', 'ConComp1'),
('hp-hcip-gwy', 1803, 'udp', 'HP-HCIP-GWY'),
('enl', 1804, 'udp', 'ENL'),
('enl-name', 1805, 'udp', 'ENL-Name'),
('musiconline', 1806, 'udp', 'Musiconline'),
('fhsp', 1807, 'udp', 'Fujitsu Hot Standby Protocol'),
('oracle-vp2', 1808, 'udp', 'Oracle-VP2'),
('oracle-vp1', 1809, 'udp', 'Oracle-VP1'),
('jerand-lm', 1810, 'udp', 'Jerand License Manager'),
('scientia-sdb', 1811, 'udp', 'Scientia-SDB'),
('radius', 1812, 'udp', 'RADIUS'),
('radius-acct', 1813, 'udp', 'RADIUS Accounting'),
('tdp-suite', 1814, 'udp', 'TDP Suite'),
('mmpft', 1815, 'udp', 'MMPFT'),
('harp', 1816, 'udp', 'HARP'),
('rkb-oscs', 1817, 'udp', 'RKB-OSCS'),
('etftp', 1818, 'udp', 'Enhanced Trivial File Transfer Protocol'),
('plato-lm', 1819, 'udp', 'Plato License Manager'),
('mcagent', 1820, 'udp', 'mcagent'),
('donnyworld', 1821, 'udp', 'donnyworld'),
('es-elmd', 1822, 'udp', 'es-elmd'),
('unisys-lm', 1823, 'udp', 'Unisys Natural Language License Manager'),
('metrics-pas', 1824, 'udp', 'metrics-pas'),
('direcpc-video', 1825, 'udp', 'DirecPC Video'),
('ardt', 1826, 'udp', 'ARDT'),
('asi', 1827, 'udp', 'ASI'),
('itm-mcell-u', 1828, 'udp', 'itm-mcell-u'),
('optika-emedia', 1829, 'udp', 'Optika eMedia'),
('net8-cman', 1830, 'udp', 'Oracle Net8 CMan Admin'),
('myrtle', 1831, 'udp', 'Myrtle'),
('tht-treasure', 1832, 'udp', 'ThoughtTreasure'),
('udpradio', 1833, 'udp', 'udpradio'),
('ardusuni', 1834, 'udp', 'ARDUS Unicast'),
('ardusmul', 1835, 'udp', 'ARDUS Multicast'),
('ste-smsc', 1836, 'udp', 'ste-smsc'),
('csoft1', 1837, 'udp', 'csoft1'),
('talnet', 1838, 'udp', 'TALNET'),
('netopia-vo1', 1839, 'udp', 'netopia-vo1'),
('netopia-vo2', 1840, 'udp', 'netopia-vo2'),
('netopia-vo3', 1841, 'udp', 'netopia-vo3'),
('netopia-vo4', 1842, 'udp', 'netopia-vo4'),
('netopia-vo5', 1843, 'udp', 'netopia-vo5'),
('direcpc-dll', 1844, 'udp', 'DirecPC-DLL'),
('altalink', 1845, 'udp', 'altalink'),
('tunstall-pnc', 1846, 'udp', 'Tunstall PNC'),
('slp-notify', 1847, 'udp', 'SLP Notification'),
('fjdocdist', 1848, 'udp', 'fjdocdist'),
('alpha-sms', 1849, 'udp', 'ALPHA-SMS'),
('gsi', 1850, 'udp', 'GSI'),
('ctcd', 1851, 'udp', 'ctcd'),
('virtual-time', 1852, 'udp', 'Virtual Time'),
('vids-avtp', 1853, 'udp', 'VIDS-AVTP'),
('buddy-draw', 1854, 'udp', 'Buddy Draw'),
('fiorano-rtrsvc', 1855, 'udp', 'Fiorano RtrSvc'),
('fiorano-msgsvc', 1856, 'udp', 'Fiorano MsgSvc'),
('datacaptor', 1857, 'udp', 'DataCaptor'),
('privateark', 1858, 'udp', 'PrivateArk'),
('gammafetchsvr', 1859, 'udp', 'Gamma Fetcher Server'),
('sunscalar-svc', 1860, 'udp', 'SunSCALAR Services'),
('lecroy-vicp', 1861, 'udp', 'LeCroy VICP'),
('techra-server', 1862, 'udp', 'techra-server'),
('msnp', 1863, 'udp', 'MSNP'),
('paradym-31port', 1864, 'udp', 'Paradym 31 Port'),
('entp', 1865, 'udp', 'ENTP'),
('swrmi', 1866, 'udp', 'swrmi'),
('udrive', 1867, 'udp', 'UDRIVE'),
('viziblebrowser', 1868, 'udp', 'VizibleBrowser'),
('yestrader', 1869, 'udp', 'YesTrader'),
('sunscalar-dns', 1870, 'udp', 'SunSCALAR DNS Service'),
('canocentral0', 1871, 'udp', 'Cano Central 0'),
('canocentral1', 1872, 'udp', 'Cano Central 1'),
('fjmpjps', 1873, 'udp', 'Fjmpjps'),
('fjswapsnp', 1874, 'udp', 'Fjswapsnp'),
('westell-stats', 1875, 'udp', 'westell stats'),
('ewcappsrv', 1876, 'udp', 'ewcappsrv'),
('hp-webqosdb', 1877, 'udp', 'hp-webqosdb'),
('drmsmc', 1878, 'udp', 'drmsmc'),
('nettgain-nms', 1879, 'udp', 'NettGain NMS'),
('vsat-control', 1880, 'udp', 'Gilat VSAT Control'),
('ibm-mqseries2', 1881, 'udp', 'IBM MQSeries'),
('ecsqdmn', 1882, 'udp', 'ecsqdmn'),
('ibm-mqisdp', 1883, 'udp', 'IBM MQSeries SCADA'),
('idmaps', 1884, 'udp', 'Internet Distance Map Svc'),
('vrtstrapserver', 1885, 'udp', 'Veritas Trap Server'),
('leoip', 1886, 'udp', 'Leonardo over IP'),
('filex-lport', 1887, 'udp', 'FileX Listening Port'),
('ncconfig', 1888, 'udp', 'NC Config Port'),
('unify-adapter', 1889, 'udp', 'Unify Web Adapter Service'),
('wilkenlistener', 1890, 'udp', 'wilkenListener'),
('childkey-notif', 1891, 'udp', 'ChildKey Notification'),
('childkey-ctrl', 1892, 'udp', 'ChildKey Control'),
('elad', 1893, 'udp', 'ELAD Protocol'),
('o2server-port', 1894, 'udp', 'O2Server Port'),
('b-novative-ls', 1896, 'udp', 'b-novative license server'),
('metaagent', 1897, 'udp', 'MetaAgent'),
('cymtec-port', 1898, 'udp', 'Cymtec secure management'),
('mc2studios', 1899, 'udp', 'MC2Studios'),
('ssdp', 1900, 'udp', 'SSDP'),
('fjicl-tep-a', 1901, 'udp', 'Fujitsu ICL Terminal Emulator Program A'),
('fjicl-tep-b', 1902, 'udp', 'Fujitsu ICL Terminal Emulator Program B'),
('linkname', 1903, 'udp', 'Local Link Name Resolution'),
('fjicl-tep-c', 1904, 'udp', 'Fujitsu ICL Terminal Emulator Program C'),
('sugp', 1905, 'udp', 'Secure UP.Link Gateway Protocol'),
('tpmd', 1906, 'udp', 'TPortMapperReq'),
('intrastar', 1907, 'udp', 'IntraSTAR'),
('dawn', 1908, 'udp', 'Dawn'),
('global-wlink', 1909, 'udp', 'Global World Link'),
('ultrabac', 1910, 'udp', 'UltraBac Software communications port'),
('mtp', 1911, 'udp', 'Starlight Networks Multimedia Transport Protocol'),
('rhp-iibp', 1912, 'udp', 'rhp-iibp'),
('armadp', 1913, 'udp', 'armadp'),
('elm-momentum', 1914, 'udp', 'Elm-Momentum'),
('facelink', 1915, 'udp', 'FACELINK'),
('persona', 1916, 'udp', 'Persoft Persona'),
('noagent', 1917, 'udp', 'nOAgent'),
('can-nds', 1918, 'udp', 'Candle Directory Service - NDS'),
('can-dch', 1919, 'udp', 'Candle Directory Service - DCH'),
('can-ferret', 1920, 'udp', 'Candle Directory Service - FERRET'),
('noadmin', 1921, 'udp', 'NoAdmin'),
('tapestry', 1922, 'udp', 'Tapestry'),
('spice', 1923, 'udp', 'SPICE'),
('xiip', 1924, 'udp', 'XIIP'),
('discovery-port', 1925, 'udp', 'Surrogate Discovery Port'),
('egs', 1926, 'udp', 'Evolution Game Server'),
('videte-cipc', 1927, 'udp', 'Videte CIPC Port'),
('emsd-port', 1928, 'udp', 'Expnd Maui Srvr Dscovr'),
('bandwiz-system', 1929, 'udp', 'Bandwiz System - Server'),
('driveappserver', 1930, 'udp', 'Drive AppServer'),
('amdsched', 1931, 'udp', 'AMD SCHED'),
('ctt-broker', 1932, 'udp', 'CTT Broker'),
('xmapi', 1933, 'udp', 'IBM LM MT Agent'),
('xaapi', 1934, 'udp', 'IBM LM Appl Agent'),
('tincan', 1935, 'udp', 'TinCan'),
('jetcmeserver', 1936, 'udp', 'JetCmeServer Server Port'),
('jwserver', 1937, 'udp', 'JetVWay Server Port'),
('jwclient', 1938, 'udp', 'JetVWay Client Port'),
('jvserver', 1939, 'udp', 'JetVision Server Port'),
('jvclient', 1940, 'udp', 'JetVision Client Port'),
('dic-aida', 1941, 'udp', 'DIC-Aida'),
('res', 1942, 'udp', 'Real Enterprise Service'),
('beeyond-media', 1943, 'udp', 'Beeyond Media'),
('close-combat', 1944, 'udp', 'close-combat'),
('dialogic-elmd', 1945, 'udp', 'dialogic-elmd'),
('tekpls', 1946, 'udp', 'tekpls'),
('hlserver', 1947, 'udp', 'hlserver'),
('eye2eye', 1948, 'udp', 'eye2eye'),
('ismaeasdaqlive', 1949, 'udp', 'ISMA Easdaq Live'),
('ismaeasdaqtest', 1950, 'udp', 'ISMA Easdaq Test'),
('bcs-lmserver', 1951, 'udp', 'bcs-lmserver'),
('mpnjsc', 1952, 'udp', 'mpnjsc'),
('rapidbase', 1953, 'udp', 'Rapid Base'),
('abr-basic', 1954, 'udp', 'ABR-Basic Data'),
('abr-secure', 1955, 'udp', 'ABR-Secure Data'),
('vrtl-vmf-ds', 1956, 'udp', 'Vertel VMF DS'),
('unix-status', 1957, 'udp', 'unix-status'),
('dxadmind', 1958, 'udp', 'CA Administration Daemon'),
('simp-all', 1959, 'udp', 'SIMP Channel'),
('nasmanager', 1960, 'udp', 'Merit DAC NASmanager'),
('bts-appserver', 1961, 'udp', 'BTS APPSERVER'),
('biap-mp', 1962, 'udp', 'BIAP-MP'),
('webmachine', 1963, 'udp', 'WebMachine'),
('solid-e-engine', 1964, 'udp', 'SOLID E ENGINE'),
('tivoli-npm', 1965, 'udp', 'Tivoli NPM'),
('slush', 1966, 'udp', 'Slush'),
('sns-quote', 1967, 'udp', 'SNS Quote'),
('lipsinc', 1968, 'udp', 'LIPSinc'),
('lipsinc1', 1969, 'udp', 'LIPSinc 1'),
('netop-rc', 1970, 'udp', 'NetOp Remote Control'),
('netop-school', 1971, 'udp', 'NetOp School'),
('intersys-cache', 1972, 'udp', 'Cache'),
('dlsrap', 1973, 'udp', 'Data Link Switching Remote Access Protocol'),
('drp', 1974, 'udp', 'DRP'),
('tcoflashagent', 1975, 'udp', 'TCO Flash Agent'),
('tcoregagent', 1976, 'udp', 'TCO Reg Agent'),
('tcoaddressbook', 1977, 'udp', 'TCO Address Book'),
('unisql', 1978, 'udp', 'UniSQL'),
('unisql-java', 1979, 'udp', 'UniSQL Java'),
('pearldoc-xact', 1980, 'udp', 'PearlDoc XACT'),
('p2pq', 1981, 'udp', 'p2pQ'),
('estamp', 1982, 'udp', 'Evidentiary Timestamp'),
('lhtp', 1983, 'udp', 'Loophole Test Protocol'),
('bb', 1984, 'udp', 'BB'),
('hsrp', 1985, 'udp', 'Hot Standby Router Protocol'),
('licensedaemon', 1986, 'udp', 'cisco license management'),
('tr-rsrb-p1', 1987, 'udp', 'cisco RSRB Priority 1 port'),
('tr-rsrb-p2', 1988, 'udp', 'cisco RSRB Priority 2 port'),
('tr-rsrb-p3', 1989, 'udp', 'cisco RSRB Priority 3 port'),
('mshnet', 1989, 'udp', 'MHSnet system'),
('stun-p1', 1990, 'udp', 'cisco STUN Priority 1 port'),
('stun-p2', 1991, 'udp', 'cisco STUN Priority 2 port'),
('stun-p3', 1992, 'udp', 'cisco STUN Priority 3 port'),
('ipsendmsg', 1992, 'udp', 'IPsendmsg'),
('snmp-tcp-port', 1993, 'udp', 'cisco SNMP TCP port'),
('stun-port', 1994, 'udp', 'cisco serial tunnel port'),
('perf-port', 1995, 'udp', 'cisco perf port'),
('tr-rsrb-port', 1996, 'udp', 'cisco Remote SRB port'),
('gdp-port', 1997, 'udp', 'cisco Gateway Discovery Protocol'),
('x25-svc-port', 1998, 'udp', 'cisco X.25 service (XOT)'),
('tcp-id-port', 1999, 'udp', 'cisco identification port'),
('callbook', 2000, 'udp', ''),
('wizard', 2001, 'udp', 'curry'),
('globe', 2002, 'udp', ''),
('emce', 2004, 'udp', 'CCWS mm conf'),
('oracle', 2005, 'udp', ''),
('raid-cc', 2006, 'udp', 'raid'),
('raid-am', 2007, 'udp', ''),
('terminaldb', 2008, 'udp', ''),
('whosockami', 2009, 'udp', ''),
('pipe_server', 2010, 'udp', ''),
('servserv', 2011, 'udp', ''),
('raid-ac', 2012, 'udp', ''),
('raid-cd', 2013, 'udp', ''),
('raid-sf', 2014, 'udp', ''),
('raid-cs', 2015, 'udp', ''),
('bootserver', 2016, 'udp', ''),
('bootclient', 2017, 'udp', ''),
('rellpack', 2018, 'udp', ''),
('about', 2019, 'udp', ''),
('xinupageserver', 2020, 'udp', ''),
('xinuexpansion1', 2021, 'udp', ''),
('xinuexpansion2', 2022, 'udp', ''),
('xinuexpansion3', 2023, 'udp', ''),
('xinuexpansion4', 2024, 'udp', ''),
('xribs', 2025, 'udp', ''),
('scrabble', 2026, 'udp', ''),
('shadowserver', 2027, 'udp', ''),
('submitserver', 2028, 'udp', ''),
('device2', 2030, 'udp', ''),
('blackboard', 2032, 'udp', ''),
('glogger', 2033, 'udp', ''),
('scoremgr', 2034, 'udp', ''),
('imsldoc', 2035, 'udp', ''),
('p2plus', 2037, 'udp', 'P2plus Application Server'),
('objectmanager', 2038, 'udp', ''),
('lam', 2040, 'udp', ''),
('interbase', 2041, 'udp', ''),
('isis', 2042, 'udp', 'isis'),
('isis-bcast', 2043, 'udp', 'isis-bcast'),
('rimsl', 2044, 'udp', ''),
('cdfunc', 2045, 'udp', ''),
('sdfunc', 2046, 'udp', ''),
('dls', 2047, 'udp', ''),
('dls-monitor', 2048, 'udp', ''),
('shilp', 2049, 'udp', ''),
('nfs', 2049, 'udp', 'Network File System - Sun Microsystems'),
('av-emb-config', 2050, 'udp', 'Avaya EMB Config Port'),
('epnsdp', 2051, 'udp', 'EPNSDP'),
('clearvisn', 2052, 'udp', 'clearVisn Services Port'),
('lot105-ds-upd', 2053, 'udp', 'Lot105 DSuper Updates'),
('weblogin', 2054, 'udp', 'Weblogin Port'),
('iop', 2055, 'udp', 'Iliad-Odyssey Protocol'),
('omnisky', 2056, 'udp', 'OmniSky Port'),
('rich-cp', 2057, 'udp', 'Rich Content Protocol'),
('newwavesearch', 2058, 'udp', 'NewWaveSearchables RMI'),
('bmc-messaging', 2059, 'udp', 'BMC Messaging Service'),
('teleniumdaemon', 2060, 'udp', 'Telenium Daemon IF'),
('netmount', 2061, 'udp', 'NetMount'),
('icg-swp', 2062, 'udp', 'ICG SWP Port'),
('icg-bridge', 2063, 'udp', 'ICG Bridge Port'),
('icg-iprelay', 2064, 'udp', 'ICG IP Relay Port'),
('dlsrpn', 2065, 'udp', 'Data Link Switch Read Port Number'),
('dlswpn', 2067, 'udp', 'Data Link Switch Write Port Number'),
('avauthsrvprtcl', 2068, 'udp', 'Avocent AuthSrv Protocol'),
('event-port', 2069, 'udp', 'HTTP Event Port'),
('ah-esp-encap', 2070, 'udp', 'AH and ESP Encapsulated in UDP packet'),
('acp-port', 2071, 'udp', 'Axon Control Protocol'),
('msync', 2072, 'udp', 'GlobeCast mSync'),
('gxs-data-port', 2073, 'udp', 'DataReel Database Socket'),
('vrtl-vmf-sa', 2074, 'udp', 'Vertel VMF SA'),
('newlixengine', 2075, 'udp', 'Newlix ServerWare Engine'),
('newlixconfig', 2076, 'udp', 'Newlix JSPConfig'),
('trellisagt', 2077, 'udp', 'TrelliSoft Agent'),
('trellissvr', 2078, 'udp', 'TrelliSoft Server'),
('idware-router', 2079, 'udp', 'IDWARE Router Port'),
('autodesk-nlm', 2080, 'udp', 'Autodesk NLM (FLEXlm)'),
('kme-trap-port', 2081, 'udp', 'KME PRINTER TRAP PORT'),
('infowave', 2082, 'udp', 'Infowave Mobiltiy Server'),
('eli', 2087, 'udp', 'ELI - Event Logging Integration'),
('sep', 2089, 'udp', 'Security Encapsulation Protocol - SEP'),
('lrp', 2090, 'udp', 'Load Report Protocol'),
('prp', 2091, 'udp', 'PRP'),
('descent3', 2092, 'udp', 'Descent 3'),
('nbx-cc', 2093, 'udp', 'NBX CC'),
('nbx-au', 2094, 'udp', 'NBX AU'),
('nbx-ser', 2095, 'udp', 'NBX SER'),
('nbx-dir', 2096, 'udp', 'NBX DIR'),
('jetformpreview', 2097, 'udp', 'Jet Form Preview'),
('dialog-port', 2098, 'udp', 'Dialog Port'),
('h2250-annex-g', 2099, 'udp', 'H.225.0 Annex G'),
('amiganetfs', 2100, 'udp', 'Amiga Network Filesystem'),
('rtcm-sc104', 2101, 'udp', 'rtcm-sc104'),
('zephyr-srv', 2102, 'udp', 'Zephyr server'),
('zephyr-clt', 2103, 'udp', 'Zephyr serv-hm connection'),
('zephyr-hm', 2104, 'udp', 'Zephyr hostmanager'),
('minipay', 2105, 'udp', 'MiniPay'),
('mzap', 2106, 'udp', 'MZAP'),
('bintec-admin', 2107, 'udp', 'BinTec Admin'),
('comcam', 2108, 'udp', 'Comcam'),
('ergolight', 2109, 'udp', 'Ergolight'),
('umsp', 2110, 'udp', 'UMSP'),
('dsatp', 2111, 'udp', 'DSATP'),
('idonix-metanet', 2112, 'udp', 'Idonix MetaNet'),
('hsl-storm', 2113, 'udp', 'HSL StoRM'),
('newheights', 2114, 'udp', 'NEWHEIGHTS'),
('kdm', 2115, 'udp', 'Key Distribution Manager'),
('ccowcmr', 2116, 'udp', 'CCOWCMR'),
('mentaclient', 2117, 'udp', 'MENTACLIENT'),
('mentaserver', 2118, 'udp', 'MENTASERVER'),
('gsigatekeeper', 2119, 'udp', 'GSIGATEKEEPER'),
('qencp', 2120, 'udp', 'Quick Eagle Networks CP'),
('scientia-ssdb', 2121, 'udp', 'SCIENTIA-SSDB'),
('caupc-remote', 2122, 'udp', 'CauPC Remote Control'),
('gtp-control', 2123, 'udp', 'GTP-Control Plane (3GPP)'),
('elatelink', 2124, 'udp', 'ELATELINK'),
('lockstep', 2125, 'udp', 'LOCKSTEP'),
('pktcable-cops', 2126, 'udp', 'PktCable-COPS'),
('index-pc-wb', 2127, 'udp', 'INDEX-PC-WB'),
('net-steward', 2128, 'udp', 'Net Steward Control'),
('cs-live', 2129, 'udp', 'cs-live.com'),
('swc-xds', 2130, 'udp', 'SWC-XDS'),
('avantageb2b', 2131, 'udp', 'Avantageb2b'),
('avail-epmap', 2132, 'udp', 'AVAIL-EPMAP'),
('zymed-zpp', 2133, 'udp', 'ZYMED-ZPP'),
('avenue', 2134, 'udp', 'AVENUE'),
('gris', 2135, 'udp', 'Grid Resource Information Server'),
('appworxsrv', 2136, 'udp', 'APPWORXSRV'),
('connect', 2137, 'udp', 'CONNECT'),
('unbind-cluster', 2138, 'udp', 'UNBIND-CLUSTER'),
('ias-auth', 2139, 'udp', 'IAS-AUTH'),
('ias-reg', 2140, 'udp', 'IAS-REG'),
('ias-admind', 2141, 'udp', 'IAS-ADMIND'),
('tdm-over-ip', 2142, 'udp', 'TDM-OVER-IP'),
('lv-jc', 2143, 'udp', 'Live Vault Job Control'),
('lv-ffx', 2144, 'udp', 'Live Vault Fast Object Transfer'),
('lv-pici', 2145, 'udp', 'Live Vault Remote Diagnostic Console Support'),
('lv-not', 2146, 'udp', 'Live Vault Admin Event Notification'),
('lv-auth', 2147, 'udp', 'Live Vault Authentication'),
('veritas-ucl', 2148, 'udp', 'VERITAS UNIVERSAL COMMUNICATION LAYER'),
('acptsys', 2149, 'udp', 'ACPTSYS'),
('dynamic3d', 2150, 'udp', 'DYNAMIC3D'),
('docent', 2151, 'udp', 'DOCENT'),
('gtp-user', 2152, 'udp', 'GTP-User Plane (3GPP)'),
('gdbremote', 2159, 'udp', 'GDB Remote Debug Port'),
('apc-cms', 2160, 'udp', 'APC Central Mgmt Server'),
('apc-agent', 2161, 'udp', 'APC Agent'),
('navisphere', 2162, 'udp', 'Navisphere'),
('navisphere-sec', 2163, 'udp', 'Navisphere Secure'),
('ddns-v3', 2164, 'udp', 'Dynamic DNS Version 3'),
('x-bone-api', 2165, 'udp', 'X-Bone API'),
('iwserver', 2166, 'udp', 'iwserver'),
('raw-serial', 2167, 'udp', 'Raw Async Serial Link'),
('mc-gt-srv', 2180, 'udp', 'Millicent Vendor Gateway Server'),
('eforward', 2181, 'udp', 'eforward'),
('tivoconnect', 2190, 'udp', 'TiVoConnect Beacon'),
('ici', 2200, 'udp', 'ICI'),
('ats', 2201, 'udp', 'Advanced Training System Program'),
('imtc-map', 2202, 'udp', 'Int. Multimedia Teleconferencing Cosortium'),
('kali', 2213, 'udp', 'Kali'),
('netiq', 2220, 'udp', 'NetIQ End2End'),
('rockwell-csp1', 2221, 'udp', 'Rockwell CSP1'),
('rockwell-csp2', 2222, 'udp', 'Rockwell CSP2'),
('rockwell-csp3', 2223, 'udp', 'Rockwell CSP3'),
('ivs-video', 2232, 'udp', 'IVS Video default'),
('infocrypt', 2233, 'udp', 'INFOCRYPT'),
('directplay', 2234, 'udp', 'DirectPlay'),
('sercomm-wlink', 2235, 'udp', 'Sercomm-WLink'),
('nani', 2236, 'udp', 'Nani'),
('optech-port1-lm', 2237, 'udp', 'Optech Port1 License Manager'),
('aviva-sna', 2238, 'udp', 'AVIVA SNA SERVER'),
('imagequery', 2239, 'udp', 'Image Query'),
('recipe', 2240, 'udp', 'RECIPe'),
('ivsd', 2241, 'udp', 'IVS Daemon'),
('foliocorp', 2242, 'udp', 'Folio Remote Server'),
('magicom', 2243, 'udp', 'Magicom Protocol'),
('nmsserver', 2244, 'udp', 'NMS Server'),
('hao', 2245, 'udp', 'HaO'),
('pc-mta-addrmap', 2246, 'udp', 'PacketCable MTA Addr Map'),
('ums', 2248, 'udp', 'User Management Service'),
('rfmp', 2249, 'udp', 'RISO File Manager Protocol'),
('remote-collab', 2250, 'udp', 'remote-collab'),
('dif-port', 2251, 'udp', 'Distributed Framework Port'),
('njenet-ssl', 2252, 'udp', 'NJENET using SSL'),
('dtv-chan-req', 2253, 'udp', 'DTV Channel Request'),
('seispoc', 2254, 'udp', 'Seismic P.O.C. Port'),
('vrtp', 2255, 'udp', 'VRTP - ViRtue Transfer Protocol'),
('apc-pbeconsole', 2260, 'udp', 'APC Console Comm Port'),
('xmquery', 2279, 'udp', 'xmquery'),
('lnvpoller', 2280, 'udp', 'LNVPOLLER'),
('lnvconsole', 2281, 'udp', 'LNVCONSOLE'),
('lnvalarm', 2282, 'udp', 'LNVALARM'),
('lnvstatus', 2283, 'udp', 'LNVSTATUS'),
('lnvmaps', 2284, 'udp', 'LNVMAPS'),
('lnvmailmon', 2285, 'udp', 'LNVMAILMON'),
('nas-metering', 2286, 'udp', 'NAS-Metering'),
('dna', 2287, 'udp', 'DNA'),
('netml', 2288, 'udp', 'NETML'),
('konshus-lm', 2294, 'udp', 'Konshus License Manager (FLEX)'),
('advant-lm', 2295, 'udp', 'Advant License Manager'),
('theta-lm', 2296, 'udp', 'Theta License Manager (Rainbow)'),
('d2k-datamover1', 2297, 'udp', 'D2K DataMover 1'),
('d2k-datamover2', 2298, 'udp', 'D2K DataMover 2'),
('pc-telecommute', 2299, 'udp', 'PC Telecommute'),
('cvmmon', 2300, 'udp', 'CVMMON'),
('cpq-wbem', 2301, 'udp', 'Compaq HTTP'),
('binderysupport', 2302, 'udp', 'Bindery Support'),
('proxy-gateway', 2303, 'udp', 'Proxy Gateway'),
('attachmate-uts', 2304, 'udp', 'Attachmate UTS'),
('mt-scaleserver', 2305, 'udp', 'MT ScaleServer'),
('tappi-boxnet', 2306, 'udp', 'TAPPI BoxNet'),
('pehelp', 2307, 'udp', 'pehelp'),
('sdhelp', 2308, 'udp', 'sdhelp'),
('sdserver', 2309, 'udp', 'SD Server'),
('sdclient', 2310, 'udp', 'SD Client'),
('messageservice', 2311, 'udp', 'Message Service'),
('iapp', 2313, 'udp', 'IAPP (Inter Access Point Protocol)'),
('cr-websystems', 2314, 'udp', 'CR WebSystems'),
('precise-sft', 2315, 'udp', 'Precise Sft.'),
('sent-lm', 2316, 'udp', 'SENT License Manager'),
('attachmate-g32', 2317, 'udp', 'Attachmate G32'),
('cadencecontrol', 2318, 'udp', 'Cadence Control'),
('infolibria', 2319, 'udp', 'InfoLibria'),
('siebel-ns', 2320, 'udp', 'Siebel NS'),
('rdlap', 2321, 'udp', 'RDLAP'),
('ofsd', 2322, 'udp', 'ofsd'),
('3d-nfsd', 2323, 'udp', '3d-nfsd'),
('cosmocall', 2324, 'udp', 'Cosmocall'),
('designspace-lm', 2325, 'udp', 'Design Space License Management'),
('idcp', 2326, 'udp', 'IDCP'),
('xingcsm', 2327, 'udp', 'xingcsm'),
('netrix-sftm', 2328, 'udp', 'Netrix SFTM'),
('nvd', 2329, 'udp', 'NVD'),
('tscchat', 2330, 'udp', 'TSCCHAT'),
('agentview', 2331, 'udp', 'AGENTVIEW'),
('rcc-host', 2332, 'udp', 'RCC Host'),
('snapp', 2333, 'udp', 'SNAPP'),
('ace-client', 2334, 'udp', 'ACE Client Auth'),
('ace-proxy', 2335, 'udp', 'ACE Proxy'),
('appleugcontrol', 2336, 'udp', 'Apple UG Control'),
('ideesrv', 2337, 'udp', 'ideesrv'),
('norton-lambert', 2338, 'udp', 'Norton Lambert'),
('3com-webview', 2339, 'udp', '3Com WebView'),
('wrs_registry', 2340, 'udp', 'WRS Registry'),
('xiostatus', 2341, 'udp', 'XIO Status'),
('manage-exec', 2342, 'udp', 'Seagate Manage Exec'),
('nati-logos', 2343, 'udp', 'nati logos'),
('fcmsys', 2344, 'udp', 'fcmsys'),
('dbm', 2345, 'udp', 'dbm'),
('redstorm_join', 2346, 'udp', 'Game Connection Port'),
('redstorm_find', 2347, 'udp', 'Game Announcement and Location'),
('redstorm_info', 2348, 'udp', 'Information to query for game status'),
('redstorm_diag', 2349, 'udp', 'Diagnostics Port'),
('psbserver', 2350, 'udp', 'psbserver'),
('psrserver', 2351, 'udp', 'psrserver'),
('pslserver', 2352, 'udp', 'pslserver'),
('pspserver', 2353, 'udp', 'pspserver'),
('psprserver', 2354, 'udp', 'psprserver'),
('psdbserver', 2355, 'udp', 'psdbserver'),
('gxtelmd', 2356, 'udp', 'GXT License Managemant'),
('unihub-server', 2357, 'udp', 'UniHub Server'),
('futrix', 2358, 'udp', 'Futrix'),
('flukeserver', 2359, 'udp', 'FlukeServer'),
('nexstorindltd', 2360, 'udp', 'NexstorIndLtd'),
('tl1', 2361, 'udp', 'TL1'),
('digiman', 2362, 'udp', 'digiman'),
('mediacntrlnfsd', 2363, 'udp', 'Media Central NFSD'),
('oi-2000', 2364, 'udp', 'OI-2000'),
('dbref', 2365, 'udp', 'dbref'),
('qip-login', 2366, 'udp', 'qip-login'),
('service-ctrl', 2367, 'udp', 'Service Control'),
('opentable', 2368, 'udp', 'OpenTable'),
('acs2000-dsp', 2369, 'udp', 'ACS2000 DSP'),
('l3-hbmon', 2370, 'udp', 'L3-HBMon'),
('worldwire', 2371, 'udp', 'Compaq WorldWire Port'),
('compaq-https', 2381, 'udp', 'Compaq HTTPS'),
('ms-olap3', 2382, 'udp', 'Microsoft OLAP'),
('ms-olap4', 2383, 'udp', 'Microsoft OLAP'),
('sd-capacity', 2384, 'udp', 'SD-CAPACITY'),
('sd-data', 2385, 'udp', 'SD-DATA'),
('virtualtape', 2386, 'udp', 'Virtual Tape'),
('vsamredirector', 2387, 'udp', 'VSAM Redirector'),
('mynahautostart', 2388, 'udp', 'MYNAH AutoStart'),
('ovsessionmgr', 2389, 'udp', 'OpenView Session Mgr'),
('rsmtp', 2390, 'udp', 'RSMTP'),
('3com-net-mgmt', 2391, 'udp', '3COM Net Management'),
('tacticalauth', 2392, 'udp', 'Tactical Auth'),
('ms-olap1', 2393, 'udp', 'MS OLAP 1'),
('ms-olap2', 2394, 'udp', 'MS OLAP 2'),
('lan900_remote', 2395, 'udp', 'LAN900 Remote'),
('wusage', 2396, 'udp', 'Wusage'),
('ncl', 2397, 'udp', 'NCL'),
('orbiter', 2398, 'udp', 'Orbiter'),
('fmpro-fdal', 2399, 'udp', 'FileMaker, Inc. - Data Access Layer'),
('opequus-server', 2400, 'udp', 'OpEquus Server'),
('cvspserver', 2401, 'udp', 'cvspserver'),
('taskmaster2000', 2402, 'udp', 'TaskMaster 2000 Server'),
('taskmaster2000', 2403, 'udp', 'TaskMaster 2000 Web'),
('iec870-5-104', 2404, 'udp', 'IEC870-5-104'),
('trc-netpoll', 2405, 'udp', 'TRC Netpoll'),
('jediserver', 2406, 'udp', 'JediServer'),
('orion', 2407, 'udp', 'Orion'),
('optimanet', 2408, 'udp', 'OptimaNet'),
('sns-protocol', 2409, 'udp', 'SNS Protocol'),
('vrts-registry', 2410, 'udp', 'VRTS Registry'),
('netwave-ap-mgmt', 2411, 'udp', 'Netwave AP Management'),
('cdn', 2412, 'udp', 'CDN'),
('orion-rmi-reg', 2413, 'udp', 'orion-rmi-reg'),
('beeyond', 2414, 'udp', 'Beeyond'),
('comtest', 2415, 'udp', 'COMTEST'),
('rmtserver', 2416, 'udp', 'RMT Server'),
('composit-server', 2417, 'udp', 'Composit Server'),
('cas', 2418, 'udp', 'cas'),
('attachmate-s2s', 2419, 'udp', 'Attachmate S2S'),
('dslremote-mgmt', 2420, 'udp', 'DSL Remote Management'),
('g-talk', 2421, 'udp', 'G-Talk'),
('crmsbits', 2422, 'udp', 'CRMSBITS'),
('rnrp', 2423, 'udp', 'RNRP'),
('kofax-svr', 2424, 'udp', 'KOFAX-SVR'),
('fjitsuappmgr', 2425, 'udp', 'Fujitsu App Manager'),
('mgcp-gateway', 2427, 'udp', 'Media Gateway Control Protocol Gateway'),
('ott', 2428, 'udp', 'One Way Trip Time'),
('ft-role', 2429, 'udp', 'FT-ROLE'),
('venus', 2430, 'udp', 'venus'),
('venus-se', 2431, 'udp', 'venus-se'),
('codasrv', 2432, 'udp', 'codasrv'),
('codasrv-se', 2433, 'udp', 'codasrv-se'),
('pxc-epmap', 2434, 'udp', 'pxc-epmap'),
('optilogic', 2435, 'udp', 'OptiLogic'),
('topx', 2436, 'udp', 'TOP/X'),
('unicontrol', 2437, 'udp', 'UniControl'),
('msp', 2438, 'udp', 'MSP'),
('sybasedbsynch', 2439, 'udp', 'SybaseDBSynch'),
('spearway', 2440, 'udp', 'Spearway Lockers'),
('pvsw-inet', 2441, 'udp', 'pvsw-inet'),
('netangel', 2442, 'udp', 'Netangel'),
('powerclientcsf', 2443, 'udp', 'PowerClient Central Storage Facility'),
('btpp2sectrans', 2444, 'udp', 'BT PP2 Sectrans'),
('dtn1', 2445, 'udp', 'DTN1'),
('bues_service', 2446, 'udp', 'bues_service'),
('ovwdb', 2447, 'udp', 'OpenView NNM daemon'),
('hpppssvr', 2448, 'udp', 'hpppsvr'),
('ratl', 2449, 'udp', 'RATL'),
('netadmin', 2450, 'udp', 'netadmin'),
('netchat', 2451, 'udp', 'netchat'),
('snifferclient', 2452, 'udp', 'SnifferClient'),
('madge-om', 2453, 'udp', 'madge-om'),
('indx-dds', 2454, 'udp', 'IndX-DDS'),
('wago-io-system', 2455, 'udp', 'WAGO-IO-SYSTEM'),
('altav-remmgt', 2456, 'udp', 'altav-remmgt'),
('rapido-ip', 2457, 'udp', 'Rapido_IP'),
('griffin', 2458, 'udp', 'griffin'),
('community', 2459, 'udp', 'Community'),
('ms-theater', 2460, 'udp', 'ms-theater'),
('qadmifoper', 2461, 'udp', 'qadmifoper'),
('qadmifevent', 2462, 'udp', 'qadmifevent'),
('symbios-raid', 2463, 'udp', 'Symbios Raid'),
('direcpc-si', 2464, 'udp', 'DirecPC SI'),
('lbm', 2465, 'udp', 'Load Balance Management'),
('lbf', 2466, 'udp', 'Load Balance Forwarding'),
('high-criteria', 2467, 'udp', 'High Criteria'),
('qip-msgd', 2468, 'udp', 'qip_msgd'),
('mti-tcs-comm', 2469, 'udp', 'MTI-TCS-COMM'),
('taskman-port', 2470, 'udp', 'taskman port'),
('seaodbc', 2471, 'udp', 'SeaODBC'),
('c3', 2472, 'udp', 'C3'),
('aker-cdp', 2473, 'udp', 'Aker-cdp'),
('vitalanalysis', 2474, 'udp', 'Vital Analysis'),
('ace-server', 2475, 'udp', 'ACE Server'),
('ace-svr-prop', 2476, 'udp', 'ACE Server Propagation'),
('ssm-cvs', 2477, 'udp', 'SecurSight Certificate Valifation Service'),
('ssm-cssps', 2478, 'udp', 'SecurSight Authentication Server (SSL)'),
('ssm-els', 2479, 'udp', 'SecurSight Event Logging Server (SSL)'),
('lingwood', 2480, 'udp', 'Lingwoods Detail'),
('giop', 2481, 'udp', 'Oracle GIOP'),
('giop-ssl', 2482, 'udp', 'Oracle GIOP SSL'),
('ttc', 2483, 'udp', 'Oracle TTC'),
('ttc-ssl', 2484, 'udp', 'Oracle TTC SSL'),
('netobjects1', 2485, 'udp', 'Net Objects1'),
('netobjects2', 2486, 'udp', 'Net Objects2'),
('pns', 2487, 'udp', 'Policy Notice Service'),
('moy-corp', 2488, 'udp', 'Moy Corporation'),
('tsilb', 2489, 'udp', 'TSILB'),
('qip-qdhcp', 2490, 'udp', 'qip_qdhcp'),
('conclave-cpp', 2491, 'udp', 'Conclave CPP'),
('groove', 2492, 'udp', 'GROOVE'),
('talarian-mqs', 2493, 'udp', 'Talarian MQS'),
('bmc-ar', 2494, 'udp', 'BMC AR'),
('fast-rem-serv', 2495, 'udp', 'Fast Remote Services'),
('dirgis', 2496, 'udp', 'DIRGIS'),
('quaddb', 2497, 'udp', 'Quad DB'),
('odn-castraq', 2498, 'udp', 'ODN-CasTraq'),
('unicontrol', 2499, 'udp', 'UniControl'),
('rtsserv', 2500, 'udp', 'Resource Tracking system server'),
('rtsclient', 2501, 'udp', 'Resource Tracking system client'),
('kentrox-prot', 2502, 'udp', 'Kentrox Protocol'),
('nms-dpnss', 2503, 'udp', 'NMS-DPNSS'),
('wlbs', 2504, 'udp', 'WLBS'),
('jbroker', 2506, 'udp', 'jbroker'),
('spock', 2507, 'udp', 'spock'),
('jdatastore', 2508, 'udp', 'JDataStore'),
('fjmpss', 2509, 'udp', 'fjmpss'),
('fjappmgrbulk', 2510, 'udp', 'fjappmgrbulk'),
('metastorm', 2511, 'udp', 'Metastorm'),
('citrixima', 2512, 'udp', 'Citrix IMA'),
('citrixadmin', 2513, 'udp', 'Citrix ADMIN'),
('facsys-ntp', 2514, 'udp', 'Facsys NTP'),
('facsys-router', 2515, 'udp', 'Facsys Router'),
('maincontrol', 2516, 'udp', 'Main Control'),
('call-sig-trans', 2517, 'udp', 'H.323 Annex E call signaling transport'),
('willy', 2518, 'udp', 'Willy'),
('globmsgsvc', 2519, 'udp', 'globmsgsvc'),
('pvsw', 2520, 'udp', 'pvsw'),
('adaptecmgr', 2521, 'udp', 'Adaptec Manager'),
('windb', 2522, 'udp', 'WinDb'),
('qke-llc-v3', 2523, 'udp', 'Qke LLC V.3'),
('optiwave-lm', 2524, 'udp', 'Optiwave License Management'),
('ms-v-worlds', 2525, 'udp', 'MS V-Worlds'),
('ema-sent-lm', 2526, 'udp', 'EMA License Manager'),
('iqserver', 2527, 'udp', 'IQ Server'),
('ncr_ccl', 2528, 'udp', 'NCR CCL'),
('utsftp', 2529, 'udp', 'UTS FTP'),
('vrcommerce', 2530, 'udp', 'VR Commerce'),
('ito-e-gui', 2531, 'udp', 'ITO-E GUI'),
('ovtopmd', 2532, 'udp', 'OVTOPMD'),
('snifferserver', 2533, 'udp', 'SnifferServer'),
('combox-web-acc', 2534, 'udp', 'Combox Web Access'),
('madcap', 2535, 'udp', 'MADCAP'),
('btpp2audctr1', 2536, 'udp', 'btpp2audctr1'),
('upgrade', 2537, 'udp', 'Upgrade Protocol'),
('vnwk-prapi', 2538, 'udp', 'vnwk-prapi'),
('vsiadmin', 2539, 'udp', 'VSI Admin'),
('lonworks', 2540, 'udp', 'LonWorks'),
('lonworks2', 2541, 'udp', 'LonWorks2'),
('davinci', 2542, 'udp', 'daVinci Presenter'),
('reftek', 2543, 'udp', 'REFTEK'),
('novell-zen', 2544, 'udp', 'Novell ZEN'),
('sis-emt', 2545, 'udp', 'sis-emt'),
('vytalvaultbrtp', 2546, 'udp', 'vytalvaultbrtp'),
('vytalvaultvsmp', 2547, 'udp', 'vytalvaultvsmp'),
('vytalvaultpipe', 2548, 'udp', 'vytalvaultpipe'),
('ipass', 2549, 'udp', 'IPASS'),
('ads', 2550, 'udp', 'ADS'),
('isg-uda-server', 2551, 'udp', 'ISG UDA Server'),
('call-logging', 2552, 'udp', 'Call Logging'),
('efidiningport', 2553, 'udp', 'efidiningport'),
('vcnet-link-v10', 2554, 'udp', 'VCnet-Link v10'),
('compaq-wcp', 2555, 'udp', 'Compaq WCP'),
('nicetec-nmsvc', 2556, 'udp', 'nicetec-nmsvc'),
('nicetec-mgmt', 2557, 'udp', 'nicetec-mgmt'),
('pclemultimedia', 2558, 'udp', 'PCLE Multi Media'),
('lstp', 2559, 'udp', 'LSTP'),
('labrat', 2560, 'udp', 'labrat'),
('mosaixcc', 2561, 'udp', 'MosaixCC'),
('delibo', 2562, 'udp', 'Delibo'),
('cti-redwood', 2563, 'udp', 'CTI Redwood'),
('coord-svr', 2565, 'udp', 'Coordinator Server'),
('pcs-pcw', 2566, 'udp', 'pcs-pcw'),
('clp', 2567, 'udp', 'Cisco Line Protocol'),
('spamtrap', 2568, 'udp', 'SPAM TRAP'),
('sonuscallsig', 2569, 'udp', 'Sonus Call Signal'),
('hs-port', 2570, 'udp', 'HS Port'),
('cecsvc', 2571, 'udp', 'CECSVC'),
('ibp', 2572, 'udp', 'IBP'),
('trustestablish', 2573, 'udp', 'Trust Establish'),
('blockade-bpsp', 2574, 'udp', 'Blockade BPSP'),
('hl7', 2575, 'udp', 'HL7'),
('tclprodebugger', 2576, 'udp', 'TCL Pro Debugger'),
('scipticslsrvr', 2577, 'udp', 'Scriptics Lsrvr'),
('rvs-isdn-dcp', 2578, 'udp', 'RVS ISDN DCP'),
('mpfoncl', 2579, 'udp', 'mpfoncl'),
('tributary', 2580, 'udp', 'Tributary'),
('argis-te', 2581, 'udp', 'ARGIS TE'),
('argis-ds', 2582, 'udp', 'ARGIS DS'),
('mon', 2583, 'udp', 'MON'),
('cyaserv', 2584, 'udp', 'cyaserv'),
('netx-server', 2585, 'udp', 'NETX Server'),
('netx-agent', 2586, 'udp', 'NETX Agent'),
('masc', 2587, 'udp', 'MASC'),
('privilege', 2588, 'udp', 'Privilege'),
('quartus-tcl', 2589, 'udp', 'quartus tcl'),
('idotdist', 2590, 'udp', 'idotdist'),
('maytagshuffle', 2591, 'udp', 'Maytag Shuffle'),
('netrek', 2592, 'udp', 'netrek'),
('mns-mail', 2593, 'udp', 'MNS Mail Notice Service'),
('dts', 2594, 'udp', 'Data Base Server'),
('worldfusion1', 2595, 'udp', 'World Fusion 1'),
('worldfusion2', 2596, 'udp', 'World Fusion 2'),
('homesteadglory', 2597, 'udp', 'Homestead Glory'),
('citriximaclient', 2598, 'udp', 'Citrix MA Client'),
('meridiandata', 2599, 'udp', 'Meridian Data'),
('hpstgmgr', 2600, 'udp', 'HPSTGMGR'),
('discp-client', 2601, 'udp', 'discp client'),
('discp-server', 2602, 'udp', 'discp server'),
('servicemeter', 2603, 'udp', 'Service Meter'),
('nsc-ccs', 2604, 'udp', 'NSC CCS'),
('nsc-posa', 2605, 'udp', 'NSC POSA'),
('netmon', 2606, 'udp', 'Dell Netmon'),
('connection', 2607, 'udp', 'Dell Connection'),
('wag-service', 2608, 'udp', 'Wag Service'),
('system-monitor', 2609, 'udp', 'System Monitor'),
('versa-tek', 2610, 'udp', 'VersaTek'),
('lionhead', 2611, 'udp', 'LIONHEAD'),
('qpasa-agent', 2612, 'udp', 'Qpasa Agent'),
('smntubootstrap', 2613, 'udp', 'SMNTUBootstrap'),
('neveroffline', 2614, 'udp', 'Never Offline'),
('firepower', 2615, 'udp', 'firepower'),
('appswitch-emp', 2616, 'udp', 'appswitch-emp'),
('cmadmin', 2617, 'udp', 'Clinical Context Managers'),
('priority-e-com', 2618, 'udp', 'Priority E-Com'),
('bruce', 2619, 'udp', 'bruce'),
('lpsrecommender', 2620, 'udp', 'LPSRecommender'),
('miles-apart', 2621, 'udp', 'Miles Apart Jukebox Server'),
('metricadbc', 2622, 'udp', 'MetricaDBC'),
('lmdp', 2623, 'udp', 'LMDP'),
('aria', 2624, 'udp', 'Aria'),
('blwnkl-port', 2625, 'udp', 'Blwnkl Port'),
('gbjd816', 2626, 'udp', 'gbjd816'),
('moshebeeri', 2627, 'udp', 'Moshe Beeri'),
('dict', 2628, 'udp', 'DICT'),
('sitaraserver', 2629, 'udp', 'Sitara Server'),
('sitaramgmt', 2630, 'udp', 'Sitara Management'),
('sitaradir', 2631, 'udp', 'Sitara Dir'),
('irdg-post', 2632, 'udp', 'IRdg Post'),
('interintelli', 2633, 'udp', 'InterIntelli'),
('pk-electronics', 2634, 'udp', 'PK Electronics'),
('backburner', 2635, 'udp', 'Back Burner'),
('solve', 2636, 'udp', 'Solve'),
('imdocsvc', 2637, 'udp', 'Import Document Service'),
('sybaseanywhere', 2638, 'udp', 'Sybase Anywhere'),
('aminet', 2639, 'udp', 'AMInet'),
('sai_sentlm', 2640, 'udp', 'Sabbagh Associates Licence Manager'),
('hdl-srv', 2641, 'udp', 'HDL Server'),
('tragic', 2642, 'udp', 'Tragic'),
('gte-samp', 2643, 'udp', 'GTE-SAMP'),
('travsoft-ipx-t', 2644, 'udp', 'Travsoft IPX Tunnel'),
('novell-ipx-cmd', 2645, 'udp', 'Novell IPX CMD'),
('and-lm', 2646, 'udp', 'AND License Manager'),
('syncserver', 2647, 'udp', 'SyncServer'),
('upsnotifyprot', 2648, 'udp', 'Upsnotifyprot'),
('vpsipport', 2649, 'udp', 'VPSIPPORT'),
('eristwoguns', 2650, 'udp', 'eristwoguns'),
('ebinsite', 2651, 'udp', 'EBInSite'),
('interpathpanel', 2652, 'udp', 'InterPathPanel'),
('sonus', 2653, 'udp', 'Sonus'),
('corel_vncadmin', 2654, 'udp', 'Corel VNC Admin'),
('unglue', 2655, 'udp', 'UNIX Nt Glue'),
('kana', 2656, 'udp', 'Kana'),
('sns-dispatcher', 2657, 'udp', 'SNS Dispatcher'),
('sns-admin', 2658, 'udp', 'SNS Admin'),
('sns-query', 2659, 'udp', 'SNS Query'),
('gcmonitor', 2660, 'udp', 'GC Monitor'),
('olhost', 2661, 'udp', 'OLHOST'),
('bintec-capi', 2662, 'udp', 'BinTec-CAPI'),
('bintec-tapi', 2663, 'udp', 'BinTec-TAPI'),
('patrol-mq-gm', 2664, 'udp', 'Patrol for MQ GM'),
('patrol-mq-nm', 2665, 'udp', 'Patrol for MQ NM'),
('extensis', 2666, 'udp', 'extensis'),
('alarm-clock-s', 2667, 'udp', 'Alarm Clock Server'),
('alarm-clock-c', 2668, 'udp', 'Alarm Clock Client'),
('toad', 2669, 'udp', 'TOAD'),
('tve-announce', 2670, 'udp', 'TVE Announce'),
('newlixreg', 2671, 'udp', 'newlixreg'),
('nhserver', 2672, 'udp', 'nhserver'),
('firstcall42', 2673, 'udp', 'First Call 42'),
('ewnn', 2674, 'udp', 'ewnn'),
('ttc-etap', 2675, 'udp', 'TTC ETAP'),
('simslink', 2676, 'udp', 'SIMSLink'),
('gadgetgate1way', 2677, 'udp', 'Gadget Gate 1 Way'),
('gadgetgate2way', 2678, 'udp', 'Gadget Gate 2 Way'),
('syncserverssl', 2679, 'udp', 'Sync Server SSL'),
('pxc-sapxom', 2680, 'udp', 'pxc-sapxom'),
('mpnjsomb', 2681, 'udp', 'mpnjsomb'),
('ncdloadbalance', 2683, 'udp', 'NCDLoadBalance'),
('mpnjsosv', 2684, 'udp', 'mpnjsosv'),
('mpnjsocl', 2685, 'udp', 'mpnjsocl'),
('mpnjsomg', 2686, 'udp', 'mpnjsomg'),
('pq-lic-mgmt', 2687, 'udp', 'pq-lic-mgmt'),
('md-cg-http', 2688, 'udp', 'md-cf-http'),
('fastlynx', 2689, 'udp', 'FastLynx'),
('hp-nnm-data', 2690, 'udp', 'HP NNM Embedded Database'),
('itinternet', 2691, 'udp', 'ITInternet ISM Server'),
('admins-lms', 2692, 'udp', 'Admins LMS'),
('belarc-http', 2693, 'udp', 'belarc-http'),
('pwrsevent', 2694, 'udp', 'pwrsevent'),
('vspread', 2695, 'udp', 'VSPREAD'),
('unifyadmin', 2696, 'udp', 'Unify Admin'),
('oce-snmp-trap', 2697, 'udp', 'Oce SNMP Trap Port'),
('mck-ivpip', 2698, 'udp', 'MCK-IVPIP'),
('csoft-plusclnt', 2699, 'udp', 'Csoft Plus Client'),
('tqdata', 2700, 'udp', 'tqdata'),
('sms-rcinfo', 2701, 'udp', 'SMS RCINFO'),
('sms-xfer', 2702, 'udp', 'SMS XFER'),
('sms-chat', 2703, 'udp', 'SMS CHAT'),
('sms-remctrl', 2704, 'udp', 'SMS REMCTRL'),
('sds-admin', 2705, 'udp', 'SDS Admin'),
('ncdmirroring', 2706, 'udp', 'NCD Mirroring'),
('emcsymapiport', 2707, 'udp', 'EMCSYMAPIPORT'),
('banyan-net', 2708, 'udp', 'Banyan-Net'),
('supermon', 2709, 'udp', 'Supermon'),
('sso-service', 2710, 'udp', 'SSO Service'),
('sso-control', 2711, 'udp', 'SSO Control'),
('aocp', 2712, 'udp', 'Axapta Object Communication Protocol'),
('raven1', 2713, 'udp', 'Raven1'),
('raven2', 2714, 'udp', 'Raven2'),
('hpstgmgr2', 2715, 'udp', 'HPSTGMGR2'),
('inova-ip-disco', 2716, 'udp', 'Inova IP Disco'),
('pn-requester', 2717, 'udp', 'PN REQUESTER'),
('pn-requester2', 2718, 'udp', 'PN REQUESTER 2'),
('scan-change', 2719, 'udp', 'Scan & Change'),
('wkars', 2720, 'udp', 'wkars'),
('smart-diagnose', 2721, 'udp', 'Smart Diagnose'),
('proactivesrvr', 2722, 'udp', 'Proactive Server'),
('watchdognt', 2723, 'udp', 'WatchDog NT'),
('qotps', 2724, 'udp', 'qotps'),
('msolap-ptp2', 2725, 'udp', 'MSOLAP PTP2'),
('tams', 2726, 'udp', 'TAMS'),
('mgcp-callagent', 2727, 'udp', 'Media Gateway Control Protocol Call Agent'),
('sqdr', 2728, 'udp', 'SQDR'),
('tcim-control', 2729, 'udp', 'TCIM Control'),
('nec-raidplus', 2730, 'udp', 'NEC RaidPlus'),
('fyre-messanger', 2731, 'udp', 'Fyre Messagner'),
('g5m', 2732, 'udp', 'G5M'),
('signet-ctf', 2733, 'udp', 'Signet CTF'),
('ccs-software', 2734, 'udp', 'CCS Software'),
('netiq-mc', 2735, 'udp', 'NetIQ Monitor Console'),
('radwiz-nms-srv', 2736, 'udp', 'RADWIZ NMS SRV'),
('srp-feedback', 2737, 'udp', 'SRP Feedback'),
('ndl-tcp-ois-gw', 2738, 'udp', 'NDL TCP-OSI Gateway'),
('tn-timing', 2739, 'udp', 'TN Timing'),
('alarm', 2740, 'udp', 'Alarm'),
('tsb', 2741, 'udp', 'TSB'),
('tsb2', 2742, 'udp', 'TSB2'),
('murx', 2743, 'udp', 'murx'),
('honyaku', 2744, 'udp', 'honyaku'),
('urbisnet', 2745, 'udp', 'URBISNET'),
('cpudpencap', 2746, 'udp', 'CPUDPENCAP'),
('fjippol-swrly', 2747, 'udp', ''),
('fjippol-polsvr', 2748, 'udp', ''),
('fjippol-cnsl', 2749, 'udp', ''),
('fjippol-port1', 2750, 'udp', ''),
('fjippol-port2', 2751, 'udp', ''),
('rsisysaccess', 2752, 'udp', 'RSISYS ACCESS'),
('de-spot', 2753, 'udp', 'de-spot'),
('apollo-cc', 2754, 'udp', 'APOLLO CC'),
('expresspay', 2755, 'udp', 'Express Pay'),
('simplement-tie', 2756, 'udp', 'simplement-tie'),
('cnrp', 2757, 'udp', 'CNRP'),
('apollo-status', 2758, 'udp', 'APOLLO Status'),
('apollo-gms', 2759, 'udp', 'APOLLO GMS'),
('sabams', 2760, 'udp', 'Saba MS'),
('dicom-iscl', 2761, 'udp', 'DICOM ISCL'),
('dicom-tls', 2762, 'udp', 'DICOM TLS'),
('desktop-dna', 2763, 'udp', 'Desktop DNA'),
('data-insurance', 2764, 'udp', 'Data Insurance'),
('qip-audup', 2765, 'udp', 'qip-audup'),
('compaq-scp', 2766, 'udp', 'Compaq SCP'),
('uadtc', 2767, 'udp', 'UADTC'),
('uacs', 2768, 'udp', 'UACS'),
('singlept-mvs', 2769, 'udp', 'Single Point MVS'),
('veronica', 2770, 'udp', 'Veronica'),
('vergencecm', 2771, 'udp', 'Vergence CM'),
('auris', 2772, 'udp', 'auris'),
('pcbakcup1', 2773, 'udp', 'PC Backup'),
('pcbakcup2', 2774, 'udp', 'PC Backup'),
('smpp', 2775, 'udp', 'SMPP'),
('ridgeway1', 2776, 'udp', 'Ridgeway Systems & Software'),
('ridgeway2', 2777, 'udp', 'Ridgeway Systems & Software'),
('gwen-sonya', 2778, 'udp', 'Gwen-Sonya'),
('lbc-sync', 2779, 'udp', 'LBC Sync'),
('lbc-control', 2780, 'udp', 'LBC Control'),
('whosells', 2781, 'udp', 'whosells'),
('everydayrc', 2782, 'udp', 'everydayrc'),
('aises', 2783, 'udp', 'AISES'),
('www-dev', 2784, 'udp', 'world wide web - development'),
('aic-np', 2785, 'udp', 'aic-np'),
('aic-oncrpc', 2786, 'udp', 'aic-oncrpc - Destiny MCD database'),
('piccolo', 2787, 'udp', 'piccolo - Cornerstone Software'),
('fryeserv', 2788, 'udp', 'NetWare Loadable Module - Seagate Software'),
('media-agent', 2789, 'udp', 'Media Agent'),
('plgproxy', 2790, 'udp', 'PLG Proxy'),
('mtport-regist', 2791, 'udp', 'MT Port Registrator'),
('f5-globalsite', 2792, 'udp', 'f5-globalsite'),
('initlsmsad', 2793, 'udp', 'initlsmsad'),
('aaftp', 2794, 'udp', 'aaftp'),
('livestats', 2795, 'udp', 'LiveStats'),
('ac-tech', 2796, 'udp', 'ac-tech'),
('esp-encap', 2797, 'udp', 'esp-encap'),
('tmesis-upshot', 2798, 'udp', 'TMESIS-UPShot'),
('icon-discover', 2799, 'udp', 'ICON Discover'),
('acc-raid', 2800, 'udp', 'ACC RAID'),
('igcp', 2801, 'udp', 'IGCP'),
('veritas-udp1', 2802, 'udp', 'Veritas UDP1'),
('btprjctrl', 2803, 'udp', 'btprjctrl'),
('telexis-vtu', 2804, 'udp', 'Telexis VTU'),
('wta-wsp-s', 2805, 'udp', 'WTA WSP-S'),
('cspuni', 2806, 'udp', 'cspuni'),
('cspmulti', 2807, 'udp', 'cspmulti'),
('j-lan-p', 2808, 'udp', 'J-LAN-P'),
('corbaloc', 2809, 'udp', 'CORBA LOC'),
('netsteward', 2810, 'udp', 'Active Net Steward'),
('gsiftp', 2811, 'udp', 'GSI FTP'),
('atmtcp', 2812, 'udp', 'atmtcp'),
('llm-pass', 2813, 'udp', 'llm-pass'),
('llm-csv', 2814, 'udp', 'llm-csv'),
('lbc-measure', 2815, 'udp', 'LBC Measurement'),
('lbc-watchdog', 2816, 'udp', 'LBC Watchdog'),
('nmsigport', 2817, 'udp', 'NMSig Port'),
('rmlnk', 2818, 'udp', 'rmlnk'),
('fc-faultnotify', 2819, 'udp', 'FC Fault Notification'),
('univision', 2820, 'udp', 'UniVision'),
('vml-dms', 2821, 'udp', 'vml_dms'),
('ka0wuc', 2822, 'udp', 'ka0wuc'),
('cqg-netlan', 2823, 'udp', 'CQG Net/LAN'),
('cqg-netlan-1', 2824, 'udp', 'CQG Net/Lan 1'),
('slc-systemlog', 2826, 'udp', 'slc systemlog'),
('slc-ctrlrloops', 2827, 'udp', 'slc ctrlrloops'),
('itm-lm', 2828, 'udp', 'ITM License Manager'),
('silkp1', 2829, 'udp', 'silkp1'),
('silkp2', 2830, 'udp', 'silkp2'),
('silkp3', 2831, 'udp', 'silkp3'),
('silkp4', 2832, 'udp', 'silkp4'),
('glishd', 2833, 'udp', 'glishd'),
('evtp', 2834, 'udp', 'EVTP'),
('evtp-data', 2835, 'udp', 'EVTP-DATA'),
('catalyst', 2836, 'udp', 'catalyst'),
('repliweb', 2837, 'udp', 'Repliweb'),
('starbot', 2838, 'udp', 'Starbot'),
('nmsigport', 2839, 'udp', 'NMSigPort'),
('l3-exprt', 2840, 'udp', 'l3-exprt'),
('l3-ranger', 2841, 'udp', 'l3-ranger'),
('l3-hawk', 2842, 'udp', 'l3-hawk'),
('pdnet', 2843, 'udp', 'PDnet'),
('bpcp-poll', 2844, 'udp', 'BPCP POLL'),
('bpcp-trap', 2845, 'udp', 'BPCP TRAP'),
('aimpp-hello', 2846, 'udp', 'AIMPP Hello'),
('aimpp-port-req', 2847, 'udp', 'AIMPP Port Req'),
('amt-blc-port', 2848, 'udp', 'AMT-BLC-PORT'),
('fxp', 2849, 'udp', 'FXP'),
('metaconsole', 2850, 'udp', 'MetaConsole'),
('webemshttp', 2851, 'udp', 'webemshttp'),
('bears-01', 2852, 'udp', 'bears-01'),
('ispipes', 2853, 'udp', 'ISPipes'),
('infomover', 2854, 'udp', 'InfoMover'),
('cesdinv', 2856, 'udp', 'cesdinv'),
('simctlp', 2857, 'udp', 'SimCtIP'),
('ecnp', 2858, 'udp', 'ECNP'),
('activememory', 2859, 'udp', 'Active Memory'),
('dialpad-voice1', 2860, 'udp', 'Dialpad Voice 1'),
('dialpad-voice2', 2861, 'udp', 'Dialpad Voice 2'),
('ttg-protocol', 2862, 'udp', 'TTG Protocol'),
('sonardata', 2863, 'udp', 'Sonar Data'),
('astromed-main', 2864, 'udp', 'main 5001 cmd'),
('pit-vpn', 2865, 'udp', 'pit-vpn'),
('iwlistener', 2866, 'udp', 'iwlistener'),
('esps-portal', 2867, 'udp', 'esps-portal'),
('npep-messaging', 2868, 'udp', 'NPEP Messaging'),
('icslap', 2869, 'udp', 'ICSLAP'),
('daishi', 2870, 'udp', 'daishi'),
('msi-selectplay', 2871, 'udp', 'MSI Select Play'),
('radix', 2872, 'udp', 'RADIX'),
('paspar2-zoomin', 2873, 'udp', 'PASPAR2 ZoomIn'),
('dxmessagebase1', 2874, 'udp', 'dxmessagebase1'),
('dxmessagebase2', 2875, 'udp', 'dxmessagebase2'),
('sps-tunnel', 2876, 'udp', 'SPS Tunnel'),
('bluelance', 2877, 'udp', 'BLUELANCE'),
('aap', 2878, 'udp', 'AAP'),
('ucentric-ds', 2879, 'udp', 'ucentric-ds'),
('synapse', 2880, 'udp', 'Synapse Transport'),
('ndsp', 2881, 'udp', 'NDSP'),
('ndtp', 2882, 'udp', 'NDTP'),
('ndnp', 2883, 'udp', 'NDNP'),
('flashmsg', 2884, 'udp', 'Flash Msg'),
('topflow', 2885, 'udp', 'TopFlow'),
('responselogic', 2886, 'udp', 'RESPONSELOGIC'),
('aironetddp', 2887, 'udp', 'aironet'),
('spcsdlobby', 2888, 'udp', 'SPCSDLOBBY'),
('rsom', 2889, 'udp', 'RSOM'),
('cspclmulti', 2890, 'udp', 'CSPCLMULTI'),
('cinegrfx-elmd', 2891, 'udp', 'CINEGRFX-ELMD License Manager'),
('snifferdata', 2892, 'udp', 'SNIFFERDATA'),
('vseconnector', 2893, 'udp', 'VSECONNECTOR'),
('abacus-remote', 2894, 'udp', 'ABACUS-REMOTE'),
('natuslink', 2895, 'udp', 'NATUS LINK'),
('ecovisiong6-1', 2896, 'udp', 'ECOVISIONG6-1'),
('citrix-rtmp', 2897, 'udp', 'Citrix RTMP'),
('appliance-cfg', 2898, 'udp', 'APPLIANCE-CFG'),
('powergemplus', 2899, 'udp', 'POWERGEMPLUS'),
('quicksuite', 2900, 'udp', 'QUICKSUITE'),
('allstorcns', 2901, 'udp', 'ALLSTORCNS'),
('netaspi', 2902, 'udp', 'NET ASPI'),
('suitcase', 2903, 'udp', 'SUITCASE'),
('m2ua', 2904, 'udp', 'M2UA'),
('m3ua', 2905, 'udp', 'De-registered (2001 June 07)'),
('caller9', 2906, 'udp', 'CALLER9'),
('webmethods-b2b', 2907, 'udp', 'WEBMETHODS B2B'),
('mao', 2908, 'udp', 'mao'),
('funk-dialout', 2909, 'udp', 'Funk Dialout'),
('tdaccess', 2910, 'udp', 'TDAccess'),
('blockade', 2911, 'udp', 'Blockade'),
('epicon', 2912, 'udp', 'Epicon'),
('boosterware', 2913, 'udp', 'Booster Ware'),
('gamelobby', 2914, 'udp', 'Game Lobby'),
('tksocket', 2915, 'udp', 'TK Socket'),
('elvin_server', 2916, 'udp', 'Elvin Server'),
('elvin_client', 2917, 'udp', 'Elvin Client'),
('kastenchasepad', 2918, 'udp', 'Kasten Chase Pad'),
('roboer', 2919, 'udp', 'ROBOER'),
('roboeda', 2920, 'udp', 'ROBOEDA'),
('cesdcdman', 2921, 'udp', 'CESD Contents Delivery Management'),
('cesdcdtrn', 2922, 'udp', 'CESD Contents Delivery Data Transfer'),
('wta-wsp-wtp-s', 2923, 'udp', 'WTA-WSP-WTP-S'),
('precise-vip', 2924, 'udp', 'PRECISE-VIP'),
('mobile-file-dl', 2926, 'udp', 'MOBILE-FILE-DL'),
('unimobilectrl', 2927, 'udp', 'UNIMOBILECTRL'),
('redstone-cpss', 2928, 'udp', 'REDSTONE-CPSS'),
('panja-webadmin', 2929, 'udp', 'PANJA-WEBADMIN'),
('panja-weblinx', 2930, 'udp', 'PANJA-WEBLINX'),
('circle-x', 2931, 'udp', 'Circle-X'),
('incp', 2932, 'udp', 'INCP'),
('4-tieropmgw', 2933, 'udp', '4-TIER OPM GW'),
('4-tieropmcli', 2934, 'udp', '4-TIER OPM CLI'),
('qtp', 2935, 'udp', 'QTP'),
('otpatch', 2936, 'udp', 'OTPatch'),
('pnaconsult-lm', 2937, 'udp', 'PNACONSULT-LM'),
('sm-pas-1', 2938, 'udp', 'SM-PAS-1'),
('sm-pas-2', 2939, 'udp', 'SM-PAS-2'),
('sm-pas-3', 2940, 'udp', 'SM-PAS-3'),
('sm-pas-4', 2941, 'udp', 'SM-PAS-4'),
('sm-pas-5', 2942, 'udp', 'SM-PAS-5'),
('ttnrepository', 2943, 'udp', 'TTNRepository'),
('megaco-h248', 2944, 'udp', 'Megaco H-248'),
('h248-binary', 2945, 'udp', 'H248 Binary'),
('fjsvmpor', 2946, 'udp', 'FJSVmpor'),
('gpsd', 2947, 'udp', 'GPSD'),
('wap-push', 2948, 'udp', 'WAP PUSH'),
('wap-pushsecure', 2949, 'udp', 'WAP PUSH SECURE'),
('esip', 2950, 'udp', 'ESIP'),
('ottp', 2951, 'udp', 'OTTP'),
('mpfwsas', 2952, 'udp', 'MPFWSAS'),
('ovalarmsrv', 2953, 'udp', 'OVALARMSRV'),
('ovalarmsrv-cmd', 2954, 'udp', 'OVALARMSRV-CMD'),
('csnotify', 2955, 'udp', 'CSNOTIFY'),
('ovrimosdbman', 2956, 'udp', 'OVRIMOSDBMAN'),
('jmact5', 2957, 'udp', 'JAMCT5'),
('jmact6', 2958, 'udp', 'JAMCT6'),
('rmopagt', 2959, 'udp', 'RMOPAGT'),
('dfoxserver', 2960, 'udp', 'DFOXSERVER'),
('boldsoft-lm', 2961, 'udp', 'BOLDSOFT-LM'),
('iph-policy-cli', 2962, 'udp', 'IPH-POLICY-CLI'),
('iph-policy-adm', 2963, 'udp', 'IPH-POLICY-ADM'),
('bullant-srap', 2964, 'udp', 'BULLANT SRAP'),
('bullant-rap', 2965, 'udp', 'BULLANT RAP'),
('idp-infotrieve', 2966, 'udp', 'IDP-INFOTRIEVE'),
('ssc-agent', 2967, 'udp', 'SSC-AGENT'),
('enpp', 2968, 'udp', 'ENPP'),
('essp', 2969, 'udp', 'ESSP'),
('index-net', 2970, 'udp', 'INDEX-NET'),
('netclip', 2971, 'udp', 'NetClip clipboard daemon'),
('pmsm-webrctl', 2972, 'udp', 'PMSM Webrctl'),
('svnetworks', 2973, 'udp', 'SV Networks'),
('signal', 2974, 'udp', 'Signal'),
('fjmpcm', 2975, 'udp', 'Fujitsu Configuration Management Service'),
('cns-srv-port', 2976, 'udp', 'CNS Server Port'),
('ttc-etap-ns', 2977, 'udp', 'TTCs Enterprise Test Access Protocol - NS'),
('ttc-etap-ds', 2978, 'udp', 'TTCs Enterprise Test Access Protocol - DS'),
('h263-video', 2979, 'udp', 'H.263 Video Streaming'),
('wimd', 2980, 'udp', 'Instant Messaging Service'),
('mylxamport', 2981, 'udp', 'MYLXAMPORT'),
('iwb-whiteboard', 2982, 'udp', 'IWB-WHITEBOARD'),
('netplan', 2983, 'udp', 'NETPLAN'),
('hpidsadmin', 2984, 'udp', 'HPIDSADMIN'),
('hpidsagent', 2985, 'udp', 'HPIDSAGENT'),
('stonefalls', 2986, 'udp', 'STONEFALLS'),
('identify', 2987, 'udp', 'identify'),
('hippad', 2988, 'udp', 'HIPPA Reporting Protocol'),
('zarkov', 2989, 'udp', 'ZARKOV'),
('boscap', 2990, 'udp', 'BOSCAP'),
('wkstn-mon', 2991, 'udp', 'WKSTN-MON'),
('itb301', 2992, 'udp', 'ITB301'),
('veritas-vis1', 2993, 'udp', 'VERITAS VIS1'),
('veritas-vis2', 2994, 'udp', 'VERITAS VIS2'),
('idrs', 2995, 'udp', 'IDRS'),
('vsixml', 2996, 'udp', 'vsixml'),
('rebol', 2997, 'udp', 'REBOL'),
('realsecure', 2998, 'udp', 'Real Secure'),
('remoteware-un', 2999, 'udp', 'RemoteWare Unassigned'),
('hbci', 3000, 'udp', 'HBCI'),
('remoteware-cl', 3000, 'udp', 'RemoteWare Client'),
('redwood-broker', 3001, 'udp', 'Redwood Broker'),
('exlm-agent', 3002, 'udp', 'EXLM Agent'),
('remoteware-srv', 3002, 'udp', 'RemoteWare Server'),
('cgms', 3003, 'udp', 'CGMS'),
('csoftragent', 3004, 'udp', 'Csoft Agent'),
('geniuslm', 3005, 'udp', 'Genius License Manager'),
('ii-admin', 3006, 'udp', 'Instant Internet Admin'),
('lotusmtap', 3007, 'udp', 'Lotus Mail Tracking Agent Protocol'),
('midnight-tech', 3008, 'udp', 'Midnight Technologies'),
('pxc-ntfy', 3009, 'udp', 'PXC-NTFY'),
('ping-pong', 3010, 'udp', 'Telerate Workstation'),
('trusted-web', 3011, 'udp', 'Trusted Web'),
('twsdss', 3012, 'udp', 'Trusted Web Client'),
('gilatskysurfer', 3013, 'udp', 'Gilat Sky Surfer'),
('broker_service', 3014, 'udp', 'Broker Service'),
('nati-dstp', 3015, 'udp', 'NATI DSTP'),
('notify_srvr', 3016, 'udp', 'Notify Server'),
('event_listener', 3017, 'udp', 'Event Listener'),
('srvc_registry', 3018, 'udp', 'Service Registry'),
('resource_mgr', 3019, 'udp', 'Resource Manager'),
('cifs', 3020, 'udp', 'CIFS'),
('agriserver', 3021, 'udp', 'AGRI Server'),
('csregagent', 3022, 'udp', 'CSREGAGENT'),
('magicnotes', 3023, 'udp', 'magicnotes'),
('nds_sso', 3024, 'udp', 'NDS_SSO'),
('arepa-raft', 3025, 'udp', 'Arepa Raft'),
('agri-gateway', 3026, 'udp', 'AGRI Gateway'),
('LiebDevMgmt_C', 3027, 'udp', 'LiebDevMgmt_C'),
('LiebDevMgmt_DM', 3028, 'udp', 'LiebDevMgmt_DM'),
('LiebDevMgmt_A', 3029, 'udp', 'LiebDevMgmt_A'),
('arepa-cas', 3030, 'udp', 'Arepa Cas'),
('eppc', 3031, 'udp', 'Remote AppleEvents/PPC Toolbox'),
('redwood-chat', 3032, 'udp', 'Redwood Chat'),
('pdb', 3033, 'udp', 'PDB'),
('osmosis-aeea', 3034, 'udp', 'Osmosis / Helix (R) AEEA Port'),
('fjsv-gssagt', 3035, 'udp', 'FJSV gssagt'),
('hagel-dump', 3036, 'udp', 'Hagel DUMP'),
('hp-san-mgmt', 3037, 'udp', 'HP SAN Mgmt'),
('santak-ups', 3038, 'udp', 'Santak UPS'),
('cogitate', 3039, 'udp', 'Cogitate, Inc.'),
('tomato-springs', 3040, 'udp', 'Tomato Springs'),
('di-traceware', 3041, 'udp', 'di-traceware'),
('journee', 3042, 'udp', 'journee'),
('brp', 3043, 'udp', 'BRP'),
('epp', 3044, 'udp', 'EndPoint Protocol'),
('responsenet', 3045, 'udp', 'ResponseNet'),
('di-ase', 3046, 'udp', 'di-ase'),
('hlserver', 3047, 'udp', 'Fast Security HL Server'),
('pctrader', 3048, 'udp', 'Sierra Net PC Trader'),
('nsws', 3049, 'udp', 'NSWS'),
('gds_db', 3050, 'udp', 'gds_db'),
('galaxy-server', 3051, 'udp', 'Galaxy Server'),
('apcpcns', 3052, 'udp', 'APCPCNS'),
('dsom-server', 3053, 'udp', 'dsom-server'),
('amt-cnf-prot', 3054, 'udp', 'AMT CNF PROT'),
('policyserver', 3055, 'udp', 'Policy Server'),
('cdl-server', 3056, 'udp', 'CDL Server'),
('goahead-fldup', 3057, 'udp', 'GoAhead FldUp'),
('videobeans', 3058, 'udp', 'videobeans'),
('qsoft', 3059, 'udp', 'qsoft'),
('interserver', 3060, 'udp', 'interserver'),
('cautcpd', 3061, 'udp', 'cautcpd'),
('ncacn-ip-tcp', 3062, 'udp', 'ncacn-ip-tcp'),
('ncadg-ip-udp', 3063, 'udp', 'ncadg-ip-udp'),
('rprt', 3064, 'udp', 'Remote Port Redirector'),
('slinterbase', 3065, 'udp', 'slinterbase'),
('netattachsdmp', 3066, 'udp', 'NETATTACHSDMP'),
('fjhpjp', 3067, 'udp', 'FJHPJP'),
('ls3bcast', 3068, 'udp', 'ls3 Broadcast'),
('ls3', 3069, 'udp', 'ls3'),
('mgxswitch', 3070, 'udp', 'MGXSWITCH'),
('csd-mgmt-port', 3071, 'udp', 'ContinuStor Manager Port'),
('csd-monitor', 3072, 'udp', 'ContinuStor Monitor Port'),
('vcrp', 3073, 'udp', 'Very simple chatroom prot'),
('xbox', 3074, 'udp', 'Xbox game port'),
('orbix-locator', 3075, 'udp', 'Orbix 2000 Locator'),
('orbix-config', 3076, 'udp', 'Orbix 2000 Config'),
('orbix-loc-ssl', 3077, 'udp', 'Orbix 2000 Locator SSL'),
('orbix-cfg-ssl', 3078, 'udp', 'Orbix 2000 Locator SSL'),
('lv-frontpanel', 3079, 'udp', 'LV Front Panel'),
('stm_pproc', 3080, 'udp', 'stm_pproc'),
('tl1-lv', 3081, 'udp', 'TL1-LV'),
('tl1-raw', 3082, 'udp', 'TL1-RAW'),
('tl1-telnet', 3083, 'udp', 'TL1-TELNET'),
('itm-mccs', 3084, 'udp', 'ITM-MCCS'),
('pcihreq', 3085, 'udp', 'PCIHReq'),
('jdl-dbkitchen', 3086, 'udp', 'JDL-DBKitchen'),
('asoki-sma', 3087, 'udp', 'Asoki SMA'),
('xdtp', 3088, 'udp', 'eXtensible Data Transfer Protocol'),
('ptk-alink', 3089, 'udp', 'ParaTek Agent Linking'),
('rtss', 3090, 'udp', 'Rappore Session Services'),
('1ci-smcs', 3091, 'udp', '1Ci Server Management'),
('njfss', 3092, 'udp', 'Netware sync services'),
('rapidmq-center', 3093, 'udp', 'Jiiva RapidMQ Center'),
('rapidmq-reg', 3094, 'udp', 'Jiiva RapidMQ Registry'),
('panasas', 3095, 'udp', 'Panasas rendevous port'),
('ndl-aps', 3096, 'udp', 'Active Print Server Port'),
('umm-port', 3098, 'udp', 'Universal Message Manager'),
('chmd', 3099, 'udp', 'CHIPSY Machine Daemon'),
('opcon-xps', 3100, 'udp', 'OpCon/xps'),
('hp-pxpib', 3101, 'udp', 'HP PolicyXpert PIB Server'),
('slslavemon', 3102, 'udp', 'SoftlinK Slave Mon Port'),
('autocuesmi', 3103, 'udp', 'Autocue SMI Protocol'),
('autocuetime', 3104, 'udp', 'Autocue Time Service'),
('cardbox', 3105, 'udp', 'Cardbox'),
('cardbox-http', 3106, 'udp', 'Cardbox HTTP'),
('business', 3107, 'udp', 'Business protocol'),
('geolocate', 3108, 'udp', 'Geolocate protocol'),
('personnel', 3109, 'udp', 'Personnel protocol'),
('sim-control', 3110, 'udp', 'simulator control port'),
('wsynch', 3111, 'udp', 'Web Synchronous Services'),
('ksysguard', 3112, 'udp', 'KDE System Guard'),
('cs-auth-svr', 3113, 'udp', 'CS-Authenticate Svr Port'),
('ccmad', 3114, 'udp', 'CCM AutoDiscover'),
('mctet-master', 3115, 'udp', 'MCTET Master'),
('mctet-gateway', 3116, 'udp', 'MCTET Gateway'),
('mctet-jserv', 3117, 'udp', 'MCTET Jserv'),
('pkagent', 3118, 'udp', 'PKAgent'),
('d2000kernel', 3119, 'udp', 'D2000 Kernel Port'),
('d2000webserver', 3120, 'udp', 'D2000 Webserver Port'),
('epp-temp', 3121, 'udp', 'Extensible Provisioning Protocol'),
('vtr-emulator', 3122, 'udp', 'MTI VTR Emulator port'),
('edix', 3123, 'udp', 'EDI Translation Protocol'),
('beacon-port', 3124, 'udp', 'Beacon Port'),
('a13-an', 3125, 'udp', 'A13-AN Interface'),
('ms-dotnetster', 3126, 'udp', 'Microsoft .NETster Port'),
('ctx-bridge', 3127, 'udp', 'CTX Bridge Port'),
('ndl-aas', 3128, 'udp', 'Active API Server Port'),
('netport-id', 3129, 'udp', 'NetPort Discovery Port'),
('icpv2', 3130, 'udp', 'ICPv2'),
('netbookmark', 3131, 'udp', 'Net Book Mark'),
('ms-slipstream', 3132, 'udp', 'MS-Slipstream'),
('prism-deploy', 3133, 'udp', 'Prism Deploy User Port'),
('ecp', 3134, 'udp', 'Extensible Code Protocol'),
('peerbook-port', 3135, 'udp', 'PeerBook Port'),
('grubd', 3136, 'udp', 'Grub Server Port'),
('rtnt-1', 3137, 'udp', 'rtnt-1 data packets'),
('rtnt-2', 3138, 'udp', 'rtnt-2 data packets'),
('incognitorv', 3139, 'udp', 'Incognito Rendez-Vous'),
('ariliamulti', 3140, 'udp', 'Arilia Multiplexor'),
('vmodem', 3141, 'udp', 'VMODEM'),
('rdc-wh-eos', 3142, 'udp', 'RDC WH EOS'),
('seaview', 3143, 'udp', 'Sea View'),
('tarantella', 3144, 'udp', 'Tarantella'),
('csi-lfap', 3145, 'udp', 'CSI-LFAP'),
('bears-02', 3146, 'udp', 'bears-02'),
('rfio', 3147, 'udp', 'RFIO'),
('nm-game-admin', 3148, 'udp', 'NetMike Game Administrator'),
('nm-game-server', 3149, 'udp', 'NetMike Game Server'),
('nm-asses-admin', 3150, 'udp', 'NetMike Assessor Administrator'),
('nm-assessor', 3151, 'udp', 'NetMike Assessor'),
('feitianrockey', 3152, 'udp', 'FeiTian Port'),
('s8-client-port', 3153, 'udp', 'S8Cargo Client Port'),
('ccmrmi', 3154, 'udp', 'ON RMI Registry'),
('jpegmpeg', 3155, 'udp', 'JpegMpeg Port'),
('indura', 3156, 'udp', 'Indura Collector'),
('e3consultants', 3157, 'udp', 'CCC Listener Port'),
('stvp', 3158, 'udp', 'SmashTV Protocol'),
('navegaweb-port', 3159, 'udp', 'NavegaWeb Tarification'),
('tip-app-server', 3160, 'udp', 'TIP Application Server'),
('doc1lm', 3161, 'udp', 'DOC1 License Manager'),
('sflm', 3162, 'udp', 'SFLM'),
('res-sap', 3163, 'udp', 'RES-SAP'),
('imprs', 3164, 'udp', 'IMPRS'),
('newgenpay', 3165, 'udp', 'Newgenpay Engine Service'),
('qrepos', 3166, 'udp', 'Quest Repository'),
('poweroncontact', 3167, 'udp', 'poweroncontact'),
('poweronnud', 3168, 'udp', 'poweronnud'),
('serverview-as', 3169, 'udp', 'SERVERVIEW-AS'),
('serverview-asn', 3170, 'udp', 'SERVERVIEW-ASN'),
('serverview-gf', 3171, 'udp', 'SERVERVIEW-GF'),
('serverview-rm', 3172, 'udp', 'SERVERVIEW-RM'),
('serverview-icc', 3173, 'udp', 'SERVERVIEW-ICC'),
('armi-server', 3174, 'udp', 'ARMI Server'),
('t1-e1-over-ip', 3175, 'udp', 'T1_E1_Over_IP'),
('ars-master', 3176, 'udp', 'ARS Master'),
('phonex-port', 3177, 'udp', 'Phonex Protocol'),
('radclientport', 3178, 'udp', 'Radiance UltraEdge Port'),
('h2gf-w-2m', 3179, 'udp', 'H2GF W.2m Handover prot.'),
('mc-brk-srv', 3180, 'udp', 'Millicent Broker Server'),
('bmcpatrolagent', 3181, 'udp', 'BMC Patrol Agent'),
('bmcpatrolrnvu', 3182, 'udp', 'BMC Patrol Rendezvous'),
('cops-tls', 3183, 'udp', 'COPS/TLS'),
('apogeex-port', 3184, 'udp', 'ApogeeX Port'),
('smpppd', 3185, 'udp', 'SuSE Meta PPPD'),
('iiw-port', 3186, 'udp', 'IIW Monitor User Port'),
('odi-port', 3187, 'udp', 'Open Design Listen Port'),
('brcm-comm-port', 3188, 'udp', 'Broadcom Port'),
('pcle-infex', 3189, 'udp', 'Pinnacle Sys InfEx Port'),
('csvr-proxy', 3190, 'udp', 'ConServR Proxy'),
('csvr-sslproxy', 3191, 'udp', 'ConServR SSL Proxy'),
('firemonrcc', 3192, 'udp', 'FireMon Revision Control'),
('cordataport', 3193, 'udp', 'Cordaxis Data Port'),
('magbind', 3194, 'udp', 'Rockstorm MAG protocol'),
('ncu-1', 3195, 'udp', 'Network Control Unit'),
('ncu-2', 3196, 'udp', 'Network Control Unit'),
('embrace-dp-s', 3197, 'udp', 'Embrace Device Protocol Server'),
('embrace-dp-c', 3198, 'udp', 'Embrace Device Protocol Client'),
('dmod-workspace', 3199, 'udp', 'DMOD WorkSpace'),
('tick-port', 3200, 'udp', 'Press-sense Tick Port'),
('cpq-tasksmart', 3201, 'udp', 'CPQ-TaskSmart'),
('intraintra', 3202, 'udp', 'IntraIntra'),
('netwatcher-mon', 3203, 'udp', 'Network Watcher Monitor'),
('netwatcher-db', 3204, 'udp', 'Network Watcher DB Access'),
('isns', 3205, 'udp', 'iSNS Server Port'),
('ironmail', 3206, 'udp', 'IronMail POP Proxy'),
('vx-auth-port', 3207, 'udp', 'Veritas Authentication Port'),
('pfu-prcallback', 3208, 'udp', 'PFU PR Callback'),
('netwkpathengine', 3209, 'udp', 'HP OpenView Network Path Engine Server'),
('flamenco-proxy', 3210, 'udp', 'Flamenco Networks Proxy'),
('avsecuremgmt', 3211, 'udp', 'Avocent Secure Management'),
('surveyinst', 3212, 'udp', 'Survey Instrument'),
('neon24x7', 3213, 'udp', 'NEON 24X7 Mission Control'),
('jmq-daemon-1', 3214, 'udp', 'JMQ Daemon Port 1'),
('jmq-daemon-2', 3215, 'udp', 'JMQ Daemon Port 2'),
('ferrari-foam', 3216, 'udp', 'Ferrari electronic FOAM'),
('unite', 3217, 'udp', 'Unified IP & Telecomm Env'),
('smartpackets', 3218, 'udp', 'EMC SmartPackets'),
('wms-messenger', 3219, 'udp', 'WMS Messenger'),
('xnm-ssl', 3220, 'udp', 'XML NM over SSL'),
('xnm-clear-text', 3221, 'udp', 'XML NM over TCP'),
('glbp', 3222, 'udp', 'Gateway Load Balancing Pr'),
('digivote', 3223, 'udp', 'DIGIVOTE (R) Vote-Server'),
('aes-discovery', 3224, 'udp', 'AES Discovery Port'),
('fcip-port', 3225, 'udp', 'FCIP'),
('isi-irp', 3226, 'udp', 'ISI Industry Software IRP'),
('dwnmshttp', 3227, 'udp', 'DiamondWave NMS Server'),
('dwmsgserver', 3228, 'udp', 'DiamondWave MSG Server'),
('global-cd-port', 3229, 'udp', 'Global CD Port'),
('sftdst-port', 3230, 'udp', 'Software Distributor Port'),
('dsnl', 3231, 'udp', 'Delta Solutions Direct'),
('mdtp', 3232, 'udp', 'MDT port'),
('whisker', 3233, 'udp', 'WhiskerControl main port'),
('alchemy', 3234, 'udp', 'Alchemy Server'),
('mdap-port', 3235, 'udp', 'MDAP Port'),
('apparenet-ts', 3236, 'udp', 'appareNet Test Server'),
('apparenet-tps', 3237, 'udp', 'appareNet Test Packet Sequencer'),
('apparenet-as', 3238, 'udp', 'appareNet Analysis Server'),
('apparenet-ui', 3239, 'udp', 'appareNet User Interface'),
('triomotion', 3240, 'udp', 'Trio Motion Control Port'),
('sysorb', 3241, 'udp', 'SysOrb Monitoring Server'),
('sdp-id-port', 3242, 'udp', 'Session Description ID'),
('timelot', 3243, 'udp', 'Timelot Port'),
('onesaf', 3244, 'udp', 'OneSAF'),
('vieo-fe', 3245, 'udp', 'VIEO Fabric Executive'),
('dvt-system', 3246, 'udp', 'DVT SYSTEM PORT'),
('dvt-data', 3247, 'udp', 'DVT DATA LINK'),
('procos-lm', 3248, 'udp', 'PROCOS LM'),
('ssp', 3249, 'udp', 'State Sync Protocol'),
('hicp', 3250, 'udp', 'HMS hicp port'),
('sysscanner', 3251, 'udp', 'Sys Scanner'),
('dhe', 3252, 'udp', 'DHE port'),
('pda-data', 3253, 'udp', 'PDA Data'),
('pda-sys', 3254, 'udp', 'PDA System'),
('semaphore', 3255, 'udp', 'Semaphore Connection Port'),
('cpqrpm-agent', 3256, 'udp', 'Compaq RPM Agent Port'),
('cpqrpm-server', 3257, 'udp', 'Compaq RPM Server Port'),
('ivecon-port', 3258, 'udp', 'Ivecon Server Port'),
('epncdp2', 3259, 'udp', 'Epson Network Common Devi'),
('iscsi-target', 3260, 'udp', 'iSCSI port'),
('winshadow', 3261, 'udp', 'winShadow'),
('necp', 3262, 'udp', 'NECP'),
('ecolor-imager', 3263, 'udp', 'E-Color Enterprise Imager'),
('ccmail', 3264, 'udp', 'cc:mail/lotus'),
('altav-tunnel', 3265, 'udp', 'Altav Tunnel'),
('ns-cfg-server', 3266, 'udp', 'NS CFG Server'),
('ibm-dial-out', 3267, 'udp', 'IBM Dial Out'),
('msft-gc', 3268, 'udp', 'Microsoft Global Catalog'),
('msft-gc-ssl', 3269, 'udp', 'Microsoft Global Catalog with LDAP/SSL'),
('verismart', 3270, 'udp', 'Verismart'),
('csoft-prev', 3271, 'udp', 'CSoft Prev Port'),
('user-manager', 3272, 'udp', 'Fujitsu User Manager'),
('sxmp', 3273, 'udp', 'Simple Extensible Multiplexed Protocol'),
('ordinox-server', 3274, 'udp', 'Ordinox Server'),
('samd', 3275, 'udp', 'SAMD'),
('maxim-asics', 3276, 'udp', 'Maxim ASICs'),
('awg-proxy', 3277, 'udp', 'AWG Proxy'),
('lkcmserver', 3278, 'udp', 'LKCM Server'),
('admind', 3279, 'udp', 'admind'),
('vs-server', 3280, 'udp', 'VS Server'),
('sysopt', 3281, 'udp', 'SYSOPT'),
('datusorb', 3282, 'udp', 'Datusorb'),
('net-assistant', 3283, 'udp', 'Net Assistant'),
('4talk', 3284, 'udp', '4Talk'),
('plato', 3285, 'udp', 'Plato'),
('e-net', 3286, 'udp', 'E-Net'),
('directvdata', 3287, 'udp', 'DIRECTVDATA'),
('cops', 3288, 'udp', 'COPS'),
('enpc', 3289, 'udp', 'ENPC'),
('caps-lm', 3290, 'udp', 'CAPS LOGISTICS TOOLKIT - LM'),
('sah-lm', 3291, 'udp', 'S A Holditch & Associates - LM'),
('cart-o-rama', 3292, 'udp', 'Cart O Rama'),
('fg-fps', 3293, 'udp', 'fg-fps'),
('fg-gip', 3294, 'udp', 'fg-gip'),
('dyniplookup', 3295, 'udp', 'Dynamic IP Lookup'),
('rib-slm', 3296, 'udp', 'Rib License Manager'),
('cytel-lm', 3297, 'udp', 'Cytel License Manager'),
('transview', 3298, 'udp', 'Transview'),
('pdrncs', 3299, 'udp', 'pdrncs'),
('mcs-fastmail', 3302, 'udp', 'MCS Fastmail'),
('opsession-clnt', 3303, 'udp', 'OP Session Client'),
('opsession-srvr', 3304, 'udp', 'OP Session Server'),
('odette-ftp', 3305, 'udp', 'ODETTE-FTP'),
('mysql', 3306, 'udp', 'MySQL'),
('opsession-prxy', 3307, 'udp', 'OP Session Proxy'),
('tns-server', 3308, 'udp', 'TNS Server'),
('tns-adv', 3309, 'udp', 'TNS ADV'),
('dyna-access', 3310, 'udp', 'Dyna Access'),
('mcns-tel-ret', 3311, 'udp', 'MCNS Tel Ret'),
('appman-server', 3312, 'udp', 'Application Management Server'),
('uorb', 3313, 'udp', 'Unify Object Broker'),
('uohost', 3314, 'udp', 'Unify Object Host'),
('cdid', 3315, 'udp', 'CDID'),
('aicc-cmi', 3316, 'udp', 'AICC/CMI'),
('vsaiport', 3317, 'udp', 'VSAI PORT'),
('ssrip', 3318, 'udp', 'Swith to Swith Routing Information Protocol'),
('sdt-lmd', 3319, 'udp', 'SDT License Manager'),
('officelink2000', 3320, 'udp', 'Office Link 2000'),
('vnsstr', 3321, 'udp', 'VNSSTR'),
('sftu', 3326, 'udp', 'SFTU'),
('bbars', 3327, 'udp', 'BBARS'),
('egptlm', 3328, 'udp', 'Eaglepoint License Manager'),
('hp-device-disc', 3329, 'udp', 'HP Device Disc'),
('mcs-calypsoicf', 3330, 'udp', 'MCS Calypso ICF'),
('mcs-messaging', 3331, 'udp', 'MCS Messaging'),
('mcs-mailsvr', 3332, 'udp', 'MCS Mail Server'),
('dec-notes', 3333, 'udp', 'DEC Notes'),
('directv-web', 3334, 'udp', 'Direct TV Webcasting'),
('directv-soft', 3335, 'udp', 'Direct TV Software Updates'),
('directv-tick', 3336, 'udp', 'Direct TV Tickers'),
('directv-catlg', 3337, 'udp', 'Direct TV Data Catalog'),
('anet-b', 3338, 'udp', 'OMF data b'),
('anet-l', 3339, 'udp', 'OMF data l'),
('anet-m', 3340, 'udp', 'OMF data m'),
('anet-h', 3341, 'udp', 'OMF data h'),
('webtie', 3342, 'udp', 'WebTIE'),
('ms-cluster-net', 3343, 'udp', 'MS Cluster Net'),
('bnt-manager', 3344, 'udp', 'BNT Manager'),
('influence', 3345, 'udp', 'Influence'),
('trnsprntproxy', 3346, 'udp', 'Trnsprnt Proxy'),
('phoenix-rpc', 3347, 'udp', 'Phoenix RPC'),
('pangolin-laser', 3348, 'udp', 'Pangolin Laser'),
('chevinservices', 3349, 'udp', 'Chevin Services'),
('findviatv', 3350, 'udp', 'FINDVIATV'),
('btrieve', 3351, 'udp', 'BTRIEVE'),
('ssql', 3352, 'udp', 'SSQL'),
('fatpipe', 3353, 'udp', 'FATPIPE'),
('suitjd', 3354, 'udp', 'SUITJD'),
('ordinox-dbase', 3355, 'udp', 'Ordinox Dbase'),
('upnotifyps', 3356, 'udp', 'UPNOTIFYPS'),
('adtech-test', 3357, 'udp', 'Adtech Test IP'),
('mpsysrmsvr', 3358, 'udp', 'Mp Sys Rmsvr'),
('wg-netforce', 3359, 'udp', 'WG NetForce'),
('kv-server', 3360, 'udp', 'KV Server'),
('kv-agent', 3361, 'udp', 'KV Agent'),
('dj-ilm', 3362, 'udp', 'DJ ILM'),
('nati-vi-server', 3363, 'udp', 'NATI Vi Server'),
('creativeserver', 3364, 'udp', 'Creative Server'),
('contentserver', 3365, 'udp', 'Content Server'),
('creativepartnr', 3366, 'udp', 'Creative Partner'),
('tip2', 3372, 'udp', 'TIP 2'),
('lavenir-lm', 3373, 'udp', 'Lavenir License Manager'),
('cluster-disc', 3374, 'udp', 'Cluster Disc'),
('vsnm-agent', 3375, 'udp', 'VSNM Agent'),
('cdbroker', 3376, 'udp', 'CD Broker'),
('cogsys-lm', 3377, 'udp', 'Cogsys Network License Manager'),
('wsicopy', 3378, 'udp', 'WSICOPY'),
('socorfs', 3379, 'udp', 'SOCORFS'),
('sns-channels', 3380, 'udp', 'SNS Channels'),
('geneous', 3381, 'udp', 'Geneous'),
('fujitsu-neat', 3382, 'udp', 'Fujitsu Network Enhanced Antitheft function'),
('esp-lm', 3383, 'udp', 'Enterprise Software Products License Manager'),
('hp-clic', 3384, 'udp', 'Hardware Management'),
('qnxnetman', 3385, 'udp', 'qnxnetman'),
('gprs-sig', 3386, 'udp', 'GPRS SIG'),
('backroomnet', 3387, 'udp', 'Back Room Net'),
('cbserver', 3388, 'udp', 'CB Server'),
('ms-wbt-server', 3389, 'udp', 'MS WBT Server'),
('dsc', 3390, 'udp', 'Distributed Service Coordinator'),
('savant', 3391, 'udp', 'SAVANT'),
('efi-lm', 3392, 'udp', 'EFI License Management'),
('d2k-tapestry1', 3393, 'udp', 'D2K Tapestry Client to Server'),
('d2k-tapestry2', 3394, 'udp', 'D2K Tapestry Server to Server'),
('dyna-lm', 3395, 'udp', 'Dyna License Manager (Elam)'),
('printer_agent', 3396, 'udp', 'Printer Agent'),
('cloanto-lm', 3397, 'udp', 'Cloanto License Manager'),
('mercantile', 3398, 'udp', 'Mercantile'),
('csms', 3399, 'udp', 'CSMS'),
('csms2', 3400, 'udp', 'CSMS2'),
('filecast', 3401, 'udp', 'filecast'),
('fxaengine-net', 3402, 'udp', 'FXa Engine Network Port'),
('copysnap', 3403, 'udp', 'CopySnap Server Port'),
('nokia-ann-ch1', 3405, 'udp', 'Nokia Announcement ch 1'),
('nokia-ann-ch2', 3406, 'udp', 'Nokia Announcement ch 2'),
('ldap-admin', 3407, 'udp', 'LDAP admin server port'),
('issapi', 3408, 'udp', 'POWERpack API Port'),
('networklens', 3409, 'udp', 'NetworkLens Event Port'),
('networklenss', 3410, 'udp', 'NetworkLens SSL Event'),
('biolink-auth', 3411, 'udp', 'BioLink Authenteon'),
('xmlblaster', 3412, 'udp', 'xmlBlaster'),
('svnet', 3413, 'udp', 'SpecView Networking'),
('wip-port', 3414, 'udp', 'BroadCloud WIP Port'),
('bcinameservice', 3415, 'udp', 'BCI Name Service'),
('commandport', 3416, 'udp', 'AirMobile IS Command Port'),
('csvr', 3417, 'udp', 'ConServR file translation'),
('rnmap', 3418, 'udp', 'Remote nmap'),
('softaudit', 3419, 'udp', 'ISogon SoftAudit'),
('ifcp-port', 3420, 'udp', 'iFCP User Port'),
('bmap', 3421, 'udp', 'Bull Apprise portmapper'),
('rusb-sys-port', 3422, 'udp', 'Remote USB System Port'),
('xtrm', 3423, 'udp', 'xTrade Reliable Messaging'),
('xtrms', 3424, 'udp', 'xTrade over TLS/SSL'),
('agps-port', 3425, 'udp', 'AGPS Access Port'),
('arkivio', 3426, 'udp', 'Arkivio Storage Protocol'),
('websphere-snmp', 3427, 'udp', 'WebSphere SNMP'),
('twcss', 3428, 'udp', '2Wire CSS'),
('gcsp', 3429, 'udp', 'GCSP user port'),
('ssdispatch', 3430, 'udp', 'Scott Studios Dispatch'),
('ndl-als', 3431, 'udp', 'Active License Server Port'),
('osdcp', 3432, 'udp', 'Secure Device Protocol'),
('alta-smp', 3433, 'udp', 'Altaworks Service Management Platform'),
('opencm', 3434, 'udp', 'OpenCM Server'),
('pacom', 3435, 'udp', 'Pacom Security User Port'),
('gc-config', 3436, 'udp', 'GuardControl Exchange Protocol'),
('autocueds', 3437, 'udp', 'Autocue Directory Service'),
('spiral-admin', 3438, 'udp', 'Spiralcraft Admin'),
('hri-port', 3439, 'udp', 'HRI Interface Port'),
('ans-console', 3440, 'udp', 'Net Steward Mgmt Console'),
('connect-client', 3441, 'udp', 'OC Connect Client'),
('connect-server', 3442, 'udp', 'OC Connect Server'),
('ov-nnm-websrv', 3443, 'udp', 'OpenView Network Node Manager WEB Server'),
('denali-server', 3444, 'udp', 'Denali Server'),
('monp', 3445, 'udp', 'Media Object Network'),
('3comfaxrpc', 3446, 'udp', '3Com FAX RPC port'),
('cddn', 3447, 'udp', 'CompuDuo DirectNet'),
('dnc-port', 3448, 'udp', 'Discovery and Net Config'),
('hotu-chat', 3449, 'udp', 'HotU Chat'),
('castorproxy', 3450, 'udp', 'CAStorProxy'),
('asam', 3451, 'udp', 'ASAM Services'),
('sabp-signal', 3452, 'udp', 'SABP-Signalling Protocol'),
('pscupd', 3453, 'udp', 'PSC Update Port'),
('prsvp', 3455, 'udp', 'RSVP Port'),
('vat', 3456, 'udp', 'VAT default data'),
('vat-control', 3457, 'udp', 'VAT default control'),
('d3winosfi', 3458, 'udp', 'D3WinOSFI'),
('integral', 3459, 'udp', 'TIP Integral'),
('edm-manager', 3460, 'udp', 'EDM Manger'),
('edm-stager', 3461, 'udp', 'EDM Stager'),
('edm-std-notify', 3462, 'udp', 'EDM STD Notify'),
('edm-adm-notify', 3463, 'udp', 'EDM ADM Notify'),
('edm-mgr-sync', 3464, 'udp', 'EDM MGR Sync'),
('edm-mgr-cntrl', 3465, 'udp', 'EDM MGR Cntrl'),
('workflow', 3466, 'udp', 'WORKFLOW'),
('rcst', 3467, 'udp', 'RCST'),
('ttcmremotectrl', 3468, 'udp', 'TTCM Remote Controll'),
('pluribus', 3469, 'udp', 'Pluribus'),
('jt400', 3470, 'udp', 'jt400'),
('jt400-ssl', 3471, 'udp', 'jt400-ssl'),
('jaugsremotec-1', 3472, 'udp', 'JAUGS N-G Remotec 1'),
('jaugsremotec-2', 3473, 'udp', 'JAUGS N-G Remotec 2'),
('ttntspauto', 3474, 'udp', 'TSP Automation'),
('genisar-port', 3475, 'udp', 'Genisar Comm Port'),
('nppmp', 3476, 'udp', 'NVIDIA Mgmt Protocol'),
('ecomm', 3477, 'udp', 'eComm link port'),
('nat-stun-port', 3478, 'udp', 'Simple Traversal of UDP Through NAT (STUN) port'),
('twrpc', 3479, 'udp', '2Wire RPC'),
('plethora', 3480, 'udp', 'Secure Virtual Workspace'),
('cleanerliverc', 3481, 'udp', 'CleanerLive remote ctrl'),
('vulture', 3482, 'udp', 'Vulture Monitoring System'),
('slim-devices', 3483, 'udp', 'Slim Devices Protocol'),
('gbs-stp', 3484, 'udp', 'GBS SnapTalk Protocol'),
('celatalk', 3485, 'udp', 'CelaTalk'),
('ifsf-hb-port', 3486, 'udp', 'IFSF Heartbeat Port'),
('ltcudp', 3487, 'udp', 'LISA UDP Transfer Channel'),
('fs-rh-srv', 3488, 'udp', 'FS Remote Host Server'),
('dtp-dia', 3489, 'udp', 'DTP/DIA'),
('colubris', 3490, 'udp', 'Colubris Management Port'),
('swr-port', 3491, 'udp', 'SWR Port'),
('tvdumtray-port', 3492, 'udp', 'TVDUM Tray Port'),
('nut', 3493, 'udp', 'Network UPS Tools'),
('ibm3494', 3494, 'udp', 'IBM 3494'),
('seclayer-tcp', 3495, 'udp', 'securitylayer over tcp'),
('seclayer-tls', 3496, 'udp', 'securitylayer over tls'),
('ipether232port', 3497, 'udp', 'ipEther232Port'),
('dashpas-port', 3498, 'udp', 'DASHPAS user port'),
('sccip-media', 3499, 'udp', 'SccIP Media'),
('rtmp-port', 3500, 'udp', 'RTMP Port'),
('isoft-p2p', 3501, 'udp', 'iSoft-P2P'),
('avinstalldisc', 3502, 'udp', 'Avocent Install Discovery'),
('lsp-ping', 3503, 'udp', 'MPLS LSP-echo Port'),
('ironstorm', 3504, 'udp', 'IronStorm game server'),
('ccmcomm', 3505, 'udp', 'CCM communications port'),
('apc-aem-status', 3506, 'udp', 'APC Device Status Port'),
('nesh-broker', 3507, 'udp', 'Nesh Broker Port'),
('interactionweb', 3508, 'udp', 'Interaction Web'),
('vt-ssl', 3509, 'udp', 'Virtual Token SSL Port'),
('xss-port', 3510, 'udp', 'XSS Port'),
('webmail-2', 3511, 'udp', 'WebMail/2'),
('aztec', 3512, 'udp', 'Aztec Distribution Port'),
('arcpd', 3513, 'udp', 'Adaptec Remote Protocol'),
('must-p2p', 3514, 'udp', 'MUST Peer to Peer'),
('must-backplane', 3515, 'udp', 'MUST Backplane'),
('smartcard-port', 3516, 'udp', 'Smartcard Port'),
('802-11-iapp', 3517, 'udp', 'IEEE 802.11 WLANs WG IAPP'),
('artifact-msg', 3518, 'udp', 'Artifact Message Server'),
('galileo', 3519, 'udp', 'Netvion Galileo Port'),
('galileolog', 3520, 'udp', 'Netvion Galileo Log Port'),
('mc3ss', 3521, 'udp', 'Telequip Labs MC3SS'),
('nssocketport', 3522, 'udp', 'DO over NSSocketPort'),
('odeumservlink', 3523, 'udp', 'Odeum Serverlink'),
('ecmport', 3524, 'udp', 'ECM Server port'),
('eisport', 3525, 'udp', 'EIS Server port'),
('starquiz-port', 3526, 'udp', 'starQuiz Port'),
('beserver-msg-q', 3527, 'udp', 'VERITAS Backup Exec Server'),
('jboss-iiop', 3528, 'udp', 'JBoss IIOP'),
('jboss-iiop-ssl', 3529, 'udp', 'JBoss IIOP/SSL'),
('gf', 3530, 'udp', 'Grid Friendly'),
('joltid', 3531, 'udp', 'Joltid'),
('raven-rmp', 3532, 'udp', 'Raven Remote Management Control'),
('raven-rdp', 3533, 'udp', 'Raven Remote Management Data'),
('urld-port', 3534, 'udp', 'URL Daemon Port'),
('ms-la', 3535, 'udp', 'MS-LA'),
('snac', 3536, 'udp', 'SNAC'),
('ni-visa-remote', 3537, 'udp', 'Remote NI-VISA port'),
('ibm-diradm', 3538, 'udp', 'IBM Directory Server'),
('ibm-diradm-ssl', 3539, 'udp', 'IBM Directory Server SSL'),
('pnrp-port', 3540, 'udp', 'PNRP User Port'),
('voispeed-port', 3541, 'udp', 'VoiSpeed Port'),
('hacl-monitor', 3542, 'udp', 'HA cluster monitor'),
('qftest-lookup', 3543, 'udp', 'qftest Lookup Port'),
('teredo', 3544, 'udp', 'Teredo Port'),
('camac', 3545, 'udp', 'CAMAC equipment'),
('kopek-httphead', 3546, 'udp', 'Kopek HTTP Head Port'),
('symantec-sim', 3547, 'udp', 'Symantec SIM'),
('interworld', 3548, 'udp', 'Interworld'),
('tellumat-nms', 3549, 'udp', 'Tellumat MDR NMS'),
('ssmpp', 3550, 'udp', 'Secure SMPP'),
('apcupsd', 3551, 'udp', 'Apcupsd Information Port'),
('taserver', 3552, 'udp', 'TeamAgenda Server Port'),
('rbr-discovery', 3553, 'udp', 'Red Box Recorder ADP'),
('questnotify', 3554, 'udp', 'Quest Notification Server'),
('razor', 3555, 'udp', 'Vipuls Razor'),
('sky-transport', 3556, 'udp', 'Sky Transport Protocol'),
('personalos-001', 3557, 'udp', 'PersonalOS Comm Port'),
('mcp-port', 3558, 'udp', 'MCP user port'),
('cctv-port', 3559, 'udp', 'CCTV control port'),
('iniserve-port', 3560, 'udp', 'INIServe port'),
('bmc-onekey', 3561, 'udp', 'BMC-OneKey'),
('sdbproxy', 3562, 'udp', 'SDBProxy'),
('watcomdebug', 3563, 'udp', 'Watcom Debug'),
('esimport', 3564, 'udp', 'Electromed SIM port'),
('qsintelliagent', 3566, 'udp', 'Quest Intelliagent'),
('emware-oft', 3567, 'udp', 'emWare OFT Services'),
('gamesmith-port', 3568, 'udp', 'GameSmith Port'),
('mbg-ctrl', 3569, 'udp', 'Meinberg Control Service'),
('mccwebsvr-port', 3570, 'udp', 'MCC Web Server Port'),
('megardsvr-port', 3571, 'udp', 'MegaRAID Server Port'),
('megaregsvrport', 3572, 'udp', 'Registration Server Port'),
('tag-ups-1', 3573, 'udp', 'Advantage Group UPS Suite'),
('dmaf-caster', 3574, 'udp', 'DMAF Caster'),
('ccm-port', 3575, 'udp', 'Coalsere CCM Port'),
('cmc-port', 3576, 'udp', 'Coalsere CMC Port'),
('config-port', 3577, 'udp', 'Configuration Port'),
('data-port', 3578, 'udp', 'Data Port'),
('ttat3lb', 3579, 'udp', 'Tarantella Load Balancing'),
('sharp-server', 3617, 'udp', 'ATI SHARP Logic Engine'),
('lispworks-orb', 3672, 'udp', 'LispWorks ORB'),
('ca-idms', 3709, 'udp', 'CA-IDMS Server'),
('sphidia-port', 3737, 'udp', 'Sphidia Game Port'),
('vhd', 3802, 'udp', 'VHD'),
('v-one-spp', 3845, 'udp', 'V-ONE Single Port Proxy'),
('giga-pocket', 3862, 'udp', 'GIGA-POCKET'),
('pnbscada', 3875, 'udp', 'PNBSCADA'),
('topflow-ssl', 3885, 'udp', 'TopFlow SSL'),
('udt_os', 3900, 'udp', 'Unidata UDT OS'),
('aamp', 3939, 'udp', 'Anti-virus Application Management Port'),
('mapper-nodemgr', 3984, 'udp', 'MAPPER network node manager'),
('mapper-mapethd', 3985, 'udp', 'MAPPER TCP/IP server'),
('mapper-ws_ethd', 3986, 'udp', 'MAPPER workstation server'),
('centerline', 3987, 'udp', 'Centerline'),
('terabase', 4000, 'udp', 'Terabase'),
('newoak', 4001, 'udp', 'NewOak'),
('pxc-spvr-ft', 4002, 'udp', 'pxc-spvr-ft'),
('pxc-splr-ft', 4003, 'udp', 'pxc-splr-ft'),
('pxc-roid', 4004, 'udp', 'pxc-roid'),
('pxc-pin', 4005, 'udp', 'pxc-pin'),
('pxc-spvr', 4006, 'udp', 'pxc-spvr'),
('pxc-splr', 4007, 'udp', 'pxc-splr'),
('netcheque', 4008, 'udp', 'NetCheque accounting'),
('chimera-hwm', 4009, 'udp', 'Chimera HWM'),
('samsung-unidex', 4010, 'udp', 'Samsung Unidex'),
('altserviceboot', 4011, 'udp', 'Alternate Service Boot'),
('pda-gate', 4012, 'udp', 'PDA Gate'),
('acl-manager', 4013, 'udp', 'ACL Manager'),
('taiclock', 4014, 'udp', 'TAICLOCK'),
('talarian-mcast1', 4015, 'udp', 'Talarian Mcast'),
('talarian-mcast2', 4016, 'udp', 'Talarian Mcast'),
('talarian-mcast3', 4017, 'udp', 'Talarian Mcast'),
('talarian-mcast4', 4018, 'udp', 'Talarian Mcast'),
('talarian-mcast5', 4019, 'udp', 'Talarian Mcast'),
('trap', 4020, 'udp', 'TRAP Port'),
('nexus-portal', 4021, 'udp', 'Nexus Portal'),
('dnox', 4022, 'udp', 'DNOX'),
('esnm-zoning', 4023, 'udp', 'ESNM Zoning Port'),
('tnp1-port', 4024, 'udp', 'TNP1 User Port'),
('partimage', 4025, 'udp', 'Partition Image Port'),
('as-debug', 4026, 'udp', 'Graphical Debug Server'),
('bxp', 4027, 'udp', 'bitxpress'),
('dtserver-port', 4028, 'udp', 'DTServer Port'),
('ip-qsig', 4029, 'udp', 'IP Q signaling protocol'),
('suucp', 4031, 'udp', 'UUCP over SSL'),
('vrts-auth-port', 4032, 'udp', 'VERITAS Authorize Server'),
('sanavigator', 4033, 'udp', 'SANavigator Peer Port'),
('ubxd', 4034, 'udp', 'Ubiquinox Daemon'),
('wap-push-http', 4035, 'udp', 'WAP Push OTA-HTTP port'),
('wap-push-https', 4036, 'udp', 'WAP Push OTA-HTTP secure'),
('yo-main', 4040, 'udp', 'Yo.net main service'),
('houston', 4041, 'udp', 'Rocketeer-Houston'),
('ldxp', 4042, 'udp', 'LDXP'),
('bre', 4096, 'udp', 'BRE (Bridge Relay Element)'),
('patrolview', 4097, 'udp', 'Patrol View'),
('drmsfsd', 4098, 'udp', 'drmsfsd'),
('dpcp', 4099, 'udp', 'DPCP'),
('igo-incognito', 4100, 'udp', 'IGo Incognito Data Port'),
('nuts_dem', 4132, 'udp', 'NUTS Daemon'),
('nuts_bootp', 4133, 'udp', 'NUTS Bootp Server'),
('nifty-hmi', 4134, 'udp', 'NIFTY-Serve HMI protocol'),
('oirtgsvc', 4141, 'udp', 'Workflow Server'),
('oidocsvc', 4142, 'udp', 'Document Server'),
('oidsr', 4143, 'udp', 'Document Replication'),
('vvr-control', 4145, 'udp', 'VVR Control'),
('jini-discovery', 4160, 'udp', 'Jini Discovery'),
('eims-admin', 4199, 'udp', 'EIMS ADMIN'),
('corelccam', 4300, 'udp', 'Corel CCam'),
('rwhois', 4321, 'udp', 'Remote Who Is'),
('unicall', 4343, 'udp', 'UNICALL'),
('vinainstall', 4344, 'udp', 'VinaInstall'),
('m4-network-as', 4345, 'udp', 'Macro 4 Network AS'),
('elanlm', 4346, 'udp', 'ELAN LM'),
('lansurveyor', 4347, 'udp', 'LAN Surveyor'),
('itose', 4348, 'udp', 'ITOSE'),
('fsportmap', 4349, 'udp', 'File System Port Map'),
('net-device', 4350, 'udp', 'Net Device'),
('plcy-net-svcs', 4351, 'udp', 'PLCY Net Services'),
('f5-iquery', 4353, 'udp', 'F5 iQuery'),
('qsnet-trans', 4354, 'udp', 'QSNet Transmitter'),
('qsnet-workst', 4355, 'udp', 'QSNet Workstation'),
('qsnet-assist', 4356, 'udp', 'QSNet Assistant'),
('qsnet-cond', 4357, 'udp', 'QSNet Conductor'),
('qsnet-nucl', 4358, 'udp', 'QSNet Nucleus'),
('saris', 4442, 'udp', 'Saris'),
('pharos', 4443, 'udp', 'Pharos'),
('krb524', 4444, 'udp', 'KRB524'),
('nv-video', 4444, 'udp', 'NV Video default'),
('upnotifyp', 4445, 'udp', 'UPNOTIFYP'),
('n1-fwp', 4446, 'udp', 'N1-FWP'),
('n1-rmgmt', 4447, 'udp', 'N1-RMGMT'),
('asc-slmd', 4448, 'udp', 'ASC Licence Manager'),
('privatewire', 4449, 'udp', 'PrivateWire'),
('camp', 4450, 'udp', 'Camp'),
('ctisystemmsg', 4451, 'udp', 'CTI System Msg'),
('ctiprogramload', 4452, 'udp', 'CTI Program Load'),
('nssalertmgr', 4453, 'udp', 'NSS Alert Manager'),
('nssagentmgr', 4454, 'udp', 'NSS Agent Manager'),
('prchat-user', 4455, 'udp', 'PR Chat User'),
('prchat-server', 4456, 'udp', 'PR Chat Server'),
('prRegister', 4457, 'udp', 'PR Register'),
('ipsec-msft', 4500, 'udp', 'Microsoft IPsec NAT-T'),
('worldscores', 4545, 'udp', 'WorldScores'),
('sf-lm', 4546, 'udp', 'SF License Manager (Sentinel)'),
('lanner-lm', 4547, 'udp', 'Lanner License Manager'),
('rsip', 4555, 'udp', 'RSIP Port'),
('hylafax', 4559, 'udp', 'HylaFAX'),
('tram', 4567, 'udp', 'TRAM'),
('bmc-reporting', 4568, 'udp', 'BMC Reporting'),
('piranha1', 4600, 'udp', 'Piranha1'),
('piranha2', 4601, 'udp', 'Piranha2'),
('smaclmgr', 4660, 'udp', 'smaclmgr'),
('kar2ouche', 4661, 'udp', 'Kar2ouche Peer location service'),
('rfa', 4672, 'udp', 'remote file access server'),
('snap', 4752, 'udp', 'Simple Network Audio Protocol'),
('iims', 4800, 'udp', 'Icona Instant Messenging System'),
('iwec', 4801, 'udp', 'Icona Web Embedded Chat'),
('ilss', 4802, 'udp', 'Icona License System Server'),
('htcp', 4827, 'udp', 'HTCP'),
('varadero-0', 4837, 'udp', 'Varadero-0'),
('varadero-1', 4838, 'udp', 'Varadero-1'),
('varadero-2', 4839, 'udp', 'Varadero-2'),
('appserv-http', 4848, 'udp', 'App Server - Admin HTTP'),
('appserv-https', 4849, 'udp', 'App Server - Admin HTTPS'),
('phrelay', 4868, 'udp', 'Photon Relay'),
('phrelaydbg', 4869, 'udp', 'Photon Relay Debug'),
('abbs', 4885, 'udp', 'ABBS'),
('lyskom', 4894, 'udp', 'LysKOM Protocol A'),
('att-intercom', 4983, 'udp', 'AT&T Intercom'),
('smar-se-port1', 4987, 'udp', 'SMAR Ethernet Port 1'),
('smar-se-port2', 4988, 'udp', 'SMAR Ethernet Port 2'),
('commplex-main', 5000, 'udp', ''),
('commplex-link', 5001, 'udp', ''),
('rfe', 5002, 'udp', 'radio free ethernet'),
('fmpro-internal', 5003, 'udp', 'FileMaker, Inc. - Proprietary name binding'),
('avt-profile-1', 5004, 'udp', 'avt-profile-1'),
('avt-profile-2', 5005, 'udp', 'avt-profile-2'),
('wsm-server', 5006, 'udp', 'wsm server'),
('wsm-server-ssl', 5007, 'udp', 'wsm server ssl'),
('synapsis-edge', 5008, 'udp', 'Synapsis EDGE'),
('telelpathstart', 5010, 'udp', 'TelepathStart'),
('telelpathattack', 5011, 'udp', 'TelepathAttack'),
('zenginkyo-1', 5020, 'udp', 'zenginkyo-1'),
('zenginkyo-2', 5021, 'udp', 'zenginkyo-2'),
('mice', 5022, 'udp', 'mice server'),
('htuilsrv', 5023, 'udp', 'Htuil Server for PLD2'),
('asnaacceler8db', 5042, 'udp', 'asnaacceler8db'),
('mmcc', 5050, 'udp', 'multimedia conference control tool'),
('ita-agent', 5051, 'udp', 'ITA Agent'),
('ita-manager', 5052, 'udp', 'ITA Manager'),
('unot', 5055, 'udp', 'UNOT'),
('intecom-ps1', 5056, 'udp', 'Intecom PS 1'),
('intecom-ps2', 5057, 'udp', 'Intecom PS 2'),
('sip', 5060, 'udp', 'SIP'),
('sip-tls', 5061, 'udp', 'SIP-TLS'),
('ca-1', 5064, 'udp', 'Channel Access 1'),
('ca-2', 5065, 'udp', 'Channel Access 2'),
('stanag-5066', 5066, 'udp', 'STANAG-5066-SUBNET-INTF'),
('i-net-2000-npr', 5069, 'udp', 'I/Net 2000-NPR'),
('powerschool', 5071, 'udp', 'PowerSchool'),
('sdl-ets', 5081, 'udp', 'SDL - Ent Trans Server'),
('sentinel-lm', 5093, 'udp', 'Sentinel LM'),
('sentlm-srv2srv', 5099, 'udp', 'SentLM Srv2Srv'),
('talarian-udp', 5101, 'udp', 'Talarian_UDP'),
('ctsd', 5137, 'udp', 'MyCTS server port'),
('rmonitor_secure', 5145, 'udp', 'RMONITOR SECURE'),
('atmp', 5150, 'udp', 'Ascend Tunnel Management Protocol'),
('esri_sde', 5151, 'udp', 'ESRI SDE Remote Start'),
('sde-discovery', 5152, 'udp', 'ESRI SDE Instance Discovery'),
('ife_icorp', 5165, 'udp', 'ife_1corp'),
('aol', 5190, 'udp', 'America-Online'),
('aol-1', 5191, 'udp', 'AmericaOnline1'),
('aol-2', 5192, 'udp', 'AmericaOnline2'),
('aol-3', 5193, 'udp', 'AmericaOnline3'),
('targus-getdata', 5200, 'udp', 'TARGUS GetData'),
('targus-getdata1', 5201, 'udp', 'TARGUS GetData 1'),
('targus-getdata2', 5202, 'udp', 'TARGUS GetData 2'),
('targus-getdata3', 5203, 'udp', 'TARGUS GetData 3'),
('jabber-client', 5222, 'udp', 'Jabber Client Connection'),
('hp-server', 5225, 'udp', 'HP Server'),
('hp-status', 5226, 'udp', 'HP Status'),
('padl2sim', 5236, 'udp', ''),
('igateway', 5250, 'udp', 'iGateway'),
('jabber-server', 5269, 'udp', 'Jabber Server Connection'),
('pk', 5272, 'udp', 'PK'),
('transmit-port', 5282, 'udp', 'Marimba Transmitter Port'),
('hacl-hb', 5300, 'udp', '# HA cluster heartbeat'),
('hacl-gs', 5301, 'udp', '# HA cluster general services'),
('hacl-cfg', 5302, 'udp', '# HA cluster configuration'),
('hacl-probe', 5303, 'udp', '# HA cluster probing'),
('hacl-local', 5304, 'udp', ''),
('hacl-test', 5305, 'udp', ''),
('sun-mc-grp', 5306, 'udp', 'Sun MC Group'),
('sco-aip', 5307, 'udp', 'SCO AIP'),
('cfengine', 5308, 'udp', 'CFengine'),
('jprinter', 5309, 'udp', 'J Printer'),
('outlaws', 5310, 'udp', 'Outlaws'),
('tmlogin', 5311, 'udp', 'TM Login'),
('opalis-rbt-ipc', 5314, 'udp', 'opalis-rbt-ipc'),
('hacl-poll', 5315, 'udp', 'HA Cluster UDP Polling'),
('mdns', 5353, 'udp', 'Multicast DNS'),
('excerpt', 5400, 'udp', 'Excerpt Search'),
('excerpts', 5401, 'udp', 'Excerpt Search Secure'),
('mftp', 5402, 'udp', 'MFTP'),
('hpoms-ci-lstn', 5403, 'udp', 'HPOMS-CI-LSTN'),
('hpoms-dps-lstn', 5404, 'udp', 'HPOMS-DPS-LSTN'),
('netsupport', 5405, 'udp', 'NetSupport'),
('systemics-sox', 5406, 'udp', 'Systemics Sox'),
('foresyte-clear', 5407, 'udp', 'Foresyte-Clear'),
('foresyte-sec', 5408, 'udp', 'Foresyte-Sec'),
('salient-dtasrv', 5409, 'udp', 'Salient Data Server'),
('salient-usrmgr', 5410, 'udp', 'Salient User Manager'),
('actnet', 5411, 'udp', 'ActNet'),
('continuus', 5412, 'udp', 'Continuus'),
('wwiotalk', 5413, 'udp', 'WWIOTALK'),
('statusd', 5414, 'udp', 'StatusD'),
('ns-server', 5415, 'udp', 'NS Server'),
('sns-gateway', 5416, 'udp', 'SNS Gateway'),
('sns-agent', 5417, 'udp', 'SNS Agent'),
('mcntp', 5418, 'udp', 'MCNTP'),
('dj-ice', 5419, 'udp', 'DJ-ICE'),
('cylink-c', 5420, 'udp', 'Cylink-C'),
('netsupport2', 5421, 'udp', 'Net Support 2'),
('salient-mux', 5422, 'udp', 'Salient MUX'),
('virtualuser', 5423, 'udp', 'VIRTUALUSER'),
('devbasic', 5426, 'udp', 'DEVBASIC'),
('sco-peer-tta', 5427, 'udp', 'SCO-PEER-TTA'),
('telaconsole', 5428, 'udp', 'TELACONSOLE'),
('base', 5429, 'udp', 'Billing and Accounting System Exchange'),
('radec-corp', 5430, 'udp', 'RADEC CORP'),
('park-agent', 5431, 'udp', 'PARK AGENT'),
('postgresql', 5432, 'udp', 'PostgreSQL Database'),
('dttl', 5435, 'udp', 'Data Tunneling Transceiver Linking (DTTL)'),
('apc-tcp-udp-4', 5454, 'udp', 'apc-tcp-udp-4'),
('apc-tcp-udp-5', 5455, 'udp', 'apc-tcp-udp-5'),
('apc-tcp-udp-6', 5456, 'udp', 'apc-tcp-udp-6'),
('silkmeter', 5461, 'udp', 'SILKMETER'),
('ttl-publisher', 5462, 'udp', 'TTL Publisher'),
('ttlpriceproxy', 5463, 'udp', 'TTL Price Proxy'),
('netops-broker', 5465, 'udp', 'NETOPS-BROKER'),
('fcp-addr-srvr1', 5500, 'udp', 'fcp-addr-srvr1'),
('fcp-addr-srvr2', 5501, 'udp', 'fcp-addr-srvr2'),
('fcp-srvr-inst1', 5502, 'udp', 'fcp-srvr-inst1'),
('fcp-srvr-inst2', 5503, 'udp', 'fcp-srvr-inst2'),
('fcp-cics-gw1', 5504, 'udp', 'fcp-cics-gw1'),
('sgi-esphttp', 5554, 'udp', 'SGI ESP HTTP'),
('personal-agent', 5555, 'udp', 'Personal Agent'),
('udpplus', 5566, 'udp', 'UDPPlus'),
('esinstall', 5599, 'udp', 'Enterprise Security Remote Install'),
('esmmanager', 5600, 'udp', 'Enterprise Security Manager'),
('esmagent', 5601, 'udp', 'Enterprise Security Agent'),
('a1-msc', 5602, 'udp', 'A1-MSC'),
('a1-bs', 5603, 'udp', 'A1-BS'),
('a3-sdunode', 5604, 'udp', 'A3-SDUNode'),
('a4-sdunode', 5605, 'udp', 'A4-SDUNode'),
('pcanywheredata', 5631, 'udp', 'pcANYWHEREdata'),
('pcanywherestat', 5632, 'udp', 'pcANYWHEREstat'),
('jms', 5673, 'udp', 'JACL Message Server'),
('hyperscsi-port', 5674, 'udp', 'HyperSCSI Port'),
('v5ua', 5675, 'udp', 'V5UA application port'),
('raadmin', 5676, 'udp', 'RA Administration'),
('questdb2-lnchr', 5677, 'udp', 'Quest Central DB2 Launchr'),
('rrac', 5678, 'udp', 'Remote Replication Agent Connection'),
('dccm', 5679, 'udp', 'Direct Cable Connect Manager'),
('proshareaudio', 5713, 'udp', 'proshare conf audio'),
('prosharevideo', 5714, 'udp', 'proshare conf video'),
('prosharedata', 5715, 'udp', 'proshare conf data'),
('prosharerequest', 5716, 'udp', 'proshare conf request'),
('prosharenotify', 5717, 'udp', 'proshare conf notify'),
('openmail', 5729, 'udp', 'Openmail User Agent Layer'),
('unieng', 5730, 'udp', 'Steltors calendar access'),
('ida-discover1', 5741, 'udp', 'IDA Discover Port 1'),
('ida-discover2', 5742, 'udp', 'IDA Discover Port 2'),
('fcopy-server', 5745, 'udp', 'fcopy-server'),
('fcopys-server', 5746, 'udp', 'fcopys-server'),
('openmailg', 5755, 'udp', 'OpenMail Desk Gateway server'),
('x500ms', 5757, 'udp', 'OpenMail X.500 Directory Server'),
('openmailns', 5766, 'udp', 'OpenMail NewMail Server'),
('s-openmail', 5767, 'udp', 'OpenMail Suer Agent Layer (Secure)'),
('openmailpxy', 5768, 'udp', 'OpenMail CMTS Server'),
('netagent', 5771, 'udp', 'NetAgent'),
('icmpd', 5813, 'udp', 'ICMPD'),
('wherehoo', 5859, 'udp', 'WHEREHOO'),
('mppolicy-v5', 5968, 'udp', 'mppolicy-v5'),
('mppolicy-mgr', 5969, 'udp', 'mppolicy-mgr'),
('wbem-rmi', 5987, 'udp', 'WBEM RMI'),
('wbem-http', 5988, 'udp', 'WBEM HTTP'),
('wbem-https', 5989, 'udp', 'WBEM HTTPS'),
('wbem-local', 5990, 'udp', 'HP WBEM Local Connection'),
('nuxsl', 5991, 'udp', 'NUXSL'),
('cvsup', 5999, 'udp', 'CVSup'),
('x11', -63, 'udp', 'X Window System'),
('ndl-ahp-svc', 6064, 'udp', 'NDL-AHP-SVC'),
('winpharaoh', 6065, 'udp', 'WinPharaoh'),
('ewctsp', 6066, 'udp', 'EWCTSP'),
('srb', 6067, 'udp', 'SRB'),
('gsmp', 6068, 'udp', 'GSMP'),
('trip', 6069, 'udp', 'TRIP'),
('messageasap', 6070, 'udp', 'Messageasap'),
('ssdtp', 6071, 'udp', 'SSDTP'),
('diagnose-proc', 6072, 'udp', 'DIAGNOSE-PROC'),
('directplay8', 6073, 'udp', 'DirectPlay8'),
('synchronet-db', 6100, 'udp', 'SynchroNet-db'),
('synchronet-rtc', 6101, 'udp', 'SynchroNet-rtc'),
('synchronet-upd', 6102, 'udp', 'SynchroNet-upd'),
('rets', 6103, 'udp', 'RETS'),
('dbdb', 6104, 'udp', 'DBDB'),
('primaserver', 6105, 'udp', 'Prima Server'),
('mpsserver', 6106, 'udp', 'MPS Server'),
('etc-control', 6107, 'udp', 'ETC Control'),
('sercomm-scadmin', 6108, 'udp', 'Sercomm-SCAdmin'),
('globecast-id', 6109, 'udp', 'GLOBECAST-ID'),
('softcm', 6110, 'udp', 'HP SoftBench CM'),
('spc', 6111, 'udp', 'HP SoftBench Sub-Process Control'),
('dtspcd', 6112, 'udp', 'dtspcd'),
('backup-express', 6123, 'udp', 'Backup Express'),
('meta-corp', 6141, 'udp', 'Meta Corporation License Manager'),
('aspentec-lm', 6142, 'udp', 'Aspen Technology License Manager'),
('watershed-lm', 6143, 'udp', 'Watershed License Manager'),
('statsci1-lm', 6144, 'udp', 'StatSci License Manager - 1'),
('statsci2-lm', 6145, 'udp', 'StatSci License Manager - 2'),
('lonewolf-lm', 6146, 'udp', 'Lone Wolf Systems License Manager'),
('montage-lm', 6147, 'udp', 'Montage License Manager'),
('ricardo-lm', 6148, 'udp', 'Ricardo North America License Manager'),
('tal-pod', 6149, 'udp', 'tal-pod'),
('crip', 6253, 'udp', 'CRIP'),
('bmc-grx', 6300, 'udp', 'BMC GRX'),
('emp-server1', 6321, 'udp', 'Empress Software Connectivity Server 1'),
('emp-server2', 6322, 'udp', 'Empress Software Connectivity Server 2'),
('gnutella-svc', 6346, 'udp', 'gnutella-svc'),
('gnutella-rtr', 6347, 'udp', 'gnutella-rtr'),
('metatude-mds', 6382, 'udp', 'Metatude Dialogue Server'),
('clariion-evr01', 6389, 'udp', 'clariion-evr01'),
('lvision-lm', 6471, 'udp', 'LVision License Manager'),
('boks', 6500, 'udp', 'BoKS Master'),
('boks_servc', 6501, 'udp', 'BoKS Servc'),
('boks_servm', 6502, 'udp', 'BoKS Servm'),
('boks_clntd', 6503, 'udp', 'BoKS Clntd'),
('badm_priv', 6505, 'udp', 'BoKS Admin Private Port'),
('badm_pub', 6506, 'udp', 'BoKS Admin Public Port'),
('bdir_priv', 6507, 'udp', 'BoKS Dir Server, Private Port'),
('bdir_pub', 6508, 'udp', 'BoKS Dir Server, Public Port'),
('mgcs-mfp-port', 6509, 'udp', 'MGCS-MFP Port'),
('mcer-port', 6510, 'udp', 'MCER Port'),
('apc-tcp-udp-1', 6547, 'udp', 'apc-tcp-udp-1'),
('apc-tcp-udp-2', 6548, 'udp', 'apc-tcp-udp-2'),
('apc-tcp-udp-3', 6549, 'udp', 'apc-tcp-udp-3'),
('fg-sysupdate', 6550, 'udp', 'fg-sysupdate'),
('xdsxdm', 6558, 'udp', ''),
('parsec-master', 6580, 'udp', 'Parsec Masterserver'),
('parsec-peer', 6581, 'udp', 'Parsec Peer-to-Peer'),
('parsec-game', 6582, 'udp', 'Parsec Gameserver'),
('ircu', -4, 'udp', 'IRCU'),
('vocaltec-gold', 6670, 'udp', 'Vocaltec Global Online Directory'),
('vision_server', 6672, 'udp', 'vision_server'),
('vision_elmd', 6673, 'udp', 'vision_elmd'),
('kti-icad-srvr', 6701, 'udp', 'KTI/ICAD Nameserver'),
('ibprotocol', 6714, 'udp', 'Internet Backplane Protocol'),
('bmc-perf-agent', 6767, 'udp', 'BMC PERFORM AGENT'),
('bmc-perf-mgrd', 6768, 'udp', 'BMC PERFORM MGRD'),
('smc-https', 6789, 'udp', 'SMC-HTTPS'),
('hnmp', 6790, 'udp', 'HNMP'),
('ambit-lm', 6831, 'udp', 'ambit-lm'),
('netmo-default', 6841, 'udp', 'Netmo Default'),
('netmo-http', 6842, 'udp', 'Netmo HTTP'),
('iccrushmore', 6850, 'udp', 'ICCRUSHMORE'),
('muse', 6888, 'udp', 'MUSE'),
('jmact3', 6961, 'udp', 'JMACT3'),
('jmevt2', 6962, 'udp', 'jmevt2'),
('swismgr1', 6963, 'udp', 'swismgr1'),
('swismgr2', 6964, 'udp', 'swismgr2'),
('swistrap', 6965, 'udp', 'swistrap'),
('swispol', 6966, 'udp', 'swispol'),
('acmsoda', 6969, 'udp', 'acmsoda'),
('iatp-highpri', 6998, 'udp', 'IATP-highPri'),
('iatp-normalpri', 6999, 'udp', 'IATP-normalPri'),
('afs3-fileserver', 7000, 'udp', 'file server itself'),
('afs3-callback', 7001, 'udp', 'callbacks to cache managers'),
('afs3-prserver', 7002, 'udp', 'users & groups database'),
('afs3-vlserver', 7003, 'udp', 'volume location database'),
('afs3-kaserver', 7004, 'udp', 'AFS/Kerberos authentication service'),
('afs3-volser', 7005, 'udp', 'volume managment server'),
('afs3-errors', 7006, 'udp', 'error interpretation service'),
('afs3-bos', 7007, 'udp', 'basic overseer process'),
('afs3-update', 7008, 'udp', 'server-to-server updater'),
('afs3-rmtsys', 7009, 'udp', 'remote cache manager service'),
('ups-onlinet', 7010, 'udp', 'onlinet uninterruptable power supplies'),
('talon-disc', 7011, 'udp', 'Talon Discovery Port'),
('talon-engine', 7012, 'udp', 'Talon Engine'),
('microtalon-dis', 7013, 'udp', 'Microtalon Discovery'),
('microtalon-com', 7014, 'udp', 'Microtalon Communications'),
('talon-webserver', 7015, 'udp', 'Talon Webserver'),
('dpserve', 7020, 'udp', 'DP Serve'),
('dpserveadmin', 7021, 'udp', 'DP Serve Admin'),
('op-probe', 7030, 'udp', 'ObjectPlanet probe'),
('arcp', 7070, 'udp', 'ARCP'),
('lazy-ptop', 7099, 'udp', 'lazy-ptop'),
('font-service', 7100, 'udp', 'X Font Service'),
('virprot-lm', 7121, 'udp', 'Virtual Prototypes License Manager'),
('clutild', 7174, 'udp', 'Clutild'),
('fodms', 7200, 'udp', 'FODMS FLIP'),
('dlip', 7201, 'udp', 'DLIP'),
('itactionserver1', 7280, 'udp', 'ITACTIONSERVER 1'),
('itactionserver2', 7281, 'udp', 'ITACTIONSERVER 2'),
('mindfilesys', 7391, 'udp', 'mind-file system server'),
('mrssrendezvous', 7392, 'udp', 'mrss-rendezvous server'),
('winqedit', 7395, 'udp', 'winqedit'),
('pmdmgr', 7426, 'udp', 'OpenView DM Postmaster Manager'),
('oveadmgr', 7427, 'udp', 'OpenView DM Event Agent Manager'),
('ovladmgr', 7428, 'udp', 'OpenView DM Log Agent Manager'),
('opi-sock', 7429, 'udp', 'OpenView DM rqt communication'),
('xmpv7', 7430, 'udp', 'OpenView DM xmpv7 api pipe'),
('pmd', 7431, 'udp', 'OpenView DM ovc/xmpv3 api pipe'),
('faximum', 7437, 'udp', 'Faximum'),
('telops-lmd', 7491, 'udp', 'telops-lmd'),
('ovbus', 7501, 'udp', 'HP OpenView Bus Daemon'),
('ovhpas', 7510, 'udp', 'HP OpenView Application Server'),
('pafec-lm', 7511, 'udp', 'pafec-lm'),
('nta-ds', 7544, 'udp', 'FlowAnalyzer DisplayServer'),
('nta-us', 7545, 'udp', 'FlowAnalyzer UtilityServer'),
('vsi-omega', 7566, 'udp', 'VSI Omega'),
('aries-kfinder', 7570, 'udp', 'Aries Kfinder'),
('sun-lm', 7588, 'udp', 'Sun License Manager'),
('indi', 7624, 'udp', 'Instrument Neutral Distributed Interface'),
('pmdfmgt', 7633, 'udp', 'PMDF Management'),
('imqtunnels', 7674, 'udp', 'iMQ SSL tunnel'),
('imqtunnel', 7675, 'udp', 'iMQ Tunnel'),
('imqbrokerd', 7676, 'udp', 'iMQ Broker Rendezvous'),
('sstp-1', 7743, 'udp', 'Sakura Script Transfer Protocol'),
('cbt', 7777, 'udp', 'cbt'),
('interwise', 7778, 'udp', 'Interwise'),
('vstat', 7779, 'udp', 'VSTAT'),
('accu-lmgr', 7781, 'udp', 'accu-lmgr'),
('minivend', 7786, 'udp', 'MINIVEND'),
('pnet-conn', 7797, 'udp', 'Propel Connector port'),
('pnet-enc', 7798, 'udp', 'Propel Encoder port'),
('apc-snmptrap', 7845, 'udp', 'APC SNMP Trap Proxy'),
('apc-snmp', 7846, 'udp', 'APC SNMP Proxy'),
('qo-secure', 7913, 'udp', 'QuickObjects secure port'),
('t2-drm', 7932, 'udp', 'Tier 2 Data Resource Manager'),
('t2-brm', 7933, 'udp', 'Tier 2 Business Rules Manager'),
('supercell', 7967, 'udp', 'Supercell'),
('micromuse-ncps', 7979, 'udp', 'Micromuse-ncps'),
('quest-vista', 7980, 'udp', 'Quest Vista'),
('irdmi2', 7999, 'udp', 'iRDMI2'),
('irdmi', 8000, 'udp', 'iRDMI'),
('vcom-tunnel', 8001, 'udp', 'VCOM Tunnel'),
('teradataordbms', 8002, 'udp', 'Teradata ORDBMS'),
('http-alt', 8008, 'udp', 'HTTP Alternate'),
('oa-system', 8022, 'udp', 'oa-system'),
('pro-ed', 8032, 'udp', 'ProEd'),
('mindprint', 8033, 'udp', 'MindPrint'),
('http-alt', 8080, 'udp', 'HTTP Alternate (see port 80)'),
('radan-http', 8088, 'udp', 'Radan HTTP'),
('xprint-server', 8100, 'udp', 'Xprint Server'),
('mtl8000-matrix', 8115, 'udp', 'MTL8000 Matrix'),
('cp-cluster', 8116, 'udp', 'Check Point Clustering'),
('privoxy', 8118, 'udp', 'Privoxy HTTP proxy'),
('indigo-vrmi', 8130, 'udp', 'INDIGO-VRMI'),
('indigo-vbcp', 8131, 'udp', 'INDIGO-VBCP'),
('dbabble', 8132, 'udp', 'dbabble'),
('patrol', 8160, 'udp', 'Patrol'),
('patrol-snmp', 8161, 'udp', 'Patrol SNMP'),
('vvr-data', 8199, 'udp', 'VVR DATA'),
('trivnet1', 8200, 'udp', 'TRIVNET'),
('trivnet2', 8201, 'udp', 'TRIVNET'),
('lm-perfworks', 8204, 'udp', 'LM Perfworks'),
('lm-instmgr', 8205, 'udp', 'LM Instmgr'),
('lm-dta', 8206, 'udp', 'LM Dta'),
('lm-sserver', 8207, 'udp', 'LM SServer'),
('lm-webwatcher', 8208, 'udp', 'LM Webwatcher'),
('server-find', 8351, 'udp', 'Server Find'),
('cruise-enum', 8376, 'udp', 'Cruise ENUM'),
('cruise-swroute', 8377, 'udp', 'Cruise SWROUTE'),
('cruise-config', 8378, 'udp', 'Cruise CONFIG'),
('cruise-diags', 8379, 'udp', 'Cruise DIAGS'),
('cruise-update', 8380, 'udp', 'Cruise UPDATE'),
('cvd', 8400, 'udp', 'cvd'),
('sabarsd', 8401, 'udp', 'sabarsd'),
('abarsd', 8402, 'udp', 'abarsd'),
('admind', 8403, 'udp', 'admind'),
('pcsync-https', 8443, 'udp', 'PCsync HTTPS'),
('pcsync-http', 8444, 'udp', 'PCsync HTTP'),
('npmp', 8450, 'udp', 'npmp'),
('vp2p', 8473, 'udp', 'Virtual Point to Point'),
('rtsp-alt', 8554, 'udp', 'RTSP Alternate (see port 554)'),
('ibus', 8733, 'udp', 'iBus'),
('mc-appserver', 8763, 'udp', 'MC-APPSERVER'),
('openqueue', 8764, 'udp', 'OPENQUEUE'),
('ultraseek-http', 8765, 'udp', 'Ultraseek HTTP'),
('truecm', 8804, 'udp', 'truecm'),
('cddbp-alt', 8880, 'udp', 'CDDBP'),
('ddi-udp-1', 8888, 'udp', 'NewsEDGE server UDP (UDP 1)'),
('ddi-udp-2', 8889, 'udp', 'NewsEDGE server broadcast'),
('ddi-udp-3', 8890, 'udp', 'NewsEDGE client broadcast'),
('ddi-udp-4', 8891, 'udp', 'Desktop Data UDP 3: NESS application'),
('ddi-udp-5', 8892, 'udp', 'Desktop Data UDP 4: FARM product'),
('ddi-udp-6', 8893, 'udp', 'Desktop Data UDP 5: NewsEDGE/Web application'),
('ddi-udp-7', 8894, 'udp', 'Desktop Data UDP 6: COAL application'),
('jmb-cds1', 8900, 'udp', 'JMB-CDS 1'),
('jmb-cds2', 8901, 'udp', 'JMB-CDS 2'),
('manyone-http', 8910, 'udp', 'manyone-http'),
('manyone-xml', 8911, 'udp', 'manyone-xml'),
('cumulus-admin', 8954, 'udp', 'Cumulus Admin Port'),
('bctp', 8999, 'udp', 'Brodos Crypto Trade Protocol'),
('cslistener', 9000, 'udp', 'CSlistener'),
('etlservicemgr', 9001, 'udp', 'ETL Service Manager'),
('dynamid', 9002, 'udp', 'DynamID authentication'),
('tambora', 9020, 'udp', 'TAMBORA'),
('panagolin-ident', 9021, 'udp', 'Pangolin Identification'),
('paragent', 9022, 'udp', 'PrivateArk Remote Agent'),
('swa-1', 9023, 'udp', 'Secure Web Access - 1'),
('swa-2', 9024, 'udp', 'Secure Web Access - 2'),
('swa-3', 9025, 'udp', 'Secure Web Access - 3'),
('swa-4', 9026, 'udp', 'Secure Web Access - 4'),
('websm', 9090, 'udp', 'WebSM'),
('xmltec-xmlmail', 9091, 'udp', 'xmltec-xmlmail'),
('hp-pdl-datastr', 9100, 'udp', 'PDL Data Streaming Port'),
('bacula-dir', 9101, 'udp', 'Bacula Director'),
('bacula-fd', 9102, 'udp', 'Bacula File Daemon'),
('bacula-sd', 9103, 'udp', 'Bacula Storage Daemon'),
('netlock1', 9160, 'udp', 'NetLOCK1'),
('netlock2', 9161, 'udp', 'NetLOCK2'),
('netlock3', 9162, 'udp', 'NetLOCK3'),
('netlock4', 9163, 'udp', 'NetLOCK4'),
('netlock5', 9164, 'udp', 'NetLOCK5'),
('wap-wsp', 9200, 'udp', 'WAP connectionless session service'),
('wap-wsp-wtp', 9201, 'udp', 'WAP session service'),
('wap-wsp-s', 9202, 'udp', 'WAP secure connectionless session service'),
('wap-wsp-wtp-s', 9203, 'udp', 'WAP secure session service'),
('wap-vcard', 9204, 'udp', 'WAP vCard'),
('wap-vcal', 9205, 'udp', 'WAP vCal'),
('wap-vcard-s', 9206, 'udp', 'WAP vCard Secure'),
('wap-vcal-s', 9207, 'udp', 'WAP vCal Secure'),
('lif-mlp', 9210, 'udp', 'LIF Mobile Locn Protocol'),
('lif-mlp-s', 9211, 'udp', 'LIF Mobile Locn Secure'),
('fsc-port', 9217, 'udp', 'FSC Communication Port'),
('swtp-port1', 9281, 'udp', 'SofaWare transport port 1'),
('swtp-port2', 9282, 'udp', 'SofaWare transport port 2'),
('callwaveiam', 9283, 'udp', 'CallWaveIAM'),
('visd', 9284, 'udp', 'VERITAS Information Serve'),
('n2h2server', 9285, 'udp', 'N2H2 Filter Service Port'),
('cumulus', 9287, 'udp', 'Cumulus'),
('armtechdaemon', 9292, 'udp', 'ArmTech Daemon'),
('guibase', 9321, 'udp', 'guibase'),
('mpidcmgr', 9343, 'udp', 'MpIdcMgr'),
('mphlpdmc', 9344, 'udp', 'Mphlpdmc'),
('ctechlicensing', 9346, 'udp', 'C Tech Licensing'),
('fjdmimgr', 9374, 'udp', 'fjdmimgr'),
('fjinvmgr', 9396, 'udp', 'fjinvmgr'),
('mpidcagt', 9397, 'udp', 'MpIdcAgt'),
('ismserver', 9500, 'udp', 'ismserver'),
('mngsuite', 9535, 'udp', ''),
('msgsys', 9594, 'udp', 'Message System'),
('pds', 9595, 'udp', 'Ping Discovery Service'),
('micromuse-ncpw', 9600, 'udp', 'MICROMUSE-NCPW'),
('streamcomm-ds', 9612, 'udp', 'StreamComm User Directory'),
('l5nas-parchan', 9747, 'udp', 'L5NAS Parallel Channel'),
('rasadv', 9753, 'udp', 'rasadv'),
('davsrc', 9800, 'udp', 'WebDav Source Port'),
('sstp-2', 9801, 'udp', 'Sakura Script Transfer Protocol-2'),
('sapv1', 9875, 'udp', 'Session Announcement v1'),
('sd', 9876, 'udp', 'Session Director'),
('cyborg-systems', 9888, 'udp', 'CYBORG Systems'),
('monkeycom', 9898, 'udp', 'MonkeyCom'),
('sctp-tunneling', 9899, 'udp', 'SCTP TUNNELING'),
('iua', 9900, 'udp', 'IUA'),
('domaintime', 9909, 'udp', 'domaintime'),
('apcpcpluswin1', 9950, 'udp', 'APCPCPLUSWIN1'),
('apcpcpluswin2', 9951, 'udp', 'APCPCPLUSWIN2'),
('apcpcpluswin3', 9952, 'udp', 'APCPCPLUSWIN3'),
('palace-1', 9992, 'udp', 'OnLive-1'),
('palace-2', 9993, 'udp', 'OnLive-2'),
('palace-3', 9994, 'udp', 'OnLive-3'),
('palace-4', 9995, 'udp', 'Palace-4'),
('palace-5', 9996, 'udp', 'Palace-5'),
('palace-6', 9997, 'udp', 'Palace-6'),
('distinct32', 9998, 'udp', 'Distinct32'),
('distinct', 9999, 'udp', 'distinct'),
('ndmp', 10000, 'udp', 'Network Data Management Protocol'),
('scp-config', 10001, 'udp', 'SCP Configuration Port'),
('mvs-capacity', 10007, 'udp', 'MVS Capacity'),
('amanda', 10080, 'udp', 'Amanda'),
('ezmeeting-2', 10101, 'udp', 'eZmeeting'),
('ezproxy-2', 10102, 'udp', 'eZproxy'),
('ezrelay', 10103, 'udp', 'eZrelay'),
('netiq-endpoint', 10113, 'udp', 'NetIQ Endpoint'),
('netiq-qcheck', 10114, 'udp', 'NetIQ Qcheck'),
('netiq-endpt', 10115, 'udp', 'NetIQ Endpoint'),
('netiq-voipa', 10116, 'udp', 'NetIQ VoIP Assessor'),
('bmc-perf-sd', 10128, 'udp', 'BMC-PERFORM-SERVICE DAEMON'),
('axis-wimp-port', 10260, 'udp', 'Axis WIMP Port'),
('blocks', 10288, 'udp', 'Blocks'),
('rmiaux', 10990, 'udp', 'Auxiliary RMI Port'),
('irisa', 11000, 'udp', 'IRISA'),
('metasys', 11001, 'udp', 'Metasys'),
('vce', 11111, 'udp', 'Viral Computing Environment (VCE)'),
('smsqp', 11201, 'udp', 'smsqp'),
('imip', 11319, 'udp', 'IMIP'),
('imip-channels', 11320, 'udp', 'IMIP Channels Port'),
('arena-server', 11321, 'udp', 'Arena Server Listen'),
('atm-uhas', 11367, 'udp', 'ATM UHAS'),
('tempest-port', 11600, 'udp', 'Tempest Protocol Port'),
('h323callsigalt', 11720, 'udp', 'h323 Call Signal Alternate'),
('entextxid', 12000, 'udp', 'IBM Enterprise Extender SNA XID Exchange'),
('entextnetwk', 12001, 'udp', 'IBM Enterprise Extender SNA COS Network Priority'),
('entexthigh', 12002, 'udp', 'IBM Enterprise Extender SNA COS High Priority'),
('entextmed', 12003, 'udp', 'IBM Enterprise Extender SNA COS Medium Priority'),
('entextlow', 12004, 'udp', 'IBM Enterprise Extender SNA COS Low Priority'),
('dbisamserver1', 12005, 'udp', 'DBISAM Database Server - Regular'),
('dbisamserver2', 12006, 'udp', 'DBISAM Database Server - Admin'),
('hivep', 12172, 'udp', 'HiveP'),
('italk', 12345, 'udp', 'Italk Chat System'),
('tsaf', 12753, 'udp', 'tsaf port'),
('i-zipqd', 13160, 'udp', 'I-ZIPQD'),
('powwow-client', 13223, 'udp', 'PowWow Client'),
('powwow-server', 13224, 'udp', 'PowWow Server'),
('bprd', 13720, 'udp', 'BPRD Protocol (VERITAS NetBackup)'),
('bpdbm', 13721, 'udp', 'BPDBM Protocol (VERITAS NetBackup)'),
('bpjava-msvc', 13722, 'udp', 'BP Java MSVC Protocol'),
('vnetd', 13724, 'udp', 'Veritas Network Utility'),
('bpcd', 13782, 'udp', 'VERITAS NetBackup'),
('vopied', 13783, 'udp', 'VOPIED Protocol'),
('dsmcc-config', 13818, 'udp', 'DSMCC Config'),
('dsmcc-session', 13819, 'udp', 'DSMCC Session Messages'),
('dsmcc-passthru', 13820, 'udp', 'DSMCC Pass-Thru Messages'),
('dsmcc-download', 13821, 'udp', 'DSMCC Download Protocol'),
('dsmcc-ccp', 13822, 'udp', 'DSMCC Channel Change Protocol'),
('sua', 14001, 'udp', 'De-Registered (2001 June 06)'),
('sage-best-com1', 14033, 'udp', 'sage Best! Config Server 1'),
('sage-best-com2', 14034, 'udp', 'sage Best! Config Server 2'),
('vcs-app', 14141, 'udp', 'VCS Application'),
('gcm-app', 14145, 'udp', 'GCM Application'),
('vrts-tdd', 14149, 'udp', 'Veritas Traffic Director'),
('hde-lcesrvr-1', 14936, 'udp', 'hde-lcesrvr-1'),
('hde-lcesrvr-2', 14937, 'udp', 'hde-lcesrvr-2'),
('hydap', 15000, 'udp', 'Hypack Data Aquisition'),
('xpilot', 15345, 'udp', 'XPilot Contact Port'),
('netserialext1', 16360, 'udp', 'netserialext1'),
('netserialext2', 16361, 'udp', 'netserialext2'),
('netserialext3', 16367, 'udp', 'netserialext3'),
('netserialext4', 16368, 'udp', 'netserialext4'),
('intel-rci-mp', 16991, 'udp', 'INTEL-RCI-MP'),
('isode-dua', 17007, 'udp', ''),
('soundsvirtual', 17185, 'udp', 'Sounds Virtual'),
('chipper', 17219, 'udp', 'Chipper'),
('biimenu', 18000, 'udp', 'Beckman Instruments, Inc.'),
('opsec-cvp', 18181, 'udp', 'OPSEC CVP'),
('opsec-ufp', 18182, 'udp', 'OPSEC UFP'),
('opsec-sam', 18183, 'udp', 'OPSEC SAM'),
('opsec-lea', 18184, 'udp', 'OPSEC LEA'),
('opsec-omi', 18185, 'udp', 'OPSEC OMI'),
('opsec-ela', 18187, 'udp', 'OPSEC ELA'),
('checkpoint-rtm', 18241, 'udp', 'Check Point RTM'),
('ac-cluster', 18463, 'udp', 'AC Cluster'),
('ique', 18769, 'udp', 'IQue Protocol'),
('apc-necmp', 18888, 'udp', 'APCNECMP'),
('opsec-uaa', 19191, 'udp', 'opsec-uaa'),
('keysrvr', 19283, 'udp', 'Key Server for SASSAFRAS'),
('keyshadow', 19315, 'udp', 'Key Shadow for SASSAFRAS'),
('mtrgtrans', 19398, 'udp', 'mtrgtrans'),
('hp-sco', 19410, 'udp', 'hp-sco'),
('hp-sca', 19411, 'udp', 'hp-sca'),
('hp-sessmon', 19412, 'udp', 'HP-SESSMON'),
('sxuptp', 19540, 'udp', 'SXUPTP'),
('jcp', 19541, 'udp', 'JCP Client'),
('dnp', 20000, 'udp', 'DNP'),
('ipulse-ics', 20222, 'udp', 'iPulse-ICS'),
('track', 20670, 'udp', 'Track'),
('athand-mmp', 20999, 'udp', 'AT Hand MMP'),
('vofr-gateway', 21590, 'udp', 'VoFR Gateway'),
('tvpm', 21800, 'udp', 'TVNC Pro Multiplexing'),
('webphone', 21845, 'udp', 'webphone'),
('netspeak-is', 21846, 'udp', 'NetSpeak Corp. Directory Services'),
('netspeak-cs', 21847, 'udp', 'NetSpeak Corp. Connection Services'),
('netspeak-acd', 21848, 'udp', 'NetSpeak Corp. Automatic Call Distribution'),
('netspeak-cps', 21849, 'udp', 'NetSpeak Corp. Credit Processing System'),
('snapenetio', 22000, 'udp', 'SNAPenetIO'),
('optocontrol', 22001, 'udp', 'OptoControl'),
('wnn6', 22273, 'udp', 'wnn6'),
('vocaltec-phone', 22555, 'udp', 'Vocaltec Internet Phone'),
('aws-brf', 22800, 'udp', 'Telerate Information Platform LAN'),
('brf-gw', 22951, 'udp', 'Telerate Information Platform WAN'),
('med-ltp', 24000, 'udp', 'med-ltp'),
('med-fsp-rx', 24001, 'udp', 'med-fsp-rx'),
('med-fsp-tx', 24002, 'udp', 'med-fsp-tx'),
('med-supp', 24003, 'udp', 'med-supp'),
('med-ovw', 24004, 'udp', 'med-ovw'),
('med-ci', 24005, 'udp', 'med-ci'),
('med-net-svc', 24006, 'udp', 'med-net-svc'),
('filesphere', 24242, 'udp', 'fileSphere'),
('vista-4gl', 24249, 'udp', 'Vista 4GL'),
('intel_rci', 24386, 'udp', 'Intel RCI'),
('binkp', 24554, 'udp', 'BINKP'),
('flashfiler', 24677, 'udp', 'FlashFiler'),
('proactivate', 24678, 'udp', 'Turbopower Proactivate'),
('snip', 24922, 'udp', 'Simple Net Ident Protocol'),
('icl-twobase1', 25000, 'udp', 'icl-twobase1'),
('icl-twobase2', 25001, 'udp', 'icl-twobase2'),
('icl-twobase3', 25002, 'udp', 'icl-twobase3'),
('icl-twobase4', 25003, 'udp', 'icl-twobase4'),
('icl-twobase5', 25004, 'udp', 'icl-twobase5'),
('icl-twobase6', 25005, 'udp', 'icl-twobase6'),
('icl-twobase7', 25006, 'udp', 'icl-twobase7'),
('icl-twobase8', 25007, 'udp', 'icl-twobase8'),
('icl-twobase9', 25008, 'udp', 'icl-twobase9'),
('icl-twobase10', 25009, 'udp', 'icl-twobase10'),
('vocaltec-hos', 25793, 'udp', 'Vocaltec Address Server'),
('niobserver', 25901, 'udp', 'NIObserver'),
('niprobe', 25903, 'udp', 'NIProbe'),
('quake', 26000, 'udp', 'quake'),
('wnn6-ds', 26208, 'udp', 'wnn6-ds'),
('ezproxy', 26260, 'udp', 'eZproxy'),
('ezmeeting', 26261, 'udp', 'eZmeeting'),
('k3software-svr', 26262, 'udp', 'K3 Software-Server'),
('k3software-cli', 26263, 'udp', 'K3 Software-Client'),
('gserver', 26264, 'udp', 'Gserver'),
('imagepump', 27345, 'udp', 'ImagePump'),
('tw-auth-key', 27999, 'udp', 'Attribute Certificate Services'),
('pago-services1', 30001, 'udp', 'Pago Services 1'),
('pago-services2', 30002, 'udp', 'Pago Services 2'),
('xqosd', 31416, 'udp', 'XQoS network monitor'),
('filenet-tms', 32768, 'udp', 'Filenet TMS'),
('filenet-rpc', 32769, 'udp', 'Filenet RPC'),
('filenet-nch', 32770, 'udp', 'Filenet NCH'),
('filenet-rmi', 32771, 'udp', 'FileNet RMI'),
('diamondport', 33331, 'udp', 'DiamondCentral Interface'),
('traceroute', 33434, 'udp', 'traceroute use'),
('turbonote-2', 34249, 'udp', 'TurboNote Relay Server Default Port'),
('kastenxpipe', 36865, 'udp', 'KastenX Pipe'),
('neckar', 37475, 'udp', 'science + computings Venus Administration Port'),
('turbonote-1', 39681, 'udp', 'TurboNote Default Port'),
('cscp', 40841, 'udp', 'CSCP'),
('csccredir', 40842, 'udp', 'CSCCREDIR'),
('csccfirewall', 40843, 'udp', 'CSCCFIREWALL'),
('fs-qos', 41111, 'udp', 'Foursticks QoS Protocol'),
('reachout', 43188, 'udp', 'REACHOUT'),
('ndm-agent-port', 43189, 'udp', 'NDM-AGENT-PORT'),
('ip-provision', 43190, 'udp', 'IP-PROVISION'),
('pmcd', 44321, 'udp', 'PCP server (pmcd)'),
('rockwell-encap', 44818, 'udp', 'Rockwell Encapsulation'),
('invision-ag', 45054, 'udp', 'InVision AG'),
('eba', 45678, 'udp', 'EBA PRISE'),
('ssr-servermgr', 45966, 'udp', 'SSRServerMgr'),
('mbus', 47000, 'udp', 'Message Bus'),
('dbbrowse', 47557, 'udp', 'Databeam Corporation'),
('directplaysrvr', 47624, 'udp', 'Direct Play Server'),
('ap', 47806, 'udp', 'ALC Protocol'),
('bacnet', 47808, 'udp', 'Building Automation and Control Networks'),
('nimcontroller', 48000, 'udp', 'Nimbus Controller'),
('nimspooler', 48001, 'udp', 'Nimbus Spooler'),
('nimhub', 48002, 'udp', 'Nimbus Hub'),
('nimgtw', 48003, 'udp', 'Nimbus Gateway'),
('com-bardac-dw', 48556, 'udp', 'com-bardac-dw'););
close SQL;

